/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <assfuncs.h>
#include <routines.h>


/* Vergleicht zwei IDs miteinander, wobei der domain-part case-insensitiv
 * behandelt wird.
 */
GLOBAL _BOOL CmpId(CONST _UBYTE *str1, CONST _UBYTE *str2)
{
	while (*str1 != '\0')
	{
		if (*str1 != *str2)
			return FALSE;
		str2++;
		if (*str1++ == '@')
		{
			while (*str1 != '\0')
			{
				if (ucase(*str1) != ucase(*str2))
					return FALSE;
				str1++;
				str2++;
			}
		}
	}
	if (*str2 == '\0')
		return TRUE;
	return FALSE;
}
