#ifndef __CAT_MENU_H__
#define __CAT_MENU_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif

typedef struct _menu_entry {
	_WORD configNum;
	_WORD entry;
	_WORD defaultKey;
	_WORD title;
	_WORD key;
	_UBYTE *text;
} MENU_KEY_ENTRY;

_VOID Menu_Loadkeys(OBJECT *menu, MENU_KEY_ENTRY *menuTable, _WORD numEntries);
/* Einstellungen aus den Config-Variablen holen */

_VOID Menu_Savekeys(OBJECT *menu, MENU_KEY_ENTRY *menuTable, _WORD numEntries);
/* Einstellungen wieder in Config-Variablen schreiben */

_VOID Menu_Setkeys(OBJECT *menu, MENU_KEY_ENTRY *menuTable, _WORD numEntries, _BOOL settext);
/* Menue entsprechend den Einstellungen aendern */

_VOID Menu_Editkeys(OBJECT *menu, MENU_KEY_ENTRY *menuTable, _WORD numEntries, _VOID (*doHelp)(_VOID));
/* Dialog zum aendern aufrufen */

#endif /* __CAT_MENU_H__ */
