#ifndef __CAT_CATOPTS2_H__
#define __CAT_CATOPTS2_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#include <datasys.h>	/*DYJ 5.38b */


_VOID CatOpts2_doFloskel(_VOID);
/* Der Floskeltastendialog
 */

_VOID CatOpts2_doIOFilter(_VOID);
/* Der IO-Filter Dialog
 */

_VOID CatOpts2_doPMFilter(_VOID);
/* Der PM-Filter Dialog
 */

_BOOL CatOpts2_doFilter(_WORD *filterNumber, _UBYTE *cmd, size_t strsize);
/* Es wird ein IO-Filter aufgerufen
 */

_BOOL CatOpts2_doPopupFilter(_WORD *filterNumber, _UBYTE *cmd, size_t strsize);
/* Es wird ein IO-Filter aufgerufen, nur keine Editmoeglichkeit
 */
GLOBAL _VOID CatOpts2_doHilfsPrg(_VOID);
/* Der Hilfsprogramm Dialog */

_BOOL CatOpts2_NrHolen(_UBYTE *Nr, size_t strsize);
/* Fragt nach einer ID, ab der gelesen werden soll
 */

_BOOL CatOpts2_DatumHolen(_BOOL forWv, _UBYTE *Nr, size_t strsize);
/* Holt ein Datum, ab dem Gelesen werden soll
 */

_VOID CatOpts2_DoUserSelect(_VOID);
/* User eintragen in eine Gruppe
 */

_VOID CatOpts2_CheckFlagLine(CONST _UBYTE *str, MSGBITS *setBits, MSGBITS *clearBits);		/*DYJ 5.38b */
/*	wandelt eine Flagline in setBits und clearBits								*/
_VOID CatOpts2_InitSounds(_VOID);

_VOID CatOpts2_EditSounds(_VOID);

#define MAX_CBC_REG 7

_VOID CatOpts2_doCbC(_VOID);
/* Der CbC Dialog
 */


typedef enum _TEL_DAYS {CBC_UNBENUTZT,
	SONNTAG,MONTAG,DIENSTAG,MITTWOCH,
	DONNERSTAG,FREITAG,SAMMSTAG,
	WOCHENTAG,WOCHENENDE,
	FEIERTAG,SASOFT,SOFT,TAEGL}TEL_DAYS;
	
/*	WOCHENTAG=MONTAG|DIENSTAG|MITTWOCH|DONNERSTAG|FREITAG,
	WOCHENENDE=SAMMSTAG|SONNTAG,
	SASOFT=WOCHENENDE|FEIERTAG,
	SOFT=SONNTAG|FEIERTAG,
	TAEGL=WOCHENTAG|WOCHENENDE} TEL_DAYS;*/

 _WORD CatOpts2_GetCbC(_WORD nummer,_WORD *von,_WORD *bis,_UBYTE *vvWahl,size_t size);


#endif /* __CAT_CATOPTS2_H__ */
