#ifndef __CAT_CATUTIL_H__
#define __CAT_CATUTIL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */




#ifndef __PORTAB_H__
#include <portab.h>
#endif

_VOID CatUtil_makeTmpName(_UBYTE *path, _UBYTE *name);

_VOID CatUtil_buildCommand(HWND wdw, CONST _UBYTE *com, CONST _UBYTE *path, CONST _UBYTE *in, CONST _UBYTE *out, _UBYTE *cmd, size_t cmdsize);

_VOID CatUtil_PipeEditBlock(HWND wdw, CONST _UBYTE *command);

_VOID CatUtil_GetPosPath(_UBYTE *path);

_BOOL CatUtil_WriteSavePos(_BOOL force, _BOOL delVars);

_VOID insert_app_name(_UBYTE *title, size_t strsize);

_VOID insert_box_name(_UBYTE *title, size_t strsize);

_WORD mtAlerts_AlertSichL(_WORD unsave, _WORD save, CONST _UBYTE *str);

#endif /* __CAT_CATUTIL_H__ */
