#ifndef __CAT_GRINTOOLS_H__
#define __CAT_GRINTOOLS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#include <groupsel.h>


/* Hier sollen demnaechst auch die neuen Nachrichten erstellt werden, damit u.a. */
/* BetreffHolen aus Cat komplett entfernt werden kann/ jetzt ist BetreffHolen   */
/* hier original mit reinkopiert */

/* Dann kann HandleComment/CopyResult und BetreffHolen aus Cat raus */

typedef enum {
	Action_comment,
	Action_answer,
	Action_copy,
	Action_pass,
	Action_otherGroup
} ActionType;


size_t grinTools_LengthOf(CONST _UBYTE *str);
/* Liefert die Laenge eines Strings nach einer Umlautumwandlung */

_BOOL grinTools_CheckBetreff(_UBYTE *Betreff);
/* Prueft nach, ob der Betreff alle gueltigen Regeln einhaelt */

typedef enum {BH_LEER,BH_ASK_GRIN,BH_ASK_GRIN_RE} BETR_HOL_MOD;
_BOOL grinTools_BetreffHolen(HWND grinWdw, _UBYTE *Betreff, size_t strsize, CONST _UBYTE *optStr, CONST _UBYTE *WGruppe, CONST _UBYTE *preStr, BETR_HOL_MOD bhMode);
/* Fuehrt den Dialog mit der Betreffzeile durch.
 * Fragt ggf. bei grin nach der aktuellen an!
 */

_BOOL grinTools_GetCommentLine(_UBYTE *str, size_t strsize, _BOOL copy);
/* Wird in MsgManager auch gebraucht */

_VOID grinTools_Handle(HWND grinWdw, ActionType what);

_BOOL grinTools_NewMessage(CONST _UBYTE *an, CONST _UBYTE *betreff);

_VOID grinTools_Init(_VOID);
/* Objektbaum der Betreffauswahlbox und Kommentarzeilenbox */

_BOOL grintool_getMlServ(CONST CAT_GROUP_NUMBER catNumber,CONST _UBYTE *gName,group_line followup);	/*DYJ 5.34d */

#endif /* __CAT_GRINTOOLS_H__ */
