#ifndef __CAT_HLP_PRG_H__
#define __CAT_HLP_PRG_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */
/*
 * Die vorliegende Version wurde von Dimitri Junker aus IOFILTER.C
 * abgeleitet (am 30.3.00)
 */


#ifndef __CAT_CATTYPES_H__
#include <cattypes.h>
#endif

#define MAX_HLP_PRG 10
typedef struct hlpPrgStruct {
	_UBYTE hprgPath[PATH_MAX];
	String255 Cmd;
	_UBYTE hprgName[26];
	_BOOL activ;
	_BOOL term;
	_WORD mulStart;
} hlpPrgStruct;

GLOBAL _VOID HlpPrg_ReadPrg(hlpPrgStruct *hlpPrg, _WORD num);
GLOBAL _VOID HlpPrg_WritePrg(CONST hlpPrgStruct *hlpPrg, _WORD num);


#endif /* __CAT_HLP_PRG_H__ */
