#ifndef __CAT_MAUSTAUSCHRSC_H__
#define __CAT_MAUSTAUSCHRSC_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#include <cat.h>
#include <mtalerts.h>

/*DYJ 5.32b Start*/
/*DYJ  Ende; alt:	
#define MENU_PMF "  PM-Filter...          "
#define MENU_CBC "  CbC-Vor-Vorwahl...    "
*/

extern OBJECT **TreeAddr;

#define mtAlerts_AlertRSC(def,nr) mtAlerts_Alert((def),(MausTauschrsc_WrkString(nr)))
#define mtAlerts_AlertSichLRSC(unsave,save,nr) mtAlerts_AlertSichL((unsave),(save),(MausTauschrsc_WrkString(nr)))
#define MTE_infoRSC(nr) MTE_info(MausTauschrsc_WrkString(nr))

_BOOL MausTauschrsc_RscInit(_VOID);

_VOID MausTauschrsc_RscFree(_VOID);

_VOID MausTauschrsc_AdjustDialogSize(OBJECT *tree, _WORD treeNum);

_VOID MausTauschrsc_DialogSizes(_VOID);

_VOID MausTauschrsc_Shortcuts(_VOID);

_VOID MausTauschrsc_MenuInit(_VOID);

OBJECT *MausTauschrsc_WrkTree(_WORD treeNr);

_UBYTE *MausTauschrsc_WrkString(_WORD nr);

#endif /* __CAT_MAUSTAUSCHRSC_H__ */
