#ifndef __CAT_PARSER_H__
#define __CAT_PARSER_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#include <cat_vb.h>
typedef enum{OM_OUTFILE,OM_OUTFHDR,OM_822}OUTF_MODE;

_WORD Parser_OutfileEinsortieren(
	CONST _UBYTE *importPath,
	CONST _UBYTE *outfileName,
	CONST _UBYTE *archiveName,
	CONST _UBYTE *arcName,
	OUTF_MODE mode);

_VOID Parser_EmergencyClose(_VOID);
/* Schliesst die noch offene Protokolldatei im Falle eines Absturzes */
/* Wird direkt in cat.m in den ExeptionHandler gehaengt. */


#endif /* __CAT_PARSER_H__ */
