#ifndef __CAT_VARNAME_H__
#define __CAT_VARNAME_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/* catopts.c*/
#define cSortNames                      "SortNames"
#define cMsgSelectHoldCol               "MsgSelectHoldCol"
#define cMsgSelectHoldEff               "MsgSelectHoldEff"
#define cMsgSelectPersCol               "MsgSelectPersCol"
#define cMsgSelectPersEff               "MsgSelectPersEff"
#define cMsgSelectTextCol               "MsgSelectTextCol"
#define cMsgSelectBackCol               "MsgSelectBackCol"

/* adr.c */
#define cLocateAdrMode         		    "LocateAdrMode"
#define cAliasInfoIsRName				"AliasInfoIsRName"
/*DYJ  Ende;*/

#define cAdrPath         			    "AdrPath"
#define cAdrAliasPath         		    "AdrAliasPath"
#define cOwnNameAlias                   "MausIdAlias"



/* msglist.c */
#define cListFont                       "ListFont"
#define cListFontSize                   "ListFontSize"
#define cListWindowPos                  "ListWindowPos"
#define cListGroup                      "ListGroup"
#define cListStart                      "ListStart"
#define cListLeftOffset                 "ListLeftOffset"
#define cListLineDist                   "ListLineDist"
#define cListDefaultSort                "ListDefaultSort"
#define cListDefReverse                 "ListDefReverse"
#define cListShowSmallList              "ListShowSmallList"
#define cListDontShowFiltered           "ListDontShowFiltered"
#define cListDefaultSelect              "ListDefaultSelect"
#define cListSortIgnoreCase             "ListSortIgnoreCase"
#define cListSuppressCursorDown         "ListSuppressCursorDown"
#define cListTextCol                    "ListTextCol"
#define cListNotReadCol                 "ListNotReadCol"
#define cListNotReadEffect              "ListNotReadEffect"
#define cListBackCol                    "ListBackCol"
#define cListOwnMessCol                 "ListOwnMessCol"
#define cListOwnMessEffect              "ListOwnMessEffect"
#define cListC2OMessCol                 "ListC2OMessCol"
#define cListC2OMessEffect              "ListC2OMessEffect"
#define cPrivateMsgListElems            "PrivateMsgListElems"
#define cGrpMsgListElems                "GrpMsgListElems"
#define cListMarkBackground             "ListMarkBackground"
#define cListIdemMode		            "ListIdemMode"
#define cListIdemStr		            "ListIdemStr"
#define cListLstPgF						"ListLstPgF"

/* treelist.c */
#define cTreeFont                       "TreeFont"
#define cTreeFontSize                   "TreeFontSize"
#define cTreeWindowPos                  "TreeWindowPos"
#define cTreeTextCol                    "TreeTextCol"
#define cTreeBackCol                    "TreeBackCol"
#define cTreeSubjChangeCol              "TreeSubjChangeCol"
#define cTreeNotReadCol                 "TreeNotReadCol"
#define cTreeNotReadEffect              "TreeNotReadEffect"
#define cTreeUpLevels                   "TreeUpLevels"
#define cTreeMaxDepth                   "TreeMaxDepth"
#define cTreeZoomMode                   "TreeZoomMode"
#define cTreeBuildType                  "TreeBuildType"

/* catbutto.c */
#define cButtonWindowOpen               "ButtonWindowOpen"
#define cAddVersionToFuncWin            "AddVersionToFuncWin"
#define cSmallFunctionWindow            "SmallFunctionWindow"
#define cWiggle                         "Wiggle"


/* messages.c */
#define cMausTauschGroupName            "MausTauschGroupName"
#define cMausTauschVersionName          "MausTauschVersionName"
#define cDontSetDistribution            "DontSetDistribution"
#define cMsgSelectEdit                  "MsgSelectEdit"
#define cNewsDefAddr                 	"NewsDefAddr"
#define cAnswerAsReceiver				"AnswerAsReceiver"
#define cAttachSrcPath					"AttachSrcPath"
#define cNewsDefReplyTo					"NewsDefReplyTo"
#define cDefReplyTo						"DefReplyTo"

/* grintool.c */

#define cAskRepAlias					"AskRepAlias"

/* msgwindow.c */

#define cMsgSelectOpen                  "MsgSelectOpen"
#define cMsgSelectWindowPos             "MsgSelectWindowPos"
#define cMsgSelectFont                  "MsgSelectFont"
#define cMsgSelectFontSize              "MsgSelectFontSize"
#define cMsgSelectLeftOffset            "MsgSelectLeftOffset"
#define cMsgSelectLineDist              "MsgSelectLineDist"
#define cMsgSelectMaxNum                "MsgSelectMaxNum"
#define cMsgLstPgF						"MsgLstPgF"


#define cMsgSelectHoldEff               "MsgSelectHoldEff"
#define cMsgSelectPersEff               "MsgSelectPersEff"


/* wiedervo.c */
#define cLastResubmissionDate           "LastResubmissionDate"
#define cSaveLastResubDate2File         "SaveLastResubDate2File"
#define cCommentEntriesHoldDays         "CommentEntriesHoldDays"

/* maustaus.c */

#define cDialogVertical                 "DialogVertical"
#define cDialogVerticalSize             "DialogVerticalSize"
#define cDialogHorizontal               "DialogHorizontal"
#define cDialogHorizontalSize           "DialogHorizontalSize"


/* grintool.c*/
#define cAddReToSubject           		"AddReToSubject"
#define cChangeSubjectMode           	"ChangeSubjectMode"
#define cChangeSubjAlt2Was           	"ChangeSubjAlt2Was"


#endif /* __CAT_VARNAME_H__ */
