#ifndef __CAT_VARN_SRC_H__
#define __CAT_VARN_SRC_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */
/* searchhe.c */
#define cSearchStr                      "SearchStr"
#define cSearchLogical                  "SearchLogical"
#define cSearchLocation                 "SearchLocation"
#define cSearchShow                     "SearchShow"
#define cSearchChange                   "SearchChange"
#define cSearchStatus                   "SearchStatus"
#define cSearchAsk                      "SearchAsk"
#define cSearchText                     "SearchText"
#define cSearchCasesensitive            "SearchCasesensitive"
#define cSearchSetBits                  "SearchSetBits"
#define cSearchClearedBits              "SearchClearedBits"
#define cSearchToSetBits                "SearchToSetBits"
#define cSearchToClearBits              "SearchToClearBits"
#define cSearchAllGroups                "SearchAllGroups"
#define cSearchName             	    "SearchName"


/*iofilter.c*/
#define cIoFilterProgram                "IoFilterProgram"
#define cIoFilterInCmdline              "IoFilterInCmdline"
#define cIoFilterOutCmdline             "IoFilterOutCmdline"
#define cIoFilterType 	                "IoFilterType"
#define cIoFilterBeforeMsg              "IoFilterBeforeMsg"
#define cIoFilterForInfile              "IoFilterForInfile"
#define cIoFilterForOutfile             "IoFilterForOutfile"
#define cIoFilterPastOutfile            "IoFilterPastOutfile"
#define cIoFilterActive                 "IoFilterActive"
#define cIoFilterPass	                "IoFilterPass"
#define cIoFilterErrorBreak             "IoFilterErrorBreak"
#define cIoFilterName                   "IoFilterName"
#define cIoRedrawAftFilter              "IoRedrawAftFilter"

/*pmfilter.c*/
#define cPmFilterName                   "PmFilterName"
#define cPmFilterPrio	                "PmFilterPrio"
#define cPmFilterType 	                "PmFilterType"
#define cPmFilterSuchStr       	        "PmFilterSuchStr"
#define cPmFilterMListPrio       	    "PmFilterMListPrio"	/*DYJ 5.34d */
#define cPmFilterGruppe             	"PmFilterGruppe"
#define cPmFilterAktStr             	"PmFilterAktStr"
#define cPmFilterAktTyp             	"PmFilterAktTyp"

/*parser.c*/
#define cRedirectPackerToLog            "RedirectPackerToLog"
#define cNoRedirectFilter           	 "NoRedirectFilter"		/*DYJ 5.30p */
#define cNoInfofileBackups              "NoInfofileBackups"
#define cCheckRedrawMsgCount            "CheckRedrawMsgCount"
#define cEnableLowMemWarning            "EnableLowMemWarning"
#define cWriteCommentsEntries           "WriteCommentsEntries"

/* doitk.c */
#define cMTCmd                          "MTCmd"
#define cMTCmdVersion                   "MTCmdVersion"
#define cMTCmdMaxIdent                  "MTCmdMaxIdent"
#define cMTSortType                     "MTSortType"
#define cMTGroupVisible                 "MTGroupVisible"
#define cSendPSN                        "SendPSN"
#define cMemoryLineInInfile             "MemoryLineInInfile"
#define cRequestPmails                  "RequestPmails"
#define cRequestBackOwnPmails           "RequestBackOwnPmails"
#define cRequestGrpMsgs                 "RequestGrpMsgs"
#define cItkTransformed                 "ItkTransformed"

/* listhelp.c */
#define cSmallWriteList                 "SmallWriteList"
#define cGroupListPmCol					"GroupListPmCol"
#define cGroupListOmCol					"GroupListOmCol"

/* gruppena.c */
#define cGroupSelectDispType            "GroupSelectDispType"
#define cGroupSelectSortType            "GroupSelectSortType"
#define cAutoClearEdit                  "AutoClearEdit"
#define cLocateGruMode         		    "LocateGruMode"


/*cbc.c*/
#define cCbcDays						"CbcDays"
#define cCbcFrom						"CbcFrom"
#define cCbcUntil						"CbcUntil"
#define cCbcNumber						"CbcNumber"
#define cCbcNumberDef					"CbcNumberDef"

/* mime.h*/
#define cMausCharsetMode				"MausCharsetMode"	/*DYJ 5.34m */
#endif /* __CAT_VARN_SRC_H__ */
