#ifndef __CAT_VDISTANDARDS_H__
#define __CAT_VDISTANDARDS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __CAT_MAGICVDI_H__
#include <portvdi.h>
#endif

#ifndef __PORTAES_H__
#include <portaes.h>
#endif


_BOOL VDIStandards_InitVDIStandards(_VOID);


#define VDIStandards_GetSpec GetObSpec
_VOID VDIStandards_SetSpec(OBJECT *tree, _WORD Item, _VOID *newSpec);

_VOID VDIStandards_CheckItem(OBJECT *tree, _WORD item, _BOOL enable);

_VOID VDIStandards_StatusEnable(_BOOL yep);

_VOID VDIStandards_enableMenuItems(HWND wdw);
_VOID VDIStandards_enableNewTop(HWND wdw);

_VOID VDIStandards_enableOrDisableMenu(_BOOL disable);
/* Enablet oder disablet alle Menueintraege */


#endif /* __CAT_VDISTANDARDS_H__ */
