/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Der vorliegende Teil wurde geschrieben von Dimitri Junker
 *	Cat@Dimitri_Junker.de
 *

 * 3.8.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.11a'
 *	da fehlte die Untersttzung von pEZeitX
 *
 * 9.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16l'
 *	Beim Versenden von Textanhngen wurde ein ungltiger Filter
 *	benutzt
 *
 * 20.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17e'
 *	Cat gab bei encoded-word den Zeichensatz falsch an (iso-8859- statt
 *	iso-8859-1)
 *
 * 24.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17k'
 *	Cp1250 hinzugefgt
 *
 * 25.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.18b'
 *	Speicherloch gestopft
 *
 * 5.12.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19l'
 *	Wurde im Mimeheader der Filname in der Form =3d"file.ext"
 *	angegeben kamen die Anfhrungszeichen mit in den Filenamen
 *
 * 6.12.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19o'
 *	Beim Schreiben des Internet-Infiles wurden hinter einem weichen
 *	Zeilenumbruch vergessen ggf einen folgenden Punkt zu verdoppeln.
 *
 * 28.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20f'
 * Neue Modi (6+7) fr die Anhangpfade, dabei werden die Monate
 * klein geschrieben.
 *
 * 29.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20i'
 *	Da gab es Anhangnamen die quoted-printable waren.
 *
 * 31.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20l'
 *	multipart/signed: Die Signatur wird wie ein Anhang behandelt.
 *
 * 2.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20o'
 *	multipart Teile ohne Content-Type Information sind text/plain
 *
 * 2.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20p'
 *	Da wurde geprft ob eine vorzeichenlose Zahl negativ ist, dadurch
 *	wurden Fehler beim dekodieren von Anhngen bersehen.
 *
 * 2.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20q'
 *	Ein C zu viel, aber wahrscheinlich ohne Folgen
 *
 * 4.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20r'
 *	Bei Filenamen von Anhngen die erlaubten Zeichen eingeschrnkt.
 *
 * 5.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20s'
 *	Anhnge des Typs message/rfc822 werden als *.822 gesichert
 *
 * 11.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20zb'
 *	Mehrere Fehler die alle die Erzeugung des Anhangpfades beim Sichern einer Mail
 *	vermurksten
 *
 * 15.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20zg'
 *	Enthielt ein Mailtext (im MSGxxx.TXT File Zeilen mit nur einem CR
 *	am Ende, so wurde die folgende Zeile berlesen.
 *
 * 26.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21k'
 *	Fehler bei den neuen Anhangmodi 6+7 behoben
 *
 * 27.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23j'
 *	Irgendwie scheint es multipart/related Msgs zu geben die 
 *	nicht richtig erkannt werden. Erstmals nur ein paar Symptome behoben
 *	bis ich ein Outfile habe, da diesen Bug erzeugt.
 *
 * 20.8.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29h'
 *	Bei Quoted-printable gibt es 2 Besonderheiten an Zeilenenden:
 *	1) Leerzeichen und Tabs werden ignoriert
 *	2) Ein '=' vor dem Zeilenende bedeutet, da der Zeilenumbruch ignoriert
 *		werden soll.
 *	Beides wurde von Cat einzeln beachtet, nur die Kombination fhrte dazu,
 *	da ggf. der Zeilenumbruch erhalten blieb.
 *
 * 30.8.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30a'
 *	Cat war etwas kleinlich mit der Erkennung von Charset-Namen.
 *
 * 5.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30q'
 *	Beim Export als Outfile fehlten die ':' am Zeilenanfang im Bereich
 *	der Anhnge.
 *
 * 4.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.31b'
 *	Die neue flexiblere charset Erkennung funktionierte nicht
 *
 * 11.11.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32g'
 *	Ist ein Anhangname bereits vorhanden hngt Cat jetzt vor
 *	der laufenden Nummer zuerst ein Zeichen fr den Tag an, so
 *	wird die Laufende Nummer nicht so gro, und es mssen am
 *	Monatsende nicht so viele Files auf Existenz geprft werden.
 *
 * 11.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35k'
 *	Waren in einer Mime-Zeile z.B. bei name zwischen dem Keyword
 *	und dem Wert viele Leerzeichen konnte Cat dies nicht verstehen
 *
 * 4.5.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36h'
 *	multipart/signed wurde flschlicherweise nicht erkannt und
 *	multipart/encrypted war noch garnicht enthalten. Beide werden
 *	jetzt hnlich wie multipart/mixed behandelt, die Signatur
 *	o.. wird also einfach wie ein Anhang behandelt.
 *
 * 4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.37b'
 * und
 * 15.8.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.38a'
 *
 *	Spezialmodus fr Fidel.
 */

/* -------------------------------------------------------------------- */
/*		Includes														*/
/* -------------------------------------------------------------------- */
#include <catfiles.h>
#include <catgloba.h>
#include <confvars.h>
#include <data.h>
#include <mime.h>
#include <mime_i2a.h>
#include <mtpaths.h>
#include <mtutils.h>
#include <mte.h>
#include <routinec.h>
#include <routines.h>
#include <routine.h>
#include <tos.h>
#include <userinfo.h>
#include <varnamel.h>
#include <mime_typ.h>
#include <vaproto.h>
#include <protokol.h>
#include <mtdir.h>
#include <magicstr.h>
#include <mtalerts.h>
#include <dir_io.h>
#include <keytab.h>
#include <MAGICCOO.H>
#include <mtrsc.h>
#include <punycode.h>
/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */

#define CR 0x0d
#define LF 0x0a
#define is_space(c) ((c) == ' ' || (c) == '\t' || (c) == '\r' || (c) == '\n')

/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */

typedef enum {MIME_QUOT,MIME_BASE64,MIME_SONST,MIME_UUE} MIME_TYP;
typedef enum { noErr, lineToShort, illCharInLine } decodeErrType;
typedef enum { DTunknown,DTencWordQ,DTencWordB,DTcontent } decodeType;

/* -------------------------------------------------------------------- */
/*		Globale Variablen												*/
/* -------------------------------------------------------------------- */

LOCAL decodeErrType decodeErr;
_UBYTE *decodeBlk=NULL,*decodePtr;
LOCAL _BOOL checkLastLine;
LOCAL decodeType Dtype;
_UBYTE Euro=0xEC;
_WORD CP1252Mode=0;	/*DYJ 5.37b */
extern unsigned int *locale2UnicTab;	/*DYJ 5.36a */
_BOOL ReplaceEuro=TRUE;

KEYT *Keyt=NULL;
LOCAL _LONG DecFilter;

LOCAL _UBYTE DecCharsetName[30];
/*DYJ 5.17k */
_UBYTE cMIME_Iso[][15]={"WINDOWS-1252","ISO-8859-1","ISO-8859-2","ISO-8859-3","ISO-8859-4","ISO-8859-5",
/*DYJ 5.34n Start*/
			"ISO-8859-6","ISO-8859-7","ISO-8859-8","ISO-8859-9","ISO-8859-15","utf-8","WINDOWS-1250",
			"US-ASCII",""};
/*DYJ  Ende; alt:	
			"ISO-8859-6","ISO-8859-7","ISO-8859-8","ISO-8859-9","ISO-8859-15","utf-8","WINDOWS-1250"};
*/
/*DYJ 5.30a Start*/
_UBYTE cnMIME_Iso[][15]={"WINDOWS1252","ISO88591","ISO88592","ISO88593","ISO88594","ISO88595",
			"ISO88596","ISO88597","ISO88598","ISO88599","ISO885915","utf8","WINDOWS1250"};
/*DYJ  Ende; */

		/* Zur Wandlung vom Atari-ZS nach ISO-8859-1 dies ist die Umkehrung von iso_8859_1_tab*/
LOCAL _UBYTE atari_tab[256] ={
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, /* 0 - 7 */
	0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, /* 8 - F */
	0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, /* 10 - 17 */
	0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F, /* 18 - 1F */
	0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, /* 20 - 27 */
	0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F, /* 28 - 2F */
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, /* 30 - 37 */
	0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, /* 38 - 3F */
	0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, /* 40 - 47 */
	0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, /* 48 - 4F */
	0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, /* 50 - 57 */
	0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F, /* 58 - 5F */
	0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, /* 60 - 67 */
	0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, /* 68 - 6F */
	0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, /* 70 - 77 */
	0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F, /* 78 - 7F */
	0xC7, 0xFC, 0xE9, 0xE2, 0xE4, 0xE0, 0xE5, 0xE7, /* 80 - 87 */
	0xEA, 0xEB, 0xE8, 0xEF, 0xEE, 0xEC, 0xC4, 0xC5, /* 88 - 8F */
	0xC9, 0xE6, 0xC6, 0xF4, 0xF6, 0xF2, 0xFB, 0xF9, /* 90 - 97 */
	0xFF, 0xD6, 0xDC, 0xA2, 0xA3, 0xA5, 0xDF, 0x83, /* 98 - 9F */
	0xE1, 0xED, 0xF3, 0xFA, 0xF1, 0xD1, 0xAA, 0xBA, /* A0 - A7 */
	0xBF, 0x9A, 0xAC, 0xBD, 0xBC, 0xA1, 0xAB, 0xBB, /* A8 - AF */
	0xE3, 0xF5, 0xD8, 0xF8, 0x9C, 0x8C, 0xC0, 0xC3, /* B0 - B7 */
	0xD5, 0xA8, 0xB4, 0x86, 0xB6, 0xA9, 0xAE, 0x99, /* B8 - BF */
	0x9F, 0x8E, 0x88, 0x91, 0x92, 0x9E, 0x89, 0x8B, /* C0 - C7 */
	0x9B, 0x81, 0x8D, 0x8F, 0x90, 0xC1, 0xC2, 0xCB, /* C8 - CF */
	0x98, 0xCD, 0xCE, 0xD3, 0xD4, 0xDA, 0xA0, 0xAD, /* D0 - D7 */
	0xC8, 0xCA, 0xCC, 0xCF, 0xD0, 0xA7, 0x96, 0x97, /* D8 - DF */
	0xD7, 0xD9, 0xB8, 0xB9, 0xBE, 0xD2, 0xB5, 0xDB, /* E0 - E7 */
	0x82, 0xDD, 0xDE, 0xF0, 0x80, 0xFD, 0xFE, 0x8A, /* E8 - EF */
	0x93, 0xB1, 0x94, 0x84, 0x87, 0x85, 0xF7, 0xA4, /* F0 - F7 */
/*DYJ 5.34n Start*/
	0xB0, 0x95, 0xB7, 0xA6, 0x9D, 0xB2, 0xB3, 0xAF /* F8 - FF */
/*DYJ  Ende; alt:	
	0xB0, 0xA6, 0x95, 0xB7, 0x9D, 0xB2, 0xB3, 0xAF /* F8 - FF */
*/
};
/*DYJ 5.34m Start*/
		/* Zur Wandlung vom Atari-ZS nach ISO-8859-15 dies ist die Umkehrung von iso_8859_15_tab*/
LOCAL _UBYTE atari_tab15[256] ={
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, /* 0 - 7 */
	0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, /* 8 - F */
	0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, /* 10 - 17 */
	0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F, /* 18 - 1F */
	0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, /* 20 - 27 */
	0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F, /* 28 - 2F */
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, /* 30 - 37 */
	0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, /* 38 - 3F */
	0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, /* 40 - 47 */
	0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, /* 48 - 4F */
	0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, /* 50 - 57 */
	0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F, /* 58 - 5F */
	0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, /* 60 - 67 */
	0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, /* 68 - 6F */
	0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, /* 70 - 77 */
	0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F, /* 78 - 7F */
	0xC7, 0xFC, 0xE9, 0xE2, 0xE4, 0xE0, 0xE5, 0xE7, /* 80 - 87 */
	0xEA, 0xEB, 0xE8, 0xEF, 0xEE, 0xEC, 0xC4, 0xC5, /* 88 - 8F */
	0xC9, 0xE6, 0xC6, 0xF4, 0xF6, 0xF2, 0xFB, 0xF9, /* 90 - 97 */
	0xFF, 0xD6, 0xDC, 0xA2, 0xA3, 0xA5, 0xDF, 0x83, /* 98 - 9F */
	0xE1, 0xED, 0xF3, 0xFA, 0xF1, 0xD1, 0xAA, 0xBA, /* A0 - A7 */
	0xBF, 0xA8, 0xAC, 0x8E, 0x80, 0xA1, 0xAB, 0xBB, /* A8 - AF */
	0xE3, 0xF5, 0xD8, 0xF8, 0xBD, 0xBC, 0xC0, 0xC3, /* B0 - B7 */
	0xD5, 0x9E, 0x9F, 0x86, 0xB6, 0xA9, 0xAE, 0x99, /* B8 - BF */
	0xBE, 0xB4, 0x88, 0x91, 0x92, 0xB8, 0x89, 0x8B, /* C0 - C7 */
	0x9B, 0x81, 0x8D, 0x8F, 0x90, 0xC1, 0xC2, 0xCB, /* C8 - CF */
	0x98, 0xCD, 0xCE, 0xD3, 0xD4, 0xDA, 0xA0, 0xAD, /* D0 - D7 */
	0xC8, 0xCA, 0xCC, 0xCF, 0xD0, 0xA7, 0x96, 0x97, /* D8 - DF */
	0xD7, 0xD9, 0x8C, 0xB9, 0x9A, 0xD2, 0xB5, 0xDB, /* E0 - E7 */
	0x82, 0xDD, 0xDE, 0xF0, 0xA4, 0xFD, 0xFE, 0x9C, /* E8 - EF */
	0x93, 0xB1, 0x94, 0x84, 0x87, 0x85, 0xF7, 0x9D, /* F0 - F7 */
/*DYJ 5.34n Start*/
	0xB0, 0x95, 0xB7, 0x8A, 0x9D, 0xB2, 0xB3, 0xAF  /* F8 - FF */
/*DYJ  Ende; alt:	
	0xB0, 0x8A, 0x95, 0xb7, 0x9D, 0xB2, 0xB3, 0xAF  /* F8 - FF */
*/
};
/*DYJ  Ende; */


/*ATARI*/
/* Es fehlen:$F9*/
/*39o einige Eintrge auf Anregung von Martin Elssser gendert*/
unsigned int atari2UnicTab[]={
	0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, /* 0 - 7 */
	0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, /* 8 - F */
	0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, /* 10 - 17 */
	0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F, /* 18 - 1F */
	0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, /* 20 - 27 */
	0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F, /* 28 - 2F */
	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, /* 30 - 37 */
	0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, /* 38 - 3F */
	0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, /* 40 - 47 */
	0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, /* 48 - 4F */
	0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, /* 50 - 57 */
	0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F, /* 58 - 5F */
	0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, /* 60 - 67 */
	0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, /* 68 - 6F */
	0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, /* 70 - 77 */
	0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F, /* 78 - 7F */
	0x00C7, 0x00FC, 0x00E9, 0x00E2, 0x00E4, 0x00E0, 0x00E5, 0x00E7, /* $80 - $87 */
	0x00EA, 0x00EB, 0x00E8, 0x00EF, 0x00EE, 0x00EC, 0x00C4, 0x00C5, /* $88 - $8F */
	0x00C9, 0x00E6, 0x00C6, 0x00F4, 0x00F6, 0x00F2, 0x00FB, 0x00F9, /* $90 - $97 */
	0x00FF, 0x00D6, 0x00DC, 0x00A2, 0x00A3, 0x00A5, 0x00DF, 0x0192, /* $98 - $9F */
	0x00E1, 0x00ED, 0x00F3, 0x00FA, 0x00F1, 0x00D1, 0x00AA, 0x00BA, /* $A0 - $A7 */
	0x00BF, 0x2310, 0x00AC, 0x00BD, 0x00BC, 0x00A1, 0x00AB, 0x00BB, /* $A8 - $AF */
	0x00E3, 0x00F5, 0x00D8, 0x00F8, 0x0153, 0x0152, 0x00C0, 0x00C3, /* $B0 - $B7 */
	0x00D5, 0x00A8, 0x00B4, 0x2020, 0x00B6, 0x00A9, 0x00AE, 0x2122, /* $B8 - $BF */
	0x0133, 0x0132, 0x05D0, 0x05D1, 0x05D2, 0x05DA, 0x05D4, 0x05D3, /* $C0 - $C7 */
	0x05D6, 0x05D7, 0x05D8, 0x05D9, 0x05DB, 0x05DC, 0x05DE, 0x05E0, /* $C8 - $CF */
	0x05DD, 0x05E2, 0x05E4, 0x05E6, 0x05E7, 0x05E8, 0x05E9, 0x05EA, /* $D0 - $D7 */
	0x05DF, 0x05DA, 0x05DD, 0x05E3, 0x05E5, 0x00A7, 0x2227, 0x221E, /* $D8 - $DF */
	0x03B1, 0x03B2, 0x0393, 0x03C0, 0x03A3, 0x03C3, 0x038C, 0x03C4, /* $E0 - $E7 */
	0x03A6, 0x0398, 0x03A9, 0x0384, 0x20AC, 0x03D5, 0x2208, 0x2229, /* $E8 - $EF EC:Euro Original:0x222E */
	0x2261, 0x00B1, 0x2265, 0x2264, 0x2320, 0x2321, 0x00F7, 0x2248, /* $F0 - $F7 */
/*DYJ 5.34n Start*/
	0x00B0, 0x2022, 0x00b7, 0x221a, 0x207F, 0x00B2, 0x00B3, 0x00AF  /* $F8 - $FF */
/*DYJ  Ende; alt:	
	0x00B0, 0x2022, 0x00b7, 0x221a, 0x207F, 0x00B2, 0x00B3, 0x00AF  /* $F8 - $FF */
*/
};
/*DYJ 5.32f Start*/
unsigned int koi8_r2UnicTab[]={
	0x0000,0x0001,0x0002,0x0003,0x0004,0x0005,0x0006,0x0007, /* 00 - 07 */
	0x0008,0x0009,0x000A,0x000B,0x000C,0x000D,0x000E,0x000F, /* 08 - 0F */
	0x0010,0x0011,0x0012,0x0013,0x0014,0x0015,0x0016,0x0017, /* 10 - 17 */
	0x0018,0x0019,0x001A,0x001B,0x001C,0x001D,0x001E,0x001F, /* 18 - 1F */
	0x0020,0x0021,0x0022,0x0023,0x0024,0x0025,0x0026,0x0027, /* 20 - 27 */
	0x0028,0x0029,0x002A,0x002B,0x002C,0x002D,0x002E,0x002F, /* 28 - 2F */
	0x0030,0x0031,0x0032,0x0033,0x0034,0x0035,0x0036,0x0037, /* 30 - 37 */
	0x0038,0x0039,0x003A,0x003B,0x003C,0x003D,0x003E,0x003F, /* 38 - 3F */
	0x0040,0x0041,0x0042,0x0043,0x0044,0x0045,0x0046,0x0047, /* 40 - 47 */
	0x0048,0x0049,0x004A,0x004B,0x004C,0x004D,0x004E,0x004F, /* 48 - 4F */
	0x0050,0x0051,0x0052,0x0053,0x0054,0x0055,0x0056,0x0057, /* 50 - 57 */
	0x0058,0x0059,0x005A,0x005B,0x005C,0x005D,0x005E,0x005F, /* 58 - 5F */
	0x0060,0x0061,0x0062,0x0063,0x0064,0x0065,0x0066,0x0067, /* 60 - 67 */
	0x0068,0x0069,0x006A,0x006B,0x006C,0x006D,0x006E,0x006F, /* 68 - 6F */
	0x0070,0x0071,0x0072,0x0073,0x0074,0x0075,0x0076,0x0077, /* 70 - 77 */
	0x0078,0x0079,0x007A,0x007B,0x007C,0x007D,0x007E,0x007F, /* 78 - 7F */
	0x2500,0x2502,0x250C,0x2510,0x2514,0x2518,0x251C,0x2524, /* 80 - 87 */
	0x252C,0x2534,0x253C,0x2580,0x2584,0x2588,0x258C,0x2590, /* 88 - 8F */
	0x2591,0x2592,0x2593,0x2320,0x25A0,0x2219,0x221A,0x2248, /* 90 - 97 */
	0x2264,0x2265,0x00A0,0x2321,0x00B0,0x00B2,0x00B7,0x00F7, /* 98 - 9F */
	0x2550,0x2551,0x2552,0x0451,0x2553,0x2554,0x2555,0x2556, /* a0 - a7 */
	0x2557,0x2558,0x2559,0x255A,0x255B,0x255C,0x255D,0x255E, /* a8 - aF */
	0x255F,0x2560,0x2561,0x0401,0x2562,0x2563,0x2564,0x2565, /* b0 - b7 */
	0x2566,0x2567,0x2568,0x2569,0x256A,0x256B,0x256C,0x00A9, /* b8 - bF */
	0x044E,0x0430,0x0431,0x0446,0x0434,0x0435,0x0444,0x0433, /* c0 - c7 */
	0x0445,0x0438,0x0439,0x043A,0x043B,0x043C,0x043D,0x043E, /* c8 - cF */
	0x043F,0x044F,0x0440,0x0441,0x0442,0x0443,0x0436,0x0432, /* d0 - d7 */
	0x044C,0x044B,0x0437,0x0448,0x044D,0x0449,0x0447,0x044A, /* d8 - dF */
	0x042E,0x0410,0x0411,0x0426,0x0414,0x0415,0x0424,0x0413, /* e0 - e7 */
	0x0425,0x0418,0x0419,0x041A,0x041B,0x041C,0x041D,0x041E, /* e8 - eF */
	0x041F,0x042F,0x0420,0x0421,0x0422,0x0423,0x0416,0x0412, /* f0 - f7 */
	0x042C,0x042B,0x0417,0x0428,0x042D,0x0429,0x0427,0x042A};/* f8 - fF */

/*DYJ  Ende; */

/* -------------------------------------------------------------------- */
/* 		lokale Funktionsprototypen										*/
/* -------------------------------------------------------------------- */
extern MimeCodeB64(_UBYTE *ziel,_UBYTE *quell,_LONG len,_BOOL uue);

/* -------------------------------------------------------------------- */
/*		Funktionen														*/
/* -------------------------------------------------------------------- */
/*DYJ 5.20f */	/*DYJ 5.21k */
GLOBAL _VOID Mime_AnhangOrdner(_UBYTE *pfad,_WORD jahr,_WORD monat,_WORD mode)
{
	_UBYTE subDir[PATH_MAX];
	
	strCpy(pfad,AttachmentPath);
	if(mode>0 && mode<4)
	{
		_UBYTE format[][6]={"%d","%d_%s","%d\\%s"};
		_UBYTE monatsname[][4]={"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
		sprintf(subDir,format[mode-1],jahr,monatsname[monat-1]);
		F_Path_Append(pfad,subDir);
	}
	else if(mode>3 && mode<6)
	{
		_UBYTE format[][12]={"%d_%02d.%s","%d\\%02d_%s"};
		_UBYTE monatsname[][4]={"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"};
		sprintf(subDir,format[mode-4],jahr,monat,monatsname[monat-1]);
		F_Path_Append(pfad,subDir);
	}
	else if(mode>5 && mode<8)
	{
		_UBYTE format[][12]={"%d_%02d.%s","%d\\%02d_%s"};
		_UBYTE monatsname[][4]={"jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec"};
		sprintf(subDir,format[mode-6],jahr,monat,monatsname[monat-1]);
		F_Path_Append(pfad,subDir);
	}
}


/*** ------------------------------------------------------------------------ ***/
/*	_BOOL Mime_AnhangPfad(_UBYTE *pfad,_UBYTE *string,PtrRecord *toData,_UBYTE *name,_WORD multiType)*/
/*	Ermittelt den Pfad fr einen Anhang, auerdem wird der String ermittelt		*/
/*	der an itemAttachment eingefgt werden soll									*/
/*	Parameter:	pfad:		hierher kommt der Pfad								*/
/*				string:		und der String fr itemAttachment					*/
/*				toData:		die zugehrige Nachricht							*/
/*				name:		und ggf der Name aus der Mime-Zeile					*/
/*				multiType	Welche Art von multipart							*/
/*	Ergebnis:	erfolgreich?													*/
/*	9.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ  5.11a */	/*DYJ 5.20l */	/*DYJ 5.20r */	/*DYJ 5.20zd */
GLOBAL _BOOL Mime_AnhangPfad(_UBYTE *pfad,_UBYTE *string,PtrRecord *toData,_UBYTE *name,_WORD multiType)
{
	_WORD val,tMode,maxFilelen=PATH_MAX,i;
	_BOOL valB,gefunden=FALSE;
	_UBYTE fName[PATH_MAX],ofName[FILENAME_MAX],ofExt[FILENAME_MAX],*ptr,*endePfad;
	_WORD jahr,monat;
	
	ConfVars_GetConfDefInt(cAttachTMode,&val,0);
	sscanf(toData->pEZeit,"%4d%2d",&jahr,&monat);
	if(toData->pEZeitX && *toData->pEZeitX)
		jahr=atoi(toData->pEZeitX);
	if(jahr<1900)
		jahr+=1990;
	Mime_AnhangOrdner(pfad,jahr,monat, val);
	if(!CatFiles_FolderExist(pfad))
		F_Path_Create(pfad);
	endePfad=strChr(pfad,'\0');
	ConfVars_GetConfDefBool(cUseTosNames,&valB,FALSE);
	if(valB)
		tMode=DP_DOSTRUNC;
	else
		tMode=F_Path_TruncMode(pfad);
	ConfVars_GetConfDefBool(cAttachOName,&valB,TRUE);
	if((toData->whatsThere&bAttachment)==0)	/* vor dem 1. noch die Modi*/
		sprintf(string,"0/%d:",val);
	else
		*string='\0';
	if(tMode==DP_DOSTRUNC)	/*ggf auf 8.3 krzen, ungltige Zeichen konv. und tar.gz ->tgz	*/
	{
		F_Path_DoTrunc(name,ofName,ofExt);
		maxFilelen=8;
	}
	else
	{
		F_Path_Copy(ofName,name);	/*	den bergebenen Namen in Name und Endung auftrennen*/
		ptr=strChr(ofName,'.');
		if(ptr)
		{
			strCpy(ofExt,ptr);
			*ptr='\0';
		}
		if(tMode==DP_NOTRUNC)
			maxFilelen=F_Path_MaxFlen(pfad)-(_WORD)strLen(ofExt);
	}
	if(!*ofName)	/*nur Extension*/
	{
		if(multiType==fMultipartA)
			strCpy(ofName,"alt");
/*DYJ 5.36h Start*/
		else if(multiType==fMultipartE)
			strCpy(ofName,"enc");
/*DYJ  Ende; */
		else if(multiType==fMultipartS)
			strCpy(ofName,"sig");
		else
			strCpy(ofName,"anh");
	}
	if(valB && *ofName)
	{	
		/*	1.Versuch Originalname ggf auf 8.3 gekrzt */
		strCpy(fName,ofName);
		strCat(fName,ofExt);
		maxFilelen=Min(PATH_MAX-(_WORD)(strLen(pfad)+strLen(ofExt))-2,maxFilelen);
		F_Path_Append(pfad,fName);
		if(!CatFiles_Exists(pfad))
			gefunden=TRUE;
		else
		{
		/*	2.Versuch Originalname mit angehngter Zahl*/
/*DYJ 5.32g Start*/
			char tag;
			tag=Tgetdate()&31;
			if(tag>9)
				tag+='a'-10;
			else
				tag+='0';
/*DYJ  Ende; */
			i=1;
			do
			{
				*endePfad='\0';
/*DYJ 5.32g Start*/
				sprintf(fName,"%s_%c%d%s",ofName,tag,i,ofExt);
/*DYJ  Ende; alt:	
				sprintf(fName,"%s_%d%s",ofName,i,ofExt);
*/
				if(strLen(fName)>maxFilelen)
					break;
				F_Path_Append(pfad,fName);
				if(!CatFiles_Exists(pfad))
					gefunden=TRUE;
				i++;
			}while(!gefunden);
		}
	}
	if(!gefunden)
	{
		/*	3.Versuch ein chaotischer zeitabhngiger String, beginnt mit 'C' oder 'D'*/
		_LONG d,z;
		d=Tgetdate()+0x88000l;		/* Damit der String mit c oder d beginnt aber nur 4 Zeichen lang ist*/
		ltoa(d,fName,36);
					
		for(z=Tgettime()*32l;z>0l;z--)	/*irgendwas mu doch frei sein*/
		{
			ltoa(z,fName+4,36);
			strCat(fName,ofExt);
			*endePfad='\0';
			F_Path_Append(pfad,fName);
			if(!CatFiles_Exists(pfad))
			{
				gefunden=TRUE;
				break;
			}
		}
	}
	if(gefunden)
	{	
		VaProto_Quote(strChr(string,'\0'),PATH_MAX-3,fName,DO_QUOTE);
		if(strCmp(fName,name))
		{
			_UBYTE *pkt;
			strCat(string," =");
			
			if(*name=='.')	/*nur Extension*/
			{
				if(multiType==fMultipartM)
					sprintf(ofName,"anhang_%d%s",toData->mAttachment.anzZeilen+1,ofExt);	/*laufende Nummer +ext*/
				else if(multiType==fMultipartA)
					sprintf(ofName,"alternativ_%d%s",toData->mAttachment.anzZeilen+1,ofExt);	/*laufende Nummer +ext*/
				else if(multiType==fMultipartS)
					sprintf(ofName,"sig_%d%s",toData->mAttachment.anzZeilen+1,ofExt);	/*laufende Nummer +ext*/
/*DYJ 5.36h Start*/
				else if(multiType==fMultipartE)
					sprintf(ofName,"enc_%d%s",toData->mAttachment.anzZeilen+1,ofExt);	/*laufende Nummer +ext*/
/*DYJ  Ende; */
				else
					sprintf(ofName,"%d%s",toData->mAttachment.anzZeilen+1,ofExt);	/*laufende Nummer +ext*/
				VaProto_Quote(strChr(string,'\0'),PATH_MAX-strLen(string),ofName,DO_QUOTE);
			}
			else
			{
				pkt=strrChr(fName,'.');
				if(pkt)
				{
					*pkt='\0';
					ptr=strrChr(fName,'_');
					if(ptr)
					{
						*ptr='.';
						strCpy(ptr+1,pkt+1);
					}
				}
				if(strCmp(fName,name))
					VaProto_Quote(strChr(string,'\0'),PATH_MAX-strLen(string),name,DO_QUOTE);
			}
		}
	}
	return gefunden;
}
/*** ------------------------------------------------------------------------ ***/
/*	_LONG Mime_getKeytabNr(_UBYTE *name,_BOOL immer,_BOOL import)				*/
/*	Ermittelt die Filternummer fr Keytab										*/
/*	Parameter:	name:	Fremder Zeichensatz										*/
/*				immer:	immer Keytab oder nur wenn Keytab bevorzugt?			*/
/*				import:	Im- oder Exportfilter									*/
/*	Ergebnis:	Filternummer oder 												*/
/*				FILTER_NONE:	kein Keytab oder unbekannter Zeichensatz		*/
/*				FILTER_NO_PREF_KT: nicht bevorzugt und immer=FALSE				*/		
/*	7.1.02 von Dimitri Junker	DYJ 4.34d										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.32f Start*/
GLOBAL _LONG Mime_getKeytabNr(_UBYTE *name,_BOOL immer,_BOOL import)
/*DYJ  Ende; alt:	
LOCAL _LONG getKeytabNr(_UBYTE *name,_BOOL immer,_BOOL import)
*/
{
	static _BOOL first=TRUE,prefKeytab=FALSE;
	_LONG ret=FILTER_NONE;
	if(first)
	{
		_WORD useKeytab;
		ConfVars_GetConfDefInt(cUseKeytab,&useKeytab,1);
		if(useKeytab && FindCookie("KEYT",(_LONG*)&Keyt))
		{
			if(Keyt->magic!='KEYT' ||Keyt->size<84)
				Keyt=NULL;
			else
				prefKeytab=useKeytab==2;
		}
		else
			Keyt=NULL;
		first=FALSE;
	}
	if(Keyt && (prefKeytab||immer))
	{
		if(import)
		   ret=(_UWORD)Keyt->GetImpNrFromName(name)|FILTER_KEYT;
		else
		   ret=(_UWORD)Keyt->GetExpNrFromName(name)|FILTER_KEYT_EXP;
		 if((ret&0xffff)==0)
		 	ret=FILTER_NONE;
	}
	else if(Keyt)
		ret=FILTER_NO_PREF_KT;
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *Mime_ParseAnhStr(_UBYTE *string,_UBYTE *sName,_UBYTE *oName,_LONG *filterNr)	*/
/*	Analysiert einen String der Form "Z1:Name1 =Name2 ;Z2:Name3 =Name4"			*/
/*	Wobei Name2(4) nicht vorhanden sein mssen, die Namen knnen gequoted sein	*/
/*	Parameter:	string:		der zu analysierende String							*/
/*				oName:		jeweilige Name hinter dem '=', oben also Name2		*/
/*				sName:		jeweilige Name vor dem '=', oben also Name1			*/
/*				filterNr:	Rckgabe:Exportfilter zum Wandeln in O-Zeichnsatz	*/
/* Achtung oName und sName mssen [PATH_MAX]sein!								*/
/*	Ist oName wird nur Initialisiert, es wird der Anfang des 1. Teilstcks 		*/
/*	zurckgegeben. string mu dann der Anfang von attachment sein				*/
/*	Ergebnis:	Ptr auf den nchsten Teilstring, oben also Name3, oder auf		*/
/*				das Stringende													*/
/*	18.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.17k */
GLOBAL _UBYTE *Mime_ParseAnhStr(_UBYTE *string,_UBYTE *sName,_UBYTE *oName,_LONG *filterNr)
{
	_UBYTE *pkt,*ptr,keytab[20];
	_WORD len;
	if(!oName)
	{
		ptr=strChr(string,':');
		if(ptr)
			ptr++;
		return ptr;
	}
	if(string[1]==':')
	{
		switch(string[0])
		{
			case 'C':
				*filterNr=WINDOWS1250+FILTER_EXP;
				break;
			case 'F':
				*filterNr=ISO8859_15+FILTER_EXP;
				break;
			case 'W':
				*filterNr=WINDOWS1252+FILTER_EXP;
				break;
			case 'U':
				*filterNr=UTF_8+FILTER_EXP;
				break;
			case 'R':
				*filterNr=FILTER_RELATED;
				break;
			case 'K':
				strBcpy(keytab,string+4);
				len=string[3]-'0';
				keytab[len]='\0';
				string+=len+3;
/*DYJ 5.32f Start*/
				*filterNr=Mime_getKeytabNr(keytab,TRUE,FALSE);
/*DYJ  Ende; alt:	
				*filterNr=getKeytabNr(keytab,TRUE,FALSE);
*/
				if(*filterNr==FILTER_NONE)
					*filterNr=Mime_FindFilt(keytab,FALSE);
			default:
				if(string[0]>'0' && string[0] <= '9')
					*filterNr=string[0]-'0'+FILTER_EXP;
				else
					*filterNr=FILTER_NONE;
		}
		string+=2;
	}
	else
		*filterNr=FILTER_NONE;
	string+=VaProto_UnQuote(sName,sizeof(nameStrType),string);
	if(*string==' ')
		string++;
	if(*string=='=')
	{
		string++;
		string+=VaProto_UnQuote(oName,sizeof(nameStrType),string);
		if(!oName[0])
		{
			strCpy(oName,sName);
			pkt=strrChr(oName,'.');
			if(pkt)
			{
				*pkt='\0';
				ptr=strrChr(oName,'_');
				if(ptr)
				{
					*ptr='.';
					strCpy(ptr+1,pkt+1);
				}
			}
		}
	}
	else
		strCpy(oName,sName);
	if(*string==' ')
		string++;
	if(*string==';')
		string++;
	return string;
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *getValue(const _UBYTE *str,const _UBYTE *varName)					*/
/*	Ermittelt den Wert z.B. von name=xyz										*/
/*	Parameter:	str:	der String in dem gesucht werden soll					*/
/*				varName:der name der Variable die gesucht werden soll			*/
/*	Ergebnis:	der Wert oder NULL												*/		
/*	9.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19l */	/*DYJ 5.20w */
LOCAL _UBYTE *getValue(const _UBYTE *str,const _UBYTE *varName,_UBYTE *saveChar)
{
	_UBYTE *ret=NULL,*ptr=NULL;
	size_t len;
	*saveChar='\0';
	if(str)
		ptr=(_UBYTE *)strCaseStr(str,varName);
	if(ptr)
		ptr=strChr(ptr,'=');
	if(ptr)
	{
		ptr+=strSpn(ptr+1," ");	/*DYJ 5.35k */
		ret=strChr(ptr,'\"');
		if(ret && (_ULONG)ret-(_ULONG)ptr<4)
		{
			ret++;
			ptr=strChr(ret,'\"');
			if(ptr)
			{
				*saveChar=*ptr;
				*ptr='\0';
			}
		}
		else
		{
			if(!strnCaseCmp(ptr,"=3d",3))
				ret=ptr+3;
			else
				ret=ptr+1;
			len=strcSpn(ret," \t");
			*saveChar=ret[len];
			ret[len]='\0';
		}
	}
	return ret;
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID CheckMemLine(_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)			*/
/*	durchsucht den Speicher bis zum CR/LF										*/
/*	Die gleiche Routine wie in Parser.c											*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID CheckMemLine(_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)
{
	_UBYTE _HUGE *p;
	_ULONG count;
	
	count = *pCount;
	p = oPtr + count;
	while (count < oAnz && *p != LF)
	{
		count++;
		p++;
	}
	if (count < oAnz && *p == LF)
		count++;
	*pCount = count;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID CpyMemLineUnfold(String1023 ziel,_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)	*/
/*	Kopiert eine Internet-Infile Zeile und beseitigt das Folding				*/
/*	Dabei darf die Zeile bereits durch CheckMemLineUnfSpl verndert worden sein	*/
/*	Als Zeilenendekennung werden \r\n oder \0\n verstanden, wobei auch mehrere 	*/
/*	\0 OK sind, also z.B. \0\0\n das eigentliche Zeilenende ist also das \n, 	*/
/*	\r wird bersprungen und \0 am String-Ende stren ja sowieso nicht.			*/
/*	Parameter:	ziel:	na was wohl												*/
/*				pCount:	Position												*/
/*				oPtr:	der ganze Block											*/
/*				oAnz:	und seine Lnge											*/
/*	Ergebnis:	keines															*/		
/*  10.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID CpyMemLineUnfold(String1023 ziel,_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)
{
	_UBYTE _HUGE *p,*z;
	_ULONG count;
	
	count = *pCount;
	p = oPtr + count;
	z=ziel;
	oAnz=LMin(oAnz,count+sizeof(String1023));	/*Stimmt nicht ganz, aber schneller und sicherer*/
	do
	{
		if(*p==LF)
		{
/*DYJ 5.30m Start*/
			if((p[1]!=' '&&p[1]!='\t')|| z==ziel)
/*DYJ  Ende; alt:	
			if(p[1]!=' '&&p[1]!='\t')
*/
				break;
		}
		else if(*p!=CR)
			*(z++)=*p;
		count++;
		p++;
	}
	while (count < oAnz );
		
	*z='\0';
	if (count < oAnz && *p == LF)
		count++;
	*pCount = count;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID getExtFromTyp(_UBYTE *ext,_UBYTE *cont)								*/
/*	Ermittelt aus dem Mime-Typ eine sinnvolle Endung fr das File, ntig wenn	*/
/*	kein Filename angegeben ist. Dazu habe ich aus:								*/
/*	http://fsinfo.cs.uni-sb.de/~abe/apache-tips/mime.types etwas ber 200 		*/
/*	Zuordnungen ermittelt (mime_typ.h), weitere knnen ber Config-Variablen	*/
/*	definiert werden, diese haben Vorrang, ist alles erfolglos wird txt benutzt	*/
/*	Parameter:	ext:	dahin soll die Endung (mit '.') 	PATH_MAX			*/
/*				cont:	der Inhalt der Content-Types Zeile						*/
/*	Ergebnis:	keines															*/		
/*	12.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
LOCAL _VOID getExtFromTyp(_UBYTE *ext,_UBYTE *cont)
{
	_UBYTE varname[512],*type,saveChar,*ptr;
	_WORD anz,i;
	size_t len;
	type=strChr(cont,':');
	if(type)
		type+=strSpn(type," \t:");
	len=strcSpn(type," \t;");
	saveChar=type[len];
	type[len]='\0';
	strMcpy(varname, sizeof(varname), cMimeTyp);
	strMcat(varname, sizeof(varname), type);
	if(!ConfVars_GetConfigString(varname,ext,PATH_MAX))
	{
		strCpy(ext,".txt");	/*default*/
		anz=(_WORD)(sizeof(MimeTypes)/sizeof(MimeTypes[0]));
		for(i=0;i<anz;i+=2)
		{
			if(!strCaseCmp(MimeTypes[i],type))
			{
				strCpy(ext,MimeTypes[i+1]);
				ptr=strChr(ext+1,'.');
				if(ptr)
					*ptr='\0';
				break;
			}
		}
	}
	else if(*ext!='.')
	{
		strBcpy(varname,ext);
		*ext='.';
		strMcpy(ext+1,PATH_MAX-1,varname);
	}
	type[len]=saveChar;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD getTypFromExt(_UBYTE *typ,_UBYTE *name)								*/
/*	Ermittelt aus der Fileendung den Mime-Typ.Es wird das gleiche File wie oben	*/
/*	benutzt. Weitere Zuordnungen knnen ber Config-Variablen definiert werden, */
/*	diese haben Vorrang, ist alles erfolglos wird application/octet-stream		*/
/*	benutzt	auerdem wird zrckgegeben ob dieser Typ als quoted-printablle oder */
/*	base64 versendet werden soll												*/
/*	Parameter:	typ:	dahin soll der Typ										*/
/*				name:	der Filename											*/
/*				charset:Name des Zeichensatzes fr text							*/
/*	Ergebnis:	welche Kodierung												*/		
/*	12.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _WORD getTypFromExt(_UBYTE *typ,_UBYTE *name,_UBYTE *charset)
{
	_UBYTE varname[512],ext[10]=".",*ptr;
	_WORD anz,i,ret=MIME_BASE64;
	ptr=strrChr(name,'.');
	if(ptr)
		strCpy(ext,ptr);
	strMcpy(varname, sizeof(varname), cMimeExt);
	strMcat(varname, sizeof(varname), ext);
	if(!ConfVars_GetConfigString(varname,typ,PATH_MAX))
	{
		strCpy(typ,"application/octet-stream");	/*default*/
		strCat(ext,".");
		anz=(_WORD)(sizeof(MimeTypes)/sizeof(MimeTypes[0]));
		for(i=0;i<anz;i+=2)
		{
			if(strCaseStr(MimeTypes[i+1],ext))
			{
				strCpy(typ,MimeTypes[i]);
				break;
			}
		}
	}
	if(strnCaseCmp(typ,"text/",5)==0)
	{
		strCat(typ,"; charset=");
		strCat(typ,charset);
		ret=MIME_QUOT;
	}
	return ret;
	
}
/*** ------------------------------------------------------------------------ ***/
/*	size_t Mime_unQuote(_UBYTE *ziel,_UBYTE *quell, size_t len,_WORD mode)		*/
/*	Entfernt das Quoting und ggf CR												*/
/*	Parameter:	ziel:	der gewandelte String, darf =quell sein					*/
/*				quell:	der zu wandelnde String									*/
/*				len:	seine Lnge												*/
/*				mode:	QUOTE_PR_NORM: nur das normale Quoting					*/
/*						QUOTE_PR_MAIL: zustzlich CRLF nach LF wandeln			*/
/*						QUOTE_PR_WORD: zustzlich '_' nach ' ' wandeln			*/
/*	Ergebnis:	die neue Lnge													*/
/*	25.10.01 von Dimitri Junker	DYJ 4.30n										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
GLOBAL size_t Mime_unQuote(_UBYTE *ziel,_UBYTE *quell, _LONG len,_WORD mode)
{
	size_t newLen=0l,anzWsp;
	_WORD val;
	if (len)
	{
		do
		{
			switch(*quell)
			{
				case '=':
					if(quell[1]>='0')
					{
						sscanf(quell+1,"%2x",&val);
						ziel[newLen++] = val;
						quell+=3;
						len-=2;
					}
					else
					{
						if(quell[1]=='\r'&& quell[2]=='\n')
						{
							quell+=3;
							len-=2;
						}
						else if(quell[1]=='\n')
						{
							quell+=2;
							len-=1;
						}
						else
							quell++;
					}
					break;
				case '\r':
					if(mode!=QUOTE_PR_MAIL || quell[1]!='\n')
						ziel[newLen++] = *quell;
					quell++;
					break;
				case '_':
					if(mode==QUOTE_PR_WORD)
						ziel[newLen++] =' ';
					else
						ziel[newLen++] = *quell;
					quell++;
					break;
				case ' ':		/*keine Whitespaces am Zeilenende!*/
				case '\t':
					anzWsp=strSpn(quell," \t");
					if(quell[anzWsp]=='\r')
					{
						quell+=anzWsp;
						len-=anzWsp-1;
						break;
					}
				default:
					ziel[newLen++] = *(quell++);
			}
		} while ((--len)>0);
	}
	return newLen;
}
/*** ------------------------------------------------------------------------ ***/
/*	size_t elimCR(_UBYTE *str, size_t len)										*/
/*	ersetzt CRLF durch LF														*/
/*	Parameter:	str:	der zu wandelnde String									*/
/*				len:	seine Lnge												*/
/*				elimCR:	soll CRLF nach LF gewandelt werden?						*/
/*	Ergebnis:	die neue Lnge													*/
/*	25.10.01 von Dimitri Junker	DYJ 4.30n										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL size_t elimCR(_UBYTE *str, size_t len)
{
	size_t newLen=0l,i;
	for(i=0;i<len;i++)
	{
		if(str[i]!='\r' || str[i+1]!='\n')
			str[newLen++] = str[i];
	}
	return newLen;
}
		

/*** ------------------------------------------------------------------------ ***/
/*	_LONG Mime_FindFilt(_UBYTE *name,_BOOL forImport)							*/
/*	Ermittelt den Filter zum Wandeln fr den Im- oder Export 					*/
/*	Parameter:	name:	fremder Zeichensatz										*/
/*				forImport:	fr Im- oder Export									*/
/*	Ergebnis:	Filternummer													*/		
/*	7.1.02 von Dimitri Junker	DYJ 4.34d										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _LONG Mime_FindFilt(_UBYTE *name,_BOOL forImport)
{
	_LONG ret,i;
	_LONG isDef=0l;
	if(!name || !*name)
	{
		name=cMIME_Iso[ISO8859_1];
		isDef=FILTER_DEFAULT;
	}
/*DYJ 5.32f Start*/
	ret=Mime_getKeytabNr(name,FALSE,forImport);
/*DYJ  Ende; alt:	
	ret=getKeytabNr(name,FALSE,forImport);
*/
	if((ret&0xffff)==0)
/*DYJ 5.30a Start*/
	{
	
		_UBYTE name_nor[100];
		strBcpy(name_nor,name);
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor)," ","");
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor),"-","");
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor),"Latin","8859");
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor),"Codepage","Windows");
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor),"CP","Windows");
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor),"WindowsWindows","Windows");
		CatGlobal_ReplaceStr(name_nor,sizeof(name_nor),"WindowsANSI","Windows1252");
/*DYJ 5.31b Start*/
		if(!strnCaseCmp(name_nor,"ISO8859",7))
/*DYJ  Ende; alt:	
		if(!strnCaseCmp(name,"ISO8859",7))
*/
		{
			if(forImport)
				ret=ISO8859_1;
			else
				ret=ISO8859_1+FILTER_EXP;
		}
		for(i=0;i<MIME_ANZ_FONTS;i++)
		{
/*DYJ 5.31b Start*/
			if(!strCaseCmp(name_nor,cnMIME_Iso[i]))
/*DYJ  Ende; alt:	
			if(!strCaseCmp(name,cnMIME_Iso[i]))
*/
			{
				ret=i;
				if(!forImport)
					ret+=FILTER_EXP;
				break;
			}
		}

		if(ret==FILTER_NO_PREF_KT)
/*DYJ 5.32f Start*/
			ret=Mime_getKeytabNr(name,TRUE,forImport);
/*DYJ  Ende; alt:	
			ret=getKeytabNr(name,TRUE,forImport);
*/
	}
/*DYJ  Ende; alt:	
	{
		for(i=0;i<MIME_ANZ_FONTS;i++)
		{
			if(!strCaseCmp(name,cMIME_Iso[i]))
			{
				ret=i;
				if(!forImport)
					ret+=FILTER_EXP;
				break;
			}
			if(!strnCaseCmp(name,"ISO-8859",8))
			{
				if(forImport)
					ret=ISO8859_1;
				else
					ret=ISO8859_1+FILTER_EXP;
			}
		}
		if(ret==FILTER_NO_PREF_KT)
			ret=getKeytabNr(name,TRUE,forImport);
	}
*/
	return ret|isDef;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL saveMime(_UBYTE *partAddr,_ULONG partLen,PtrRecord *toData,_BOOL kompl,_WORD multiType)*/
/*	Speichert einen Mime-Block ab												*/
/*	Parameter:	partAddr:	Blockanfang											*/
/*				partLen:	Blocklnge											*/
/*				toData:		die zugehrige Mail oder NULL beim Blockfiltern		*/
/*				kompl:		Anhang komplett? Oder gesplittetet MausMail			*/
/*				multiType	Welche Art von multipart							*/
/*	Ergebnis:	erfolgreich?													*/		
/*	9.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.17k */
/*DYJ 5.18b */	/*DYJ 5.19n */	/*DYJ 5.21b */	/*DYJ 5.20w */	/*DYJ 5.20s */	/*DYJ 5.20p */
/*DYJ 5.20o */	/*DYJ 5.23j */	/*DYJ 5.20i */	/*DYJ 5.29e */	/*DYJ 5.20o */

LOCAL _BOOL saveMime(_UBYTE *partAddr,_ULONG partLen,PtrRecord *toData,_BOOL kompl,_WORD multiType)
{
	F_ERROR error=NoError;
	_BOOL ok=TRUE;
	_BOOL isRelFile=FALSE;
	_BOOL isTextPlain=FALSE;
	String1023 relID="";
	_WORD multiTypeS;
	_UBYTE name[PATH_MAX]="",*ptr,saveChar;
	String1023 zeile;
	_ULONG old,count=0L;
	_BOOL done=FALSE,isMailTxt=FALSE,skip;
	MIME_TYP mTyp=MIME_SONST;
	_LONG filter=FILTER_NONE;
	_BOOL hasContType=FALSE,isRFC822=FALSE;
	if(!partLen)
		return TRUE;
	do
	{
		old = count;
		CpyMemLineUnfold(zeile,&count, partAddr, partLen);
		if(!strnCaseCmp(zeile,"CONTENT",7))
		{
			skip=FALSE;
			if(!strnCaseCmp(zeile+7,"-TYPE",5))
			{
				hasContType=TRUE;
				if(!name[0])
				{
					ptr=getValue(zeile,"name",&saveChar);
					if(ptr)
					{
						char *ptr2;
						ptr2=strrChr(ptr,'\\');
						if(ptr2)
							ptr=ptr2+1;
						strCpy(name,ptr);
						Mime_DecodeWord(name);
						*strChr(ptr,'\0')=saveChar;
					}
				}
				isTextPlain=strCaseStr(zeile,"text/plain")!=NULL;
				isRFC822=strCaseStr(zeile,"message/rfc822")!=NULL;
				if(!ptr && isTextPlain && toData && (toData->prFlags&fText)==0)	/*DYJ 5.34g */
					isMailTxt=TRUE;
				else if((multiTypeS=Mime_multiType(zeile))>-1)
				{
					count=old+Mime_SplitMultipart(partAddr+old,partLen-old,toData,multiTypeS,&ok);
					done=TRUE;
				}
				else if(!name[0])	/*Aus Typ zumindest die Endung ermitteln		*/
					getExtFromTyp(name,zeile);
				ptr=getValue(zeile,"charset",&saveChar);
				filter=Mime_FindFilt(ptr,TRUE);
				if(ptr)
					*strChr(ptr,'\0')=saveChar;
			}
			else if(!strnCaseCmp(zeile+7,"-Disposition",12))
			{
				ptr=getValue(zeile,"filename",&saveChar);
				if(ptr)
				{
					char *ptr2;
					ptr2=strrChr(ptr,'\\');
					if(ptr2)
						ptr=ptr2+1;
					strCpy(name,ptr);
					Mime_DecodeWord(name);
					*strChr(ptr,'\0')=saveChar;
				}
			}
			else if(!strnCaseCmp(zeile+7,"-Transfer-Encoding",18))
			{
				if(strCaseStr(zeile,"base64"))
					mTyp=MIME_BASE64;
				else if(strCaseStr(zeile,"quoted-printable"))
				{
					mTyp=MIME_QUOT;
					skip=TRUE;		/* nach dem unquoten stimmt's ja nicht mehr*/
				}
				
			}
			else if(!strnCaseCmp(zeile+7,"-Cat-RELFILE",12))
				isRelFile=TRUE;
			else if(!strnCaseCmp(zeile+7,"-ID",3) && toData->relatedFN>0)
			{
				_UBYTE *ptr;
				ptr=strChr(zeile,'<');
				if(ptr)
					strBcpy(relID,ptr);
				else
				{
					ptr=strChr(relID,' ');
					if(!ptr)
						ptr=zeile+12;
					strBcpy(relID,ptr);
					*ptr='<';
					strCat(relID,">");
				}
					
				while((ptr=strChr(relID,'%'))!=NULL)
				{
					_WORD val;
					sscanf(ptr+1,"%2x",&val);
					*ptr=(_UBYTE)val;
					Delete(ptr,1,2);
				}
			}
			if(isMailTxt && !skip)
			{
				strCpy(partAddr+old,zeile);		/*ich will es ohne folding*/
				Mime_AddToMultLines(&toData->mMime,partAddr+old,toData->prFlags&fmMime);	/*DYJ 5.34g */
				toData->prFlags |= fmMime;	/*DYJ 5.34g */
			}
		}
		else if((!*zeile))
			break;
	}while(!done);
	if(!hasContType)
	{
		isTextPlain=TRUE;
		if(toData && (toData->prFlags&fText)==0)	/*DYJ 5.34g */
			isMailTxt=TRUE;
	}
	if(!done)
	{
		_UBYTE *addr;
		long len;
		if(!*name)
			strCpy(name,".dat");
		if(kompl)
		{
			addr=partAddr+count;
			len=partLen-count;
		}
		else
		{
			addr=partAddr;
			len=partLen;
			mTyp=MIME_SONST;
			ptr=strrChr(name,'.');
			if(!ptr)
				ptr=strChr(name,'\0');
			strCpy(ptr,".mim");
		}
		switch(mTyp)
		{
			_UBYTE *sCopy=NULL;
			FILE *sFile=NULL;
			size_t sCopLen;
			case MIME_QUOT:
				len=Mime_unQuote(addr,addr, len,isMailTxt?QUOTE_PR_MAIL:QUOTE_PR_NORM);
				break;
			case MIME_BASE64:
				if(toData)
				{
					sCopy=MALLOC(len,"saveMime: sCopy");
					if(sCopy)
						memcpy(sCopy,addr,len);
					else
					{
						sFile=tmpfile();
						if(sFile)
							fwrite(addr,1,len,sFile);
					}
					sCopLen=len;
				}	
				len=Mime_DecodeB64(addr,len);
				if(toData)
				{
					if(len<0)
					{
						len=partLen;
						if(sCopy)
							memcpy(addr,sCopy,sCopLen);
						else if(sFile)
						{
							fseek(sFile,0,SEEK_SET);
							fread(addr,1,sCopLen,sFile);
						}
						else
							len=-1;
						addr=partAddr;
						mTyp=MIME_SONST;
						ptr=strrChr(name,'.');
						if(!ptr)
							ptr=strChr(name,'\0');
						strCpy(ptr,".mim");
					}
					if(sCopy)
						SFREE(sCopy);
					else
						fclose(sFile);
				}
				if(len>-1 || !toData)
					break;

			case MIME_SONST:
				if(isMailTxt)
					len=elimCR(addr,len);
		}
		if(isMailTxt)
		{
			toData->pText=addr;
			toData->TextMax=(mess_len)len;
			toData->prFlags|=fText;	/*DYJ 5.34g */
		}
		else
		{
			_UBYTE pfad[PATH_MAX],string[PATH_MAX];
			FILENO anhFn;

			error=notAllWritten;
			if(!len)
				error=NoError;		/* Irgendwie leer, aber kein erkennbarer Fehler	bzw Datenverlust*/
			else if (len>0)
			{
				if(!toData)
				{
					_UBYTE suff[PATH_MAX],basName[PATH_MAX];
					mtDir_SplitPath(name, pfad, basName, suff);
					if (suff[0] != '\0')
						Insert("*.", suff, sizeof(suff), 0);
					else
						strBcpy(suff, "*.*");
					if (mtDir_FselGet(pfad, basName, suff, Rsc_WrkString(FS_SAVE_BLK), FALSE))
						F_Path_Append(pfad, basName);
					else
					{
						len=0;
						error=NotFound;
					}

				}
				else
				{
					if(isRFC822 && strStr(name,".822")==NULL)
						strCat(name,".822");
					if(!Mime_AnhangPfad(pfad,string,toData,name,multiType))
					{
						len=0;
						error=NotFound;
					}
					else if(*relID)
					{
						strBcat(relID,"\t");
						strBcat(relID,pfad);
						strBcat(relID,"\r\n");
						error = CatFiles_WriteMuch(strLen(relID), toData->relatedFN,relID);
					}

				}
			}
			if((filter&FILTER_DEFAULT)>0)
			{
				if(isTextPlain)
					filter&=~FILTER_DEFAULT;
				else
					filter=FILTER_NONE;
			}
			if(len)
			{
				if(filter!=FILTER_NONE && !isMailTxt && kompl)
					len=Mime_WandleIso(addr,addr,len,filter,QUOTE_PR_NONE);
				anhFn=CatFiles_OpenFile(pfad,CatFiles_writeFile);
				if (anhFn >= 0)
				{
					if(isRelFile)
					{
						_UBYTE txt[]=";Hilfsdatei fr CAT\r\n;bersetzung <content-ID>\tFilename\r\n;und #Anhang-Nr:Position:ID-Lnge\r\n";
						toData->relatedFN=anhFn;
						error = CatFiles_WriteMuch(strLen(txt), toData->relatedFN,txt);
						error=NoError;
					}
					else
					{
						error = CatFiles_WriteMuch(len, anhFn,addr);
						CatFiles_CloseFile(anhFn);
					}
				}
			}

			if(toData)	/*Attachment-String nicht irgendwohin wo Platz ist*/
			{
				_WORD skip=0;
				_UBYTE zsStr[20]="0:";
				if((toData->whatsThere&bAttachment)==0)
				{
					strMcpy(zeile,5,string);			/* Das 0/M:	*/
					skip=4;
				}
				else
					zeile[0]='\0';
				if(kompl&&filter<FILTER_KEYT)
				{
					switch((_WORD)filter)
					{
						case WINDOWS1252:
							strCat(zeile,"W:");
							break;
						case ISO8859_15:
							strCat(zeile,"F:");
							break;
						case UTF_8:
							strCat(zeile,"U:");
							break;
						case WINDOWS1250:
							strCat(partAddr,"C:");
							break;
						case ISO8859_1:
						case ISO8859_2:
						case ISO8859_3:
						case ISO8859_4:
						case ISO8859_5:
						case ISO8859_6:
						case ISO8859_7:
						case ISO8859_8:
						case ISO8859_9:
							*zsStr=filter+'0';
							strCat(zeile,zsStr);
							break;
						default:
							sprintf(strChr(partAddr,'\0'),"?(%d):",(_WORD)filter);
							break;
					}
				}
				else if(kompl && filter!=FILTER_NONE)
				{
					sprintf(zsStr,"K:( %s)",Keyt->GetImpShortNameFromNr((_WORD)filter));
					zsStr[3]=(_UBYTE)strLen(zsStr)-5+'0';
					strCat(zeile,zsStr);
				}
				else if(!kompl)
					strCat(zeile,"M:");
				else if(isRelFile)
					strCat(zeile,"R:");
				strCat(zeile,string+skip);

				ptr=Mime_GetMem4Record(toData,strLen(zeile)+1);
				if(ptr)
					strCpy(ptr,zeile);
				Mime_AddToMultLines(&toData->mAttachment,ptr,toData->whatsThere&bAttachment);
				toData->whatsThere|=bAttachment;
			}

			if (!batchProcess)
			{
				switch(error)
				{
					case NotFound:
						MTE_info(Rsc_WrkString(MTE_AttNoFound));
						break;
					case notAllWritten:
						MTE_info(Rsc_WrkString(MTE_AttNoSave));
					case NoError:
						break;
				}
			}
		}
	}
	return ok && (error==NoError);
}



/*** ------------------------------------------------------------------------ ***/
/*	_ULONG Mime_SplitMultipart(_UBYTE *startAddr,_ULONG partLen,PtrRecord *toData,_WORD multiType)	*/
/*	Teitl eine multipart Mail auf und speichert die einzelnen Teile				*/
/*	Parameter:	startAddr:	dort fngt alles an									*/
/*				laenge:		und so lang ist es									*/
/*				toData:		die zugehrige Mail oder NULL beim Blockfiltern		*/
/*				multiType	Welche Art von multipart							*/
/*	Ergebnis:	die Anzahl verarbeiteter Bytes									*/		
/*	9.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
GLOBAL _ULONG Mime_SplitMultipart(_UBYTE *startAddr,_ULONG laenge,PtrRecord *toData,_WORD multiType,_BOOL *ok)
{
	_UBYTE *bndId=NULL,leer='\0',saveChar;
	_ULONG old,lenId=0l,start=0l,count=0l;
	_BOOL weiter=TRUE,endId=FALSE;
	_BOOL closeRel=FALSE;
	_BOOL isSplit=FALSE;
	if(toData &&(toData->whatsThere&bMId)!=0)
	{
		_UBYTE *dp;
		if((dp=strrChr(toData->pMId,':'))!=NULL)
		{
			if(strSpn(dp+1," 1234567890")==strLen(dp+1))
				isSplit=TRUE;
		}
	}
	if(multiType==fMultipartR && !FILENO_OK(toData->relatedFN))
	{
		_UBYTE dummy[]="Content-Type: text/cat-related; name=\"related.txt\"\nContent-Cat-RELFILE\n\n";
		*ok&=saveMime(dummy,sizeof(dummy),toData,TRUE,multiType)!=NoError;
		closeRel=*ok;
	}
/*DYJ 5.33b Start*/
	if(multiType==fMultipart1)
	{
		*ok&=saveMime(startAddr,laenge,toData,TRUE,multiType)!=NoError;
		count=laenge;
	}
	else
	{
/*DYJ  Ende; */
		bndId=getValue(startAddr,"BOUNDARY",&saveChar);
		if(bndId)
			lenId=strLen(bndId);
		else
			bndId=&leer;
		do
		{
			endId=FALSE;
			do
			{
				old   = count;
				CheckMemLine(&count, startAddr, laenge); /* Zeile auslesen           */
				if(startAddr[old]=='-' && startAddr[old+1]=='-' &&
					strChr("\n\r \t-",startAddr[old+lenId+2]) &&
					strnCmp(&startAddr[old+2],bndId,lenId)==0)
				{
					endId=TRUE;
					break;
				}
			}while(count<laenge);
			if(!endId)
				old   = count;
			else if(startAddr[old+lenId+2]=='-' && startAddr[old+lenId+3]=='-')
				weiter=FALSE;
			if(start)
				*ok&=saveMime(startAddr+start,old-start,toData,endId,multiType)!=NoError;
			else if(isSplit)
				*ok&=saveMime(startAddr,old,toData,FALSE,multiType)!=NoError;
		start=count;
		}while(count<laenge && weiter);
		if(closeRel)
		{
			CatFiles_CloseFile(toData->relatedFN);
			toData->relatedFN=-2;						/* Markiert fr die Hauptroutine, da cid angepat werden mssen*/
		}
	}	/*DYJ 5.33b */
	return count;
}

/*** ------------------------------------------------------------------------ ***/
/*	_BOOL Mime_AddToMultLines(MultiLines *ml,_UBYTE *adr,stringTypes set)		*/
/*	Fgt eine Zeile zur MULTILINE Struktur hinzu								*/
/*	Parameter:	ml:		die Struktur											*/
/*				adr:	die neue Zeile											*/
/*				set:	0 wenn noch leer										*/
/*	Ergebnis:	Erfolgreich?													*/		
/*	2.3.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL Mime_AddToMultLines(MultiLines *ml,_UBYTE *adr,stringTypes set)
{
	_UBYTE **tmp;
	if(!set)
	{
		ml->adr = SYSMALLOC(100*sizeof(_UBYTE *), MEM_SHARABLE|MEM_NOERR, "Mime_AddToMultLines: MultLines");
		if(!ml->adr)
			return FALSE;
		ml->maxZeilen=100;
		ml->anzZeilen=0;
	}
	else if(ml->maxZeilen<=ml->anzZeilen)
	{
		tmp = SYSMALLOC((ml->maxZeilen+100)*sizeof(_UBYTE *), MEM_SHARABLE|MEM_NOERR, "Mime_AddToMultLines: MultLines");
		if(!tmp)
			return FALSE;
		memcpy(tmp,ml->adr,ml->maxZeilen*sizeof(_UBYTE *));
		SYSFREE(ml->adr,ml->maxZeilen*sizeof(_UBYTE *));
		ml->maxZeilen+=100;
		ml->adr =tmp;
	}
	ml->adr[ml->anzZeilen++]=adr;
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID *Mime_GetMem4Record(PtrRecord *mess,_ULONG len)				*/
/*	Reserviert Speicher und fgt diesen in die Liste des am Ende freizugebenden	*/
/*	Speicher in der	PtrRecord Struktur ein.										*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	23.7.02 von Dimitri Junker	DYJ 4.41e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID *Mime_GetMem4Record(PtrRecord *mess,_ULONG len)
{
	VERK_BLK *ptr;
	ptr = SYSMALLOC(sizeof(VERK_BLK)+len, MEM_SHARABLE|MEM_NOERR, "Mime_GetMem4Record");
	if(ptr)
	{
		ptr->nxt=mess->tmpMem;
		mess->tmpMem=ptr;
	}
	return &(ptr->data);
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_FreeMultilines(PtrRecord *mess)										*/
/*	gibt die Multilines wieder frei												*/
/*	Parameter:	mess:	die Nachricht											*/
/*	Ergebnis:	keines															*/		
/*	18.11.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.00a */
GLOBAL _VOID Mime_FreeMultilines(PtrRecord *mess)
{
	VERK_BLK *nxt,*akt;
	if(mess->mKeyW.adr)
		SFREE(mess->mKeyW.adr);
	if(mess->mResent.adr)
		SFREE(mess->mResent.adr);
	if(mess->mTrace.adr)
		SFREE(mess->mTrace.adr);
	if(mess->mReceived.adr)
		SFREE(mess->mReceived.adr);
	if(mess->mMime.adr)
		SFREE(mess->mMime.adr);
	if(mess->mAttachment.adr)
		SFREE(mess->mAttachment.adr);
	if(mess->mUnknown.adr)
		SFREE(mess->mUnknown.adr);
	nxt=mess->tmpMem;
	while(nxt)
	{
		akt=nxt;
		nxt=akt->nxt;
		SFREE(akt);
	}
		
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD undoUtf8(_WORD val)													*/
/*	dekodiert die UTF-8 Kodierung (.s RFC2279)	und wandelt es in den Atari-	*/
/*	Systemzeichensatz, da der keine Zeichen mit einem Unicode >0x2fff enthlt	*/
/*	kann etwas vereinfacht werden.												*/
/*	Parameter:	val:	ein Byte des Datenstroms	oder -1 zur Initialisierung	*/
/*	Ergebnis:	falls mit dem Byte die Kodierung eines Zeichens abgeschlossen	*/
/*				wurde wird das entsprechende Atari Zeichen (0-255) zurck 		*/
/*				gegeben. Wenn noch weitere Bytes bentigt werden -1 			*/		
/*	1.12.01 von Dimitri Junker	DYJ 4.30n										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _WORD undoUtf8(_WORD val)
{
	_WORD i,ret=-1;
	static _WORD unicode=0,rest=0;
	static _BOOL unbekannt=FALSE;
	if(val<0)		/*INIT*/
	{
		unicode=rest=0;
		unbekannt=FALSE;
		return 0;
	}
	switch(val&0xf0)
	{
		case 0x80:	/*Folgebyte*/
		case 0x90:
		case 0xA0:
		case 0xB0:
			unicode|=(val&0x3f);
			if(!(--rest))
			{
				if(unicode<128)
					ret = unicode;
				else
				{
					val=0x3f;
					if(!unbekannt)
					{
						for(i=128;i<256;i++)
						{
							if(atari2UnicTab[i]==unicode)
							{
								val=i;
								break;
							}
						}
					}
					else
						unbekannt=FALSE;
					ret=val;
				}
				unicode=0;
			}
			else
				unicode<<=6;
			break;
		case 0xC0:	/*11bit*/
		case 0xD0:
			unicode=(val & 0x1f)<<6;
			rest=1;
			break;

		case 0xE0:	/*16bit*/
			unicode=(val & 0xf)<<6;
			rest=2;
			break;

		case 0xF0:	/* >=21bit, keine Zuordnung zu Atari-ZS*/
			unbekannt=TRUE;
			rest=(val&0xfC)/5-45;	/*F0->3  F8->4 FC->5*/
			break;
		default:	/*7Bit*/
			ret= val;
	}
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _LONG Mime_WandleIso(_UBYTE *ziel, _LONG zLen,_UBYTE *quell, _LONG len,_LONG filter,_WORD mode)	*/
/*	Wandelt den String von ISO-8859-1 u.. nach ST-Zeichensatz um oder umgekehrt*/
/*	war frher als 	WandleIso in assfuncs.c										*/
/*	beseitigt aber jetzt zustzlich auf Wunsch das Quoting						*/
/*	Achtung: UTF-8 kann nicht zeilenweise dekodiert werden						*/
/*	Zeichenstze >FILTER_KEYT sollen mit Keytab dekodiert werden				*/
/*	Parameter:	ziel:	der gewandelte String, darf =quell sein					*/
/*				quell:	der zu wandelnde String									*/
/*				len:	seine Lnge												*/
/*				filter: zu verwendender Zeichensatzfilter						*/
/*				mode:	QUOTE_PR_NORM: nur das normale Quoting					*/
/*						QUOTE_PR_NONE: kein Quoting								*/
/*						QUOTE_PR_WORD: zustzlich '_' nach ' ' wandeln			*/
/*	Ergebnis:	die neue Lnge, ist nur bei quoted Strings und UTF-8 verschieden*/
/*	25.10.01 von Dimitri Junker	DYJ 4.30n										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.17k */	/*DYJ 5.20w */	/*DYJ 5.21b */	/*DYJ 5.29h */
GLOBAL _LONG Mime_WandleIso(_UBYTE *ziel,_UBYTE *quell, _LONG len,_LONG filter,_WORD mode)
{
	CONST _UBYTE *tab;
	_WORD val;
	size_t anzWsp;
	_LONG newLen=0l;
	if(!len)
		return 0L;
	filter&=~FILTER_DEFAULT;
	if(filter<FILTER_KEYT)
	{
		if(filter==FILTER_EXP+ISO8859_1)
			tab=atari_tab;
		else
		{
			switch((_WORD)filter)
			{
				case ISO8859_1:
				case ISO8859_9:
					 tab= iso_8859_1_tab;
					 break;
				case ISO8859_2:
					 tab= iso_8859_2_tab;
					 break;
				case ISO8859_3:
					 tab= iso_8859_3_tab;
					 break;
				case ISO8859_4:
					 tab= iso_8859_4_tab;
					 break;
				case ISO8859_7:
					 tab= iso_8859_7_tab;
					 break;
				case ISO8859_8:
					 tab= iso_8859_8_tab;
					 break;
				case ISO8859_15:
					 tab= iso_8859_15_tab;
					 break;
				case WINDOWS1252:
					 tab= windows_tab;
					 break;
				case WINDOWS1250:
					 tab= cp_1250_tab;
					 break;
				case UTF_8:
					undoUtf8(-1);		/* initialisieren*/
					break;
			}
		}
		if(mode!=QUOTE_PR_NONE && filter==UTF_8)
		{
			do
			{
				switch(*quell)
				{
					case '=':
						if(quell[1]>='0')
						{
							sscanf(quell+1,"%2x",&val);
							val=undoUtf8(val);
							if(val>-1)
								ziel[newLen++] = val;
						}
						else if(quell[1]==' ' ||quell[1]=='\t')	/* Evtl. Weiches Zeilenende mit Whitspaces dazwischen = und CR*/
						{
							anzWsp=strSpn(quell+1," \t");
							if(quell[anzWsp+1]=='\r')
							{
								quell+=anzWsp;
								len-=anzWsp-1;
								break;
							}
						}
						quell+=3;	/* Weiches Zeilenende -> =\r\n berspringen*/
						len-=2;
						break;
					case '_':
						if(mode==QUOTE_PR_WORD)
							ziel[newLen++] =' ';
						else
							ziel[newLen++] = *quell;
						quell++;
						break;
					case ' ':		/*keine Whitespaces am Zeilenende!*/
					case '\t':
						anzWsp=strSpn(quell," \t");
						if(quell[anzWsp]=='\r')
						{
							quell+=anzWsp;
							len-=anzWsp-1;
							break;
						}
					default:
						val=undoUtf8(*(quell++));
						if(val>-1)
							ziel[newLen++] = val;
				}
			} while ((--len)>0);
		}	
		else if(mode!=QUOTE_PR_NONE)
		{
			do
			{
				switch(*quell)
				{
					case '=':
						if(quell[1]>='0')
						{
							sscanf(quell+1,"%2x",&val);
							ziel[newLen++] = tab[val];
						}
						else if(quell[1]==' ' ||quell[1]=='\t')	/* Evtl. Weiches Zeilenende mit Whitspaces dazwischen = und CR*/
						{
							anzWsp=strSpn(quell+1," \t");
							if(quell[anzWsp+1]=='\r')
							{
								quell+=anzWsp;
								len-=anzWsp-1;
								break;
							}
						}
						quell+=3;	/* Weiches Zeilenende -> =\r\n berspringen*/
						len-=2;
						break;
					case '_':
						if(mode==QUOTE_PR_WORD)
							ziel[newLen++] =' ';
						else
							ziel[newLen++] = *quell;
						quell++;
						break;
					case ' ':		/*keine Whitespaces am Zeilenende!*/
					case '\t':
						anzWsp=strSpn(quell," \t");
						if(quell[anzWsp]=='\r')
						{
							quell+=anzWsp;
							len-=anzWsp-1;
							break;
						}
					default:
						ziel[newLen++] = tab[*(quell++)];
				}
			} while ((--len)>0);
		}
		else if(filter==UTF_8)
		{
			do
			{
				val=undoUtf8(*(quell++));
				if(val>-1)
					ziel[newLen++] = val;
			} while (--len);
		}
		else
		{
			newLen=len;
			do
			{
				*ziel++ = tab[*(quell++)];
			} while (--len);
		}
	}
	else if(filter>=FILTER_NONE)
	{
		newLen=len;
		if(ziel!=quell)
			memcpy(ziel,quell,len);
	}
	else if(Keyt->size>=136 )	/*neues Keytab nutzen*/
	{
		if(filter!=FILTER_NONE)
		{
			if(filter<FILTER_KEYT_EXP)	/*Import*/
				(Keyt->BlockXUtf2XUtf)(NULL, &newLen, 0, quell, len, (_WORD)filter);
			else								/*Export*/
				(Keyt->BlockXUtf2XUtf)(NULL, &newLen, (_WORD)filter, quell, len, 0);
			
			/* Jetzt steht in newLen die bentigte Ziel-Lnge */
			/* Ggf. kann also Speicher alloziert werden...    */
			if(newLen<=len)
			{
				if(filter<FILTER_KEYT_EXP)	/*Import*/
					(Keyt->BlockXUtf2XUtf)(ziel, &newLen, 0, quell, len, (_WORD)filter);
				else								/*Export*/
					(Keyt->BlockXUtf2XUtf)(ziel, &newLen, (_WORD)filter, quell, len, 0);
			}
			else
			{
				mtAlerts_Alert(1, Rsc_WrkString(AL_2BIG));
				if(quell!=ziel)
					memcpy(ziel,quell,len);
			}
		}
	}
	else 		/*altes Keytab nutzen*/
	{
		newLen=len;
		if(mode!=QUOTE_PR_NONE)
			newLen=Mime_unQuote(ziel,quell,len,mode);
		else if(quell!=ziel)
			memcpy(ziel,quell,len);
		if(filter!=FILTER_NONE)
		{
			if(filter<FILTER_KEYT_EXP)	/*Import*/
				Keyt->BlockX2Atari((_WORD)filter, newLen,ziel);
			else					/*Export*/
				Keyt->BlockAtari2X((_WORD)filter, newLen,ziel);
		}
	}
	return newLen;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_DoUtf2File(TEXTFILENO zielF,_UBYTE *quell,_BOOL addSoftEOL,_UBYTE c)		*/
/*	Wie Mime_DoQP2File aber fr UTF-8 ohne Quoted-Printable											*/
/*	Parameter:	zielF:	das File in das geschrieben werden soll					*/
/*				quell:	der zu wandelnde String, Nullterminiert					*/
/*	Ergebnis:	keines															*/		
/*	13.3.04 von Dimitri Junker	DYJ 5.34m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID Mime_DoUtf2File(TEXTFILENO zielF,_UBYTE *quell)
{
	_WORD zeileLen=0,zeichen;
	_UBYTE zeile[100];
	while (*quell)
	{
		if(zeileLen>70)
		{
			zeile[zeileLen]='\0';
			mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
			zeileLen=0;
		}
		zeichen=atari2UnicTab[*(quell++)];

		if(zeichen<128)
			zeile[zeileLen++]  =(_UBYTE)zeichen;
		else if(zeichen<0x7ff)
		{
			zeile[zeileLen++] =(zeichen>>6)+0xc0;
			zeile[zeileLen++] =(zeichen&0x3f)+0x80;
		}
		else
		{
			zeile[zeileLen++] =(zeichen>>12)+0xe0;
			zeile[zeileLen++] =((zeichen>>6)&0x3f)+0x80;
			zeile[zeileLen++] =(zeichen & 0x3f)+0x80;
		}
	} 
	zeile[zeileLen] ='\0';
	mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_DoUtfQP2File(TEXTFILENO zielF,_UBYTE *quell,_BOOL addSoftEOL)	*/
/*	Wie Mime_DoQP2File aber fr UTF-8											*/
/*	Parameter:	zielF:	das File in das geschrieben werden soll					*/
/*				quell:	der zu wandelnde String, Nullterminiert					*/
/*				addSoftEOL:	weiches Zeilenende am Ende anhngen?				*/
/*	Ergebnis:	keines															*/		
/*	13.3.04 von Dimitri Junker	DYJ 5.34m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID Mime_DoUtfQP2File(TEXTFILENO zielF,_UBYTE *quell,_BOOL addSoftEOL)
{
	_WORD zeileLen=0,zeichen;
	_UBYTE zeile[100];
	_BOOL quote;
	while (*quell)
	{
		_UBYTE unic[3];
		_WORD unicodeLen,i;
		if(zeileLen>70)
		{
			sprintf(zeile+zeileLen,"=\r\n");
			mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
			zeileLen=0;
		}
		zeichen=atari2UnicTab[*(quell++)];

		if(zeichen<128)
		{
			unic[0] =(_UBYTE)zeichen;
			unicodeLen=1;
		}
		else if(zeichen<0x7ff)
		{
			unic[0] =(zeichen>>6)+0xc0;
			unic[1] =(zeichen&0x3f)+0x80;
			unicodeLen=2;
		}
		else
		{
			unic[0] =(zeichen>>12)+0xe0;
			unic[1] =((zeichen>>6)&0x3f)+0x80;
			unic[2] =(zeichen & 0x3f)+0x80;
			unicodeLen=3;
		}
		for(i=0;i<unicodeLen;i++)
		{
			if(unic[i]<32||unic[i]>126)
			{
				if(unic[i]=='\r' &&*quell=='\n')
				{
					zeile[zeileLen++] =unic[i];
					unic[i]='\n';
					quote=FALSE;
				}
				else
					quote=(unic[i]!='\t'|| *quell=='\r');
			}
			else
				quote=(unic[i]=='=' ||(unic[i]==' '&& *quell=='\r'));
			if(unic[i]=='.'  && !zeileLen)
				zeile[zeileLen++] =unic[i];
			if(quote)
			{
				sprintf(zeile+zeileLen,"=%02X",(_WORD)unic[i]);
				zeileLen+=3;
			}
			else
				zeile[zeileLen++] =unic[i];
		}
	} 
	if(addSoftEOL)
		sprintf(zeile+zeileLen,"=\r\n");
	else
		zeile[zeileLen] ='\0';
	mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_DoQP2File(TEXTFILENO zielF,_UBYTE *quell,_LONG zeichensatz)		*/
/*	Wandelt den String vom Atari-Systemzeichensatz nach iso-8859-1 oder -15 und	*/
/*	kodiert nach quoted-printable. Das Ergebnis wird in ein File geschrieben	*/
/*	Parameter:	zielF:	das File in das geschrieben werden soll					*/
/*				quell:	der zu wandelnde String, Nullterminiert					*/
/*				zeichensatz: Erlaubt sind ISO8859_1, ISO8859_15 und US_ASCII	*/
/*	Ergebnis:	keines															*/		
/*	21.3.04 von Dimitri Junker	DYJ 5.34m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID Mime_Do8B2File(TEXTFILENO zielF,_UBYTE *quell,_LONG zeichensatz)
{
	_WORD zeileLen=0;
	_UBYTE zeile[100];
	_UBYTE *tab;
	if(zeichensatz==ISO8859_15)
		tab=atari_tab15;
	else
		tab=atari_tab;
	while (*quell)
	{
		if(zeileLen>70)
		{
			zeile[zeileLen]='\0';
			zeileLen=0;
			mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
		}
		zeile[zeileLen++]=tab[*(quell++)];
	} 
	zeile[zeileLen] ='\0';
	mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_DoQP2File(TEXTFILENO zielF,_UBYTE *quell,_BOOL addSoftEOL,_LONG zeichensatz)		*/
/*	Wandelt den String vom Atari-Systemzeichensatz nach iso-8859-1 oder -15 und	*/
/*	kodiert nach quoted-printable. Das Ergebnis wird in ein File geschrieben	*/
/*	Parameter:	zielF:	das File in das geschrieben werden soll					*/
/*				quell:	der zu wandelnde String, Nullterminiert					*/
/*				addSoftEOL:	weiches Zeilenende am Ende anhngen?				*/
/*				zeichensatz: Erlaubt sind ISO8859_1, ISO8859_15 und US_ASCII	*/
/*	Ergebnis:	keines															*/		
/*	22.11.01 von Dimitri Junker	DYJ 4.30zh										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19o */
/*DYJ 5.34m Start*/
LOCAL _VOID Mime_DoQP2File(TEXTFILENO zielF,_UBYTE *quell,_BOOL addSoftEOL,_LONG zeichensatz)
{
	_WORD zeileLen=0;
	_UBYTE zeichen,zeile[100];
	_BOOL quote;
	_UBYTE *tab;
	if(zeichensatz==ISO8859_15)
		tab=atari_tab15;
	else
		tab=atari_tab;		/*Wird auch fr US-ASCII benutzt, da nur Zeichen <128 vorkommen sollten ist das OK*/
	while (*quell)
	{
		if(zeileLen>70)
		{
			sprintf(zeile+zeileLen,"=\r\n");
			zeileLen=0;
			mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
		}
		zeichen=tab[*(quell++)];
		if(zeichen<32||zeichen>126)
		{
			if(zeichen=='\r' &&*quell=='\n')
			{
				zeile[zeileLen++] =zeichen;
				zeichen=tab[*(quell++)];
				quote=FALSE;
			}
			else
				quote=(zeichen!='\t'|| *quell=='\r');
		}
		else
			quote=(zeichen=='=' ||(zeichen==' '&& *quell=='\r'));
		if(zeichen=='.'  && !zeileLen)
			zeile[zeileLen++] =zeichen;
		if(quote)
		{
			sprintf(zeile+zeileLen,"=%02X",(_WORD)zeichen);
			zeileLen+=3;
		}
		else
			zeile[zeileLen++] =zeichen;
	} 
	if(addSoftEOL)
		sprintf(zeile+zeileLen,"=\r\n");
	else
		zeile[zeileLen] ='\0';
	mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
}

/*DYJ  Ende; alt:	
LOCAL _VOID Mime_DoQP2File(TEXTFILENO zielF,_UBYTE *quell,_BOOL addSoftEOL)
{
	_WORD zeileLen=0;
	_UBYTE zeichen,zeile[100];
	_BOOL quote;
	while (*quell)
	{
		if(zeileLen>70)
		{
			sprintf(zeile+zeileLen,"=\r\n");
			zeileLen=0;
			mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
		}
		zeichen=atari_tab[*(quell++)];
		if(zeichen<32||zeichen>126)
		{
			if(zeichen=='\r' &&*quell=='\n')
			{
				zeile[zeileLen++] =zeichen;
				zeichen=atari_tab[*(quell++)];
				quote=FALSE;
			}
			else
				quote=(zeichen!='\t'|| *quell=='\r');
		}
		else
			quote=(zeichen=='=' ||(zeichen==' '&& *quell=='\r'));
		if(zeichen=='.'  && !zeileLen)
			zeile[zeileLen++] =zeichen;
		if(quote)
		{
			sprintf(zeile+zeileLen,"=%02X",(_WORD)zeichen);
			zeileLen+=3;
		}
		else
			zeile[zeileLen++] =zeichen;
	} 
	if(addSoftEOL)
		sprintf(zeile+zeileLen,"=\r\n");
	else
		zeile[zeileLen] ='\0';
	mtTextfiles_WriteLine(zielF,zeile);     /* Zeile ausgeben */
}
*/

/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *analyzeEncWord(_UBYTE *encWord)										*/
/*	Analysiert den Header eines encoded-word									*/
/*	Parameter:	encWord:	das 'Wort'											*/
/*	Ergebnis:	Ptr auf den Textinhalt											*/		
/*	20.11.01 von Dimitri Junker	DYJ 4.30ze										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
LOCAL _UBYTE *analyzeEncWord(_UBYTE *encWord)
{
	_UBYTE *charset,*encoding,*text;
	size_t len;
	DecFilter=FILTER_NONE;
	*DecCharsetName='\0';
	charset=encWord+2;
	encoding=strChr(charset,'?');
	if(!encoding)
		return NULL;
	encoding+=strcSpn(++encoding,"?bBqQ");
	if(*encoding=='b'|| *encoding=='B')
		Dtype=DTencWordB;
	else
		Dtype=DTencWordQ;
	text=strChr(encoding,'?');
	if(text)
	{
		text++;
		len=strcSpn(charset,"? \t");
		if(len<sizeof(DecCharsetName))
			strMcpy(DecCharsetName,len+1,charset);
		else
			strBcpy(DecCharsetName,charset);
		DecFilter=Mime_FindFilt(DecCharsetName,TRUE);
	}
	return text;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL Mime_DecodeWord(_UBYTE *encWord)										*/
/*	Decodiert Kram der Art:														*/
/*	encoded-word = "=?" charset "?" encoding "?" encoded-text "?="				*/
/*	z.B.:	Re: =?iso-8859-1?Q?M=FCrbeteigkuchen_backen=3A_wie=3F?=				*/
/*	Parameter:	encWord:	das zu dekodierende									*/
/*	Ergebnis:	wurde was gewandelt?											*/		
/*	15.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL Mime_DecodeWord(_UBYTE *encWord)
{
	_UBYTE *text,*rest,scopy[512];
	size_t len;
	text=analyzeEncWord(encWord);
	if(!text)
		return FALSE;
	rest=strStr(text,"?=");
	if(!rest)
		return FALSE;
	rest+=2;
	len=(size_t)rest-(size_t)text-2;
	strBcpy(scopy,text);
	if(Dtype==DTencWordB)	/*b64 kodiert*/
	{
		len=Mime_DecodeB64(text,len);
		if(len!=-1)
		{
			len=Mime_WandleIso(encWord, text, len,DecFilter,QUOTE_PR_NONE);
			strCpy(encWord+len,rest);
		}
		else
			strCpy(text,scopy);
	}
	else			/*quoted-printable*/
	{
		len=Mime_WandleIso(encWord, text, len,DecFilter,QUOTE_PR_WORD);
		strCpy(encWord+len,rest);
	}
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*						*/
/*								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/
/*	28.11.04 von Dimitri Junker	DYJ 5.39e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL Mime_DecodePuny(_UBYTE *encPuny)
{
	size_t lenAlt,lenNeu=100;
	punycode_uint output[100];
	lenAlt=strSpn(encPuny+4,"abcdefghijklmnopqrstuvwxyz0123456789-");
	if(punycode_decode(lenAlt,encPuny+4,&lenNeu,output,NULL)==punycode_success)
	{
		_WORD i;
		for(i=0;i<lenNeu;i++)
		{
			if(output[i]<256)
				*encPuny=output[i];
			else
				*encPuny='?';
			encPuny++;
		}
		strCpy(encPuny,encPuny+lenAlt-lenNeu+4);
		return TRUE;
	}
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE * Mime_CodeWord(_UBYTE *ziel,size_t len,_UBYTE *quell)				*/
/*	Kodiert, falls ntig einen String in etwas der Art:							*/
/*	encoded-word = "=?" charset "?" encoding "?" encoded-text "?="				*/
/*	z.B.:	Re: =?iso-8859-1?Q?M=FCrbeteigkuchen_backen=3A_wie=3F?=				*/
/*	Parameter:	ziel:	dahin mit dem Ergebnis									*/
/*				len:	max. Lnge												*/
/*				quell:	das zu kodierende (ohne Zeilenumbruch!!!				*/
/*	Ergebnis:	wenn kodiert wurde:ziel, sonst quell							*/		
/*	15.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.17e */
GLOBAL _UBYTE * Mime_CodeWord(_UBYTE *ziel,size_t len,_UBYTE *quell)
{
	size_t wordLen;
	_UBYTE zeichen,*ret,*start=NULL,*ende=NULL,merken;
	_BOOL quote=FALSE;
	ret=quell;	/* sichern*/
	/*Erst mal testen ob wir berhaupt quoten mssen*/
	while (*quell)
	{
		zeichen=atari_tab[*(quell++)];
		if(zeichen>126)
		{
			quote=TRUE;
			ende=quell-1;
			if(!start)
				start=ende;
		}
		else if(zeichen<32)
		{
			if(zeichen!='\r' && zeichen!='\n' &&zeichen!='\t')
			{
				quote=TRUE;
				ende=quell-1;
				if(!start)
					start=ende;
			}
		}
	} 
	if(quote)
	{
		/* 1. die Worte ohne Sonderzeichen kopieren*/
		while(start>ret && *start!=' ' && *start !='\t')	
			start--;
		if(*start==' ' || *start =='\t')
			start++;
		merken=*start;
		*start='\0';
		strMcpy(ziel,len,ret);
		*start=merken;

		/* 2. Die Worte mit Sonderzeichen quoten*/
		while(*ende && *ende!=' ' && *ende !='\t')	
			ende++;
		merken=*ende;
		*ende='\0';
		
		quell=start;
		len-=5;	/*sicher ist sicher*/
		strMcat(ziel,len,"=?iso-8859-1?Q?");
		wordLen=strLen(ziel);
		while (*quell && wordLen<len)
		{
			zeichen=atari_tab[*(quell++)];
			if(zeichen<32||zeichen>126)
				quote=(zeichen!='\t');
			else if(zeichen==' ')
			{
				zeichen='_';
				quote=FALSE;
			}
			else
				quote=(zeichen=='=' ||zeichen=='_');
			if(quote)
			{
				sprintf(ziel+wordLen,"=%02X",(_WORD)zeichen);
				wordLen+=3;
			}
			else
				ziel[wordLen++] =zeichen;
		}
		strCpy(ziel+wordLen,"?=");

		/*3. Die letzten Worte ohne Sonderzeichen anhngen*/
		*ende=merken;
		strMcat(ziel,len+5,ende);
		ret=ziel;
	}
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL Mime_BeginDecode(size_t len)											*/
/*	Initialisiert die Block-Dekodierung											*/
/*	Abgeleitet von: UUDecode_BeginDecode										*/
/*	Parameter:	len:	Lnge des Blocks, oder etwas mehr						*/
/*	Ergebnis:	OK?															*/		
/*	20.11.01 von Dimitri Junker	DYJ 4.30ze										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
GLOBAL _BOOL Mime_BeginDecode(size_t len)
{
	
	decodeBlk= MALLOC(len, "Mime_BeginDecode");
	if(!decodeBlk)
	{
		MTE_info(Rsc_WrkString(AL_ERRMEM));
		return(FALSE);
	}
	decodePtr=decodeBlk;
	decodeErr = noErr;
	checkLastLine = FALSE;
	Dtype=DTunknown;
	return(TRUE);
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL F_ERROR Mime_DecodeLine(_UBYTE *line)								*/
/*	speichert die Zeilen zwischen												*/
/*	Parameter:	line:	na...													*/
/*	Ergebnis:	Fehler?															*/		
/*	20.11.01 von Dimitri Junker	DYJ 4.30ze										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */	/*DYJ 5.20q */
GLOBAL F_ERROR Mime_DecodeLine(_UBYTE *line)
{
	_UBYTE *ptr;
	size_t len;
	
	if(Dtype==DTunknown)	/* Erstmal feststellen, was fuer ein Block es ist */
	{
		if(!strnCmp(line,"=?",2))
		{
			line=analyzeEncWord(line);
			decodePtr+=sprintf(decodePtr,"Content-Type: text/plain; charset=%s\r\n",DecCharsetName);
			if(Dtype==DTencWordQ)
				decodePtr+=sprintf(decodePtr,"Content-Transfer-Encoding: quoted-printable\r\n\r\n");
			else
				decodePtr+=sprintf(decodePtr,"Content-Transfer-Encoding: base64\r\n\r\n");
		}
		else if(!strnCaseCmp(line,"Content-",8))
			Dtype=DTcontent;
		else
		{
			MTE_info(Rsc_WrkString(MTE_NoMime));
			return(-1);
		}
	}
	len=strLen(line);
	if(Dtype!=DTcontent)
	{
		ptr=strStr(line,"?=");
		if(ptr)
			len=(_ULONG)ptr-(_ULONG)line;
	}
	decodePtr+=sprintf(decodePtr,"%*s\r\n",(_WORD)len,line);
	return GERR_OK;
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_EndDecode(_VOID)													*/
/*	die Hauptroutine zum Block-dekodieren										*/
/*	Parameter:	keine															*/
/*	hier wird der von der vorigen Routine zwischengespeicherte Teil dekodiert	*/
/*	Ergebnis:	keines															*/		
/*	20.11.01 von Dimitri Junker	DYJ 4.30ze										*/
/*** ------------------------------------------------------------------------ ***/
/* Beendet die Dekodierung, schliesst ggf. offene Dateien
 */
GLOBAL _VOID Mime_EndDecode(_VOID)
{
	size_t len;
	_UBYTE *ptr;
	
	len=(_ULONG)decodePtr-(_ULONG)decodeBlk;
	if(Dtype==DTencWordQ)
	{
		while((ptr=strChr(decodeBlk,'_'))!=NULL)
			*ptr=' ';
	}	
	saveMime(decodeBlk,len,NULL,TRUE,0);
	SFREE(decodeBlk);
	decodeBlk=NULL;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_TransferQP(TEXTFILENO InHandle, TEXTFILENO INFILE, _UBYTE c)			*/
/* 	War ursprnglich als Transfer in msginfil.c									*/
/*	c war nur ein Zeichen, welches an jedem Zeilenanfang eingefgt werden soll.	*/
/*	ich habe es zu einem Modus ausgebaut, mit folgenden Werten:					*/
/*	'\0' nichts einfgen														*/
/*	':'  ':' am Zeilenanfang einfgen	(Maus)									*/
/*	'.'  '.' am Zeilenanfang einfgen, wenn die Zeile mit einem '.' beginnt		*/
/*			 (SMTP  + NNTP). Auerdem Zeichensatz wandeln nach iso 8859-1		*/
/*	ist c!='\0' drfen jetzt auch TABs beibehalten werden, also im normalen Text*/
/*	Parameter:	InHandle:	Handel des Quellfiles								*/
/*				INFILE:		Handel des Zielfiles, meist Infile					*/
/*				c:			Modus s.o.											*/
/*				zeichensatz: Erlaubt sind ISO8859_1, ISO8859_15 und US_ASCII	*/
/*							oder UTF-8											*/
/*	Ergebnis:	keines															*/		
/*	23.11.01 von Dimitri Junker	DYJ 4.30zh										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20zg */
/*DYJ 5.34m Start*/
GLOBAL _VOID Mime_TransferQP(TEXTFILENO InHandle, TEXTFILENO INFILE, _UBYTE c,_WORD zeichensatz)
/*DYJ  Ende; alt:	
GLOBAL _VOID Mime_TransferQP(TEXTFILENO InHandle, TEXTFILENO INFILE, _UBYTE c)
*/
{
	_UBYTE ch;
	_BOOL newLine;
	_UBYTE str[2][4096],*toFile;
	_BOOL keepTabs=FALSE,isEOL;
	toFile=str[1];
	if(c)
	{
		ConfVars_GetConfDefBool(cUseTabsInMail,&keepTabs,TRUE);
		if(keepTabs)
			toFile=str[0];
	}
	
	newLine = TRUE;
	do
	{
/*DYJ 5.34m Start*/
		mtTextfiles_ReadLine(InHandle, str[0], sizeof(str[0]));
/*DYJ  Ende; alt:	
		mtTextfiles_ReadLine(InHandle, str[0], sizeof(str));
*/
		ch = mtTextfiles_ReadChar(InHandle);     /* Liest Ende-Zeichen der Zeile */
		if(!keepTabs)
			Str_ConvertTabs(str[0], toFile, sizeof(str[1]), UserBLK.TabSize);
		/* Blockschutz wie JellyCat */
		if (is_space(str[0][0]) && !newLine)
		{
			mtTextfiles_WriteLn(INFILE);
			newLine = TRUE;
		}
		
		if (newLine)
		{
			if(c==':' || (c=='.' && c==*toFile))
				mtTextfiles_WriteChar(INFILE, c);
			newLine = FALSE;
		}
		isEOL=(ch == CR || mtTextfiles_EndofText(InHandle) || !UserBLK.endlessLines);
/*DYJ 5.34m Start*/
		if(c=='.')	/* Internet-Infile*/
		{
			if(zeichensatz==UTF_8)
				Mime_DoUtfQP2File(INFILE,toFile,!isEOL);
			else
				Mime_DoQP2File(INFILE,toFile,!isEOL,zeichensatz);
		}
		else		/* Maus-Infile*/
		{
			if(zeichensatz==UTF_8)
				Mime_DoUtf2File(INFILE,toFile);
/*DYJ 5.39a Start*/
			else if(zeichensatz!=US_ASCII && zeichensatz!=ZS_ATARI)
/*DYJ  Ende; alt:	
			else if(zeichensatz!=US_ASCII && zeichensatz!=ATARI)
*/
				Mime_Do8B2File(INFILE,toFile,zeichensatz);
			else
				mtTextfiles_WriteLine(INFILE, toFile);     /* Zeile ausgeben */
		}
/*DYJ  Ende; alt:	
		if(c=='.')
			Mime_DoQP2File(INFILE,toFile,!isEOL);
		else
			mtTextfiles_WriteLine(INFILE, toFile);     /* Zeile ausgeben */
*/
		if(isEOL)
		{
			/* Richtiges Zeilenende */
			mtTextfiles_WriteLn(INFILE);
			newLine = TRUE;
			if (ch == CR)
				mtTextfiles_Skip(InHandle,LF);
		}
	} while (!mtTextfiles_EndofText(InHandle));
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID transferB64(FILENO InHandle, TEXTFILENO INFILE)						*/
/* 	Abgeleitet von Mime_TransferQP aber hier fr Binaries						*/
/*	Parameter:	InHandle:	Handel des Quellfiles								*/
/*				INFILE:		Handel des Zielfiles, meist Infile					*/
/*				offset:		0: mit Doppelpunkt vor jeder Zeile (Maus)			*/
/*							1: ohne Doppelpunkt									*/
/*	Ergebnis:	keines															*/		
/*	23.11.01 von Dimitri Junker	DYJ 4.30zh										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.30q Start*/
LOCAL _VOID transferB64(FILENO InHandle, TEXTFILENO INFILE,int offset)
{
	_UBYTE binary[60],zeile[81]=":";
/*DYJ  Ende; alt:	
LOCAL _VOID transferB64(FILENO InHandle, TEXTFILENO INFILE)
{
	_UBYTE binary[60],zeile[80];
*/	
	_ULONG rest,len;
	CatFiles_Seek(0L, InHandle, CatFiles_end);
	CatFiles_FilePos(InHandle, &rest);
	CatFiles_Seek(0L, InHandle, CatFiles_start);
	while(rest)
	{
		len=LMin(rest,57);
		CatFiles_ReadMuch(len, InHandle, binary);
		rest-=len;
/*DYJ 5.30q Start*/
		MimeCodeB64(zeile+1,binary,len,FALSE);
		mtTextfiles_WriteLine(INFILE, zeile+offset);     /* Zeile ausgeben */
/*DYJ  Ende; alt:	
		MimeCodeB64(zeile,binary,len,FALSE);
		mtTextfiles_WriteLine(INFILE, zeile);     /* Zeile ausgeben */
*/
		mtTextfiles_WriteLn(INFILE);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID transferUUE(FILENO InHandle, TEXTFILENO INFILE,_WORD offs)			*/
/*	wie das vorige aber fr UUE													*/
/*	Parameter:	InHandle:	Handel des Quellfiles								*/
/*				INFILE:		Handel des Zielfiles, meist Infile					*/
/*				offset:		0: mit Doppelpunkt vor jeder Zeile (Maus)			*/
/*							1: ohne Doppelpunkt									*/
/*	Ergebnis:	keines															*/		
/*	4.12.01 von Dimitri Junker	DYJ 4.30zh										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.30q Start*/
LOCAL _VOID transferUUE(FILENO InHandle, TEXTFILENO INFILE,int offset)
{
	_UBYTE binary[60],zeile[81]=": ";
	_ULONG rest,len;

	CatFiles_Seek(0L, InHandle, CatFiles_end);
	CatFiles_FilePos(InHandle, &rest);
	CatFiles_Seek(0L, InHandle, CatFiles_start);
	while(rest)
	{
		len=LMin(rest,45);
		CatFiles_ReadMuch(len, InHandle, binary);
		rest-=len;
		MimeCodeB64(zeile+2,binary,len,TRUE);
		zeile[1]=len+32;
		mtTextfiles_WriteLine(INFILE, zeile+offset);     /* Zeile ausgeben */
		mtTextfiles_WriteLn(INFILE);
	}
}
/*DYJ  Ende; alt:	
LOCAL _VOID transferUUE(FILENO InHandle, TEXTFILENO INFILE)
{
	_UBYTE binary[60],zeile[80]=" ";
	_ULONG rest,len;

	CatFiles_Seek(0L, InHandle, CatFiles_end);
	CatFiles_FilePos(InHandle, &rest);
	CatFiles_Seek(0L, InHandle, CatFiles_start);
	while(rest)
	{
		len=LMin(rest,45);
		CatFiles_ReadMuch(len, InHandle, binary);
		rest-=len;
		MimeCodeB64(zeile+1,binary,len,TRUE);
		zeile[0]=len+32;
		mtTextfiles_WriteLine(INFILE, zeile);     /* Zeile ausgeben */
		mtTextfiles_WriteLn(INFILE);
	}
}
*/
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *zielCharsetOfFilter(_LONG filter)									*/
/*	Ermittelt den FremdZielzeichensatz eines Filters							*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	10.1.02 von Dimitri Junker	DYJ 4.34d										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _UBYTE *CharsetOfFilter(_LONG filter)
{
	_UBYTE *ret;
	if(filter<FILTER_KEYT)
		ret=cMIME_Iso[(_WORD)filter];
	else if(filter<FILTER_KEYT_EXP)
		ret=Keyt->GetImpShortNameFromNr((_WORD)filter);
	else
		ret=Keyt->GetExpShortNameFromNr((_WORD)filter);
	return ret;
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_WriteAttachments(TEXTFILENO zielF,_UBYTE *bound,_UBYTE *attPf,_UBYTE *attZeile,_WORD mode)	*/
/*	Fgt Anhnge an das Infile an, als quoted-printable, Base64 oder UUE		*/
/*	Parameter:	zielF:	dorthin soll geschrieben werden, meist Infile			*/
/*				bound:	Boundary fr Mime, kann NULL sein 						*/
/*				attPf:	Anhang-Pfad, hier stehen die Anhnge, entweder			*/
/*						Messagepath mit Filnamenstamm oder entspr Attachment-Pf	*/
/*				attZeile: Die Attachmentzeile									*/
/*				mode:	0:Text im Original-ZS	Mime							*/
/*						1:Internet Infile (. -> .. und ->Latin1) Mime			*/
/*						2:Outfile		(->original ZS)	Mime					*/
/*						3:Msg Text oder  (an TXT anhngen und lschen) 			*/
/*							in Latin1 Mime oder Atari-UUE 							*/
/*	Ergebnis:	keines															*/		
/*	23.11.01 von Dimitri Junker	DYJ 4.30zh 4.30zr								*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.16l */	/*DYJ 5.20zb */
_VOID Mime_WriteAttachments(TEXTFILENO zielF,_UBYTE *bound,_UBYTE *attPf,_UBYTE *attZeile,_WORD mode)
{
	_UBYTE sName[PATH_MAX]="",oName[PATH_MAX]="",tmpStr[1000]="",*ext,typStr[100],*tStr;
	_BOOL isDbMsg;
	_UBYTE flagB=' ';
/*DYJ 5.30q Start*/
	_WORD anhNr,mTyp,i,offset=1;
/*DYJ  Ende; alt:	
	_WORD anhNr,mTyp,i;
*/
	_UBYTE *charset;
	_LONG filter;
	if(!attZeile || attZeile[0]<'0')
		return;
	isDbMsg=(attZeile[1]=='/');		/*bei Msgs aus der Datenbank beginnt die Zeile mit A/M: bei zu versendenden mit AX, oder AMX oder AUX:*/
	tStr=Mime_ParseAnhStr(attZeile,NULL,NULL,NULL);
	ext=strChr(attPf,'\0');
	for(i=0;i<attZeile[0]-'0';i++)
	{
		tStr=Mime_ParseAnhStr(tStr,sName,oName,&filter);
		if(!mode || mode==2)
			charset=CharsetOfFilter(filter);
		else
		{
			charset=cMIME_Iso[ISO8859_1];	/*Wird bei UUE ignoriert*/
			filter=Mime_FindFilt(charset,FALSE);
			if(mode==1)
				flagB='.';
		}
/*DYJ 5.30q Start*/
		if(mode==2)
		{
			offset=0;
			flagB=':';
		}
		if(bound)									/* Mime	*/
		{
			mtTextfiles_WriteLine(zielF, ":--"+offset);
			mtTextfiles_WriteLine(zielF, bound);
			mtTextfiles_WriteLn(zielF);
		}
		if(bound || attZeile[1]=='M')
		{
			mTyp=getTypFromExt(typStr,oName,charset);
			sprintf(tmpStr,":Content-Type: %s;",typStr);
 			mtTextfiles_WriteLine(zielF, tmpStr+offset);
			mtTextfiles_WriteLn(zielF);
			sprintf(tmpStr,": name=\"%s\"",oName);
			mtTextfiles_WriteLine(zielF, tmpStr+offset);
		}
		else										/* UUE */
		{
			if(getTypFromExt(typStr,oName,charset)==MIME_QUOT)
			{
				mtTextfiles_WriteLine(zielF, ":UUE-kodierter Text-Anhang im Atari-Zeichensatz:"+offset);
				mtTextfiles_WriteLn(zielF);
			}
			mtTextfiles_WriteLine(zielF, ":table"+offset);
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLine(zielF, ":`!\"#$%&'()*+,-./0123456789:;<=>?"+offset);
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLine(zielF, ":@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_"+offset);
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLine(zielF, ":begin 644 "+offset);
			mtTextfiles_WriteLine(zielF, oName);
			mTyp=MIME_UUE;
		}
		mtTextfiles_WriteLn(zielF);
		/* Filenamen basteln */
		if(isDbMsg)
			F_Path_Append(attPf,sName);
		else
		{	
			anhNr=atoi(sName);
			sprintf(ext,"_A.%03d",anhNr);
		}

		if(mTyp==MIME_QUOT)
		{
			TEXTFILENO quellF;
			mtTextfiles_WriteLine(zielF, ":Content-Transfer-Encoding: quoted-printable"+offset);
			mtTextfiles_WriteLn(zielF);
			if(mode==2)
				mtTextfiles_WriteLine(zielF, ":");
			mtTextfiles_WriteLn(zielF);
			strCpy(sName,DataPath);
			F_Path_Append(sName,"Att_tmp.i2c");
			Fdelete(sName);
			Mime_copyFileFilter(sName,attPf,filter);
			if(mtTextfiles_OpenTextfile(sName, READ, 16348, &quellF) == GERR_OK)
			{
/*DYJ 5.34m Start*/
				Mime_TransferQP(quellF, zielF, flagB,ISO8859_1);
/*DYJ  Ende; alt:	
				Mime_TransferQP(quellF, zielF, flagB);
*/
				mtTextfiles_CloseTextfile(&quellF);
			}
			Fdelete(sName);
		}
		else
		{
			FILENO quellF;
			quellF = CatFiles_OpenFile(attPf, CatFiles_readFile);
			if (FILENO_OK(quellF))
			{
				if(mTyp==MIME_UUE)
				{
					transferUUE(quellF, zielF,offset);
					mtTextfiles_WriteLine(zielF, ":end"+offset);
					mtTextfiles_WriteLn(zielF);
				}
				else
				{
					mtTextfiles_WriteLine(zielF, ":Content-Transfer-Encoding: base64"+offset);
					mtTextfiles_WriteLn(zielF);
					if(mode==2)
						mtTextfiles_WriteLine(zielF, ":");
					mtTextfiles_WriteLn(zielF);
					transferB64(quellF, zielF,offset);
				}
				CatFiles_CloseFile(quellF);
			}
		}
		if(mode==3)
			Fdelete(attPf);
	}
	if(bound)
	{
		mtTextfiles_WriteLine(zielF, ":--"+offset);
		mtTextfiles_WriteLine(zielF, bound);
		mtTextfiles_WriteLine(zielF, "--");
	}
	mtTextfiles_WriteLn(zielF);
/*DYJ  Ende; alt:	
		if(bound)									/* Mime	*/
		{
			mtTextfiles_WriteLine(zielF, "--");
			mtTextfiles_WriteLine(zielF, bound);
			mtTextfiles_WriteLn(zielF);
		}
		if(bound || attZeile[1]=='M')
		{
			mTyp=getTypFromExt(typStr,oName,charset);
			sprintf(tmpStr,"Content-Type: %s;",typStr);
 			mtTextfiles_WriteLine(zielF, tmpStr);
			mtTextfiles_WriteLn(zielF);
			sprintf(tmpStr," name=\"%s\"",oName);
			mtTextfiles_WriteLine(zielF, tmpStr);
		}
		else										/* UUE */
		{
			if(getTypFromExt(typStr,oName,charset)==MIME_QUOT)
			{
				mtTextfiles_WriteLine(zielF, "UUE-kodierter Text-Anhang im Atari-Zeichensatz:");
				mtTextfiles_WriteLn(zielF);
			}
			mtTextfiles_WriteLine(zielF, "table");
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLine(zielF, "`!\"#$%&'()*+,-./0123456789:;<=>?");
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLine(zielF, "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_");
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLine(zielF, "begin 644 ");
			mtTextfiles_WriteLine(zielF, oName);
			mTyp=MIME_UUE;
		}
		mtTextfiles_WriteLn(zielF);
		/* Filenamen basteln */
		if(isDbMsg)
			F_Path_Append(attPf,sName);
		else
		{	
			anhNr=atoi(sName);
			sprintf(ext,"_A.%03d",anhNr);
		}

		if(mTyp==MIME_QUOT)
		{
			TEXTFILENO quellF;
			mtTextfiles_WriteLine(zielF, "Content-Transfer-Encoding: quoted-printable");
			mtTextfiles_WriteLn(zielF);
			mtTextfiles_WriteLn(zielF);
			strCpy(sName,DataPath);
			F_Path_Append(sName,"Att_tmp.i2c");
			Fdelete(sName);
			Mime_copyFileFilter(sName,attPf,filter);
			if(mtTextfiles_OpenTextfile(sName, READ, 16348, &quellF) == GERR_OK)
			{
				Mime_TransferQP(quellF, zielF, flagB);
				mtTextfiles_CloseTextfile(&quellF);
			}
			Fdelete(sName);
		}
		else
		{
			FILENO quellF;
			quellF = CatFiles_OpenFile(attPf, CatFiles_readFile);
			if (FILENO_OK(quellF))
			{
				if(mTyp==MIME_UUE)
				{
					transferUUE(quellF, zielF);
					mtTextfiles_WriteLine(zielF, "end");
					mtTextfiles_WriteLn(zielF);
				}
				else
				{
					mtTextfiles_WriteLine(zielF, "Content-Transfer-Encoding: base64");
					mtTextfiles_WriteLn(zielF);
					mtTextfiles_WriteLn(zielF);
					transferB64(quellF, zielF);
				}
				CatFiles_CloseFile(quellF);
			}
		}
		if(mode==3)
			Fdelete(attPf);
	}
	if(bound)
	{
		mtTextfiles_WriteLine(zielF, "--");
		mtTextfiles_WriteLine(zielF, bound);
		mtTextfiles_WriteLine(zielF, "--");
	}
	mtTextfiles_WriteLn(zielF);
*/
}
/*** ------------------------------------------------------------------------ ***/
/*	F_ERROR Mime_copyFileFilter(CONST _UBYTE *ziel,CONST _UBYTE *quell,_WORD isoType)	*/
/*	Kopiert ein File, wandelt dabei den Zeichensatz von Atari in einen anderen	*/
/*	Parameter:	ziel:	Ziel-Filename											*/
/*				quell:	Quell-Filename											*/
/*				filter: zu verwendender Export-Zeichensatzfilter				*/
/*	Ergebnis:	Fehler?															*/		
/*	1.12.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.17k */	/*DYJ 5.21b */	/*DYJ 5.24j */
GLOBAL F_ERROR Mime_copyFileFilter(CONST _UBYTE *ziel,CONST _UBYTE *quell,_LONG filter)
{
	CONST _UBYTE *tab=NULL,*i2aTab=NULL;
	_WORD i,blkSize=BUFSIZ,writeSize,cpyBytes;
	_UBYTE hTab[256],buf[BUFSIZ],*zielBuf;
	FILENO quellF,zielF;
	size_t len;
	_BOOL exists,freeZB=FALSE;
	F_ERROR ret;
	_UWORD val,val1;
	
	zielBuf=buf;
	if(filter<FILTER_KEYT)
	{
		switch((_WORD)filter)
		{
			case ISO8859_1:
			case ISO8859_9:
				 tab= atari_tab;
				 break;
			case ISO8859_2:
				 i2aTab= iso_8859_2_tab;
				 break;
			case ISO8859_3:
				 i2aTab= iso_8859_3_tab;
				 break;
			case ISO8859_4:
				 i2aTab= iso_8859_4_tab;
				 break;
			case ISO8859_7:
				 i2aTab= iso_8859_7_tab;
				 break;
			case ISO8859_8:
				 i2aTab= iso_8859_8_tab;
				 break;
			case ISO8859_15:
				 i2aTab= iso_8859_15_tab;
				 break;
			case WINDOWS1250:
				 i2aTab= cp_1250_tab;
				 break;
			case WINDOWS1252:
				 i2aTab= windows_tab;
				 break;
			case UTF_8:
				blkSize=BUFSIZ/4;	/* kann max 3mal lnger werden ->1/4 Lesebuffer, 3/4 Schreibbuffer*/
				zielBuf=buf+blkSize;
		}
		if(i2aTab)
		{
			for(i=0;i<256;i++)
				hTab[i2aTab[i]]=i;
			tab=hTab;
		}
	}
	
	CatFiles_FileSize(ziel,&exists);
	if(exists)
	{
		if(!strCaseCmp(ziel,quell))
		{
			mtAlerts_Alert(2, Rsc_WrkString(AL_OVERWRITE_EQ));
			return notAllWritten;
		}
		else if(mtAlerts_Alert(2, Rsc_WrkString(AL_OVERWRITE_AP))==2)
			return notAllWritten;
	}
	
	len=CatFiles_FileSize(quell,&exists);
	if(!exists || !len)
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_NOTHING));
		return NotFound;
	}
	quellF=CatFiles_OpenFile(quell, CatFiles_readFile);
	if(quellF<0)
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_QUELL));
		return notAllWritten;
	}
	zielF=CatFiles_OpenFile(ziel, CatFiles_writeFile);
	if(zielF<0)
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_ZIEL));
		CatFiles_CloseFile(quellF);
		return notAllWritten;
	}

	while(len)
	{
		if(len>blkSize)
			cpyBytes=blkSize;
		else
			cpyBytes=(_WORD)len;
		ret=CatFiles_ReadMuch(cpyBytes, quellF, buf);
		if(ret!=NoError)
			break;
		if(filter==(UTF_8+FILTER_EXP))
		{
			writeSize=0;
			for(i=0;i<cpyBytes;i++)
			{
				val=atari2UnicTab[buf[i]];
				if(val<128)							/* max 7 Bit in 1 Byte*/
					zielBuf[writeSize++] =val;
				else if(val<0x800)					/*max 11Bit in 2 Byte */
				{
					val1=val&0x3f;					/*die unteren 6 Bit */
					val>>=6;						/*und die oberen 5*/
					zielBuf[writeSize++] =val | 0xc0;
					zielBuf[writeSize++] =val1| 0x80;
				}
				else								/*max 16Bit in 2 Byte */
				{
					val1=(val&0xfff);				/*die unteren 12 Bit */
					val>>=12;						/*und die oberen 4*/
					zielBuf[writeSize++] =val | 0xE0;
					val=val1&0x3f;					/*die unteren 6*/
					val1>>=6;						/*und die mittleren 6*/
					zielBuf[writeSize++] =val1| 0x80;
					zielBuf[writeSize++] =val | 0x80;
				}
			}
			ret=CatFiles_WriteMuch(writeSize, zielF, zielBuf);
		}



		else if( filter>FILTER_KEYT_EXP && Keyt->size>=136 )	/*neues Keytab nutzen*/
		{
			size_t zLen;
			_LONG nLen;
			blkSize=BUFSIZ/4;	/* kann max 3mal lnger werden ->1/4 Lesebuffer, 3/4 Schreibbuffer*/
			zLen=BUFSIZ-blkSize;
			zielBuf=buf+blkSize;
			(Keyt->BlockXUtf2XUtf)(NULL, &nLen, (_WORD)filter, buf, cpyBytes, 0);
			
			if(nLen>zLen)
			{
				if(freeZB)
					SFREE(zielBuf);
				else
					freeZB=TRUE;
				zielBuf=SYSMALLOC(nLen+100, MEM_SHARABLE|MEM_NOERR, "Mime_copyFileFilter");
				if(!zielBuf)
				{
					MTE_info(Rsc_WrkString(AL_ERRMEM));
					return(GERR_NOMEM);
				}
			}
			(Keyt->BlockXUtf2XUtf)(zielBuf, &nLen, (_WORD)filter, buf, cpyBytes, 0);
			ret=CatFiles_WriteMuch(nLen, zielF, buf);
		}
		else if(filter>FILTER_KEYT_EXP)		/*altes Keytab nutzen*/
		{
			Keyt->BlockAtari2X((_WORD)filter, cpyBytes, buf);
			ret=CatFiles_WriteMuch(cpyBytes, zielF, buf);
		}
		else
		{
			writeSize=cpyBytes;
			for(i=0;i<cpyBytes;i++)
				buf[i] = tab[buf[i]];
			ret=CatFiles_WriteMuch(writeSize, zielF, buf);
		}
		if(ret!=NoError)
			break;
		len-=cpyBytes;
	}
	CatFiles_CloseFile(quellF);
	CatFiles_CloseFile(zielF);
	if(freeZB)
		SFREE(zielBuf);
	else if(ret!=NoError)
		mtAlerts_Alert(1, Rsc_WrkString(AL_COPY));
	return ret;

}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD Mime_multiType(_UBYTE *cType)											*/
/*	Prft um welchen Mime multipart Typ es sich handelt							*/
/*	Parameter:	cType der content-type String									*/
/*	Ergebnis:	-2: kein multipart												*/
/*				-1:	nicht untersttzter Typ (digest,...)						*/
/*				fMultipartM:	multipart/mixed									*/
/*				fMultipartA:	multipart/alternative							*/
/*				fMultipartR:	multipart/related								*/
/*				fMultipartS:	multipart/signed								*/
/*				fMultipartE:	multipart/encrypted								*/
/*	17.1.02 von Dimitri Junker	DYJ 4.35h										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20l */
GLOBAL _WORD Mime_multiType(_UBYTE *cType)
{
	const _UBYTE *multi;
	_WORD ret;
	multi=strCaseStr(cType,"multipart");
	if(!multi)
		ret=-2;
	else if(!strnCaseCmp(multi,"multipart/mixed",15))
		ret=fMultipartM;
	else if(!strnCaseCmp(multi,"multipart/alternative",21))
		ret=fMultipartA;
	else if(!strnCaseCmp(multi,"multipart/related",17))
		ret=fMultipartR;
/*DYJ 5.36h Start*/
	else if(!strnCaseCmp(multi,"multipart/encrypted",19))
		ret=fMultipartE;
	else if(!strnCaseCmp(multi,"multipart/signed",16))
/*DYJ  Ende; alt:	
	else if(!strnCaseCmp(multi,"multipart/signed",17))
*/
		ret=fMultipartS;
	else
		ret=-1;
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID swapTab(_UBYTE tab[256],_UBYTE wert1,_UBYTE wert2)					*/
/*	Vertauscht in einer Konversionstabelle 2 Eintrge							*/
/*	Parameter:	tab:	Die Tabelle												*/
/*				wert1 und wert2: die beiden Werte die vertauscht werden sollen	*/
/*	Ergebnis:	keines															*/
/*	16.5.02 von Dimitri Junker	DYJ 4.38r										*/
/*** ------------------------------------------------------------------------ ***/
_VOID swapTab(_UBYTE tab[256],_UBYTE wert1,_UBYTE wert2)
{
	_WORD i;
	for(i=0;i<256;i++)
	{
		if(tab[i]==wert1)
			tab[i]=wert2;
		else if(tab[i]==wert2)
			tab[i]=wert1;
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_init(_VOID)														*/
/*	ndert die Konversionstabellen abhngig vom EURO Cookie u..				*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/
/*	16.5.02 von Dimitri Junker	DYJ 4.38r										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.36a Start*/
GLOBAL _BOOL Mime_init(_VOID)
{
	_LONG euroCookie;
	_UBYTE tmp;
	static _BOOL first=TRUE;		/* Darf auf keinen Fall 2* ausgefhrt werden! */
	locale2UnicTab=atari2UnicTab;
/*DYJ  Ende; alt:	
GLOBAL _VOID Mime_init(_VOID)
{
	_LONG euroCookie;
	_UBYTE tmp;
	_BOOL first=TRUE;		/* Darf auf keinen Fall 2* ausgefhrt werden! */
*/
	if(first && FindCookie("EURO", &euroCookie))
	{
		Euro=euroCookie&0xff;
		ReplaceEuro=(euroCookie&0x200)!=0;
		if(Euro!=0xEC)
		{
			swapTab(iso_8859_1_tab,0xEC,Euro);
			swapTab(iso_8859_2_tab,0xEC,Euro);
			swapTab(iso_8859_3_tab,0xEC,Euro);
			swapTab(iso_8859_4_tab,0xEC,Euro);
			swapTab(iso_8859_7_tab,0xEC,Euro);
			swapTab(iso_8859_8_tab,0xEC,Euro);
			swapTab(iso_8859_15_tab,0xEC,Euro);
			swapTab(windows_tab,0xEC,Euro);
			tmp=atari_tab[Euro];
			atari_tab[Euro]=atari_tab[0xEC];
			atari_tab[0xEC]=tmp;
			atari2UnicTab[Euro]=0x20AC;
			atari2UnicTab[0xEC]=0x222E;
		}
	}
/*DYJ 5.38a Start*/
	ConfVars_GetConfDefInt(cCP1252Mode,&CP1252Mode,0);		/*DYJ 5.37b */
/*DYJ  Ende; alt:	
	ConfVars_GetConfDefBool(cCP1252Mode,&CP1252Mode,0);		/*DYJ 5.37b */
*/
	first=FALSE;
	return TRUE;	/*DYJ 5.36a */
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_repEuro(_UBYTE *str,size_t len)									*/
/*	Ersetzt ggf. das Eurozeichen durch EUR										*/
/*	Parameter:	str:	der String in dem ersetzt werden soll					*/
/*				len:	dessen Lnge											*/
/*	Ergebnis:	keines															*/		
/*	16.5.02 von Dimitri Junker	DYJ 4.38r										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID Mime_repEuro(_UBYTE *str,size_t len)
{
	_UBYTE euroStr[]="\xEC";
	if(ReplaceEuro)
	{
		euroStr[0]=Euro;
		CatGlobal_ReplaceStr(str, len,euroStr,"EUR");
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	WORD Mime_EuroChar(_VOID)													*/
/*	Gibt den Zeichencode des EURO zurueck, falls keine Euro-Ersetzung statt-	*/
/*	finden soll wird 256 zurck gegeben											*/
/*	Parameter:	keine															*/
/*	Ergebnis:	0-256															*/		
/*	23.1.03 von Dimitri Junker	DYJ 5.20b										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD Mime_EuroChar(_VOID)
{
	if(ReplaceEuro)
		return Euro;
	else
		return 256;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD Mime_CntAtt(_UBYTE *string,_BOOL cntRelated)							*/
/*	gibt die Anzahl Anhnge zurck, ggf. ohne Typ related						*/
/*	Parameter:	string:		der Anhang-String									*/
/*				cntRelated:	Soll der Pseudoanhang related gezhlt werden?		*/
/*	Ergebnis:	Anzahl Anhnge													*/		
/*	1.9.02 von Dimitri Junker	DYJ 4.42k										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD Mime_CntAtt(_UBYTE *string,_BOOL cntRelated)
{
	_WORD ret=0;
	if(string && string[0]>'0')
	{
		ret= string[0]-'0';
		if(!cntRelated && !strnCmp(Mime_ParseAnhStr(string,NULL,NULL,NULL),"R:",2))
			ret--;
	}
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD Mime_ModAtt(_UBYTE *string)											*/
/*	gibt den Anhang-Modus zurck												*/
/*	Parameter:	string:		der Anhang-String									*/
/*	Ergebnis:	Modus															*/		
/*	1.9.02 von Dimitri Junker	DYJ 4.42k										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD Mime_ModAtt(_UBYTE *string)
{
	if(strLen(string)>2 && string[2]>'0')
		return string[2]-'0';
	else
		return 0;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID Mime_ResAtt(_UBYTE *string)											*/
/*	setzt die Anzahl Anhnge auf 0												*/
/*	Parameter:	string:		der Anhang-String									*/
/*	Ergebnis:	keines															*/		
/*	1.9.02 von Dimitri Junker	DYJ 4.42k										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID Mime_ResAtt(_UBYTE *string)
{
	if(string)
		*string='0';
}
/*** ------------------------------------------------------------------------ ***/
/*	mess_len Mime_LenOrig(_UBYTE *string)										*/
/*	Gibt die Originale Textlnge zurck, falls nicht vorhanden 0				*/
/*	Parameter:	string:		der Anhang-String									*/
/*	Ergebnis:	Lnge oder 0													*/		
/*	1.9.02 von Dimitri Junker	DYJ 4.42k										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL mess_len Mime_LenOrig(_UBYTE *string)
{
	mess_len len=0;
	_UBYTE *ptr;
	ptr=strStr(string,";#:");
	if(!ptr)
		ptr=strStr(string,":#:");
	if(ptr)
		sscanf(ptr+3,"%lu",&len);
	return len;
}
/*** ------------------------------------------------------------------------ ***/
/*						*/
/*								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	10.11.03 von Dimitri Junker	DYJ 5.32f										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL short *Mime_txt2Unicode(_UBYTE *txt,_UBYTE *charsetName,size_t len)
{
	_LONG filterNr=FILTER_NONE,uniLen;
	short *ret=NULL;
	filterNr=Mime_getKeytabNr(charsetName,TRUE,FALSE);
	if(filterNr==FILTER_NO_PREF_KT || filterNr==FILTER_NONE)
	{
		unsigned int *tab=NULL;
		if(strCaseStr(charsetName,"ATARI"))
			tab=atari2UnicTab;
		else if(strCaseStr(charsetName,"koi8-r"))
			tab=koi8_r2UnicTab;
		if(tab)
		{
			ret=malloc((len+1)*sizeof(short));
			if(ret)
			{
				_WORD i;
				for(i=0;i<len;i++)
					ret[i]=tab[txt[i]];
			}
		}
		else
			mtAlerts_Alert(1, Rsc_WrkString(AL_CHARSUNKN));
	}
	else
	{
		Keyt->BlockXUtf2Unicode(NULL,&uniLen,(_WORD)filterNr, txt,len);
		ret=malloc((uniLen+1)*sizeof(short));
		if(ret)
			Keyt->BlockXUtf2Unicode(ret,&uniLen,(_WORD)filterNr,txt,len);
	}
	return ret;

}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD Mime_FindFilt4Send(TEXTFILENO txtFile,_UBYTE *fontName)				*/
/*	Ermittelt welcher Zeichensatz bentigt wird um den Text zu verschicken		*/
/*	Parameter:	txtFile:	der zu testende Text								*/
/*	Ergebnis:	US_ASCII,ISO8859_1,ISO8859_15 oder UTF-8						*/		
/*	13.3.04 von Dimitri Junker	DYJ 5.34m										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD Mime_FindFilt4Send(TEXTFILENO txtFile)
{
	_WORD ret=US_ASCII;
	
	while(!mtTextfiles_EndofText(txtFile) && ret!=UTF_8)
	{
		_UBYTE c=mtTextfiles_ReadChar(txtFile);
		
/*DYJ 5.37b Start*/
		switch(c)
		{
			case 0xb9:	/* Umlaut	*/
			case 0xba:	/* Accent aigu	*/
			case 0xab:	/* 1/4	*/
			case 0xac:	/* 1/2	*/
				if(ret==US_ASCII||ret==ISO8859_1||ret==ISO8859_X)
					ret=ISO8859_1;
				else if(ret!=WINDOWS1252)
					ret=UTF_8;
				break;
			case 0xb5:	/* OE	*/
			case 0xb4:	/* oe	*/
				if(ret==US_ASCII||ret==WINDOWS1252||ret==ISO8859_X)
				{
					if(CP1252Mode)
						ret=WINDOWS1252;
					else
						ret=ISO8859_15;
				}
				else if(ret!=ISO8859_15)
					ret=UTF_8;
				break;
			case 0x9f:	/* Florin */
			case 0xbb:	/* Dagger*/
			case 0xf9: 	/* Bullet*/
			case 0xBF:	/* TM*/
				if(CP1252Mode)
					ret=WINDOWS1252;
				else
					ret=UTF_8;
				break;		/*DYJ 5.38a */
			default:
				if(c==Euro)
				{
					if(ret==US_ASCII||ret==WINDOWS1252||ret==ISO8859_X)
					{
						if(CP1252Mode)
							ret=WINDOWS1252;
						else
							ret=ISO8859_15;
					}
					else if(ret!=ISO8859_15)
						ret=UTF_8;
				}
/*DYJ  Ende; alt:
		switch(c)
		{
			case 0xb9:	/* Umlaut	*/
			case 0xba:	/* Accent aigu	*/
			case 0xab:	/* 1/4	*/
			case 0xac:	/* 1/2	*/
				if(ret==US_ASCII||ret==ISO8859_1||ret==ISO8859_X)
					ret=ISO8859_1;
				else
					ret=UTF_8;
				break;
			case 0xb5:	/* OE	*/
			case 0xb4:	/* oe	*/
				if(ret==US_ASCII||ret==ISO8859_15||ret==ISO8859_X)
					ret=ISO8859_15;
				else
					ret=UTF_8;
				break;
			default:
				if(c==Euro)
				{
					if(ret==US_ASCII||ret==ISO8859_15||ret==ISO8859_X)
						ret=ISO8859_15;
					else
						ret=UTF_8;
				}
*/
				else if(atari2UnicTab[c]>0xff)
					ret=UTF_8;
				else if(c>127)
					ret=ISO8859_X;
		}
	}
	mtTextfiles_SetTextpos(txtFile, 0);
	if(ret==ISO8859_X)
		ret=ISO8859_1;
	return ret;
}
