GLOBL   Mime_DecodeB64,MimeCodeB64
MODULE Mime_DecodeB64		; _LONG Mime_DecodeB64(_UBYTE *a0=start,_LONG d0=len);
		movem.l		d3-d5/a2,-(a7)
		movea.l		a0,a1			;a0=Quelle, a1=Ziel
		lea			dec_b64,a2		;Tabelle
		clr.l		d3				;neue Lnge
		clr.l		d4				;0:weiter, sonst Stop (Fehler oder Ende)
		move.l		a0,d5			;Testen ob gerade
		and.l		#1,d5			;d5: Bits 8-15 mssen fr get6bit =0 sein
		bne			odd
			
even:	bsr			get6bit			;ldt 6bit nach d1:	........ ........ ..NMJKJI ........
		tst.b		d4				;
		bne			ende			;
		bsr			get6bit			;ldt 6bit nach d1:	........ ....NMLK JIHGFEDC ........
		bsr			get6bit			;ldt 6bit nach d1:	......NM LKJIHGFE DCBA9876 ........
		bsr			get6bit			;ldt 6bit nach d1:	NMLKJIHG FEDCBA98 76543210 ........
		move.l		d1,(a1)			;schreibt zwar 8Bit zu viel, aber was solls
		addq.l		#3,a1
		addq.l		#3,d3
		tst.b		d4
		bne			ende

odd:	bsr			get6bit			;ldt 6bit nach d1:	........ ........ ..NMJKJI ........
		tst.b		d4				;
		bne			ende			;
		bsr			get6bit			;ldt 6bit nach d1:	........ ....NMLK JIHGFEDC ........
		bsr			get6bit			;ldt 6bit nach d1:	......NM LKJIHGFE DCBA9876 ........
		bsr			get6bit			;ldt 6bit nach d1:	NMLKJIHG FEDCBA98 76543210 ........
		lsr.l		#8,d1			;					........ NMLKJIHG FEDCBA98 76543210
		move.w		d1,d2			;		d2.w=						  FEDCBA98 76543210
		swap		d1				;					FEDCBA98 76543210 ........ NMLKJIHG
		move.b		d1,(a1)+		; schreibt NMLKJIHG
		move.w		d2,(a1)+		; schreibt FEDCBA98 76543210
		addq.l		#3,d3
		tst.b		d4
		bne			ende
		bra			even
ende:	cmp.b		#2,d4			;d4 kann nur 0,2,4,6 sein, 0=weiter, 2=Fertig ohne Fehler
		beq			okEnd
		moveq.l		#-1,d3			;d4==4:Fehler oder d4==6:Fehler+Ende
okEnd:	move.l		d3,d0
		movem.l		(a7)+,d3-d5/a2
		rts


get6bit:move.b		(a0)+,d5		;byte lesen		    						   xxxxxxxx
		move.b		(a2,d5.w),d1	;decodieren			......yy yyyyyyyy yyyyyyyy 543210.. (y: alte Bits)
		subq.l		#1,d0			;wieder 1 gelesen
		bmi			setEnde			;war's das?
		bclr		#0,d1			;normale Zeichen sind gerade, aus ignorieren(1) wird 0, aus Ende(3) wird 2 und aus Fehler(5) wird 4
		beq			okG6b			;gerade -> normales Zeichen
		tst.b		d1
		beq			get6bit			;0 -> zu ignorierendes Zeichen (" \r\n")
		or.b		d1,d4			;bei Ende oder Fehler wird das entsprechende Bit gesetzt
		subq.l		#1,d3			;bei Ende(=) um eins verringern, bei Fehler nicht ntig aber egal	
		bra			okG6b
setEnde:or.b		#2,d4
okG6b:	lsl.l		#6,d1			;um 6Bit nach links yyyyyyyy yyyyyyyy yy543210 ........
		rts
				
;alles in HEX
;Base64 benutzt 64 Zeichen um die Werte 0-3f zu dekodieren, da ich sie in den Bits 2-8 brauche habe ich
;die Werte mit 4 multipliziert ->0 bis fc. Alle anderen Zeichen lassen sich zu 3 Gruppen zusammenfassen:
;=: Flzeichen um das letzte Quadruplet ggf aufzufllen
;' ',\n,\r da die Zeilen max 76 Zeichen lang sind mu es natrlich Zeilenumbrche geben, und da beim Mailversand
;	ggf Leerzeichen auftauchen knnen mssen diese 3 ignoriert werden
;alle anderen sind Fehler
;Um diese 4 Gruppen schnell unterscheiden zu knnen habe ich den 3 Gruppen die nichts kodieren jeweils einen ungeraden
;Wert zugewiesen, so ist mit einem Bittest zu erkennen ob es sich um ein normales Zeichen handelt. Die Zuordnung ist:
;4*n:	normale Zeichen ->dekodieren
;1:		ignorieren
;3:		= also Fllbyte
;5:		Fehler
dec_b64:	
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$01,$05,$05,$01,$05,$05		;00-0f: alle verboten(05) auer \n,\r ignorieren(01)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;10-1f: alle verboten(05)
		dc.b		$01,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$f8,$05,$05,$05,$fc		;20-2f: alle verboten(05) auer + und / ->f8,fc, und ' 'ignorieren(01)
		dc.b		$d0,$d4,$d8,$dc,$e0,$e4,$e8,$ec,$f0,$f4,$05,$05,$05,$03,$05,$05		;30-3f:	0-9->d0-f4,=->03  Rest verboten(05)
		dc.b		$05,$00,$04,$08,$0c,$10,$14,$18,$1c,$20,$24,$28,$2c,$30,$34,$38		;40-4f:	@:verboten A-O->0-38
		dc.b		$3c,$40,$44,$48,$4c,$50,$54,$58,$5c,$60,$64,$05,$05,$05,$05,$05		;50-5f:	P-Z: 3c-64, Rest verboten(05)
		dc.b		$05,$68,$6c,$70,$74,$78,$7c,$80,$84,$88,$8c,$90,$94,$98,$9c,$a0		;60-6f: `:verboten a-o->68-a0
		dc.b		$a4,$a8,$ac,$b0,$b4,$b8,$bc,$c0,$c4,$c8,$cc,$05,$05,$05,$05,$05		;70-7f:	p-z: a4-cc, Rest verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;80-8f: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;90-9f: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;a0-af: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;b0-bf: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;c0-cf: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;d0-df: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;e0-ef: alle verboten(05)
		dc.b		$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05		;f0-ff: alle verboten(05)
ENDMOD

MODULE MimeCodeB64	;MimeCodeB64(_UBYTE a0=Ziel,_UBYTE a1=Quelle,_LONG d0:Lnge,_BOOL d1:UUE)
		movem.l		d3-d4/a2,-(a7)
		moveq		#22,d2			;zum schieben um 22 Stellen
		moveq		#20,d3			;zum schieben um 20 Stellen
		moveq		#26,d4			;zum schieben um 26 Stellen
		tst.w		d1
		beq			b64
		lea			cod_uue,a2		;Tabelle
		clr.l		d1						;	........ ........ ........ ........		im Gegensatz zu oben sind hier '.' Null
		bra			trip
b64:	lea			cod_b64,a2		;Tabelle
		clr.l		d1						;	........ ........ ........ ........		im Gegensatz zu oben sind hier '.' Null
trip:	cmp.l		#3,d0
		bmi			fuell			;kein komplettes triplet mehr
		move.b		(a1)+,d1				;	........ ........ ........ NMLKJIHG
		ror.l		#2,d1					;	HG...... ........ ........ ..NMLKJI
		move.b		(a2,d1.w),d1			;	HG...... ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		lsr.l		d2,d1					;	........ ........ ......HG ........
		move.b		(a1)+,d1				;	........ ........ ......HG FEDCBA98
		ror.l		#4,d1					;	BA98.... ........ ........ ..HGFEDC
		move.b		(a2,d1.w),d1			;	BA98.... ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		lsr.l		d3,d1					;	........ ........ ....BA98 ........
		move.b		(a1)+,d1				;	........ ........ ....BA98 76543210
		ror.l		#6,d1					;	543210.. ........ ........ ..BA9876
		move.b		(a2,d1.w),d1			;	543210.. ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		lsr.l		d4,d1					;	........ ........ ........ ..543210
		move.b		(a2,d1.w),d1			;	........ ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		subq.l		#3,d0
		bra			trip					;nchstes Triplet
fuell:	tst.l		d0
		beq			ok
		cmp.l		#1,d0
		beq			eins

		move.b		(a1)+,d1				;	........ ........ ........ NMLKJIHG
		ror.l		#2,d1					;	HG...... ........ ........ ..NMLKJI
		move.b		(a2,d1.w),d1			;	HG...... ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		lsr.l		d2,d1					;	........ ........ ......HG ........
		move.b		(a1)+,d1				;	........ ........ ......HG FEDCBA98
		ror.l		#4,d1					;	BA98.... ........ ........ ..HGFEDC
		move.b		(a2,d1.w),d1			;	BA98.... ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		lsr.l		d4,d1					;	........ ........ ........ ..BA98..
		move.b		(a2,d1.w),d1			;	........ ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		move.b		64(a2),d1				; = oder `
		move.b		d1,(a0)+
		bra			ok
eins:	move.b		(a1)+,d1				;	........ ........ ........ NMLKJIHG
		ror.l		#2,d1					;	HG...... ........ ........ ..NMLKJI
		move.b		(a2,d1.w),d1			;	HG...... ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		lsr.l		d4,d1					;	........ ........ ........ ..HG....
		move.b		(a2,d1.w),d1			;	........ ........ ........ xxxxxxxx
		move.b		d1,(a0)+
		move.b		64(a2),d1				; = oder `
		move.b		d1,(a0)+
		move.b		d1,(a0)+
;		move.b		64(a2),d1				; = oder `
ok:		move.b		#0,(a0)					;Stringende
		movem.l		(a7)+,d3-d4/a2
		rts
		
cod_b64:	;und hier die umgekehrte Tabelle, natrlich viel einfacher, Das letzte Zeichen ist das Fllbyte wenn
			;len kein Vielfaches von 3
		dc.b		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="
cod_uue:	;So und jetzt das gleiche nochmal fr UUE
		dc.b		$60,$21,$22,"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_",$60
ENDMOD
