/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/* 19.04.98 Markus Hoffmann @ DU (MH)
 * - Einbau eines Icons in das Message-Fenster zum Zurueckhalten einer Nachricht
 *
 * 15.04.00 Dimitri Junker (DYJ)
 *	In der Kommentarauswahl knnen PMs und Ms unterschiedliche Farben/Effekte zugewiesen werden.
 * 28.04.00 Dimitri Junker (DYJ)
 *	kleine Erweiterung von 4.14m: zurckgehaltene PMs erhalten beide Atribute
 *
 * 6.05.00 Dimitri Junker (DYJ)
 *	kleine Erweiterung von 4.14m: die Effekte wurden nicht zurckgesetzt
 *
 * 8.3.02 Martin Elssser (ME) gekennzeichnet mit 'ME 4.36d'
 * F'Up Poster 
 *
 * 2.12.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19h'
 *	Beim Erstellen einer Kopie einer Nachricht fragt Cat nach einem neuen Betreff,
 *	dies wird zwar von der Maus untersttzt, aber nicht von SMTP -> im Internetmodus
 *	fllt diese Frage jetzt weg.
 *
 * 26.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23i'
 *	Internet Mails mit Verteiler (mehrere To, CC,BCC) werden jetzt nicht mehr
 *	Mausartig erzeugt sondern direkt durch eingabe der Adressen in eine Mail
 *
 * 2.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.24c'
 *	Im Internetmodus sollen 2 Icons in der Nachrichtenanzeige das gleiche tuen, 
 *	taten sie auch (hoffentlich), aber mit unterschiedlichem Code.
 *
 * 4.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.24e'
 *	Die nderungen zur Eingabe der Empfnger von Internet-Mails
 *	hatte leider einen Nebeneffekt auf die entspr. Funktion fr Mausmails.
 *
 * 19.7.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29b'
 *	Im Dialog zum ndern der Kopfdaten einer Mail wurde eine falsche Zeile angezeigt.
 *
 * 19.8.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29g'
 *	Die Eingabezeile fr 'Sender' funktionierte nicht (mehr)
 */
#include <msgwindo.h>
#include <catgloba.h>
#include <mtpaths.h>
#include <convertd.h>

#include <arcstart.h>
#include <catfiles.h>
#include <cattypes.h>
#include <mte.h>
#include <mtedit2.h>
#include <fontsele.h>
#include <wdwmanag.h>
#include <vdiutil.h>
#include <confvars.h>
#include <varname1.h>
#include <varn_ede.h>
#include <catgloba.h>
#include <edittype.h>
#include <maustaus.h>
#include <grintool.h>
#include <listhelp.h>
#include <grin.h>
#include <data.h>
#include <quicksor.h>
#include <infofile.h>
#include <groupsel.h>
#include <windials.h>
#include <cathelp.h>
#include <catutil.h>
#include <adr.h>

#include <mtappl.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtpopups.h>

#include <mttextfi.h>

#include <rectfunc.h>
#include <strconv.h>
#include <routinec.h>
#include <routines.h>
#include <set.h>
#include <keyboard.h>
#include <userinfo.h>

#include <mtrsc.h>

typedef struct _msgWindow {
	HWND wdw;			/* Windowhandle */
	HVDI vdi;			/* VDI-Handle   */
	GRECT butWork;
	GRECT msgWork;		/* Workrectangle des Fensters */
	_BOOL isHidden;
	msgInfo *list;
	_WORD sel;			/* Nummer des zuletzt selektierten Eintrags */
	_WORD windLines;	/* Anzahl der Zeilen im Fenster */
	_WORD number;		/* Nummer des Fensters im Modul */
	_WORD font;
	_WORD fontSize;		/* Font & Groesse */
	_WORD startPos;		/* aktuelle Top-Position */
	_WORD leftOffset;
	_WORD maxPos;		/* == messages */
	_WORD maxWidth;
	_WORD charHeight;	/* Zeichensatzvariablen */
	_WORD charWidth;
	_BOOL isFSM;
	_BOOL monoSpaced;
	_WORD msgTextCol;
	_WORD msgBackCol;
	_WORD msgHoldCol;
	_WORD msgHoldEff;
	_WORD msgPersCol;
	_WORD msgPersEff;
	_WORD lineDist;
	_WORD pixOffset;
} msgWindowType;


LOCAL msgWindowType msgWindow = { -1 };

LOCAL OBJECT *distSel;	/* DISTRIBX */
LOCAL OBJECT *butBox;	/* MSGCTRL */

LOCAL _BOOL inOpen;     /* Semaphore fuer snapWdw */


/*** ---------------------------------------------------------------------- ***/

LOCAL msgWindowType *FindWind(HWND wdw)
{
	if (wdw == msgWindow.wdw)
		return &msgWindow;
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgWindow_SetDocument(msgWindowType *ptr, _BOOL new)
{
	LGRECT doc;

	doc.x = ptr->leftOffset;
	doc.y = ptr->startPos;
	doc.w = ptr->maxWidth;
	doc.h = ptr->maxPos - 1;
	if (new)
		WdwManager_SetNewDocument(ptr->wdw, &doc, FALSE);
	else
		WdwManager_SetWdwDocument(ptr->wdw, &doc);
}

/******************************************************************************/
/*============================================================================*/
/* Hier kommen jetzt die Prozeduren zur Verwaltung des Messagefensters        */
/*============================================================================*/
/******************************************************************************/

/* ---------------------- Font-Funktionen ----------------------- */

/* Setzt den Font fuer das Stichwortlistenfenster */
LOCAL _VOID iMsgSetFont(HWND wdw, _WORD fnt, _WORD fntSize, _BOOL redraw)
{
	GRECT r;
	msgWindowType *ptr;
	
	if ((ptr = FindWind(wdw)) != NULL)
	{
		ptr->font = fnt;
		ptr->fontSize = fntSize;
		FontSelect_SetFont(ptr->vdi,
			&ptr->font,
			&ptr->fontSize,
			FALSE,
			&ptr->monoSpaced,
			&ptr->isFSM,
			&ptr->charWidth,
			&ptr->charHeight);
		/* Jetzt ist der Font gesetzt. Jetzt noch Window snappen und dann neu
		 * zeichnen lassen
		 */
		ptr->maxWidth = 0;
		ConfVars_SetConfigInt(cMsgSelectFont, ptr->font);
		ConfVars_SetConfigInt(cMsgSelectFontSize, ptr->fontSize);
		WdwManager_SetDocumentParms(wdw, 1, 2 * ptr->charHeight + ptr->lineDist);
		WdwManager_GetWdwSize(wdw, &r);
		WdwManager_SetWdwSize(wdw, &r);
		r = ptr->msgWork;
		r.g_x += ptr->pixOffset;
		if (redraw)
		{
			if (!ptr->isHidden)
				WdwManager_RedrawWdw(wdw, &r);
			MsgWindow_SetDocument(ptr, FALSE);
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Selektion von Eintraegen ----------------------*/

#define is_visible(ptr, i) \
	((i) >= (ptr)->startPos && (i) <= (ptr)->startPos + (ptr)->windLines)

LOCAL _BOOL hasSelectedEntries(msgWindowType *ptr, _WORD *first)
{
	_WORD i;

	for (i = 0; i < ptr->maxPos; i++)
		if (ptr->list[i].selected)
		{
			*first = i;
			return TRUE;
		}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR countSelectedEntries(msgWindowType *ptr)
{
	_WORD i;
	MSGNR counter;
	
	counter = 0;
	for (i = 0; i < ptr->maxPos; i++)
		if (ptr->list[i].selected)
			++counter;
	return counter;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawEntry(msgWindowType *ptr, _WORD entry)
{
	GRECT rect;

	if (ptr->wdw < 0 || ptr->isHidden)
		return;
	if (entry >= ptr->maxPos)
		return;
	rect = ptr->msgWork;
	rect.g_x += ptr->pixOffset;
	rect.g_y = rect.g_y + (entry - ptr->startPos) * (2 * ptr->charHeight + ptr->lineDist);
	rect.g_h = 2 * ptr->charHeight + ptr->lineDist;
	WdwManager_RedrawWdw(ptr->wdw, &rect);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID toggleEntry(msgWindowType *ptr, _WORD entry)
{
	if (entry >= ptr->maxPos || entry < 0)
		return;
	ptr->list[entry].selected = !ptr->list[entry].selected;
	redrawEntry(ptr, entry);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_deselectEntries(HWND wdw)
{
	_WORD i;
	GRECT rect;
	_BOOL first;
	msgWindowType *ptr;
	
	ptr = FindWind(wdw);
	if (ptr == NULL)
		return;
	rect = ptr->msgWork;
	rect.g_x += ptr->pixOffset;
	first = TRUE;
	rect.g_h = 2 * ptr->charHeight + ptr->lineDist;
	for (i = 0; i < ptr->maxPos; i++)
	{
		if (ptr->list[i].selected)
		{
			ptr->list[i].selected = FALSE;
			if (is_visible(ptr, i))
			{
				/* redraw */
				if (first)
				{
					rect.g_y = ptr->msgWork.g_y + (i - ptr->startPos) * (2 * ptr->charHeight + ptr->lineDist);
					first = FALSE;
				} else
				{
					rect.g_h = ptr->msgWork.g_y + (i - ptr->startPos + 1) * (2 * ptr->charHeight + ptr->lineDist) - rect.g_y;
				}
			}
		}
	}
	if (!first)
		WdwManager_RedrawWdw(ptr->wdw, &rect);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Funktionen fuer WdwManager --------------------*/

LOCAL _VOID AdjustTreePos(CONST GRECT *r, GRECT *rt)
{
	butBox[ROOT].ob_x = r->g_x;
	butBox[ROOT].ob_y = r->g_y;
	butBox[ROOT].ob_width = r->g_w;
	rt->g_x = butBox[ROOT].ob_x;
	rt->g_y = butBox[ROOT].ob_y;
	rt->g_w = butBox[ROOT].ob_width;
	rt->g_h = butBox[ROOT].ob_height + 1;
}

/*** ---------------------------------------------------------------------- ***/

/* Geht davon aus, dass RectFuncs.ClipRect gesetzt ist und nur Zeilen zu zeichnen sind!
 */
/*DYJ 5.21b */
LOCAL _VOID MsgWindow_rawRedraw(msgWindowType *ptr, CONST GRECT *clip)
{
	_WORD i;
	_WORD width;
	_WORD xOutput, yOutput;
	_WORD xOffset;
	_WORD topLine;
	_UBYTE tmpStr[256];
	_UBYTE msgName[PATH_MAX];
	msgInfo msg;
	GRECT fill;
	_BOOL isStatus;
	_WORD col,eff,oldcol=-1,oldeff=-1;

	topLine = ptr->startPos;
	i = 0;   /* Zeilenzaehler im Fenster */
	/* Nicht im Redrawbereich liegende Zeilen ueberspringen */
	while (topLine < ptr->maxPos && (ptr->msgWork.g_y + (i + 1) * (2 * ptr->charHeight + ptr->lineDist)) <= clip->g_y)
	{
		++topLine;
		++i;
	}
	xOutput = ptr->msgWork.g_x + ptr->pixOffset - ptr->leftOffset;
	yOutput = ptr->msgWork.g_y + i * (2 * ptr->charHeight + ptr->lineDist) + (ptr->lineDist / 2) + ptr->charHeight - 1;
	/* Eintrag in Liste suchen */
	/* Jetzt zeichnen */
	vsf_color(ptr->vdi, BLACK);
	vst_color(ptr->vdi, ptr->msgTextCol);
	vswr_mode(ptr->vdi, MD_TRANS);
	while (topLine < ptr->maxPos && i <= ptr->msgWork.g_h / (2 * ptr->charHeight + ptr->lineDist) &&
		yOutput <= clip->g_h + ptr->charHeight - 1)
	{
		msg = ptr->list[topLine];
		if (Messages_ReadHdrInfo(&msg, TRUE))
		{
			col=ptr->msgTextCol;
			eff=TXT_NORMAL;
			ptr->list[topLine] = msg;
			/* 1. Zeile: MSG001   An/Gruppe: <empfaenger/gruppenname>
			 * 2. Zeile: status   Wegen:
			 */
			if(	msg.info.msgType ==	msg_copyOwn		||
				msg.info.msgType ==	msg_forward		||
				msg.info.msgType ==	msg_persanswer	||
				msg.info.msgType ==	msg_answer		||
				msg.info.msgType ==	msg_pseudoKom	||	/*DYJ 5.34d */
				msg.info.msgType ==	msg_pseudoNews	||	/*DYJ 5.34d */
				msg.info.msgType ==	msg_private			)
			{
				switch (ptr->msgPersEff)
				{
					case 1: eff|= TXT_THICKENED; break;
					case 2: eff|= TXT_SKEWED; break;
					case 3: eff|= TXT_LIGHT; break;
				}
				if(ptr->msgPersCol!=KEEPCOL)
					col=ptr->msgPersCol;
			}
			if (!msg.info.sendMsg)
			{
				switch (ptr->msgHoldEff)
				{
					case 1: eff|= TXT_THICKENED; break;
					case 2: eff|= TXT_SKEWED; break;
					case 3: eff|= TXT_LIGHT; break;
				}
				if(ptr->msgHoldCol!=KEEPCOL)
					col=ptr->msgHoldCol;
			}
			if (msg.info.toDelete)
				eff |= TXT_SKEWED;
			if(col!=oldcol)
			{
				vst_color(ptr->vdi, col);
				oldcol=col;
			}
			if(eff!=oldeff)
			{
				vst_effects(ptr->vdi, eff);
				oldeff=eff;
			}
			/* Jetzt die einzelnen Zeilenteile ausgeben */
			xOffset = 0;
			Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msgName);
			xOffset += (_WORD)(strLen(msgName) + 2) * ptr->charWidth;
			{
				CONST _UBYTE *txt;
				
				switch (msg.info.msgType)
				{
					case msg_copyOwn:
					case msg_copyOther    : txt = MausTauschrsc_WrkString(msgCopy); break;
					case msg_forward      : txt = MausTauschrsc_WrkString(msgForward); break;
					case msg_groupcomment : txt = MausTauschrsc_WrkString(msgGrpComm); break;
					case msg_comment      : txt = MausTauschrsc_WrkString(msgComm); break;
					case msg_mail         : txt = MausTauschrsc_WrkString(msgMail); break;
					case msg_persanswer   : txt = MausTauschrsc_WrkString(msgPersAnswer); break;
					case msg_pseudoKom	  :	/*DYJ 5.34d */
					case msg_answer       : txt = MausTauschrsc_WrkString(msgAnswer); break;
					case msg_pseudoNews   :	/*DYJ 5.34d */
					case msg_private      : txt = Rsc_WrkString(GRP_PRIVATE); break;
					default               : txt = "???"; break;
				}
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, txt);
				xOffset += 18 * ptr->charWidth;
			}
			isStatus =
				msg.info.msgType == msg_copyOther ||
				msg.info.msgType == msg_copyOwn ||
				msg.info.msgType == msg_forward;
			if (msg.info.msgType == msg_mail ||
				msg.info.msgType == msg_comment ||
				msg.info.msgType == msg_groupcomment)
			{
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msgDistr);
				xOffset += 8 * ptr->charWidth;
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msgDistribs[msg.info.dist]);
				xOffset += 10 * ptr->charWidth;
			} else
			{
				xOffset += 18 * ptr->charWidth;
			}
			if (msg.info.sendMsg)
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgSend));
			else
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgKlemm));
			xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgKlemm)) + 3) * ptr->charWidth;
			if (!isStatus)
			{
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgSize));
				xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgSize)) + 1) * ptr->charWidth;
				LNumToStr(msg.info.size, 10, 0, ' ', msgName, sizeof(msgName));
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msgName);
				xOffset += (_WORD)(strLen(msgName) + 1) * ptr->charWidth;
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgBytes));
				xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgBytes)) + 2) * ptr->charWidth;
			}
			/* Jetzt noch Datum und Uhrzeit */
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgDate));
			xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgDate)) + 1) * ptr->charWidth;
			/* Datum und Zeit in String setzen */
			T_Strlftime(tmpStr, sizeof(tmpStr), "%101a, %d. %1b %Y, %H:%M:%S Uhr", T_DosToSystime(msg.info.cDate, msg.info.cTime));
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, tmpStr);
			xOffset += (_WORD)(strLen(tmpStr) + 1) * ptr->charWidth;
			width = xOffset;
			
			/* Zweite Zeile:
			 * Gruppe/Empfaenger und dann Stichwort
			 */
			yOutput += ptr->charHeight;
			xOffset = ptr->charWidth;
			if (msg.info.msgType == msg_comment ||
				msg.info.msgType == msg_mail ||
				msg.info.msgType == msg_groupcomment)
			{
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgGroup));
				xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgGroup)) + 1) * ptr->charWidth;
				if (msg.group != NULL)
				{
					VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msg.group);
					xOffset += (_WORD)(strLen(msg.group) + 2) * ptr->charWidth;
				}
			} else
			{
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgAn));
				xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgAn)) + 1) * ptr->charWidth;
				if (msg.receiver != NULL)
				{
					VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msg.receiver);
					xOffset += (_WORD)(strLen(msg.receiver) + 2) * ptr->charWidth;
				}
			}
			xOffset = Max(xOffset, 26 * ptr->charWidth);
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgWegen));
			xOffset += (_WORD)(strLen(MausTauschrsc_WrkString(msgWegen)) + 1) * ptr->charWidth;
			if (msg.topic != NULL)
			{
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msg.topic);
				xOffset += (_WORD)(strLen(msg.topic) + 1) * ptr->charWidth;
			}
			
			yOutput -= ptr->charHeight;
			width = Max(width, xOffset);
			

		} else
		{
			/* Header konnte nicht gelesen werden! Name ausgeben und
			 * dahinter Fehlermeldung
			 */
			/* Jetzt die einzelnen Zeilenteile ausgeben */
			xOffset = 0;
			Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, msgName);
			xOffset += (_WORD)(strLen(msgName) + 2) * ptr->charWidth;
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput, MausTauschrsc_WrkString(msgNoHdrText));
			VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput + ptr->charHeight, MausTauschrsc_WrkString(msgNoHdrText2));
			xOffset += (Max((_WORD)strLen(MausTauschrsc_WrkString(msgNoHdrText)), (_WORD)strLen(MausTauschrsc_WrkString(msgNoHdrText2))) + 2) * ptr->charWidth;
			width = xOffset;
		}

		ptr->maxWidth = Max(ptr->maxWidth, width + ptr->pixOffset);
		if (msg.selected)
		{
			fill.g_x = xOutput;
			fill.g_y = yOutput - ptr->charHeight + 1;
			fill.g_w = xOutput + ptr->maxWidth - 1;
			fill.g_h = yOutput + ptr->charHeight;
			/* Schreibmodus setzen */
			vswr_mode(ptr->vdi, MD_XOR);
			vr_recfl(ptr->vdi, (_WORD *)&fill);
			vswr_mode(ptr->vdi, MD_TRANS);
		}

		++i;
		++topLine;
		yOutput += 2 * ptr->charHeight + ptr->lineDist;
	}
	vswr_mode(ptr->vdi, MD_REPLACE);
	vsf_color(ptr->vdi, ptr->msgBackCol);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawMsgWdw(HWND wdw, HVDI vdiH, _VOID *special, CONST GRECT *frame)
{
	GRECT clip;
	msgWindowType *ptr;
	_WORD oldMax;
	
	UNUSED(wdw);
	UNUSED(vdiH);
	ptr = special;
	clip = *frame;
	if (rc_intersect(&ptr->butWork, &clip))
	{
		VDIUtil_SetTreeColor(butBox, ptr->msgTextCol, ptr->msgBackCol);
		mtDials_DialDraw(butBox, ROOT, MAX_DEPTH, &clip, TRUE);
		MouseOff();
	}
	clip = *frame;
	if (rc_intersect(&ptr->msgWork, &clip))
	{
		oldMax = ptr->maxWidth;
		clip = rc_clip(frame, &ptr->msgWork);
		clip.g_w = clip.g_x + clip.g_w - 1;
		clip.g_h = clip.g_y + clip.g_h - 1;
		
		vsf_color(ptr->vdi, ptr->msgBackCol);
		vr_recfl(ptr->vdi, (_WORD *)&clip);
		
		if (clip.g_x == ptr->msgWork.g_x)
			clip.g_x += ptr->pixOffset;
		
		clip.g_x = Min(clip.g_x, clip.g_w);
		
		WdwManager_SetClip(ptr->vdi, &clip, FALSE);
		
		MsgWindow_rawRedraw(ptr, &clip);
		
		if (oldMax != ptr->maxWidth)
			MsgWindow_SetDocument(ptr, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawButton(HWND wdw, OBJECT *tree, _WORD ob)
{
	GRECT r;
	
	ObjcPos(tree, ob, &r.g_x, &r.g_y);
	--r.g_x;
	--r.g_y;
	r.g_w = tree[ob].ob_width + 1;
	r.g_h = tree[ob].ob_height + 1;
	WdwManager_RedrawWdw(wdw, &r);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	msgInfo msg;
	_BOOL isCopy;
	_BOOL wasPrivate;
	_BOOL isPrivate;
	group_lineXXL grName;
	group_lineXXL lastName;
	_WORD exitBut;
	group_line grRepl;
	group_line lastRepl;
	group_line grSend;
	group_line lastSend;
	group_line grFrom;
	group_line lastFrom;
	group_lineXXL grFoll;
	group_lineXXL lastFoll;
	group_lineXXL grBcc;
	group_lineXXL lastBcc;
	_BOOL delRealName;
} grChangeInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawGrName(OBJECT *tree)
{
	_WORD x1, y1;
	GRECT r;
	
	ObjcArea(tree, CHGRUPPE, &r);
	ObjcPos(tree, CHGRSTR, &x1, &y1);
	r.g_w += r.g_x - x1;
	r.g_h += r.g_y - y1;
	r.g_x = x1;
	r.g_y = y1;
	WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

/* Empfaenger auswaehlen */
/*DYJ 5.24e */	/*DYJ 5.23i */
#define ZLEN 49
LOCAL _BOOL selName(OBJECT *tree, grChangeInfo *chInfo,_WORD but)
{
	_WORD adrAnz,adrNr,x,y,i,adrselTyp=ADR_NORMAL_EMPTY;
	_UBYTE *adr,*ptr,*part,*tmpStr=NULL,*namen;
	size_t lenTmp;
	switch(but)
	{
		case CHGRUPPE:
			namen=chInfo->grName;
			break;
		case CHFOLLOWUP:
			namen=chInfo->grFoll;
			break;
		case CHBCC:
			namen=chInfo->grBcc;
			break;
		default:
			return FALSE;
	}
	if(UserBLK.isInternet)
	{
		ObjcPos(tree, but, &x, &y);
		adrAnz=(_WORD)strCnt(namen,',');
		if(*namen)
			adrAnz++;
		if(adrAnz==1 && but==CHGRUPPE)
			adrselTyp=ADR_NORMAL;
		lenTmp=LMax(sizeof(group_lineXXL),ZLEN*(2+adrAnz));
		tmpStr=SYSMALLOC(lenTmp,MEM_NOERR,"selName:tmpStr");
		if(!tmpStr)
		{
			MTE_info(Rsc_WrkString(AL_ERRMEM));
			return FALSE;
		}
		
		adr=namen;
		for(i=0;i<adrAnz;i++)
		{
			part=tmpStr+ZLEN*i;
			strnCpy(part,adr,ZLEN);
			tmpStr[part+ZLEN]='\0';
			ptr=strChr(part,',');
			if(!ptr)
				ptr=strChr(part,'\0');
			while(ptr<(part+ZLEN-1))
				*(ptr++)=' ';
			part[ZLEN-1]='|';
			part[ZLEN]='\0';
			adr=strChr(adr,',')+1;
		}
		part=tmpStr+ZLEN*adrAnz;
		sprintf(part,"%-*s",ZLEN,MausTauschrsc_WrkString(msgNeu));
		if(adrAnz)
			adrNr = mtPopups_PosPopup(x, y, tmpStr, NULL);
		else
			adrNr = 0;
		if(adrNr<0)
		{
			SFREE(tmpStr);
			return FALSE;
		}
		else if(adrNr==adrAnz)
		{
			*tmpStr='\0';
			part=strChr(namen,'\0');
		}
		else
		{
			part=namen;
			for(i=0;i<adrNr;i++)
				part=strChr(part,',')+1;
			strCpy(tmpStr,part);
			ptr=strChr(tmpStr,',');
			if(ptr)
				*ptr='\0';
		}
	}
	else
	{
		tmpStr=namen;
		lenTmp=sizeof(group_lineXXL);
	}
	if (adr_SelectName(adrselTyp,tmpStr, lenTmp))
	{
		if(*tmpStr)
		{
			if(adrNr<(adrAnz-1))
			{
				ptr=strChr(part,',');
				if(ptr)
					strCat(tmpStr,ptr);
			}
			else if(adrNr==adrAnz && adrAnz)
				strCpy(part++,",");
			strCpy(part,tmpStr);
		}
		else
		{
			ptr=strChr(part,',');
			if(ptr)
				strCpy(part,ptr+1);
			else if(adrNr)
				part[-1]='\0';
			else
				*namen='\0';
		}
		if(tmpStr && tmpStr!=namen)
			SFREE(tmpStr);
		SetObjcString(tree, but, namen);
		switch(but)
		{
			case CHGRUPPE:
				SetObjcString(tree, CHGRSTR, MausTauschrsc_WrkString(msgAn));
				strBcpy(chInfo->lastName, chInfo->grName);
				break;
			case CHFOLLOWUP:
				SetObjcString(tree,  CHFUSTR, "CC:");
				strBcpy(chInfo->lastFoll, chInfo->grFoll);
				break;
			case CHBCC:
				SetObjcString(tree,  CHBCCSTR, "BCC:");
				strBcpy(chInfo->lastBcc, chInfo->grBcc);
				break;
		}
		chInfo->isPrivate = TRUE;
		return TRUE;
		
	}
	if(	tmpStr && tmpStr!=namen)
		SFREE(tmpStr);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID redrawGrSonst(OBJECT *tree,_WORD button)
{
	GRECT r;
	
	ObjcArea(tree, button, &r);
	WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
}
/* Reply-To oder Sender auswaehlen */
/*DYJ 5.23i */
LOCAL _BOOL selRepl(OBJECT *tree, grChangeInfo *chInfo,_BOOL useAlias)
{
	_WORD nor_alias=ADR_N_REPLY;
	if(useAlias)
		nor_alias=ADR_A_REPLY;
	if (adr_SelectName(nor_alias,chInfo->grRepl, sizeof(chInfo->grRepl)))
	{
		SetObjcString(tree, CHREPLYTO, chInfo->grRepl);
		strBcpy(chInfo->lastRepl, chInfo->grRepl);
		return TRUE;
	}
	return FALSE;
}
LOCAL _BOOL selSend(OBJECT *tree, grChangeInfo *chInfo,_BOOL useAlias)
{
	_WORD nor_alias=ADR_N_SENDER;
	if(useAlias)
		nor_alias=ADR_A_SENDER;
	if (adr_SelectName(nor_alias,chInfo->grSend, sizeof(chInfo->grSend)))
	{
		SetObjcString(tree, CHSENDER, chInfo->grSend);
		strBcpy(chInfo->lastSend, chInfo->grSend);
		redrawGrSonst(tree,CHSENDER);
		return TRUE;
	}
	return FALSE;
}
/*Und das Gleiche nochmal fr den Absender*/
/*DYJ 5.23i */
LOCAL _BOOL selFrom(OBJECT *tree, grChangeInfo *chInfo,_BOOL useAlias)
{
	_WORD nor_alias=ADR_N_FROM;
	if(useAlias)
		nor_alias=ADR_A_FROM;
	if (adr_SelectName(nor_alias,chInfo->grFrom, sizeof(chInfo->grFrom)))
	{
		SetObjcString(tree, CHFROM, chInfo->grFrom);
		strBcpy(chInfo->lastFrom, chInfo->grFrom);
		return TRUE;
	}
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/
/* Followup Gruppe auswaehlen */
/*DYJ 5.20w */	/*DYJ 5.23e */	/*DYJ 5.23i */
LOCAL _BOOL selFoll(OBJECT *tree, grChangeInfo *chInfo)
{
	CAT_GROUP_NUMBER newGroup;
	if( strCaseCmp(chInfo->grFoll, "Poster")==0 )
		STRDUP(chInfo->grFoll, Rsc_WrkString(GRP_PRIVATE));

	if (ListHelp_SelectGroup(chInfo->grFoll, sizeof(chInfo->grFoll), &newGroup, TRUE, FALSE, FALSE, gsmFollowup))
	{
		if (!GroupSelect_isPrivate(newGroup))
			SetObjcString(tree, CHFOLLOWUP, chInfo->grFoll);
		else
		{
			strCpy(chInfo->grFoll, "poster");
			SetObjcString(tree, CHFOLLOWUP, "poster");
		}
		strBcpy(chInfo->lastFoll, chInfo->grFoll);
		return TRUE;
	}
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/

/* Gruppe auswaehlen */
/*DYJ 5.21b */	/*DYJ 5.23i */
LOCAL _BOOL selGroup(OBJECT *tree, grChangeInfo *chInfo)
{
	CAT_GROUP_NUMBER newGroup;

	if (ListHelp_SelectGroup(chInfo->grName, sizeof(chInfo->grName), &newGroup, TRUE, FALSE, FALSE, gsmWrite))
	{
		SetObjcString(tree, CHGRSTR, MausTauschrsc_WrkString(msgGroup));
		if (!GroupSelect_isPrivate(newGroup))
			SetObjcString(tree, CHGRUPPE, chInfo->grName);
		strBcpy(chInfo->lastName, chInfo->grName);
		chInfo->isPrivate = FALSE;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DiscardRadioSelect(OBJECT *tree, OBJECT *popup1, _WORD sel)
{
	GRECT r;
	
	VDIUtil_SetXState(tree, CHTYPE1, sel);
	VDIUtil_SetXString(tree, CHTYPE1, popup1, sel);
	WinDials_WinDialDraw(tree, CHTYPE1, 0, &r, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID enablePopup(OBJECT *tree, _WORD ob, _BOOL enable, _BOOL draw)
{
	GRECT r;
	
	EnableObjFlags(tree, ob,   TOUCHEXIT, enable);
	EnableObjFlags(tree, ob+1, TOUCHEXIT, enable);
	EnableObjState(tree, ob,   DISABLED, !enable);
	EnableObjState(tree, ob+1, DISABLED, !enable);
	if (draw)
		WinDials_WinDialDraw(tree, ob, 1, &r, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */	/*DYJ 5.23i */	/*DYJ 5.29g */
LOCAL _BOOL changeButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	grChangeInfo *chInfo;
	OBJECT *popup1, *popup2, *pop;
	_WORD x, y;
	group_line scrap;
	GRECT r;
	_WORD select;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	popup1 = TreeAddr[MSGTYPBX];
	popup2 = TreeAddr[DISTRIBX];
	chInfo = env;
	if (button == CHDIST0)
		button = CHDIST1;
	else if (button == CHTYPE0)
		button = CHTYPE1;
	DelObjState(tree, button, SELECTED);
	switch (button)
	{
	case CHHELP:
		CatHelp_DoHelp(CatHelp_changemsg);
		CalcArea(tree, button, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	
	case CHQUIT:
		return TRUE;
		
	case CHOK:
		ObjcString(tree, CHWEGEN, scrap, sizeof(scrap));
		if (!chInfo->isCopy)
		{
			if (grinTools_CheckBetreff(scrap))
			{
				SetObjcString(tree, CHWEGEN, scrap);
				return TRUE;
			}
		} else if (strLen(scrap) > 80 && chInfo->isCopy)
		{
			MTE_infoRSC(MTE_longCopy);
		} else
		{
			return TRUE;
		}
		CalcArea(tree, button, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	
	case CHDIST1:
	case CHTYPE1:
		if (button == CHDIST1)
			pop = popup2;
		else
			pop = popup1;
		if (!GetObjState(tree, button, DISABLED))
		{
			objc_offset(tree, button, &x, &y);
			select = mtPopups_TreePopup(pop, x, y, VDIUtil_GetXState(tree, button)) - 1;
			if (select >= 0)
			{
				VDIUtil_SetXState(tree, button, select);
				VDIUtil_SetXString(tree, button, pop, select);
				WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
			}
		}
		break;
		
	case CHDIST2:
		select = VDIUtil_GetXState(tree, CHDIST1);
		if(kstate&K_SHIFT)
			select = (select + 3) % 4;
		else
			select = (select + 1) % 4;
		VDIUtil_SetXState(tree, CHDIST1, select);
		VDIUtil_SetXString(tree, CHDIST1, popup2, select);
		WinDials_WinDialDraw(tree, CHDIST1, 0, &r, FALSE);
		break;
	
	case CHTYPE2:
		select = VDIUtil_GetXState(tree, CHTYPE1);
		if(kstate&K_SHIFT)
			select = (select + 2) % 2;
		else
			select = (select + 1) % 2;
		VDIUtil_SetXState(tree, CHTYPE1, select);
		VDIUtil_SetXString(tree, CHTYPE1, popup1, select);
		WinDials_WinDialDraw(tree, CHTYPE1, 0, &r, FALSE);
		break;
	
	case CHGRUPPE: /* Entweder neuen Namen oder neue Gruppe auswaehlen und setzen */
		if (chInfo->isPrivate)
		{
			ObjcString(tree, button, scrap, sizeof(scrap));
			selName(tree, chInfo,CHGRUPPE);
		} else
		{
			selGroup(tree, chInfo);
		}
		redrawGrName(tree);
		break;
	case CHREPLYTO: /* Reply-To auswaehlen und setzen */
		ObjcString(tree, button, scrap, sizeof(scrap));
		selRepl(tree, chInfo,(kstate&K_SHIFT)==0);
		redrawGrSonst(tree,button);
		break;
	case CHSENDER: /* Sender auswaehlen und setzen */
		ObjcString(tree, button, scrap, sizeof(scrap));
		selSend(tree, chInfo,(kstate&K_SHIFT)==0);
		redrawGrSonst(tree,button);
		break;
	case CHFROM: /* Absender auswaehlen und setzen */
		ObjcString(tree, button, scrap, sizeof(scrap));
		selFrom(tree, chInfo,(kstate&K_SHIFT)==0);
		redrawGrSonst(tree,button);
		break;
	case CHBCC: /* BCC auswaehlen und setzen */
		ObjcString(tree, button, scrap, sizeof(scrap));
		selName(tree, chInfo,CHBCC);
		redrawGrSonst(tree,button);
		break;
	case CHFOLLOWUP: /* Followup auswaehlen und setzen */
		if (chInfo->isPrivate)
		{
			ObjcString(tree, button, scrap, sizeof(scrap));
			selName(tree, chInfo,CHFOLLOWUP);
		} 
		else
			selFoll(tree, chInfo);
		redrawGrSonst(tree,button);
		break;

	}
	if (button == CHTYPE1 || button == CHTYPE2)
	{
		select = VDIUtil_GetXState(tree, CHTYPE1);
		if (chInfo->isPrivate && select == 1)
		{
			chInfo->grName[0] = '\0';
			if (!selGroup(tree, chInfo))
				DiscardRadioSelect(tree, popup1, 0);
			else
				enablePopup(tree, CHDIST1, !(chInfo->isPrivate || chInfo->isCopy), TRUE);
		} else if (!chInfo->isPrivate && select == 0)
		{
			chInfo->grName[0] = '\0';
			scrap[0] = '\0';
			if (!selName(tree, chInfo,CHGRUPPE))
				DiscardRadioSelect(tree, popup1, 1);
			else
				enablePopup(tree, CHDIST1, !(chInfo->isPrivate || chInfo->isCopy), TRUE);
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.23i */	/*DYJ 5.29b */
LOCAL _VOID changeGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	grChangeInfo *chInfo;
	OBJECT *popup1, *popup2;
	group_lineXXL scrap;
	_WORD max;
	
	chInfo = env;
	exit &= 0x7fff;
	chInfo->exitBut = exit;
	popup1 = TreeAddr[MSGTYPBX];
	popup2 = TreeAddr[DISTRIBX];
	if (set)
	{
		EnableObjState(tree, CHKLEMM, SELECTED, !chInfo->msg.info.sendMsg);
		chInfo->isPrivate =
			chInfo->msg.info.msgType == msg_answer ||
			chInfo->msg.info.msgType == msg_pseudoKom ||	/*DYJ 5.34d */
			chInfo->msg.info.msgType == msg_pseudoNews ||	/*DYJ 5.34d */
			chInfo->msg.info.msgType == msg_private ||
			chInfo->msg.info.msgType == msg_persanswer;
		chInfo->isCopy =
			chInfo->msg.info.msgType == msg_copyOwn ||
			chInfo->msg.info.msgType == msg_copyOther ||
			chInfo->msg.info.msgType == msg_forward;
		chInfo->isPrivate = chInfo->isPrivate || chInfo->isCopy;
		if (chInfo->isPrivate)
			max = 0;
		else
			max = 1;
		if (chInfo->msg.refId != NULL && chInfo->msg.refId[0] != '\0')
			SetObjcString(tree, CHREFID, chInfo->msg.refId);
		else
			SetObjcString (tree, CHREFID, "");
		VDIUtil_SetXState(tree, CHTYPE1, max);
		VDIUtil_SetXString(tree, CHTYPE1, popup1, max);
		enablePopup(tree, CHTYPE1, !chInfo->isCopy, FALSE);
		if (chInfo->isPrivate)
		{
			strBcpy(chInfo->lastName, chInfo->msg.receiver ? chInfo->msg.receiver : (CONST _UBYTE *)"");
			strBcpy(chInfo->grName, chInfo->lastName);
			SetObjcString(tree, CHGRSTR, MausTauschrsc_WrkString(msgAn));
			SetObjcString(tree, CHGRUPPE, chInfo->grName);
			strBcpy(chInfo->lastFoll, chInfo->msg.cc ? chInfo->msg.cc : (CONST _UBYTE *)"");
			strBcpy(chInfo->grFoll, chInfo->lastFoll);
			SetObjcString(tree, CHFOLLOWUP, chInfo->grFoll);

			strBcpy(chInfo->lastBcc, chInfo->msg.bcc ? chInfo->msg.bcc : (CONST _UBYTE *)"");
			strBcpy(chInfo->grBcc, chInfo->lastBcc);
			SetObjcString(tree, CHBCC, chInfo->grBcc);
		} else
		{
			strBcpy(chInfo->lastName, chInfo->msg.group ? chInfo->msg.group : (CONST _UBYTE *)"");
			strBcpy(chInfo->grName, chInfo->lastName);
			SetObjcString(tree, CHGRSTR, MausTauschrsc_WrkString(msgGroup));
			SetObjcString(tree, CHGRUPPE, chInfo->grName);
			strBcpy(chInfo->lastFoll, chInfo->msg.followupTo ? chInfo->msg.followupTo : (CONST _UBYTE *)"");
			strBcpy(chInfo->grFoll, chInfo->lastFoll);
			SetObjcString(tree, CHFOLLOWUP, chInfo->grFoll);
		}
		strBcpy(chInfo->lastRepl, chInfo->msg.replyTo ? chInfo->msg.replyTo : (CONST _UBYTE *)"");
		strBcpy(chInfo->grRepl, chInfo->lastRepl);
		SetObjcString(tree, CHREPLYTO, chInfo->grRepl);

		strBcpy(chInfo->lastSend, chInfo->msg.sender ? chInfo->msg.sender : (CONST _UBYTE *)"");
		strBcpy(chInfo->grSend, chInfo->lastSend);
		SetObjcString(tree, CHSENDER, chInfo->grSend);

		
		SetObjcString(tree, CHWEGEN, chInfo->msg.topic ? chInfo->msg.topic : (CONST _UBYTE *)"");
		EnableObjFlags(tree, CHDIST0, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(tree, CHDIST1, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(tree, CHDIST2, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(tree, CHDISTB, HIDETREE, UserBLK.isInternet);
		if(!UserBLK.isInternet)
		{
			VDIUtil_SetXState(tree, CHDIST1, chInfo->msg.info.dist);
			VDIUtil_SetXString(tree, CHDIST1, popup2, chInfo->msg.info.dist);
			enablePopup(tree, CHDIST1, !(chInfo->isPrivate || chInfo->isCopy), FALSE);
		}
		strBcpy(chInfo->lastFrom, chInfo->msg.Absender ? chInfo->msg.Absender : (CONST _UBYTE *)"");
		strBcpy(chInfo->grFrom, chInfo->lastFrom);
		SetObjcString(tree, CHFROM, chInfo->grFrom);

		tree[CHFRSTR].ob_y =tree[CHFROM].ob_y = tree[CHDIST0].ob_y;
		EnableObjFlags(tree, CHFRSTR, HIDETREE, !UserBLK.isInternet);
		EnableObjFlags(tree, CHFROM, HIDETREE, !UserBLK.isInternet);
		EnableObjFlags(tree, CHFOLLOWUP, HIDETREE, ((chInfo->isPrivate&& !UserBLK.isInternet)|| chInfo->isCopy));
		EnableObjFlags(tree, CHFUSTR, HIDETREE, ((chInfo->isPrivate&& !UserBLK.isInternet)|| chInfo->isCopy));
		SetObjcString(tree, CHFUSTR, chInfo->isPrivate?"CC:":"FollowUp");

		EnableObjFlags(tree, CHBCC, HIDETREE, !chInfo->isPrivate || !UserBLK.isInternet);
		EnableObjFlags(tree, CHBCCSTR, HIDETREE, !chInfo->isPrivate || !UserBLK.isInternet);

		chInfo->wasPrivate = chInfo->isPrivate;
	} else
	{
		if (exit == CHOK)
		{
			chInfo->msg.info.dist = (tDistribution)VDIUtil_GetXState(tree, CHDIST1);
			chInfo->msg.info.sendMsg = !GetObjState(tree, CHKLEMM, SELECTED);
			ObjcString(tree, CHWEGEN, scrap, sizeof(scrap));
			if (chInfo->msg.topic == NULL || strCmp(chInfo->msg.topic, scrap) != 0)
			{
				if (chInfo->msg.topic != NULL)
					SFREE(chInfo->msg.topic);
				chInfo->msg.topic = STRDUP(scrap, "msgWindow: changeGetValues: topic");
			}
			/*
			ObjcString(tree, CHGRUPPE, scrap);
			*/
			/* lastName enthaelt den zuletzt ausgewaehlten Namen oder die
			 * zuletzt ausgewaehlte Gruppe
			 */
			strBcpy(scrap, chInfo->lastName);
			if (chInfo->isPrivate)
			{
				if(chInfo->msg.realName)
				{
					size_t len;
					len=strcSpn(chInfo->msg.receiver,",");
					if(len!=strcSpn(scrap,",") || strnCaseCmp(chInfo->msg.receiver,scrap,len))
					{
						SFREE(chInfo->msg.realName);
						chInfo->msg.realName=NULL;
					}
				}
				if (chInfo->msg.receiver == NULL || strCmp(chInfo->msg.receiver, scrap) != 0)
				{
/*DYJ 5.34d Start*/
					if (chInfo->msg.info.msgType == msg_answer ||chInfo->msg.info.msgType == msg_pseudoKom)
/*DYJ  Ende; alt:	
					if (chInfo->msg.info.msgType == msg_answer)
*/
					{
						/* war Antwort, wird zu Laestermail */
						chInfo->msg.info.msgType = msg_persanswer;
						chInfo->msg.info.noRefLine = TRUE;
					}
					if (chInfo->msg.receiver != NULL)
						SFREE(chInfo->msg.receiver);
					chInfo->msg.receiver = STRDUP(scrap, "msgWindow: changeGetValues: receiver");
				}
				if (!chInfo->wasPrivate)
				{
					if ((chInfo->msg.info.msgType == msg_comment ||
						 chInfo->msg.info.msgType == msg_groupcomment) &&
						chInfo->msg.refId != NULL && chInfo->msg.refId[0] != '\0')
					{
						chInfo->msg.info.msgType = msg_persanswer;
						chInfo->msg.info.noRefLine = TRUE;
					} else
					{
						chInfo->msg.info.msgType = msg_private;
					}
				}
				ObjcString(tree, CHFOLLOWUP, PtrSize(scrap));
				strBcpy(scrap, chInfo->lastFoll);
				if (strCmp(chInfo->msg.cc ? chInfo->msg.cc : (CONST _UBYTE *)"", scrap) != 0)
				{
					if (chInfo->msg.cc != NULL)
						SFREE(chInfo->msg.cc);
					chInfo->msg.cc = STRDUP(scrap, "msgWindow: changeGetValues: cc");
				}
				ObjcString(tree, CHBCC, PtrSize(scrap));
				strBcpy(scrap, chInfo->lastBcc);
				if (strCmp(chInfo->msg.bcc ? chInfo->msg.bcc : (CONST _UBYTE *)"", scrap) != 0)
				{
					if (chInfo->msg.bcc != NULL)
						SFREE(chInfo->msg.bcc);
					chInfo->msg.bcc = STRDUP(scrap, "msgWindow: changeGetValues: bcc");
				}

			} else
			{
				if (chInfo->msg.group == NULL || strCmp(chInfo->msg.group, scrap) != 0)
				{
					if (chInfo->msg.group != NULL)
						SFREE(chInfo->msg.group);
					chInfo->msg.group = STRDUP(scrap, "msgWindow: changeGetValues: group");
				}
				if (chInfo->wasPrivate)
				{
/*DYJ 5.34d Start*/
					if ((chInfo->msg.info.msgType == msg_private ||chInfo->msg.info.msgType == msg_pseudoNews ||
/*DYJ  Ende; alt:	
					if ((chInfo->msg.info.msgType == msg_private ||
*/
						 chInfo->msg.info.msgType == msg_persanswer) && 
						chInfo->msg.refId != NULL &&
						chInfo->msg.refId[0] != '\0')
					{
						if (strCmp(chInfo->msg.group, chInfo->msg.orgGroup) == 0)
						{
							chInfo->msg.info.msgType = msg_comment;
							chInfo->msg.info.noRefLine = FALSE;
						} else
						{
							chInfo->msg.info.msgType = msg_groupcomment;
						}
					} else
					{
						chInfo->msg.info.msgType = msg_mail;
					}
				} else
				{
					if (strCmp(chInfo->msg.group, chInfo->msg.orgGroup) != 0 &&
						chInfo->msg.info.msgType == msg_comment)
					{
						chInfo->msg.info.msgType = msg_groupcomment;
					} else if (strCmp(chInfo->msg.group, chInfo->msg.orgGroup) == 0 &&
						chInfo->msg.info.msgType == msg_groupcomment)
					{
						chInfo->msg.info.msgType = msg_comment;
						chInfo->msg.info.noRefLine = FALSE;
					}
				}
				ObjcString(tree, CHFOLLOWUP, PtrSize(scrap));
				strBcpy(scrap, chInfo->lastFoll);
				if (strCmp(chInfo->msg.followupTo ? chInfo->msg.followupTo : (CONST _UBYTE *)"", scrap) != 0)
				{
					if (chInfo->msg.followupTo != NULL)
						SFREE(chInfo->msg.followupTo);
					chInfo->msg.followupTo = STRDUP(scrap, "msgWindow: changeGetValues: followupTo");
				}
			}
			ObjcString(tree, CHREPLYTO, PtrSize(scrap));
			strBcpy(scrap, chInfo->lastRepl);
			if (strCmp(chInfo->msg.replyTo ? chInfo->msg.replyTo : (CONST _UBYTE *)"", scrap) != 0)
			{
				if (chInfo->msg.replyTo != NULL)
					SFREE(chInfo->msg.replyTo);
				chInfo->msg.replyTo = STRDUP(scrap, "msgWindow: changeGetValues: replyTo");
			}
			ObjcString(tree, CHFROM, PtrSize(scrap));
			strBcpy(scrap, chInfo->lastFrom);
			if (strCmp(chInfo->msg.Absender ? chInfo->msg.Absender : (CONST _UBYTE *)"", scrap) != 0)
			{
				if (chInfo->msg.Absender != NULL)
					SFREE(chInfo->msg.Absender);
				chInfo->msg.Absender = STRDUP(scrap, "msgWindow: changeGetValues: Absender");
			}
			Messages_WriteHdrInfo(&chInfo->msg);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23i */
GLOBAL _BOOL MsgWindow_changeHdr(msgInfo *message)
{
	OBJECT *tree;
	grChangeInfo *cInfo;
	_WORD but;

	tree = TreeAddr[CHANGEBX];
	cInfo = NEW(grChangeInfo, "MsgWindow_changeHdr");
	MemSetZeroStruct(*cInfo);

	if (cInfo == NULL)
		return FALSE;
	cInfo->msg = *message;
	cInfo->grName[0] = '\0';
	if (WinDials_OpenWinDial(tree, TRUE,
		changeGetSetValues,
		changeGetSetValues,
		changeButton,
		WinDials_defDraw,
		NULL,
		cInfo))
	{
		WinDials_WinDialHandleEvents();
		but = cInfo->exitBut;
		if (but == CHOK)
			*message = cInfo->msg;
	} else
	{
		but = -1;
	}
	OFREE(cInfo);
	return but == CHOK;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID careForButtons(msgWindowType *ptr, _BOOL redraw)
{
	MSGNR selectCount;
	msgInfo msg;
	_WORD rdwCount, i;
	_BOOL isComm;
	_BOOL isMail;
	SET selSet;
	SET disSet;

	setclr(selSet);
	setclr(disSet);
		EnableObjFlags(butBox, CTRLDIS0, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(butBox, CTRLDIS1, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(butBox, CTRLDIS2, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(butBox, CTRLDISB, HIDETREE, UserBLK.isInternet);
	for (i = CTRLEDIT; i <= CTRLDIS2; i++)
	{
		if (GetObjState(butBox, i, SELECTED))
			setincl(selSet, i);
		if (GetObjState(butBox, i, DISABLED))
			setincl(disSet, i);
	}
	setincl(selSet, CTRLDIS1);  /* Fuer Redraw */
	if (ptr->wdw >= 0 && hasSelectedEntries(ptr, &ptr->sel))
	{
		selectCount = countSelectedEntries(ptr);
		msg = msgArray[ptr->sel];
		EnableObjState(butBox, CTRLDEL, DISABLED, FALSE);
		if (selectCount == 1)
		{
			isMail = msg.info.msgType == msg_mail || msg.info.msgType == msg_comment || msg.info.msgType == msg_groupcomment;
/*DYJ 5.34d Start*/
			isComm = !(msg.info.msgType == msg_mail || msg.info.msgType == msg_private||msg.info.msgType == msg_pseudoNews);
/*DYJ  Ende; alt:	
			isComm = !(msg.info.msgType == msg_mail || msg.info.msgType == msg_private);
*/
			EnableObjState(butBox, CTRLEDIT, DISABLED,
			         (msg.info.msgType == msg_copyOwn || msg.info.msgType == msg_copyOther || msg.info.msgType == msg_forward));
			EnableObjState(butBox, CTRLVIEW, DISABLED,
			         (msg.info.msgType == msg_copyOwn || msg.info.msgType == msg_copyOther || msg.info.msgType == msg_forward));
			EnableObjState(butBox, CTRLKOMM, DISABLED, !isMail);
			EnableObjState(butBox, CTRLCOPY, DISABLED,
/*DYJ 5.34d Start*/
			          !(msg.info.msgType == msg_private || msg.info.msgType == msg_answer ||msg.info.msgType == msg_pseudoNews|| 
			          msg.info.msgType == msg_pseudoKom ||msg.info.msgType == msg_persanswer));
/*DYJ  Ende; alt:	
			          !(msg.info.msgType == msg_private || msg.info.msgType == msg_answer || msg.info.msgType == msg_persanswer));
*/
			EnableObjState(butBox, CTRLHDR, DISABLED, FALSE);
			EnableObjState(butBox, CTRLHOLD, DISABLED, FALSE);	/* (MH) */
			EnableObjState(butBox, CTRLBACK, DISABLED, !isComm);
			
			EnableObjState(butBox, CTRLDIS1, DISABLED, !isMail);
			EnableObjState(butBox, CTRLDIS2, DISABLED, !isMail);
			VDIUtil_SetXState(butBox, CTRLDIS1, msg.info.dist);
			VDIUtil_SetXString(butBox, CTRLDIS1, distSel, msg.info.dist);
			setincl(selSet, CTRLDIS1);  /* Fuer Redraw */
		} else
		{
			EnableObjState(butBox, CTRLEDIT, DISABLED, FALSE);
			EnableObjState(butBox, CTRLKOMM, DISABLED, TRUE);
			EnableObjState(butBox, CTRLVIEW, DISABLED, FALSE);
			EnableObjState(butBox, CTRLCOPY, DISABLED, TRUE);
			EnableObjState(butBox, CTRLHDR,  DISABLED, TRUE);
			EnableObjState(butBox, CTRLHOLD, DISABLED, TRUE);	/* (MH) */
			EnableObjState(butBox, CTRLBACK, DISABLED, TRUE);
			EnableObjState(butBox, CTRLDIS1, DISABLED, TRUE);
			EnableObjState(butBox, CTRLDIS2, DISABLED, TRUE);
			VDIUtil_SetXString(butBox, CTRLDIS1, distSel, 0);
		}
	} else
	{
		for (i = CTRLEDIT; i <= CTRLDIS2; i++)
		{
			DelObjState(butBox, i, SELECTED);
			SetObjState(butBox, i, DISABLED);
		}
		DelObjState(butBox, CTRLDIS0, DISABLED);
		VDIUtil_SetXString(butBox, CTRLDIS1, distSel, 0);
	}
	/* Alle neuzeichnen */
	if (redraw && ptr->wdw >= 0)
	{
		rdwCount = 0;
		for (i = CTRLEDIT; i <= CTRLDIS2; i++)
		{
			if (GetObjState(butBox, i, SELECTED) != setin(selSet, i) ||
				GetObjState(butBox, i, DISABLED) != setin(disSet, i))
			{
				++rdwCount;
			}
		}
		if (rdwCount < 5)
		{
			for (i = CTRLEDIT; i <= CTRLDIS2; i++)
			{
				if (GetObjState(butBox, i, SELECTED) != setin(selSet, i) ||
					GetObjState(butBox, i, DISABLED) != setin(disSet, i))
				{
					redrawButton(ptr->wdw, butBox, i);
				}
			}
		} else
		{
			redrawButton(ptr->wdw, butBox, ROOT);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _VOID openSelected(msgWindowType *ptr, _BOOL forView)
{
	_WORD i;
	_WORD first;
	if (hasSelectedEntries(ptr, &first))
	{
		for (i = 0; i < ptr->maxPos; i++)
		{
			if (ptr->list[i].selected)
			{
				Messages_OpenEditor(&ptr->list[i], FALSE, -1, 0, forView?MODE_SHOW:MODE_RW);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handleSelChanged(msgWindowType *ptr, _BOOL redrawBut)
{
	Messages_WriteMessageInfo(FALSE);
	redrawEntry(ptr, ptr->sel);
	if (redrawBut)
		careForButtons(ptr, TRUE);
	/* Jetzt nachsehen, ob das irgendwo benutzt wird, und
	 * dann auch dort die Anzeige aendern
	 */
	Messages_UpdateEditors(&msgArray[ptr->sel]);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.16n */	/*DYJ 5.19h */	/*DYJ 5.19g */	/*DYJ 5.21b */
/*DYJ 5.23i */	/*DYJ 5.24c */
LOCAL _BOOL handleButtons(msgWindowType *ptr, _WORD ob)
{
	MESSNR i;
	MSGNR selectCount;
	msgInfo msg;
	group_line name;
	group_line Betreff;
	_UBYTE msgName[PATH_MAX];
	_WORD x, y;
	_WORD select;

	if (!GetObjState(butBox, ob, DISABLED) && (GetObjFlags(butBox, ob, SELECTABLE) || ob == CTRLDIS2))
	{
		/* Button selektieren */
		if (ob != CTRLDIS2)
		{
			SetObjState(butBox, ob, SELECTED);
			redrawButton(ptr->wdw, butBox, ob);
		}
		Bounce();
		/* Selektierte Nachrichten zaehlen */
		selectCount = countSelectedEntries(ptr);
		if (selectCount == 1)
		{
			hasSelectedEntries(ptr, &ptr->sel);
			msg = msgArray[ptr->sel];
		}
		switch (ob)
		{
		case CTRLEDIT:
			openSelected(ptr, FALSE);
			break;
			
		case CTRLKOMM:
			if (selectCount == 1 &&
				(msg.info.msgType == msg_mail ||
				 msg.info.msgType == msg_comment ||
				 msg.info.msgType == msg_groupcomment))
			{
				if (Messages_ReadHdrInfo(&msg, TRUE))
				{
					if (msg.topic != NULL)
						strBcpy(Betreff, msg.topic);
					else
						Betreff[0] = '\0';
					Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
					if (grinTools_BetreffHolen(-1, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(FS_TOPIC),
						msgName, MausTauschrsc_WrkString(msgWegen), FALSE))
					{
						_WORD messIdx;
						_UBYTE absender[256]="",references[1024]="";
						Messages_MakeMausId(&msg, msgName, sizeof(msgName));
						Messages_GetGroupInf(cNewsDefAddr,msg.group, absender, sizeof(absender));
						if((strLen(msg.ref)+strLen(msgName)+3)<sizeof(references))
							strMcpy(references, sizeof(references),msg.ref);
						if(!(*references))	/*Falls das alte references zu lang ist, oder leer(z.B. Cat<5) dann nur refId*/
						{
							strMcpy(references, sizeof(references),msg.refId);
							if(references[1])
							{
								*references='<';
								strCat(references,">");
							}
						}
						if(*references && *msgName)
							strCat(references," ");
						if(msg.refId)
						{
							strMcat(references,sizeof(references),"<");
							strMcat(references,sizeof(references),msgName);
							strMcat(references,sizeof(references),">");
						}
						Messages_CreateMessage(msg.info.number,absender, "", msg.group, msg.group, msgName, Betreff, "", "", msg_comment, 0, "", "", msg.info.dist, TRUE, &messIdx,references);
					}
				}
			}
			break;
			
		case CTRLVIEW:
			openSelected(ptr, TRUE);
			break;
			
		case CTRLDEL:
			if (selectCount > 0)
			{
				if (mtAlerts_AlertSichLRSC(1,2, AL_DEL_SELECTED) == 1)
				{
					for (i = messages; --i >= 0; )
					{
						if (ptr->list[i].selected)
						{
							Messages_Number2Name(ptr->list[i].info.number, msgName, sizeof(msgName));
							Messages_deleteMessage(msgName, TRUE, TRUE);
						}
						/* i = Min(i, messages); */
					}
					ptr->sel = -1;
				}
				careForButtons(ptr, TRUE);
			}
			break;
			
		case CTRLCOPY:
			if (selectCount == 1 &&
				(msg.info.msgType == msg_answer ||
				 msg.info.msgType == msg_pseudoKom || 	/*DYJ 5.34d */
				 msg.info.msgType == msg_pseudoNews || 	/*DYJ 5.34d */
				 msg.info.msgType == msg_persanswer ||
				 msg.info.msgType == msg_private))
			{
				if (!Messages_ReadHdrInfo(&msg, TRUE))
					return TRUE;
				name[0] = '\0';
				if(UserBLK.isInternet)
				{
					if (selectCount == 1)
					{
						if (Messages_ReadHdrInfo(&msgArray[ptr->sel], FALSE))
							if (MsgWindow_changeHdr(&msgArray[ptr->sel]))
								handleSelChanged(ptr, TRUE);
					}
				}
				else
				{
					if (msg.info.copyCount >= 10)
					{
						MTE_infoRSC(MTE_maxCopyAlert);
					} else
					{
						if (grinTools_GetCommentLine(Betreff, sizeof(Betreff), TRUE) &&
							adr_SelectName(ADR_NORMAL,name, sizeof(name)))
						{
							Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
							Messages_CopyOwnMessage(msgName, msg.Absender, name, "", Betreff, 1);
						}
					}
				}
			}
			break;
			
		case CTRLHDR:
			if (selectCount == 1)
			{
				if (Messages_ReadHdrInfo(&msgArray[ptr->sel], FALSE))
					if (MsgWindow_changeHdr(&msgArray[ptr->sel]))
						handleSelChanged(ptr, TRUE);
			}
			break;
		
		/* (MH) */	
		case CTRLHOLD:
			if (selectCount == 1)
			{
				msgArray[ptr->sel].info.sendMsg = !msgArray[ptr->sel].info.sendMsg;
				handleSelChanged(ptr, FALSE);
			}
			break;
			
		case CTRLBACK:
			if (selectCount == 1)
				Messages_openReference(ptr->sel);
			break;
		
		case CTRLDIS1:
			if (selectCount == 1)
			{
				objc_offset(butBox, ob, &x, &y);
				select = VDIUtil_GetXState(butBox, ob);
				select = mtPopups_TreePopup(distSel, x, y, select) - 1;
				if (select >= 0)
				{
					VDIUtil_SetXState(butBox, ob, select);
					msgArray[ptr->sel].info.dist = (tDistribution)select;
					VDIUtil_SetXString(butBox, ob, distSel, select);
					/*
					redrawButton(ptr->wdw, butBox, ob);
					*/
					handleSelChanged(ptr, FALSE);
				}
			}
			break;
			
		case CTRLDIS2:
			if (selectCount == 1)
			{
				DelObjState(butBox, ob, SELECTED);
				ob = CTRLDIS1;   /* Button nehmen */
				select = VDIUtil_GetXState(butBox, ob);
				select = (select + 1) % 4;
				msgArray[ptr->sel].info.dist = (tDistribution)select;
				VDIUtil_SetXState(butBox, ob, select);
				VDIUtil_SetXString(butBox, ob, distSel, select);
				/*
				redrawButton (ptr->wdw, butBox, ob-1);
				*/
				handleSelChanged(ptr, FALSE);
			}
			break;
		}
		/* Button deselektieren */
		DelObjState(butBox, ob, SELECTED);
		redrawButton(ptr->wdw, butBox, ob);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID selectArea(msgWindowType *ptr, _WORD x, _WORD y)
{
	_WORD firstLine, lastLine;
	_WORD i;
	GRECT r, rect;
	_BOOL first;

	rect.g_x = x;
	rect.g_y = y;
	rect.g_w = 0;
	rect.g_h = 0;
	MouseFinger();
	graf_rubberbox(x, y, -32767, -32767, &rect.g_w, &rect.g_h);
	MouseArrow();
	
	if (rect.g_w < 0)
	{
		rect.g_x += rect.g_w;
		rect.g_w = -rect.g_w;
	}
	if (rect.g_h < 0)
	{
		rect.g_y += rect.g_h;
		rect.g_h = -rect.g_h;
	}
	/* clippen */
	rect = rc_clip(&rect, &ptr->msgWork);
	rect.g_h = Min(rect.g_h, ptr->msgWork.g_y + ptr->msgWork.g_h - 1 - rect.g_y);
	
	/* Jetzt testen, ob selektierbarer Bereich geschnitten wurde */
	if ((rect.g_x - ptr->msgWork.g_x < ptr->pixOffset && rect.g_x + rect.g_w - ptr->msgWork.g_x < ptr->pixOffset) ||
		(rect.g_x - ptr->msgWork.g_x > ptr->maxWidth && rect.g_x + rect.g_w - ptr->msgWork.g_x > ptr->maxWidth))
	{
		return;
	}
	
	firstLine = (rect.g_y - ptr->msgWork.g_y) / (2 * ptr->charHeight + ptr->lineDist);
	lastLine  = (rect.g_y + rect.g_h - ptr->msgWork.g_y) / (2 * ptr->charHeight + ptr->lineDist);
	if (rect.g_x - ptr->msgWork.g_x > ptr->pixOffset ||
		rect.g_x + rect.g_w - ptr->msgWork.g_x > ptr->pixOffset)
	{
		r = ptr->msgWork;
		r.g_x += ptr->pixOffset;
		r.g_h = 2 * ptr->charHeight + ptr->lineDist;
		first = TRUE;
		for (i = ptr->startPos + firstLine; i < ptr->startPos+lastLine; i++)
		{
			if (i >= 0 && i < ptr->maxPos)
			{
				ptr->list[i].selected = !ptr->list[i].selected;
				if (is_visible(ptr, i))
				{
					/* redraw */
					if (first)
					{
						r.g_y = ptr->msgWork.g_y + (i - ptr->startPos) * (2 * ptr->charHeight + ptr->lineDist);
						first = FALSE;
					} else
					{
						r.g_h = ptr->msgWork.g_y + (i - ptr->startPos + 1) * (2 * ptr->charHeight + ptr->lineDist) - r.g_y;
					}
				}
			}
		}
		if (!first)
			WdwManager_RedrawWdw(ptr->wdw, &r);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL clickInMsgWindow(HWND win, _VOID *special, _WORD x, _WORD y, _UWORD kstate, _UWORD buts, _WORD clicks)
{
	_WORD transY;
	msgWindowType *ptr;
	_BOOL entrySelected;
	_WORD line;
	_UWORD but;
	_WORD ob;
	
	ptr = special;
	if (!(buts & MOB_LEFT))
		return FALSE;
	if (rc_inside(x, y, &ptr->butWork))
	{
		ob = objc_find(butBox, ROOT, MAX_DEPTH, x, y);
		if (ob >= CTRLEDIT && ob <= CTRLDIS2)
		{
			return handleButtons(ptr, ob);
		}
	} else if (rc_inside(x, y, &ptr->msgWork))
	{
		if (!(kstate & (K_LSHIFT | K_RSHIFT)))
		{
			MsgWindow_deselectEntries(win);
			ptr->sel = -1;
		}
		/* Zeile herausfinden */
		line = (y - ptr->msgWork.g_y) / (2 * ptr->charHeight + ptr->lineDist);
		transY = (y - ptr->msgWork.g_y - (ptr->lineDist / 2));
		entrySelected = (transY >= line * (2 * ptr->charHeight + ptr->lineDist)) &&
			(transY < ((line + 1) * 2 * ptr->charHeight + line * ptr->lineDist)) &&
			((x - ptr->msgWork.g_x) >= ptr->pixOffset) &&
			((x - ptr->msgWork.g_x) <= ptr->maxWidth) &&
			(line + ptr->startPos < ptr->maxPos);
		if (entrySelected)
		{
			toggleEntry(ptr, line + ptr->startPos);
			if (ptr->list[line + ptr->startPos].selected)
				ptr->sel = line + ptr->startPos;
			else
				ptr->sel = -1;
			if (clicks > 1)
				openSelected(ptr, FALSE);
			else
				Bounce();
		} else
		{
			graf_mkstate(&x, &y, &but, &kstate);
			if (but & MOB_LEFT)
			{
				/* Graf-Rubberbox aufrufen */
				selectArea(ptr, x, y);
			}
		}
		careForButtons(ptr, TRUE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID deselectLast(msgWindowType *ptr)
{
	if (countSelectedEntries(ptr) > 1)
		MsgWindow_deselectEntries(ptr->wdw);
	else
		toggleEntry(ptr, ptr->sel);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL handleMsgKey(HWND wdw,_VOID *special, _WORD taste, _UBYTE ch, _UBYTE scan, _UWORD kstate)
{
	msgWindowType *ptr;
	_UWORD gemCh;
	Key key;
	_BOOL ctrl;
	_BOOL done;
	_BOOL newPos;
	_BOOL pg;
	
	UNUSED(taste);
	ptr = special;
	gemCh = (scan << 8) | ch;
	GemCharToKey(gemCh,  kstate, &key);
	ctrl = CatGlobal_WithCtrl(kstate);
	done = TRUE;
	newPos = FALSE;
	if (IsSpecial(&key))
	{
		switch (SpecialKey(&key))
		{
		case left:
			WdwManager_ScrollLeft(ptr->wdw, 1);
			break;
		
		case soln:
			WdwManager_PageLeft(ptr->wdw);
			break;
			
		case right:
			WdwManager_ScrollRight(ptr->wdw, 1);
			break;
			
		case eoln:
			WdwManager_PageRight(ptr->wdw);
			break;
			
		case pgUp:
		case up:
			pg = SpecialKey(&key) == pgUp;
			if (pg)
				WdwManager_PageUp(ptr->wdw);
			if (ptr->sel < 0)
			{
				ptr->sel = Min(ptr->maxPos - 1, ptr->startPos + ptr->windLines - 1);
				toggleEntry(ptr, ptr->sel);
			} else if (ptr->sel > 0)
			{
				deselectLast(ptr);
				if (pg)
				{
					ptr->sel -= ptr->windLines - 1;
					ptr->sel = Max(0, ptr->sel);
				} else
				{
					--ptr->sel;
				}
				ptr->sel = Min(ptr->sel, ptr->maxPos - 1);
				toggleEntry(ptr, ptr->sel);
				if (ptr->sel < ptr->startPos || ptr->sel > ptr->startPos + ptr->windLines - 1)
				{
					ptr->startPos = Min(ptr->maxPos - ptr->windLines, ptr->sel);
					newPos = TRUE;
				}
			}
			break;
			
		case pgDown:
		case down:
			pg = SpecialKey(&key) == pgDown;
			if (pg)
				WdwManager_PageDown(ptr->wdw);
			if (ptr->sel < 0)
			{
				ptr->sel = ptr->startPos;
				toggleEntry(ptr, ptr->sel);
			} else if (ptr->sel < ptr->maxPos - 1)
			{
				deselectLast(ptr);
				if (pg)
				{
					ptr->sel += ptr->windLines - 1;
					ptr->sel = Min(ptr->sel, ptr->maxPos - 1);
				} else
				{
					++ptr->sel;
				}
				ptr->sel = Max(ptr->sel, 0);
				toggleEntry(ptr, ptr->sel);
				if (ptr->sel < ptr->startPos || ptr->sel > ptr->startPos + ptr->windLines - 1)
				{
					ptr->startPos = Min(ptr->maxPos - ptr->windLines, ptr->sel - ptr->windLines + 1);
					newPos = TRUE;
				}
			}
			break;
		
		case home:
		case clr:
			if (ptr->sel >= 0)
			{
				deselectLast(ptr);
				pg = TRUE;
			} else
			{
				pg = FALSE;
			}
			if (SpecialKey(&key) == home)
			{
				ptr->sel = 0;
				if (pg)
					toggleEntry(ptr, ptr->sel);
				ptr->startPos = 0;
			} else
			{
				ptr->sel = ptr->maxPos - 1;
				if (pg)
					toggleEntry(ptr, ptr->sel);
				ptr->startPos = Max(ptr->maxPos - ptr->windLines, 0);
			}
			if (!pg)
				ptr->sel = -1;
			newPos = TRUE;
			break;
			
		case return_:
		case enter:
			openSelected(ptr, FALSE);
			break;
			
		case esc:
			MsgWindow_deselectEntries(wdw);
			ptr->sel = -1;
			break;
			
		case delete:
			done=handleButtons(ptr, CTRLDEL);
			break;
		default:
			done = FALSE;
			break;
		}
		if (newPos)
		{
			ptr->startPos = Max(0, ptr->startPos);
			MsgWindow_SetDocument(ptr, FALSE);
		}
		careForButtons(ptr, TRUE);
	} else if (!ctrl && !CatGlobal_WithAlt(kstate))
	{
		switch (ucase(ch))
		{
			case 'A': return handleButtons(ptr, CTRLHDR);
			case 'C': return handleButtons(ptr, CTRLCOPY);
			case 'E': return handleButtons(ptr, CTRLEDIT);
			case 'K': return handleButtons(ptr, CTRLKOMM);
			case 'L': return handleButtons(ptr, CTRLDEL);
			case 'Z': return handleButtons(ptr, CTRLHOLD);	/* (MH) */
			case 'O': return handleButtons(ptr, CTRLBACK);
			case 'D': return handleButtons(ptr, CatGlobal_WithShift(kstate) ? CTRLDIS2 : CTRLDIS1);
			case 'V': return handleButtons(ptr, CTRLVIEW);
			/*
			case '0': return handleButtons(ptr, MausTauschrsc.ctrlnone);
			case '1': return handleButtons(ptr, MausTauschrsc.ctllokal);
			case '2': return handleButtons(ptr, MausTauschrsc.ctrlmaus);
			case '3': return handleButtons(ptr, MausTauschrsc.ctrl_net);
			*/
			default: done = FALSE; break;
		}
	} else
	{
		done = FALSE;
	}
	return done;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeMsgWindow(HWND wdw,HVDI vdiH, _VOID *special, _BOOL force)
{
	msgWindowType *ptr;
	GRECT full;

	UNUSED(vdiH);
	UNUSED(force);
	ptr = special;
	WdwManager_GetWdwSize(wdw, &full); /* Groesse des Fensters abfragen */
	ConfVars_SetConfigRect(cMsgSelectWindowPos, &full);
	ConfVars_SetConfigInt(cMsgSelectFont, ptr->font);
	ConfVars_SetConfigInt(cMsgSelectFontSize, ptr->fontSize);
	ConfVars_SetConfigInt(cMsgSelectLeftOffset, ptr->pixOffset);
	ConfVars_SetConfigInt(cMsgSelectLineDist, ptr->lineDist);
	FontSelect_UnloadFonts(ptr->vdi);
	ptr->wdw = -1;
	ptr->vdi = -1;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL topMsgWdw(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID untopMsgWdw(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateMsgWdw(HWND wdw, _VOID *special, _BOOL begin)
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
	{
		Wind_Update(BEG_UPDATE);
		MouseOff();
	} else
	{
		MouseOn();
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setMsgWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	msgWindowType *ptr;
	
	UNUSED(wdw);
	UNUSED(slided);
	ptr = special;
	ptr->leftOffset = (_WORD)doc->x;
	ptr->startPos = (_WORD)doc->y;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _VOID getMsgScroll(HWND wdw,HVDI vdiH, _VOID *special, GRECT *work)
{
	msgWindowType *ptr;
	GRECT full;
	_BOOL lstPgF;
	
	UNUSED(vdiH);
	ptr = special;
	AdjustTreePos(work, &ptr->butWork);
	work->g_h -= butBox[ROOT].ob_height + 1;
	work->g_y += butBox[ROOT].ob_height + 1;
	ptr->windLines = (Min(work->g_y + work->g_h - 1, MaxHeight - 1) - work->g_y + 1) / (2 * ptr->charHeight + ptr->lineDist);
	ConfVars_GetConfDefBool(cMsgLstPgF, &lstPgF,TRUE);
	WdwManager_SetScrollParms(ptr->wdw, work->g_w - ptr->charWidth, ptr->windLines - 1, ptr->charWidth, 1,lstPgF);
	ptr->msgWork = *work;
	if (wdw >= 0)
	{
		WdwManager_GetWdwSize(wdw, &full); /* Groesse des Fensters abfragen */
		ConfVars_SetConfigRect(cMsgSelectWindowPos, &full);
	}
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _VOID snapMsgWdw(HWND wdw, _VOID *special, GRECT *work)
{
	msgWindowType *ptr;
	_BOOL lstPgF;
#define minWindWidth 128
#define minWindHeight 48

	UNUSED(wdw);
	ptr = special;
	AdjustTreePos(work, &ptr->butWork);
	if (!inOpen)
	{
		work->g_h -= ptr->butWork.g_h;
		++work->g_h;            /* Um Rundungsfehler zu vermeiden */
		work->g_h = ((work->g_h + ptr->lineDist) / (2 * ptr->charHeight + ptr->lineDist)) * (2 * ptr->charHeight + ptr->lineDist);
		while (work->g_w < minWindWidth)
			work->g_w += ptr->charWidth;
		while (work->g_h < minWindHeight)
			work->g_h += 2 * ptr->charHeight + ptr->lineDist;
		ptr->windLines = (Min(work->g_y + work->g_h - 1, MaxHeight - 1) - work->g_y + 1) / (2 * ptr->charHeight + ptr->lineDist);
		ptr->msgWork = *work;
		work->g_h += ptr->butWork.g_h;
		ConfVars_GetConfDefBool(cMsgLstPgF, &lstPgF,TRUE);
		WdwManager_SetScrollParms(ptr->wdw, work->g_w - ptr->charWidth, ptr->windLines - 1, ptr->charWidth, 1,lstPgF);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hideMsgWdw(HWND wdw, _VOID *special, _BOOL hide)
{
	msgWindowType *ptr;
	
	UNUSED(wdw);
	ptr = special;
	ptr->isHidden = hide;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL MsgWindow_msgChangeFont(HWND wdw, _WORD font, _WORD fontSize, _BOOL isMono)
{
	UNUSED(isMono);
	if (MsgWindow_msgWindowTop(wdw))
	{
		MsgWindow_msgSetFont(wdw, font, fontSize);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL MsgWindow_msgChangeColor(HWND wdw, _WORD color)
{
	if (MsgWindow_msgWindowTop(wdw))
	{
		ConfVars_SetConfigInt(cMsgSelectTextCol, color);
		MsgWindow_RedrawAll();
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgWindow_GetSettings(msgWindowType *ptr)
{
	ConfVars_GetConfDefInt(cMsgSelectLeftOffset, &ptr->pixOffset, 8);
	ptr->pixOffset = Max(0, ptr->pixOffset);
	ConfVars_GetConfDefInt(cMsgSelectLineDist, &ptr->lineDist, 2);
	ptr->lineDist = Max(0, ptr->lineDist);

	ConfVars_GetConfDefInt(cMsgSelectTextCol, &ptr->msgTextCol, BLACK);
	ConfVars_GetConfDefInt(cMsgSelectBackCol, &ptr->msgBackCol, WHITE);
	ConfVars_GetConfDefInt(cMsgSelectHoldCol, &ptr->msgHoldCol, BLACK);
	ConfVars_GetConfDefInt(cMsgSelectHoldEff, &ptr->msgHoldEff, 2);
	ConfVars_GetConfDefInt(cMsgSelectPersCol, &ptr->msgPersCol, BLACK);
	ConfVars_GetConfDefInt(cMsgSelectPersEff, &ptr->msgPersEff, 1);

	if (Bitplanes == 1)
	{
		if (ptr->msgTextCol != WHITE)
			ptr->msgBackCol = WHITE;
		else if (ptr->msgBackCol == WHITE)
			ptr->msgBackCol = BLACK;
		ptr->msgHoldCol = ptr->msgTextCol;
		ptr->msgPersCol = ptr->msgTextCol;
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- exportierte Funktionen -----------------------*/

/* Bringt das Fenster mit der Nachrichtenuebersicht
 * in den Vordergrund bzw. oeffnet es, falls noch nicht
 * offen. Die Nachricht muss dann im Fenster ausgewaehlt
 * werden.
 */
 /*DYJ 5.21b */
GLOBAL _VOID MsgWindow_msgOpen(_BOOL errorMsg)
{
	msgWindowType *ptr;
	_UWORD comps;
	_WORD i;
	_UBYTE title[256];
	
	ptr = &msgWindow;
	if (ptr->wdw >= 0)
	{
		WdwManager_ShowWindow(ptr->wdw);
	} else
	{
		MsgWindow_GetSettings(ptr);
		ConfVars_GetConfDefRect(cMsgSelectWindowPos, &ptr->msgWork, &deskSize);
		/* Fensterkomponenten setzen */
		comps = NAME | CLOSER | FULLER | MOVER | SIZER | UPARROW | DNARROW | VSLIDE | LFARROW | RTARROW | HSLIDE;
		/* Infozeile brauchen wir nicht */
		
		ptr->wdw = -1;
		ptr->maxPos = messages;
		ptr->list = msgArray;
		if (msgArray == NULL || messages <= 0)
		{
			if (errorMsg)
				MTE_infoRSC(AL_NOMSG);
			return;
		}
		for (i = 0; i < ptr->maxPos; i++)
			ptr->list[i].selected = FALSE;
		careForButtons(ptr, FALSE);
		ptr->charHeight  = 16;
		ptr->charWidth   = 8;
		inOpen = TRUE;
		/* Fenster oeffnen */
		strBcpy(title, MausTauschrsc_WrkString(msgWindowTitle));
		insert_box_name(title, sizeof(title));
		insert_app_name(title, sizeof(title));
		if (WdwManager_OpenWindow(clickInMsgWindow,
			handleMsgKey,
			FUNK_NULL,	/* timerproc */
			&deskSize,
			&ptr->msgWork,
			comps,
			TRUE,		/* snap */
			"",
			title,
			snapMsgWdw,
			closeMsgWindow,
			drawMsgWdw,
			topMsgWdw,
			untopMsgWdw,
			updateMsgWdw,
			setMsgWork,
			getMsgScroll,
			hideMsgWdw,
			ptr->pixOffset,
			ptr,
			FALSE,		/* onlyThisTop */
			TRUE,		/* showIt */
			TRUE,		/* supportIconify */
			TRUE,		/* openWorkstation */
			FALSE,		/* hasIdem*/
			&ptr->wdw,
			&ptr->vdi))
		{
			inOpen = FALSE;
			ptr->isHidden = FALSE;
			/* Font aus Configvariablen lesen und setzen */
			ConfVars_GetConfDefInt(cMsgSelectFont, &ptr->font, 1);
			ConfVars_GetConfDefInt(cMsgSelectFontSize, &ptr->fontSize, 10);
			ptr->startPos = 0;
			ptr->leftOffset = 0;
			ptr->maxWidth   = 0;
			/* Noch ein bisschen was fuer die Window-Library */
			MsgWindow_SetDocument(ptr, TRUE);
			/* Fonts laden */
			FontSelect_LoadFonts(ptr->vdi);
			/* Font setzen */
			iMsgSetFont(ptr->wdw, ptr->font, ptr->fontSize, FALSE);
			WdwManager_AcceptFont(ptr->wdw, MsgWindow_msgChangeFont);
			WdwManager_AcceptColor(ptr->wdw, MsgWindow_msgChangeColor);
			/* Jetzt noch ein paar andere VDI-Variablen setzen */
			vsf_style(ptr->vdi, IP_SOLID);
			vsf_interior(ptr->vdi, FIS_SOLID);
			vsf_color(ptr->vdi, ptr->msgBackCol);
			/* Schreibmodus setzen */
			vswr_mode(ptr->vdi, MD_REPLACE);
			ptr->sel = -1;
		} else
		{
			inOpen = FALSE;
			ptr->wdw = -1;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Kommentarfenster wird geschlossen */
GLOBAL _VOID MsgWindow_msgClose(HWND wdw)
{
	WdwManager_CloseWindow(wdw, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

/* Alle Fenster neu zeichnen */
GLOBAL _VOID MsgWindow_RedrawAll(_VOID)
{
	MsgWindow_GetSettings(&msgWindow);
	WdwManager_FullRedrawWdw(msgWindow.wdw);
}

/*** ---------------------------------------------------------------------- ***/

/* Ist ein Kommentarfenster oben? */
GLOBAL _BOOL MsgWindow_msgWindowTop(HWND wdw)
{
	return msgWindow.wdw == wdw && msgWindow.wdw >= 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_msgSetFont(HWND wdw, _WORD font, _WORD fontSize)
{
	iMsgSetFont(wdw, font, fontSize, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_SelectFont(HWND wdw)
{
	if (MsgWindow_msgWindowTop(wdw))
	{
		VDIUtil_SelectFont(msgWindow.vdi, wdw, FALSE, msgWindow.font, msgWindow.fontSize);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Selektiert alle Nachrichten in der Nachrichtenliste
 */
GLOBAL _VOID MsgWindow_msgSelectAll(HWND wdw)
{
	_WORD i;
	msgWindowType *ptr;
	
	if ((ptr = FindWind(wdw)) != NULL)
	{
		for (i = 0; i < ptr->maxPos; i++)
		{
			if (!ptr->list[i].selected)
			{
				/* Erledigt auch direkt den Redraw davon */
				toggleEntry(ptr, i);
			}
		}
		careForButtons(ptr, TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_msgSavePos(_VOID)
{
	GRECT full;
	_WORD max;
	msgWindowType *ptr;
	
	ptr = &msgWindow;
	if (ptr->wdw >= 0)
	{
		ConfVars_SetConfigBool(cMsgSelectOpen, TRUE);
		WdwManager_GetWdwSize(ptr->wdw, &full); /* Groesse des Fensters abfragen */
		ConfVars_SetConfigRect(cMsgSelectWindowPos, &full);
		ConfVars_SetConfigInt(cMsgSelectFont, ptr->font);
		ConfVars_SetConfigInt(cMsgSelectFontSize, ptr->fontSize);
		ConfVars_SetConfigInt(cMsgSelectLeftOffset, ptr->pixOffset);
		ConfVars_SetConfigInt(cMsgSelectLineDist, ptr->lineDist);
	} else
	{
		ConfVars_SetConfigBool(cMsgSelectOpen, FALSE);
	}
	Messages_SaveEditPos(&max);
	ConfVars_SetConfigInt(cMsgSelectMaxNum, max);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_msgRestorePos(_VOID)
{
	_WORD i, max, num, idx;
	_UBYTE varName[128];
	_BOOL is_open;
	_BOOL readOnly;
	_BOOL readOnlyW;
	_BOOL wasTmp;
	
	ConfVars_GetConfDefBool(cMsgSelectOpen, &is_open, FALSE);
	if (is_open)
	{
		wasTmp = ConfVars_ConfigConfigModule(FALSE);
		MsgWindow_msgOpen(FALSE);
		ConfVars_ConfigConfigModule(wasTmp);
	}
	ConfVars_GetConfDefInt(cMsgSelectMaxNum, &max, -1);
	for (i = 0; i <= max; i++)
	{
		make_varname(varName, sizeof(varName), cMsgSelectEdit, i);
		if (ConfVars_GetConfigInt(varName, &num) && (idx = Messages_FindMessage(i)) >= 0)
		{
			if (Messages_ReadHdrInfo(&msgArray[idx], FALSE))
			{
				make_varname(varName, sizeof(varName), cEditReadOnly, num);
				if(ConfVars_GetConfigBool(varName, &readOnly))
				{
					readOnlyW=readOnly?MODE_SHOW:MODE_RW;
					ConfVars_DeleteConfigVar(varName);
					ConfVars_SetConfigInt(varName, readOnlyW);
				}
				else
					ConfVars_GetConfDefInt(varName, &readOnlyW, MODE_RW);
				Messages_OpenEditor(&msgArray[idx], FALSE, num, 0, readOnlyW);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_msgUpdateInfo(_VOID)
{
	/* MSGINFO.DAT neu einlesen */
	Messages_ReReadMessageInfo();
	if (messages == 0)
	{
		MsgWindow_msgClose(msgWindow.wdw);
		Messages_CloseAllEditors(TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgWindow_msgCloseAll(_BOOL force)
{
	if (!Messages_CloseAllEditors(force))
		return FALSE;
	MsgWindow_msgClose(msgWindow.wdw);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Liste fuer das Fenster
 */
GLOBAL _VOID MsgWindow_MsgSetList(msgInfo *list, _BOOL doRedrawWdw)
{
	msgWindow.list = list;
	if (doRedrawWdw && msgWindow.wdw >= 0 && !msgWindow.isHidden)
	{
		/* Fenster ist offen */
		WdwManager_FullRedrawWdw(msgWindow.wdw);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Maximalposition fuer die Liste
 */
GLOBAL _VOID MsgWindow_MsgSetMaxPos(MESSNR maxPos, _BOOL doRedrawWdw)
{
	msgWindowType *ptr;
	
	ptr = &msgWindow;
	ptr->maxPos = maxPos;
	if (ptr->startPos >= ptr->maxPos)
		ptr->startPos = Max(0, ptr->maxPos - 1);
	if (doRedrawWdw)
	{
		if (ptr->wdw >= 0)
		{
			MsgWindow_SetDocument(ptr, FALSE);
			WdwManager_FullRedrawWdw(ptr->wdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst das Fenster, falls es offen ist
 */
GLOBAL _VOID MsgWindow_MsgCloseIfOpen(_VOID)
{
	if (msgWindow.wdw >= 0)
		WdwManager_CloseWindow(msgWindow.wdw, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

/* Aktualisiert die Buttons im Anzeigefenster passend zur Selektion
 */
GLOBAL _VOID MsgWindow_MsgUpdateButtons(_VOID)
{
	careForButtons(&msgWindow, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

/* Erzwingt das Neuzeichnen des Eintrags mit der Nummer idx
 * im Fenster
 */
GLOBAL _VOID MsgWindow_MsgRedrawEntry(_WORD idx)
{
	redrawEntry(&msgWindow, idx);
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Selectindex auf -1 und erzwingt ggf. einen Redraw
 */
GLOBAL _VOID MsgWindow_MsgDeselectAll(_VOID)
{
	msgWindowType *ptr;
	
	ptr = &msgWindow;
	if (ptr->wdw >= 0 && ptr->sel >= 0 && !ptr->isHidden)
	{
		ptr->sel = -1;
		careForButtons(ptr, FALSE);
		WdwManager_FullRedrawWdw(ptr->wdw);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgWindow_ExitMessageManager(_VOID)
{
	if (butBox != NULL)
	{
		mtDials_DisposeDial(butBox);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Initialisiert das Modul und einige wichtige Daten
 * Ruft intern auch die Initialisierung vom Modul Messages auf
 */
GLOBAL _BOOL MsgWindow_InitMessageManager(_VOID)
{
	_WORD i;

	butBox = TreeAddr[MSGCTRL];
	distSel = TreeAddr[DISTRIBX];
	if (!mtDials_NewDial(butBox))
		return FALSE;
	for (i = CTRLEDIT; i <= CTRLDIS2; i++)
		SetObjState(butBox, i, DISABLED);
	Messages_InitMessages();
	return TRUE;
}
