"##
##
##           _            __
##    __ _  (_)_ _  ___  / /___ _____  ___ ___
##   /  ' \/ /  ' \/ -_)/ __/ // / _ \/ -_|_-<
##  /_/_/_/_/_/_/_/\__(_)__/\_, / .__/\__/___/
##                         /___/_/
##                             __              __       __   __    __   
##   _    ___    ___    __ ___/ /__ ____ ____ / /___ __/ /  / /___/ /__ 
##  | |/|/ / |/|/ / |/|/ // _  / _ `/ _ `(_-</ __/ // / _ \/ // _  / -_)
##  |__,__/|__,__/|__,__(_)_,_/\_,_/\_, /___/\__/\_,_/_//_/_(_)_,_/\__/ 
##                                 /___/
##
##  kathrin.dagstuhl.de Apache HTTPd mime configuration file
##
##
##

##
## Based on the Apache 1.3.20 mime.types file
## Expanded by Axel Beckert <abe@fsinfo.cs.uni-sb.de>
## URL http://fsinfo.cs.uni-sb.de/~abe/apache-tips/mime.types
## Last modification: [mime.types: Mon 12-Nov-2001 23:18:35 (MET) axel@kathrin.dagstuhl.de]
##

# This file controls what Internet media types are sent to the client for
# given file extension(s).  Sending the correct media type to the client
# is important so they know how to handle the content of the file.
# Extra types can either be added here or by using an AddType directive
# in your config files. For more information about Internet media types,
# please read RFC 2045, 2046, 2047, 2048, and 2077.  The Internet media type
# registry is at <ftp://ftp.iana.org/in-notes/iana/assignments/media-types/>.

# MIME type			Extension
application/EDI-Consent
application/EDI-X12
application/EDIFACT
application/acad		dwg
application/activemessage
application/andrew-inset	ez
application/applefile
application/arj			arj
application/atomicmail
application/base64		mm mme
application/batch-SMTP
application/cals-1840
application/commonground
application/cprplayer		pqi
application/cybercash
application/dca-rft
application/dec-dx
application/dsssl		dsssl dsl
application/dxf			dxf
application/eps			eps
application/eshop
application/gnutar		gtar gtgz ftbz gtbz2
application/http
application/hyperstudio
application/iges
application/index
application/index.cmd
application/index.obj
application/index.response
application/index.vnd
application/iotp
application/ipp
application/java-byte-code	class
application/lha			lha
application/lzh			lzh
application/lzx			lzx
application/mac-binhex40	hqx
application/mac-compactpro	cpt
application/macwriteii
application/marc
application/mathematica
application/mathematica-old
application/news-message-id
application/news-transmission
application/ocsp-request
application/ocsp-response
application/octet-stream	bin dms o
application/oda			oda
application/pdf			pdf
application/pgp-encrypted
application/pgp-keys		pgp key
application/pgp-signature	asc
application/pkcs10		p10
application/pkcs12		p12
application/pkcs7-certificates	spc
application/pkcs7-certreqresp	p7r
application/pkcs7-mime		p7c p7c p7m
application/pkcs7-signature	p7a p7s
application/pkix-cert
application/pkix-crl
application/pkixcmp
application/postscript		ai ps
application/presentations	shw
application/prs.alvestrand.titrax-sheet
application/prs.cww
application/prs.nprend
application/remote-printing
application/riscos
video/vnd.rn-realplayer		rnx
application/rtf			rtf
application/sdp
application/set-payment
application/set-payment-initiation
application/set-registration
application/set-registration-initiation
application/sgml		sqml sgm
application/sgml-open-catalog
application/slate
application/smil		smi smil
application/vemmi
application/vnd.3M.Post-it-Notes
application/vnd.FloGraphIt
application/vnd.accpac.simply.aso
application/vnd.accpac.simply.imp
application/vnd.acucobol
application/vnd.anser-web-certificate-issue-initiation
application/vnd.anser-web-funds-transfer-initiation
application/vnd.audiograph
application/vnd.businessobjects
application/vnd.claymore
application/vnd.commerce-battelle
application/vnd.commonspace
application/vnd.comsocaller
application/vnd.contact.cmsg
application/vnd.corel-draw		cdr
application/vnd.cosmocaller
application/vnd.ctc-posml
application/vnd.cups-postscript
application/vnd.cups-raster
application/vnd.cups-raw
application/vnd.cybank
application/vnd.dna
application/vnd.dpgraph
application/vnd.dxr
application/vnd.ecdis-update
application/vnd.ecowin.chart
application/vnd.ecowin.filerequest
application/vnd.ecowin.fileupdate
application/vnd.ecowin.series
application/vnd.ecowin.seriesrequest
application/vnd.ecowin.seriesupdate
application/vnd.enliven
application/vnd.epson.esf
application/vnd.epson.msf
application/vnd.epson.quickanime
application/vnd.epson.salt
application/vnd.epson.ssf
application/vnd.ericsson.quickcall
application/vnd.eudora.data
application/vnd.fdf
application/vnd.ffsns
application/vnd.framemaker			fm fm3 fm4 fm5 mk frm frame
application/vnd.fujitsu.oasys
application/vnd.fujitsu.oasys2
application/vnd.fujitsu.oasys3
application/vnd.fujitsu.oasysgp
application/vnd.fujitsu.oasysprs
application/vnd.fujixerox.ddd
application/vnd.fujixerox.docuworks
application/vnd.fujixerox.docuworks.binder
application/vnd.fut-misnet
application/vnd.grafeq
application/vnd.groove-account
application/vnd.groove-identity-message
application/vnd.groove-injector
application/vnd.groove-tool-message
application/vnd.groove-tool-template
application/vnd.groove-vcard
application/vnd.hp-HPGL
application/vnd.hp-PCL
application/vnd.hp-PCLXL
application/vnd.hp-hpid
application/vnd.hp-hps
application/vnd.httphone
application/vnd.hzn-3d-crossword
application/vnd.ibm.MiniPay
application/vnd.ibm.modcap
application/vnd.informix-visionary
application/vnd.intercon.formnet
application/vnd.intertrust.digibox
application/vnd.intertrust.nncp
application/vnd.intu.qbo
application/vnd.intu.qfx
application/vnd.is-xpr
application/vnd.japannet-directory-service
application/vnd.japannet-jpnstore-wakeup
application/vnd.japannet-payment-wakeup
application/vnd.japannet-registration
application/vnd.japannet-registration-wakeup
application/vnd.japannet-setstore-wakeup
application/vnd.japannet-verification
application/vnd.japannet-verification-wakeup
application/vnd.koan
application/vnd.lotus-1-2-3	123 wk
application/vnd.lotus-approach
application/vnd.lotus-freelance
application/vnd.lotus-notes
application/vnd.lotus-organizer	org or2
application/vnd.lotus-screencam	scm
application/vnd.lotus-wordpro	lwp sam
application/vnd.mcd
application/vnd.mediastation.cdkey
application/vnd.meridian-slingshot
application/vnd.mif		mif
application/vnd.minisoft-hp3000-save
application/vnd.mitsubishi.misty-guard.trustweb
application/vnd.mobius.daf
application/vnd.mobius.dis
application/vnd.mobius.msl
application/vnd.mobius.plc
application/vnd.mobius.txf
application/vnd.motorola.flexsuite
application/vnd.motorola.flexsuite.adsi
application/vnd.motorola.flexsuite.fis
application/vnd.motorola.flexsuite.gotap
application/vnd.motorola.flexsuite.kmr
application/vnd.motorola.flexsuite.ttc
application/vnd.motorola.flexsuite.wem
application/vnd.mozilla.xul+xml
application/vnd.ms-access	mda mdb mde
application/vnd.ms-artgalry
application/vnd.ms-asf
application/vnd.ms-excel	xls xlm xlt xla xlb xlc xld xlk xll xlv xlw
application/vnd.ms-lrm
application/vnd.ms-powerpoint	ppt ppz pot pwz ppa pps pow
application/vnd.ms-project	mpp mpt mpv mpx mpw
application/vnd.ms-schedule	sc2 scd sch
application/vnd.ms-tnef
application/vnd.ms-word		doc dot wiz
application/vnd.ms-works
application/vnd.ms-write	wri
application/vnd.msign
application/vnd.music-niff
application/vnd.musician
application/vnd.netfpx
application/vnd.noblenet-directory
application/vnd.noblenet-sealer
application/vnd.noblenet-web
application/vnd.nokia.ringing-tone	rng
application/vnd.novadigm.EDM
application/vnd.novadigm.EDX
application/vnd.novadigm.EXT
application/vnd.osa.netdeploy
application/vnd.pg.format
application/vnd.pg.osasli
application/vnd.powerbuilder6
application/vnd.powerbuilder6-s
application/vnd.powerbuilder7
application/vnd.powerbuilder7-s
application/vnd.powerbuilder75
application/vnd.powerbuilder75-s
application/vnd.previewsystems.box
application/vnd.publishare-delta-tree
application/vnd.rapid
application/vnd.s3sms
application/vnd.seemail
application/vnd.shana.informed.formdata
application/vnd.shana.informed.formtemplate
application/vnd.shana.informed.interchange
application/vnd.shana.informed.package
application/vnd.street-stream
application/vnd.svd
application/vnd.swiftview-ics
application/vnd.triscape.mxs
application/vnd.trueapp
application/vnd.truedoc
application/vnd.ufdl
application/vnd.uplanet.alert
application/vnd.uplanet.alert-wbxml
application/vnd.uplanet.bearer-choi-wbxml
application/vnd.uplanet.bearer-choice
application/vnd.uplanet.cacheop
application/vnd.uplanet.cacheop-wbxml
application/vnd.uplanet.channel
application/vnd.uplanet.channel-wbxml
application/vnd.uplanet.list
application/vnd.uplanet.list-wbxml
application/vnd.uplanet.listcmd
application/vnd.uplanet.listcmd-wbxml
application/vnd.uplanet.signal
application/vnd.vcx
application/vnd.vectorworks
application/vnd.visio
application/vnd.wap.sic
application/vnd.wap.slc
application/vnd.wap.wbxml	wbxml
application/vnd.wap.wmlc	wmlc
application/vnd.wap.wmlscriptc	wmlsc
application/vnd.webturbo
application/vnd.wordperfect	wp wp5 wpd w51 w60 wp6 w61
application/vnd.wordstar
application/vnd.wrq-hp3000-labelled
application/vnd.wt.stf
application/vnd.xara
application/vnd.xfdl
application/vnd.yellowriver-custom-menu
application/wita
application/whoispp-query
application/whoispp-response
application/x-arc		
application/x-archive		ar
application/x-awk		awk
application/x-bcpio		bcpio
application/x-bytecode.elisp	elc
application/x-bytecode.python	pyc
application/x-bytecode.parrot	pbc
application/x-bzip
application/x-bzip2		
application/x-cdlink		vcd
application/x-chess-pgn		pgn
application/x-compress
application/x-cpio		cpio
application/x-cprplayer		pqf
application/x-debian-package	deb
application/x-director		dcr dir dxr
application/x-dvi		dvi
application/x-eiffel		e
application/x-futuresplash	spl
application/x-gawk		gawk
application/x-gzip
application/x-hdf		hdf
application/x-httpd-imap	imap
application/x-javascript	js ls moc mocha
application/x-javascript-config	jsc
application/x-koan		skp skd skt skm
application/x-latex		latex ltx cls sty
application/x-lisp		lisp lsp gcl cl
application/x-mailfolder	mail
application/x-msdos-program	com exe bat scr
application/x-nawk		nawk
application/x-netcdf		nc cdf
application/x-newton-compatible-pkg	pkg
application/x-ns-proxy-autoconfig	pac
application/x-ogg
application/x-pagemaker		pm4 pm5
application/x-rar		rar
application/x-redhat-package	rpm
application/x-sc		sc
application/x-sea		sea
application/x-shar		shar
application/x-shockwave-flash	swf
application/x-stuffit		sit sea
application/x-sv4cpio		sv4cpio
application/x-sv4crc		sv4crc
application/x-tar		tar tgz tbz tbz2
application/x-tex		tex
application/x-texinfo		texinfo texi
application/x-troff		t tr roff
application/x-troff-man		man 1 1b 1c 1f 1m 1s 2 3 3b 3c 3e 3g 3k 3m 3n 3r 3s 3t 3x 3xc 3xn 4 4b 5 6 7 7d 7fs 7i 7m 7p 8 9 9e 9f 9s l n
application/x-troff-me		me
application/x-troff-ms		ms
application/x-ustar		ustar
application/x-wais-source	src
application/x-winhelp		hlp
application/x-xfig		fig
application/x-yacc		y
application/x-zoo		zoo
application/x400-bp
application/xml
application/xslt+xml		xslt
application/zip			zip boz jar
audio/32kadpcm
audio/basic			au snd
audio/l16
audio/midi			mid midi kar rmi
audio/mod			mod mtm s3m xm
audio/mpeg			mpga mp2 mp3 m2a  mpega mpa mpa2
audio/prs.sid
audio/telephone-event
audio/tone
audio/vnd.cns.anp1
audio/vnd.cns.inf1
audio/vnd.digital-winds
audio/vnd.everad.plj
audio/vnd.lucent.voice
audio/vnd.nortel.vbk
audio/vnd.nuera.ecelp4800
audio/vnd.nuera.ecelp7470
audio/vnd.octel.sbc
audio/vnd.qcelp
audio/vnd.pn-realaudio		ra ram rm
#audio/vnd.pn-realaudio-plugin	rpm
audio/vnd.rhetorex.32kadpcm
audio/vnd.vmx.cvsd
audio/voc			voc
audio/x-aiff			aif aiff aifc
audio/x-cmf			cmf
audio/x-cvf			cvf
audio/x-mpegurl			m3u pls
audio/x-sbi			sbi
audio/x-twinvq			vqf
audio/x-twinvq-plugin		vqe vql
audio/x-vorbis			ogg
audio/x-wav			wav
chemical/x-pdb			pdb
chemical/x-xyz			xyz
image/bmp			bmp
image/cgm			cgm
image/fif			fif
image/g3fax			g3 g3f
image/gif			gif
image/ief			ief iefs
image/jpeg			jpeg jpg jpe jfif
image/naplps			nap naplps
image/quicktime			qti qif qtif
image/png			png
image/prs.btif
image/prs.pti
image/tiff			tiff tif
image/vnd.cns.inf2
image/vnd.dwg
image/vnd.dxf
image/vnd.fastbidsheet
image/vnd.fpx
image/vnd.fst
image/vnd.fujixerox.edmics-mmr
image/vnd.fujixerox.edmics-rlc
image/vnd.mix
image/vnd.net-fpx
image/vnd.svf
image/vnd.wap.wbmp		wbmp
image/vnd.xiff
image/wavelet			wi
image/x-cmu-raster		ras
image/x-cmx			cmx
image/x-fgf			fgf
image/x-icon			ico
image/x-jng			jng
image/x-niff			nif niff
image/x-pbf			pbf
image/x-pcx			pcx
image/x-photo-cd		pcd
image/x-pict			pct pict pic
image/x-pjpeg			pjp pjpeg pjpg
image/x-portable-anymap		pnm
image/x-portable-bitmap		pbm
image/x-portable-graymap	pgm
image/x-portable-pixmap		ppm
image/x-rgb			rgb
image/x-xbitmap			xbm
image/x-xcf			xcf
image/x-xpixmap			xpm
image/x-xwindowdump		xwd
image/x-zif			zif
message/delivery-status
message/disposition-notification
message/external-body
message/http
message/news
message/partial
message/rfc822			mime mhtml mht
message/s-http
model/iges			igs iges
model/mesh			msh mesh silo
model/vnd.dwf
model/vnd.flatland.3dml
model/vnd.gdl
model/vnd.gs-gdl
model/vnd.gtw
model/vnd.mts
model/vnd.vtu
model/vrml			wrl wrz vrml vrm
multipart/alternative
multipart/appledouble
multipart/byteranges
multipart/digest
multipart/encrypted
multipart/form-data
multipart/header-set
multipart/mixed
multipart/parallel
multipart/related
multipart/report
multipart/signed
multipart/voice-message
text/calendar
text/comma-separated-values	csv
text/css	css
text/directory
text/enriched	etx
text/hdml	hdml
text/html	html htm htx htmls dhtml phtml shtml inc ssi
text/pascal	p pas
text/pipe-separated-values	psv
text/plain	txt text md5 conf patch diff sed m4 def jav java log readme sha1
text/prs.lines.tag
text/rfc822-headers
text/richtext			rtx rt
text/rtf			rtf
text/sgml			sgml sgm
text/tab-separated-values	tsv
text/uri-list			uri uni unis uris
text/x-vCalendar		vcs
text/x-vCard			vcf
text/vnd.DMClientScript
text/vnd.IPTC.NITF
text/vnd.IPTC.NewsML
text/vnd.abc			abc
text/vnd.curl
text/vnd.flatland.3dml
text/vnd.fly
text/vnd.fmi.flexstor
text/vnd.in3d.3dml
text/vnd.in3d.spot
text/vnd.latex-z
text/vnd.motorola.reflex
text/vnd.ms-mediapackage
text/vnd.wap.si
text/vnd.wap.sl
text/vnd.wap.wml		wml
text/vnd.wap.wmlscript		wmls
text/x-c			c c++ cc cpp cxx
text/x-fortran			f f77 f90 for
text/x-h			h h++ hh hpp
text/x-m			m
text/x-ae			ae
text/x-javascript		js
text/x-script.sh		sh
text/x-script.ash		ash
text/x-script.bash		bash
text/x-script.bsh		bsh
text/x-script.csh		csh tcsh
text/x-script.ksh		ksh
text/x-script.zsh		zsh
text/x-script.elisp		el
text/x-script.scheme		scheme
text/x-script.tcl		tcl
text/x-script.parrot-assembler	pasm
text/x-script.perl		pl ph ptk
text/x-script.perl-module	pm
text/x-script.python		py
text/x-setext			etx
text/x-speech			talk
text/x-uuencode			uu uue
text/xml			xml xsl rdf rss
text/xml-dtd			dtd
video/flc			flc
video/fli			fli
video/mpeg			mpeg mpg mpe m1v m2v mpegv mpv mpv2
video/pointer
video/quicktime			qt mov moov
video/vdo			vdo
video/vnd.fvt
video/vnd.motorola.video
video/vnd.motorola.videop
video/vnd.msvideo		avi
video/vnd.rn-realvideo		rv
video/vnd.vivo
video/x-sgi-movie		movie
video/x-mng			mng
windows/metafile		wmf
x-conference/x-cooltalk		ice
x-world/x-3dmf			3dm 3dmf qd3 qd3d"