/*
Dieses File entstand aus:
http://fsinfo.cs.uni-sb.de/~abe/apache-tips/mime.types
Alle Zeilen ohne Endungen habe ich gelscht, bei Zeilen mit mehreren Endungen habe ich 
ggf die Reihenfolge verndert, so da meist die 1. maximal 3stellige an die 1. Stelle kam
auerdem Punkte, Anfhrunszeichen, Kommas u. eingefgt und so sortiert, da die wichtigsten am Anfang stehen

##
##
##           _            __
##    __ _  (_)_ _  ___  / /___ _____  ___ ___
##   /  ' \/ /  ' \/ -_)/ __/ // / _ \/ -_|_-<
##  /_/_/_/_/_/_/_/\__(_)__/\_, / .__/\__/___/
##                         /___/_/
##                             __              __       __   __    __   
##   _    ___    ___    __ ___/ /__ ____ ____ / /___ __/ /  / /___/ /__ 
##  | |/|/ / |/|/ / |/|/ // _  / _ `/ _ `(_-</ __/ // / _ \/ // _  / -_)
##  |__,__/|__,__/|__,__(_)_,_/\_,_/\_, /___/\__/\_,_/_//_/_(_)_,_/\__/ 
##                                 /___/
##
##  kathrin.dagstuhl.de Apache HTTPd mime configuration file
##
##
##

##
## Based on the Apache 1.3.20 mime.types file
## Expanded by Axel Beckert <abe@fsinfo.cs.uni-sb.de>
## URL http://fsinfo.cs.uni-sb.de/~abe/apache-tips/mime.types
## Last modification: [mime.types: Mon 12-Nov-2001 23:18:35 (MET) axel@kathrin.dagstuhl.de]
##

# This file controls what Internet media types are sent to the client for
# given file extension(s).  Sending the correct media type to the client
# is important so they know how to handle the content of the file.
# Extra types can either be added here or by using an AddType directive
# in your config files. For more information about Internet media types,
# please read RFC 2045, 2046, 2047, 2048, and 2077.  The Internet media type
# registry is at <ftp://ftp.iana.org/in-notes/iana/assignments/media-types/>.

# MIME type			Extension

 * 7.8.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29i'
 *	UDO-Files eingefgt

*/

_UBYTE *MimeTypes[]={
"application/arj",					".arj.",
"application/base64",				".mme.mm.",
"application/eps",					".eps.",
"application/lha",					".lha.",
"application/lzh",					".lzh.",
"application/lzx",					".lzx.",
"application/pdf",					".pdf.",
"application/pgp-keys",				".pgp.key.",
"application/postscript",			".ps.ai.",
"application/vnd.ms-word",			".doc.dot.wiz.",
"application/x-msdos-program",		".exe.com.bat.scr.",
"application/x-tar",				".tar.tgz.tbz.tbz2.",
"application/x-tex",				".tex.",
"application/zip",					".zip.boz.jar.",
"image/bmp",						".bmp.",
"image/gif",						".gif.",
"image/jpeg",						".jpg.jpeg.jpe.jfif.",
"image/png",						".png.",
"image/tiff",						".tif.tiff.",
"text/html",						".htm.html.htx.htmls.dhtml.phtml.shtml.inc.ssi.",
"text/pascal",						".pas.p.",
"text/x-c",							".c.c++.cc.cpp.cxx.",
"text/x-fortran",					".f.f77.f90.for.",
"text/x-h",							".h.h++.hh.hpp.",
"text/x-m",							".m.",
"text/x-javascript",				".js.",
"application/acad",					".dwg.",
"application/andrew-inset",			".ez.",
"application/cprplayer",			".pqi.",
"application/dsssl",				".dsl.dsssl.",
"application/dxf",					".dxf.",
"application/gnutar",				".gtar.gtgz.ftbz.gtbz2.",
"application/java-byte-code",		".class.",
"application/mac-binhex40",			".hqx.",
"application/mac-compactpro",		".cpt.",
"application/octet-stream",			".bin.dms.o.",
"application/oda",					".oda.",
"application/pgp-signature",		".asc.",
"application/pkcs10",				".p10.",
"application/pkcs12",				".p12.",
"application/pkcs7-certificates",	".spc.",
"application/pkcs7-certreqresp",	".p7r.",
"application/pkcs7-mime",			".p7c.p7m.",
"application/pkcs7-signature",		".p7a.",
"application/presentations",		".shw.",
"video/vnd.rn-realplayer",			".rnx.",
"application/rtf",					".rtf.",
"application/sgml",					".sgm.sqml.",
"application/smil",					".smi.smil.",
"application/vnd.corel-draw",		".cdr.",
"application/vnd.framemaker",		".fm.fm3.fm4.fm5.mk.frm.frame.",
"application/vnd.lotus-1-2-3",		".123.",
"application/vnd.lotus-organizer",	".org.or2..",
"application/vnd.lotus-screencam",	".scm..",
"application/vnd.lotus-wordpro",	".lwp.sam..",
"application/vnd.mif",				".mif.",
"application/vnd.ms-access",		".mda.mdb.mde..",
"application/vnd.ms-excel",			".xls.xlm.xlt.xla.xlb.xlc.xld.xlk.xll.xlv.xlw.",
"application/vnd.ms-powerpoint",	".ppt.ppz.pot.pwz.ppa.pps.pow.",
"application/vnd.ms-project",		".mpp.mpt.mpv.mpx.mpw.",
"application/vnd.ms-schedule",		".sc2.scd.sch.",
"application/vnd.ms-write",			".wri.",
"application/vnd.nokia.ringing-tone",".rng.",
"application/vnd.wap.wbxml",		".wbxml.",
"application/vnd.wap.wmlc",			".wmlc.",
"application/vnd.wap.wmlscriptc",	".wmlsc.",
"application/vnd.wordperfect",		".wp.wp5.wpd.w51.w60.wp6.w61.",
"application/x-archive",			".ar.",
"application/x-awk",				".awk.",
"application/x-bcpio",				".bcpio.",
"application/x-bytecode.elisp",		".elc.",
"application/x-bytecode.python",	".pyc.",
"application/x-bytecode.parrot",	".pbc.",
"application/x-cdlink",				".vcd.",
"application/x-chess-pgn",			".pgn.",
"application/x-cpio",				".cpio.",
"application/x-cprplayer",			".pqf.",
"application/x-debian-package",		".deb.",
"application/x-director",			".dcr.dir.dxr.",
"application/x-dvi",				".dvi.",
"application/x-eiffel",				".e.",
"application/x-futuresplash",		".spl.",
"application/x-gawk",				".gawk.",
"application/x-hdf",				".hdf.",
"application/x-httpd-imap",			".imap.",
"application/x-javascript",			".js.ls.moc.mocha.",
"application/x-javascript-config",	".jsc.",
"application/x-koan",				".skp.skd.skt.skm.",
"application/x-latex",				".ltx.latex.cls.sty.",
"application/x-lisp",				".lsp.lisp.gcl.cl.",
"application/x-mailfolder",			".mail.",
"application/x-nawk",				".nawk.",
"application/x-netcdf",				".nc.cdf.",
"application/x-newton-compatible-pkg",".pkg.",
"application/x-ns-proxy-autoconfig",".pac.",
"application/x-pagemaker",			".pm4.pm5.",
"application/x-rar",				".rar.",
"application/x-redhat-package",		".rpm.",
"application/x-sc",					".sc.",
"application/x-sea",				".sea.",
"application/x-shar",				".shar.",
"application/x-shockwave-flash",	".swf.",
"application/x-stuffit",			".sit.sea.",
"application/x-sv4cpio",			".sv4cpio.",
"application/x-sv4crc",				".sv4crc.",
"application/x-texinfo",			".texi.texinfo.",
"application/x-troff",				".tr.t.roff.",
"application/x-troff-man",			".man.1.1b.1c.1f.1m.1s.2.3.3b.3c.3e.3g.3k.3m.3n.3r.3s.3t.3x.3xc.3xn.4.4b.5.6.7.7d.7fs.7i.7m.7p.8.9.9e.9f.9s.l.n.",
"application/x-troff-me",			".me.",
"application/x-troff-ms",			".ms.",
"application/x-ustar",				".ustar.",
"application/x-wais-source",		".src.",
"application/x-winhelp",			".hlp.",
"application/x-xfig",				".fig.",
"application/x-yacc",				".y.",
"application/x-zoo",				".zoo.",
"application/xslt+xml",				".xslt.",
"audio/basic",						".snd.au.",
"audio/midi",						".mid.midi.kar.rmi.",
"audio/mod",						".mod.mtm.s3m.xm.",
"audio/mpeg",						".mpga.",
"audio/vnd.pn-realaudio",			".ra.ram.rm.",
"audio/voc",						".voc.",
"audio/x-aiff",						".aif.aiff.aifc.",
"audio/x-cmf",						".cmf.",
"audio/x-cvf",						".cvf.",
"audio/x-mpegurl",					".m3u.pls.",
"audio/x-sbi",						".sbi.",
"audio/x-twinvq",					".vqf.",
"audio/x-twinvq-plugin",			".vqe.vql.",
"audio/x-vorbis",					".ogg.",
"audio/x-wav",						".wav.",
"chemical/x-pdb",					".pdb.",
"chemical/x-xyz",					".xyz.",
"image/cgm",						".cgm.",
"image/fif",						".fif.",
"image/g3fax",						".g3.g3f.",
"image/ief",						".ief.iefs.",
"image/naplps",						".nap.naplps.",
"image/quicktime",					".qti.qif.qtif.",
"image/vnd.wap.wbmp",				".wbmp.",
"image/wavelet",					".wi.",
"image/x-cmu-raster",				".ras.",
"image/x-cmx",						".cmx.",
"image/x-fgf",						".fgf.",
"image/x-icon",						".ico.",
"image/x-jng",						".jng.",
"image/x-niff",						".nif.niff.",
"image/x-pbf",						".pbf.",
"image/x-pcx",						".pcx.",
"image/x-photo-cd",					".pcd.",
"image/x-pict",						".pct.pict.pic.",
"image/x-pjpeg",					".pjp.pjpeg.pjpg.",
"image/x-portable-anymap",			".pnm.",
"image/x-portable-bitmap",			".pbm.",
"image/x-portable-graymap",			".pgm.",
"image/x-portable-pixmap",			".ppm.",
"image/x-xbitmap",					".xbm.",
"image/x-xcf",						".xcf.",
"image/x-xpixmap",					".xpm.",
"image/x-xwindowdump",				".xwd.",
"image/x-zif",						".zif.",
"message/rfc822",					".mime.mhtml.mht.",
"model/iges",						".igs.iges.",
"model/mesh",						".msh.mesh.silo.",
"model/vrml",						".wrl.wrz.vrml.vrm.",
"text/comma-separated-values",		".csv.",
"text/css",							".css.",
"text/enriched",					".etx.",
"text/hdml",						".hdml.",
"text/pipe-separated-values",		".psv.",
"text/plain",						".txt.text.md5.conf.patch.diff.sed.m4.def.jav.java.log.readme.sha1.",
"text/richtext",					".rtx.rt.",
"text/rtf",							".rtf.",
"text/sgml",						".sgm.sgml.",
"text/tab-separated-values",		".tsv.",
"text/uri-list",					".uri.uni.unis.uris.",
"text/x-vCalendar",					".vcs.",
"text/x-vCard",						".vcf.",
"text/vnd.abc",						".abc.",
"text/vnd.wap.wml",					".wml.",
"text/vnd.wap.wmlscript",			".wmls.",
"text/x-ae",						".ae.",
"text/x-script.sh",					".sh.",
"text/x-script.ash",				".ash.",
"text/x-script.bash",				".bash.",
"text/x-script.bsh",				".bsh.",
"text/x-script.csh",				".csh.tcsh.",
"text/x-script.ksh",				".ksh.",
"text/x-script.zsh",				".zsh.",
"text/x-script.elisp",				".el.",
"text/x-script.scheme",				".scheme.",
"text/x-script.tcl",				".tcl.",
"text/x-script.parrot-assembler",	".pasm.",
"text/x-script.perl",				".pl.ph.ptk.",
"text/x-script.perl-module",		".pm.",
"text/x-script.python",				".py.",
"text/x-setext",					".etx.",
"text/x-speech",					".talk.",
"text/x-uuencode",					".uue.uu.",
"text/xml",							".xml.xsl.rdf.rss.",
"text/xml-dtd",						".dtd.",
"text/udo",							".u.ui."		/*DYJ 5.29i */
"video/flc",						".flc.",
"video/fli",						".fli.",
"video/mpeg",						".mpg.mpeg.mpe.m1v.m2v.mpegv.mpv.mpv2.",
"video/quicktime",					".qt.mov.moov.",
"video/vdo",						".vdo.",
"video/vnd.msvideo",				".avi.",
"video/vnd.rn-realvideo",			".rv.",
"video/x-sgi-movie",				".movie.",
"video/x-mng",						".mng.",
"windows/metafile",					".wmf.",
"x-conference/x-cooltalk",			".ice.",
"x-world/x-3dmf",					".3dm.3dmf.qd3.qd3d",
"multipart/digest",					".mim",
"multipart/related",				".mim",
};