#ifndef __CAT_ADR_H__
#define __CAT_ADR_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif


_VOID adr_SaveNames(_WORD nor_alias);
/* Sichert die Liste der Namen komplett
 */

_VOID adr_SortList(_WORD nor_alias,_VOID (*vorher)(_VOID));
/* Namensliste sortieren */

enum{	ADR_NORMAL,	ADR_ALIAS,		ADR_N_REPLY,	ADR_N_SENDER,
		ADR_NORMAL_EMPTY,
		ADR_A_REPLY,ADR_A_SENDER,
/*DYJ 5.34d Start*/
/*DYJ 5.35c Start*/
		ADR_N_FROM,	ADR_MLIST, ADR_STDTO,ADR_A_FROM,ADR_EIGENE,
/*DYJ  Ende; alt:	
		ADR_N_FROM,	ADR_MLIST, ADR_A_FROM,ADR_EIGENE,
*/
/*DYJ  Ende; alt:	
		ADR_N_FROM,	ADR_A_FROM,ADR_EIGENE,
*/
		ADR_ANZ_MODES,ADR_TRUE};


_BOOL adr_ReadNames(_WORD nor_alias);
/* Liest die Liste der Namen komplett
*/
_VOID E_Alias_Config(_VOID);
CONST _UBYTE *adr_exist(_WORD nor_alias, _UBYTE *name);


_VOID adr_ClearList(_WORD nor_alias);
/* Loescht die Liste der Namen
*/

_BOOL adr_SelectName(_WORD nor_alias,_UBYTE *Name, size_t namesize);

_BOOL adr_NewNameEntry(_WORD nor_alias,CONST _UBYTE *name, CONST _UBYTE *info);
/* Fuegt einen Namen in die ADR.INF ein oder aendert einen
 * vorhandenen. Speichert auch ab!
 */
_BOOL adr_getRealNameOfAlias(_UBYTE *realName,size_t len,_UBYTE *adresse);

#endif /* __CAT_ADR_H__ */

