#ifndef __CAT_ALIAS_H__
#define __CAT_ALIAS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __CAT_GROUPSELECT_H__
#include <groupsel.h>
#endif
#ifndef __LISTS_H__
#include <lists.h>
#endif

_BOOL Alias_Init(_VOID);

_VOID Alias_Exit(_VOID);

_BOOL Alias_ShowAlias(CONST _UBYTE *groupName,_BOOL test);

_VOID Alias_Setnames(group *groups, GROUPNR numGroups);

_VOID Alias_Config(_VOID);

List *Alias_GetList(_VOID);

_VOID Alias_DeleteList(_BOOL killCarrier);

#endif /* __CAT_ALIAS_H__ */

