#ifndef __CAT_EXECV_H__
#define __CAT_EXECV_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif


/*
 * v1.20 (c) 07.06.1991 Christian Sprenger - ExecMode = Exec
 * v1.10 (c) 23.05.1990 Christian Sprenger - tpStr, saemtliche ExecModes
 * v1.00 (c) 07.02.1990 Christian Sprenger
 *
 * starten von Programmen nach ARGV-Verfahren
 */

extern _UBYTE *Environment;

/* mu nach Pexec(Load)/Pexec(CreateBasePage) mit GEMDOS.Mfree(Environment)
   freigegeben werden.
   Im Falle von Pexec(LoadExec)/Pexec(ExecFree) erledigt das Pexec() selber
*/

size_t ExecV_lenQu2Argv(CONST _UBYTE *cmdln,_BOOL useQuotes);
_VOID ExecV_Qu2Argv(_UBYTE *p,CONST _UBYTE *path,CONST _UBYTE *cmdln,_BOOL useQuotes);
_WORD ExecV_Pexec(_UWORD mode, CONST _UBYTE *Path, _UBYTE *Cmdln, CONST _UBYTE *Environment,_BOOL useQuotes);
/* startet ein Programm mit Pexec(), uebergibt jedoch die Kommandozeile
   nach dem ARGV-Verfahren. Sie darf daher beliebig lang sein.
   Das erste Byte von cmdln wird nicht ausgewertet und ignoriert.
*/

_WORD ExecV_Shelw(_UBYTE *Path, _UBYTE *CmdLn);
#endif /* __CAT_EXECV_H__ */
