#ifndef __CAT_MTPATHS_H__
#define __CAT_MTPATHS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif


extern _UBYTE ARCPath[PATH_MAX];
extern _UBYTE MessagePath[PATH_MAX];
extern _UBYTE ImportPath[PATH_MAX];
extern _UBYTE ExportPath[PATH_MAX];
extern _UBYTE DataPath[PATH_MAX];
extern _UBYTE TerminalPath[PATH_MAX];
extern _UBYTE ARCName[PATH_MAX];
extern _UBYTE archiveName[PATH_MAX];
extern _UBYTE TerminalName[PATH_MAX];
extern _UBYTE enarcStr[PATH_MAX];
extern _UBYTE dearcStr[PATH_MAX];
extern _UBYTE TerminalCmd[PATH_MAX*6];
extern _UBYTE lastInfName[PATH_MAX];
extern _UBYTE AttachmentPath[PATH_MAX];

_BOOL MTPaths_ReadInf(_UBYTE *path, _UBYTE *name, _BOOL noCommand, _BOOL showError, CONST _UBYTE *inf_from_argv);
_BOOL MTPaths_DatabaseLocked(_VOID);
#define CAT_LCK_RO	-1000
GLOBAL _BOOL MTPaths_DatabaseRonly(_VOID);

_BOOL MTPaths_LockDatabase(_VOID);

_VOID MTPaths_Exit(_VOID);

#endif /* __CAT_MTPATHS_H__ */
