/*****************************************************************************
 *		ROUTINE.C
 *****************************************************************************/
#include <portab.h>

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.24d */
GLOBAL _WORD strCmp(CONST _UBYTE *str1, CONST _UBYTE *str2)
{
	_UBYTE c1, c2;

	if (str1 == NULL)
		str1 = "";
	if (str2 == NULL)
		str2 = "";
	do
	{
		c1 = *str1++;
		c2 = *str2++;
	} while (c1 != '\0' && c1 == c2);
	if (c1 == c2)
		return 0;
	if (c1 == '\0')
		return -1;
	if (c2 == '\0')
		return 1;
	return c1 - c2;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD strnCmp(CONST _UBYTE *_str1, CONST _UBYTE *str2, size_t leng)			*/
/*	wie strnCmp nur ohne die Abstrze											*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	26.7.02 von Dimitri Junker	DYJ 4.41j										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.24d */
GLOBAL _WORD strnCmp(CONST _UBYTE *str1, CONST _UBYTE *str2, size_t leng)
{
	_UBYTE c1, c2;
	_LONG count;

	if (str1 == NULL)
		str1 = "";
	if (str2 == NULL)
		str2 = "";
	count = leng;
	do
	{
		c1 = *str1++;
		c2 = *str2++;
	} while (--count >= 0 && c1 != '\0' && c1 == c2);
	if (count < 0)
		return 0;
	if (c1 == c2)
		return 0;
	if (c1 == '\0')
		return -1;
	if (c2 == '\0')
		return 1;
	return c1 - c2;
}

/*** ------------------------------------------------------------------------ ***/
/*	size_t  strLen( CONST _UBYTE *s )												*/
/*	wie strlen allerdings ohne den Absturz bei bergabe von NULL. strLen(NULL)	*/
/*	gibt 0 zurck																*/
/*	Parameter:	s: der String															*/
/*	Ergebnis:	Lnge von s															*/		
/*	25.4.02 von Dimitri Junker	DYJ 4.38b										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL size_t  strLen( CONST _UBYTE *s )
{
	size_t len=0;
	if(s)
	{
		while(*(s++))
			len++;
	}
	return len;
}

