/*****************************************************************************
 * ROS_TABS.C
 *****************************************************************************/
#include <portab.h>


/*** ---------------------------------------------------------------------- ***/

GLOBAL size_t Str_ConvertTabs(CONST _UBYTE *source, _UBYTE *dst, size_t destsize, _UWORD TabSize)
{
	_UWORD tab;
	_UBYTE *dest;
	
	--destsize;
	dest = dst;
	tab = TabSize;
	while (*source != '\0' && destsize)
	{
		if (*source == '\t')
		{
			while (tab && destsize)
			{
				*dest++ = ' ';
				tab--;
				destsize--;
			}
			tab = TabSize;
			source++;
		} else
		{
			*dest++ = *source++;
			if (--tab == 0)
				tab = TabSize;
			destsize--;
		}
	}
	*dest = '\0';
	return dest - dst;
}
