/*****************************************************************************
 * ROUTINEC.H
 *****************************************************************************/

#ifndef __ROUTINEC_H__
#define __ROUTINEC_H__

#ifndef __PORTAB_H__
#  include <portab.h>
#endif
#ifndef __VAR_ARGS_H__
#  include <var_args.h>
#endif

#define PtrSize(aa) (aa), (_UWORD)sizeof(aa)
#define PtrAdrSize(aa) ((_VOID*)&aa), (_UWORD)sizeof(aa)


_UBYTE *strMcat(_UBYTE *dest, size_t size, CONST _UBYTE *src);


_UBYTE *strMcpy(_UBYTE *dest, size_t maxlen, CONST _UBYTE *src);

#define strBcpy(aa, bb) strMcpy(PtrSize(aa), bb)
#define strBcat(aa, bb) strMcat(PtrSize(aa), bb)
	

#endif /* __ROUTINEC_H__ */
