/*****************************************************************************
 *		SET.H
 *****************************************************************************/

#ifndef __SET_H__
#define __SET_H__

/* SET-Funktionen */
#define SETSIZE     32					/* Groesse eines Sets in Longs */
#define SETMAX      (SETSIZE * 32)		/* Maximale Elemente eines Sets */

typedef _ULONG SET[SETSIZE];	/* Menge */

EXTERN _VOID setcpy(SET set1, CONST SET set2);
EXTERN _VOID setall(SET set);
EXTERN _VOID setclr(SET set);
EXTERN _VOID setnot(SET set);
EXTERN _VOID setand(SET set1, CONST SET set2);
EXTERN _VOID setor(SET set1, CONST SET set2);
EXTERN _VOID setxor(SET set1, CONST SET set2);
EXTERN _VOID setincl(SET set, _WORD elt);
EXTERN _VOID setexcl(SET set, _WORD elt);
EXTERN _BOOL setin(CONST SET set, _WORD elt);
EXTERN _BOOL setcmp(CONST SET set1, CONST SET set2);
EXTERN _WORD setcard(CONST SET set);

#endif /* __SET_H__ */
