/*****************************************************************************
 * GENERIC/FIO_INIT.C
 *****************************************************************************/

#include "_file_io.h"
#include <ro_mem.h>
#include <termproc.h>

#ifdef DEBUG
OS_GLOBAL _WORD   OpenFiles = 0;
#endif
OS_GLOBAL _BOOL NetzwerkDa = FALSE;
OS_GLOBAL FILE_BUF *FiBuf = NULL;
OS_GLOBAL _WORD fi_buf_size = 0;


/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FExit(_VOID)
{
	if (FiBuf != NULL)
	{
		SFREE(FiBuf);
		FiBuf = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

OS_GLOBAL _BOOL FInit(_VOID)
{
	_WORD ii;
	
	if (FiBuf == NULL)
	{
		FiBuf = CALLOC(36, sizeof(FILE_BUF), "Finit");
		if (FiBuf == NULL)
			return FALSE;
			
		fi_buf_size = 36;
		InstallTermproc(FExit);
		
		for (ii = 0; ii < fi_buf_size; ii++)
		{
			FiBuf[ii].open = FALSE;
			FiBuf[ii].used = FALSE;
			FiBuf[ii].seekPos = 0;
		}
	}
	return TRUE;
}
