#include "_file_io.h"
#include <routine.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID F_Path_Fullname(_UBYTE *filename)
{
	_UBYTE fnamebuf[PATH_MAX];
	_WORD drive;
	_WORD len;
	_UBYTE *sp;
	_UBYTE *fsave;

	if (!is_alpha(filename[0]) ||
		filename[1] != ':' || filename[2] != '\\')
	{
		fsave = filename;
		drive = Dgetdrv()+1;
		if (is_alpha(filename[0]) && filename[1] == ':')
		{
			drive = ucase(filename[0])-'A'+1;
			filename += 2;
		}
		fnamebuf[0] = drive+'A'-1;
		fnamebuf[1] = ':';
		fnamebuf[2] = '\0';
		if (filename[0] != '\\')
		{
			Dgetpath(fnamebuf+2, drive);
			if (is_alpha(fnamebuf[2]) && fnamebuf[3] == ':')
				strCpy(fnamebuf, fnamebuf+2);
		}
		len = (_WORD)strLen(fnamebuf);
		if (fnamebuf[len-1] == '\\')
			fnamebuf[len-1] = '\0';
		while (filename[0] == '.')
		{
			if (filename[1] == '.' && filename[2] == '\\')
			{
				if ((sp = strrChr(fnamebuf, '\\')) != NULL)
					*sp = '\0';
				filename += 3;
			} else {
				if (filename[1] == '\\')
					filename += 2;
				else
					break;
			}
		}
		if (*filename != '\\' && *filename != '\0')
			strCat(fnamebuf, "\\");
		strCat(fnamebuf, filename);
		strCpy(fsave, fnamebuf);
	}
}


