#include "_file_io.h"

OS_GLOBAL _UBYTE sys_workpath[PATH_MAX];
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL F_Path_Get(_UBYTE *pfad)
{
	_LONG retV;
	_UBYTE  drive;

	SavePD();

	if (pfad == NULL)
		pfad = sys_workpath;
	drive = 'A' + Dgetdrv();
	strCpy(pfad, "A:");
	*pfad = drive;
	retV = Dgetcwd(&pfad[2], drive - 'A' + 1, PATH_MAX-2);
	if (retV != 0 && retV != -78 /* ENAMETOOLONG */)
		retV = Dgetpath(&pfad[2], drive - 'A' + 1);
	if (retV != 0)
		*pfad = '\0';
	RestorePD();
	return retV == 0;
}
