/*****************************************************************************
 *	GENERIC/FIO_SCLS.C
 *****************************************************************************/

#include "_file_io.h"

/*** ---------------------------------------------------------------------- ***/

OS_GLOBAL F_ERROR sysFclose(FILE_BUF *ff)
{
	_WORD retV = 0;

	if (ff->open)
	{
		SavePD();
		retV = Fclose((_WORD)(ff->handle));
		RestorePD();
		ff->open = FALSE;
		
#ifdef DEBUG
		OpenFiles--;
		ErrorOut(EO_TRACE, "***C %d       ", OpenFiles);
#endif
	}
	return sys_errno(retV);
}

