/*****************************************************************************
 *	TOS/FIO_SEEK.C
 *****************************************************************************/

#include "_file_io.h"

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR F_File_Seek(FILENO fd, _LONG offset, _WORD mode)
{
	_WORD ii = 0;
	DOSFNO handle;
	F_ERROR err;
	_LONG pos;
	
	SavePD();
	for (;;)
	{
		err = FiBufHandle(fd, &handle);
		if (err != GERR_OK)
			break;
		pos = Fseek(offset, (_WORD)handle, mode);
		if (pos == NETERR)
		{
			err = GERR_ACCESS;
			if (!NetzwerkDa)
				break;
			ii++;
			if (ii > 5)
				break;
		} else if (pos < 0 && pos > -200)
		{
			err = sys_errno((_WORD) pos);
			break;
		} else
		{
			FiBuf[TO_HANDLE(fd)].seekPos = pos;
			break;
		}
		NETWAIT();
	}
	RestorePD();
	return err;
}
