/*****************************************************************************
 *	TOS/FIO_TELL.C
 *****************************************************************************/

#include "_file_io.h"

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR F_File_Tell(FILENO fd, _ULONG *pos)
{
	DOSFNO handle;
	F_ERROR error;
	
	SavePD();
	if ((error = FiBufHandle(fd, &handle)) != GERR_OK)
	{
		*pos = 0;
		return error;
	}
	RestorePD();
	*pos = FiBuf[TO_HANDLE(fd)].seekPos;
	return GERR_OK;
}
