#include "_file_io.h"
#include <routinec.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL F_Path_Get_User(_UBYTE *path, CONST _UBYTE *name)
{
	CONST _UBYTE *env;
	F_STAT s;
	
	if ((env = getenv("HOME")) != NULL)
	{
		strMcpy(path, PATH_MAX, env);
		F_Path_Append(path, "defaults");
		if (F_Getinfo(path, &s, TRUE) != GERR_OK || !s.st_is_directory)
			F_Path_Dirname(path);
		if (name != NULL)
			F_Path_Append(path, name);
		F_Path_Fullname(path);
		return TRUE;
	}
	return FALSE;
}
