#include "_file_io.h"


OS_GLOBAL F_ERROR sys_errno(_WORD err)
{
	switch (err)
	{
		case   0: return GERR_OK;
		case  -2: return GERR_NOTRDY;
		case -13: return GERR_ROFS;
		case -15: return GERR_NXIO;
		case -32: return GERR_INVFN;
		case -33: return GERR_NOENT;
		case -34: return GERR_NOPATH;
		case -35: return GERR_MFILE;
		case -36: return GERR_ACCESS;
		case -37: return GERR_BADF;
		case -39: return GERR_NOMEM;
		case -40: return GERR_FAULT;
		case -46: return GERR_NODEV;
		case -48: return GERR_XDEV;
		case -49: return GERR_NOENT;
		case -58: return GERR_LOCKED;
		case -64: return GERR_RANGE;
		case -66: return GERR_NOEXEC;
		case -67: return GERR_NOMEM;
	}
	return GERR_IO;
}
