/*****************************************************************************
 *		VAR_ARGS.H
 *****************************************************************************/

#ifndef __VAR_ARGS_H__
#define __VAR_ARGS_H__

#if defined(__cplusplus) || defined(__STDC__) || defined(HAVE_STDARG_H) || defined(STDC_HEADERS)
#  include <stdarg.h>
#  define __c_va_alist				, ...
#  define __c_va_dcl
#  define __c_va_list				va_list
#  define __c_va_start(pvar, prev) 	va_start(pvar, prev)
#  define __c_va_arg(pvar, type)	va_arg(pvar, type)
#  define __c_va_end(pvar) 			va_end(pvar)
#else
#  include <varargs.h>
#  define __c_va_alist				, va_alist
#  define __c_va_dcl				va_dcl
#  define __c_va_list				va_list
#  define __c_va_start(pvar, prev) 	va_start(pvar)
#  define __c_va_arg(pvar, type)	va_arg(pvar, type)
#  define __c_va_end(pvar) 			va_end(pvar)
#endif

#endif /* __VAR_ARGS_H__ */
