#ifndef __WDLG_H__
#define __WDLG_H__

#ifndef __PORTAES_H__
# include <portaes.h>
#endif
#ifndef __WDLGEVNT_H__
#include <wdlgevnt.h>
#endif

typedef struct _dialog { int dummy; } DIALOG;

typedef _WORD (_CDECL *HNDL_OBJ)(DIALOG *dialog, EVNT *events, _WORD obj, _WORD clicks, _VOID *data);
#define HNDL_INIT (-1)
#define HNDL_MESG (-2)
#define HNDL_CLSD (-3)
#define HNDL_OPEN (-5)
#define HNDL_EDIT (-6)
#define HNDL_EDDN (-7)
#define HNDL_EDCH (-8)
#define HNDL_MOVE (-9)
#define HNDL_TOPW (-10)
#define HNDL_UNTP (-11)

/*
 * Flags fuer wdlg_create()
 */
#define WDLG_BKGD 0x0001

_WORD wdlg_close(DIALOG *dialog, _WORD *x, _WORD *y);
DIALOG *wdlg_create(HNDL_OBJ handle_exit, OBJECT *tree, _VOID *user_data, _WORD code, _VOID *data, _WORD flags);
_WORD wdlg_delete(DIALOG *dialog);
_WORD wdlg_evnt(DIALOG *dialog, EVNT *events);
_WORD wdlg_get_edit(DIALOG *dialog, _WORD *cursor);
_WORD wdlg_get_handle(DIALOG *dialog);
_WORD wdlg_get_tree(DIALOG *dialog, OBJECT **tree, GRECT *r);
_VOID *wdlg_get_udata(DIALOG *dialog);
_WORD wdlg_open(DIALOG *dialog, CONST _UBYTE *title, _WORD kind, _WORD x, _WORD y, _WORD code, _VOID *data);
_VOID wdlg_redraw(DIALOG *dialog, GRECT *rect, _WORD obj, _WORD depth);
_WORD wdlg_set_edit(DIALOG *dialog, _WORD obj);
_WORD wdlg_set_iconify(DIALOG *dialog, GRECT *g, CONST _UBYTE *title, OBJECT *tree, _WORD obj);
_WORD wdlg_set_size(DIALOG *dialog, GRECT *new_size);
_WORD wdlg_set_tree(DIALOG *dialog, GRECT *new_tree);
_WORD wdlg_set_uniconify(DIALOG *dialog, GRECT *g, CONST _UBYTE *title, OBJECT *tree);


#endif /* __WDLG_H__ */
