/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGICTOOL_AESMEN_H__
#define __MAGICTOOL_AESMEN_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif


_BOOL InitMenuline(OBJECT *menu);
/* Initialisiert eine Menuzeile. Dabei werden die '----' Eintraege wie bei
 * Flydial-Programmen mit einer Linie ersetzt. Achtung! Dies gilt vorlaeufig
 * nur fuer Megamax-Modula-2 Programme! Liefert FALSE wenn fehlgeschlagen!
 */

_VOID DrawMenuline(OBJECT *menu);
/* Bringt eine Menuezeile auf den Schirm. Dabei wird eine TermProc in mtAppl
 * installiert, so dass man sich bei Programmende nicht um das Zuruecksetzen
 * der Menuzeile kuemmern muss.
 */

_VOID ResetMenuline(_VOID);
/* Setzt die Menuezeile zurueck. */

#endif /* __MAGICTOOL_AESMEN_H__ */
