/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGICTOOL_COMMAND_H__
#define __MAGICTOOL_COMMAND_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif


#define ENV_Path        "PATH"        /* Suchpfade */
#define ENV_Parent      "PARENT"      /* Name der aufrufenden Applikation */
#define ENV_Rows        "ROWS"        /* Anzahl der Zeilen auf dem Schirm */
#define ENV_Columns     "COLUMNS"     /* Anzahl der Spalten auf dem Schirm */
#define ENV_Home        "HOME"        /* Home-Path */
#define ENV_Editor      "EDITOR"      /* Name des Default-Editors */
#define ENV_Stderr      "STDERR"      /* Standard-Fehlerkanal */

#endif /* __MAGICTOOL_COMMAND_H__ */
