/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGICTOOL_MENUBASE_H__
#define __MAGICTOOL_MENUBASE_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif



_VOID mtMenubase_SameLength(OBJECT *menu, _WORD num, _WORD max);
/* Bringt alle Menueeintrage auf gleiche Laenge */

_UWORD mtMenubase_DoEvent(_WORD *x, _WORD *y, _UWORD *button, _WORD *scan);
/* Event-Routine fuer mtMenus und mtPopups */

_VOID mtMenubase_ScreenDim(_WORD *mw, _WORD *mh);
/* Aktualisiert die Bildschirmgroesse */

_VOID mtMenubase_DrawBar(OBJECT *t, _WORD object);
/* Zeichnet einen Menueeintrag selektiert bzw. unselektiert */

_BOOL mtMenubase_MenuKeyboard(OBJECT *t, _WORD scan, _WORD minobj, _WORD oldob, _WORD *ob);
/* Berechnet neues Objekt anhand der Tastatureingaben */

_VOID mtMenubase_PlaceOnScreen(OBJECT *t);
/* Plaziert einen Menuebaum auf dem Schirm. Dabei werden Raender etc. beachtet */

#endif /* __MAGICTOOL_MENUBASE_H__ */
