/*
 * Diese Datei ist Teil des Megamax Modula-2 Entwicklungssytems,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Megamax Modula-2 ist Copyright (c) by Thomas Tempelmann.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MOS_FILENAMES_H__
#define __MOS_FILENAMES_H__


#ifndef __MOS_GLOBALS_H__
#include <mosgloba.h>
#endif


_VOID SplitPath(CONST _UBYTE *fullname, _UBYTE *path, _UBYTE *name);
/*
 * Spaltet einen vollst. Dateinamen in seinen Pfad und den "einfachen"
 * Dateinamen (ohne Pfad) auf.
 * 'name' sollte mind. 12 Zeichen fassen, 'path' sollte so gross wie
 * 'name' (oder mind. 128 Zeichen) sein, sonst kann ein Laufzeitfehler
 * (string overflow) auftreten.
 */

#endif /* __MOS_FILENAMES_H__ */
