/*
 * Diese Datei ist Teil des Megamax Modula-2 Entwicklungssytems,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Megamax Modula-2 ist Copyright (c) by Thomas Tempelmann.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MOS_GLOBALS_H__
#define __MOS_GLOBALS_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif


typedef enum {
	shift, control, alternate, capsLock
} CtrlKey;
typedef _UWORD CtrlSet;


typedef struct Key {
	_UBYTE ch;
	CtrlSet ctrl;
	_UWORD scan;
} Key;


#endif /* __MOS_GLOBALS_H__ */
