/*      STRING.H

        String Definitions

        Copyright (C) Borland International 1990
        All Rights Reserved.
*/


#if !defined( __STRING_H__ )
#define __STRING_H__


#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned long    size_t;
#endif

char    *strerror( int errnum );

void    *memchr( const void *ptr, int val, size_t len );
#ifndef __GNUC__
int     memcmp( const void *ptr1, const void *ptr2, size_t len );
void    *memcpy( void *dest, const void *src, size_t len );
#endif
void    *memmove( void *dest, const void *src, size_t len );
void    *memset( void *ptr, int val, size_t len );

#endif /* __STRING_H__ */

/************************************************************************/
