				INCLUDE "gem.i"

				GLOBL	vst_arbpt
				GLOBL	vst_arbpt32
				GLOBL	vst_skew
				GLOBL	vst_scratch
				GLOBL	vqt_fsm_name
				GLOBL	vst_error
				GLOBL	vst_setsize
				GLOBL	vst_setsize32
				GLOBL	vqt_xfntinfo
				GLOBL	vqt_f_extent
				GLOBL	vqt_f_nextent
				GLOBL	v_ftext
				GLOBL	v_fntext
				
				
				MODULE	vst_scratch

				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				move.w	#1,v_nintin(a0)
				move.w	d1,intin(a0)
				move.w	#244,d1
				bra		_VdiCtrl

				ENDMOD


				MODULE	vst_arbpt

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				move.w	#1,v_nintin(a0)
				clr.w	ptsin(a0)
				move.w	d1,intin(a0)
				move.w	#246,d1
				bsr		_VdiCtrl
				lea		_GemParBlk+ptsout,a0
				movea.l (a7)+,a1
				move.w	(a0)+,(a1)
				movea.l (a7)+,a1
				move.w	(a0)+,(a1)
				movea.l 4(a7),a1
				move.w	(a0)+,(a1)
				movea.l 8(a7),a1
				move.w	(a0)+,(a1)
				rts

				ENDMOD

				MODULE	vst_arbpt32

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				move.w	#2,v_nintin(a0)
				clr.w	ptsin(a0)
				move.l	d1,intin(a0)
				move.w	#246,d1
				bsr		_VdiCtrl
				move.l	-2(a0),d0
				cmp.w	#2,_GemParBlk+v_nintout
				bge		vst_arb1
				clr.w	d0
vst_arb1:		lea		_GemParBlk+ptsout,a0
				movea.l (a7)+,a1
				move.w	(a0)+,(a1)
				movea.l (a7)+,a1
				move.w	(a0)+,(a1)
				movea.l 4(a7),a1
				move.w	(a0)+,(a1)
				movea.l 8(a7),a1
				move.w	(a0)+,(a1)
				rts

				ENDMOD

				MODULE	vst_skew

				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				move.w	#1,v_nintin(a0)
				move.w	d1,intin(a0)
				move.w	#253,d1
				bra		_VdiCtrl

				ENDMOD

				MODULE	vqt_fsm_name

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				move.w	#2,v_nintin(a0)
				move.w	d1,intin(a0)
				clr.w	intin+2(a0)
				move.w	#1,v_opcode2(a0)
				move.w	#130,d1
				bsr		_VdiCtrl2
				movea.l	(a7)+,a1
				moveq	#32-1,d1
vqt_xname1:		move.w	(a0)+,d2
				move.b	d2,(a1)+
				dbf		d1,vqt_xname1
				clr.b	(a1)
				move.l	(a7)+,a1
				move.w	_GemParBlk+v_nintout,d0
				clr.w	d2
				cmp.w	#34,d0
				blt		vqt_xname2
				move.w	(a0)+,d2
vqt_xname2:		move.l	a1,d1
				beq		vqt_xname3
				move.w	d2,(a1)
vqt_xname3:		
				clr.w	d2
				cmp.w	#35,d0
				blt		vqt_xname4
				move.w	(a0),d2
				and.w	#$ff,d2
vqt_xname4:		move.l	4(a7),a1
				move.l	a1,d1
				beq		vqt_xname5
				move.w	d2,(a1)
vqt_xname5:		
				clr.w	d2
				cmp.w	#35,d0
				blt		vqt_xname6
				move.w	(a0),d2
				lsr.w	#8,d2
				and.w	#$ff,d2
vqt_xname6:		move.l	8(a7),a1
				move.l	a1,d1
				beq		vqt_xname7
				move.w	d2,(a1)
vqt_xname7:		
				move.w	_GemParBlk+intout,d0
				rts
				
				ENDMOD


				MODULE	vst_error

				lea		_GemParBlk,a1
				clr.w	v_nptsin(a1)
				move.w	#3,v_nintin(a1)
				move.w	d1,intin(a1)
				move.l	a0,intin+2(a1)
				move.w	#245,d1
				move.l	a1,a0
				bra		_VdiCtrl

				ENDMOD

				
				MODULE	vst_setsize

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a1
				clr.w	v_nptsin(a1)
				move.w	#1,v_nintin(a1)
				move.w	d1,intin(a1)
				move.w	#252,d1
				move.l	a1,a0
				bsr		_VdiCtrl
				lea		_GemParBlk+ptsout,a0
				move.l	(a7)+,a1
				move.w	(a0)+,(a1)
				move.l	(a7)+,a1
				move.w	(a0)+,(a1)
				move.l	4(a7),a1
				move.w	(a0)+,(a1)
				move.l	8(a7),a1
				move.w	(a0)+,(a1)
				rts

				ENDMOD


				MODULE	vst_setsize32

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a1
				clr.w	v_nptsin(a1)
				move.w	#2,v_nintin(a1)
				move.l	d1,intin(a1)
				move.w	#252,d1
				move.l	a1,a0
				bsr		_VdiCtrl
				move.l	-2(a0),d0
				cmp.w	#2,_GemParBlk+v_nintout
				bge		vst_setsize1
				clr.w	d0
vst_setsize1:	lea		_GemParBlk+ptsout,a0
				move.l	(a7)+,a1
				move.w	(a0)+,(a1)
				move.l	(a7)+,a1
				move.w	(a0)+,(a1)
				move.l	4(a7),a1
				move.w	(a0)+,(a1)
				move.l	8(a7),a1
				move.w	(a0)+,(a1)
				rts

				ENDMOD


				MODULE	vqt_f_extent

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				movea.l	(a7)+,a1
				lea		intin(a0),a0
				moveq	#0,d1
				moveq	#0,d2
vqt_f_extent1:	move.b	(a1)+,d1
				beq		vqt_f_extent2
				move.w	d1,(a0)+
				addq.w	#1,d2
				bra		vqt_f_extent1
vqt_f_extent2:	lea		_GemParBlk,a0
				move.w	d2,v_nintin(a0)
				move.w	#240,d1
				bsr		_VdiCtrl
				lea		_GemParBlk+ptsout,a0
				movea.l	(a7)+,a1
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0),(a1)
				rts

				ENDMOD


				MODULE	vqt_f_nextent

				move.l	a1,-(a7)
				move.l	a0,-(a7)
				lea		_GemParBlk,a0
				clr.w	v_nptsin(a0)
				movea.l	(a7)+,a1
				move.w	d1,v_nintin(a0)
				lea		intin(a0),a0
				moveq	#0,d2
				tst.w	d1
				beq		vqt_f_nextent2
vqt_f_nextent1:	move.b	(a1)+,d2
				move.w	d2,(a0)+
				subq.w	#1,d1
				bne.s	vqt_f_nextent1
vqt_f_nextent2:	clr.w	(a0)
				lea		_GemParBlk,a0
				move.w	#240,d1
				bsr		_VdiCtrl
				lea		_GemParBlk+ptsout,a0
				movea.l	(a7)+,a1
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0)+,(a1)+
				move.w	(a0),(a1)
				rts

				ENDMOD


				MODULE	v_ftext

				lea		_GemParBlk,a1
				move.w	d1,ptsin(a1)
				move.w	d2,ptsin+2(a1)
				move.w	#1,v_nptsin(a1)
				lea		intin(a1),a1
				moveq	#0,d1
				moveq	#-1,d2
v_ftext1:		move.b	(a0)+,d1
				addq.w	#1,d2
				move.w	d1,(a1)+
				bne		v_ftext1
				lea		_GemParBlk,a0
				move.w	d2,v_nintin(a0)
				move.w	#241,d1
				bra		_VdiCtrl

				ENDMOD


				MODULE	v_fntext

				lea		_GemParBlk,a1
				move.w	d1,ptsin(a1)
				move.w	d2,ptsin+2(a1)
				move.w	#1,v_nptsin(a1)
				moveq	#0,d1
				move.w	4(a7),d2
				move.w	d2,v_nintin(a1)
				lea		intin(a1),a1
				tst.w	d2
				beq.s	v_fntext2
v_fntext1:		move.b	(a0)+,d1
				move.w	d1,(a1)+
				subq.w	#1,d2
				bne.s	v_fntext1
v_fntext2:		clr.w	(a1)
				lea		_GemParBlk,a0
				move.w	#241,d1
				bra		_VdiCtrl

				ENDMOD


