/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZGR_H__
#define __PUTZ_PUTZGR_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __MOS_LISTS_H__
#include <lists.h>
#endif


_UWORD PutzGr_MaxNameLength(_VOID);

_VOID PutzGr_FreeGroupList(_VOID);

_VOID PutzGr_BuildDisplayList(List *l);

_VOID PutzGr_ClearDisplayList(_BOOL killCarrier);

_VOID PutzGr_SaveSelectedState(List *gr);

_VOID PutzGr_ReadSelectedState(List *gr);

_BOOL PutzGr_InitGroups(_VOID);

_BOOL PutzGr_SelectFile(CONST _UBYTE *title, CONST _UBYTE *mask, _UBYTE *path, _UBYTE *fName, _BOOL makeFullName);

_VOID PutzGr_GetTempPath(_VOID);

_BOOL PutzGr_ReadCatInf(_BOOL noCommand, CONST _UBYTE *inf_from_argv);

_BOOL PutzGr_ReadNewInf(_BOOL doFsel, CONST _UBYTE *newinf);

_VOID PutzGr_Exit(_VOID);

#endif /* __PUTZ_PUTZGR_H__ */
