/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZGROUP_H__
#define __PUTZ_PUTZGROUP_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __PUTZ_PUTZTYPES_H__
#include <putztype.h>
#endif


_BOOL PutzGroup_deleteInGroup(grListEntry *group, CONST putzOptsRec *options, delMode mode);
/* Loescht in einer Gruppe nach den Flags in options
 */

_BOOL PutzGroup_deleteGroup(grListEntry *group, _BOOL noConfirm);
/* Loescht eine Gruppe aus der Datenbank
 */

 _VOID initWiederv(_VOID);

#endif /* __PUTZ_PUTZGROUP_H__ */
