/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZINIT_H__
#define __PUTZ_PUTZINIT_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif


/* Modul zur Darstellung der Initialisierungsbox beim
 * Laden einer CAT.INF
 */

_VOID PutzInit_InitInitBox(_VOID);
/* Initialisiert die Box, bringt das Fenster auf den Bildschirm
 */

_VOID PutzInit_SetMaxValue(_LONG max);
/* Setzt den Maximalwert fuer das Laden der Box
 */

_VOID PutzInit_SetCurrentValue(_LONG value);
/* Setzt den aktuellen Wert fuer die Box
 */

_VOID PutzInit_CloseInitBox(_VOID);
/* Schliesst die Box wieder
 */


#endif /* __PUTZ_PUTZINIT_H__ */
