/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZLOG_H__
#define __PUTZ_PUTZLOG_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

/*
 * Cat-Logfile des MausTausch-Importes
 *
 * Am besten komplett importieren, deswegen auch keine speziellen Namen
 *
 *
 */

_BOOL PutzLog_OpenLog(CONST _UBYTE *path);

_VOID PutzLog_CloseLog(_VOID);

_VOID PutzLog_WriteString(CONST _UBYTE *str);

_VOID PutzLog_WriteCard(_ULONG c);

_VOID PutzLog_WriteLn(_VOID);

_VOID PutzLog_WriteLine(CONST _UBYTE *str);

_VOID PutzLog_Write(_UBYTE c);

_VOID PutzLog_putDate(_VOID);

_VOID PutzLog_putTime(_VOID);


#endif /* __PUTZ_PUTZLOG_H__ */
