/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZWINDOWS_H__
#define __PUTZ_PUTZWINDOWS_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __MAGIC_SYS_H__
#include <magicsys.h>
#endif

#ifndef __PORTAES_H__
#include <portaes.h>
#endif

#ifndef __MOS_LISTS_H__
#include <lists.h>
#endif

#ifndef __PUTZ_PUTZTYPES_H__
#include <putztype.h>
#endif


_VOID PutzWindows_OpenWindow(List *l, HWND *wdwHandle);

_VOID PutzWindows_SetNewList(HWND wdw, List *l);

_VOID PutzWindows_GetWindowFont(HWND wdw, _WORD *font, _WORD *fontSize);

_VOID PutzWindows_SetWindowFont(HWND wdw, _WORD font, _WORD fontSize);

_BOOL PutzWindows_IsPutzWindow(HWND wdw);

_VOID PutzWindows_RedrawEntry(HWND wdw, grListEntry *entry);

_VOID PutzWindows_SelectEntry(HWND wdw, grListEntry *entry, _BOOL select);

_VOID PutzWindows_WindowParms(HWND wdw, GRECT *size, _WORD *start);

_BOOL PutzWindows_DeleteGroup(HWND wdw, grListEntry *group, _BOOL noConfirm);

_BOOL PutzWindows_SwitchInf(HWND wdw, _BOOL doFsel, CONST _UBYTE *newinf);

_BOOL PutzWindows_Save(HWND wdw, CONST _UBYTE *fname, _BOOL toclip);

_BOOL PutzWindows_SelectAll(HWND wdw, _BOOL select);

_BOOL PutzWindows_DeleteInGroups(HWND wdw);

#endif /* __PUTZ_PUTZWINDOWS_H__ */
