#ifndef __CAT_CATBUTTONS_H__
#define __CAT_CATBUTTONS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif


extern HWND CatButtons_WinHandle;

extern _BOOL buttonWindowLocked;


_BOOL CatButtons_IsButtonTop(HWND handle);

_BOOL CatButtons_DisplayButton(_BOOL init);

_BOOL CatButtons_CloseButton(_BOOL exit);

_WORD CatButtons_ClickIsInButton(_WORD Wx, _WORD Wy);

_VOID CatButtons_InitButtonWindow(_VOID);

_VOID CatButtons_DrawButton(_WORD which);

_VOID CatButtons_Select_Messages(_BOOL select);

_VOID CatButtons_Normal(_WORD obj);

_VOID CatButtons_Wiggle(_WORD obj, _BOOL simple);

#endif /* __CAT_CATBUTTONS_H__ */
