#ifndef __CAT_ZSEARCHDIAL_H__
#define __CAT_ZSEARCHDIAL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */




#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_SEARCHHELP_H__
#include <searchhe.h>
#endif


#define SEARCH_FASTAHEAD       0
#define SEARCH_FASTBACK        1
#define SEARCH_OK              2
#define SEARCH_CANCEL          (-1)

_WORD ZSearchDial_DoSearchDial(_BOOL forList);
/* Ruft die Suchbox auf; Rueckgabe < 0 -> User hat Abbruch gedrueckt */
/* sonst noch moeglich: SEARCH_FASTAHEAD, SEARCH_FASTBACK */

_WORD ZSearchDial_SearchDial(SearchRecordType *suchVar, _BOOL forList);

/* Die Vars sind gleichzeitig Eingabeparameter, damit werden die einzelnen
   Punkte gefuellt, muss dem alten Aussehen entsprechen */
/* wo1..wo4 und verkn1..verkn3 werden gemaess SearchHelp belegt!  */
/* Rueckgabewert gibt an, wie gestartet werden soll:             */
/* FASTAHEAD = Schnellstart vorwaerts    */
/* FASTBACK  = Schnellstart rueckwaerts   */
/* sonstige positive Werte: kein Start  */
/* Rueckgabe < 0 -> Abbruch              */

_BOOL ZSearchDial_InitMenuStr(_VOID);


typedef enum {
	ChangeMsg = 0x0001,
	ChangeTree = 0x0002,
	ChangeTreeDown = 0x0004,
	ChangeSelected = 0x0008
} DialAction;


typedef _UWORD DialActionSet;


_BOOL ZSearchDial_FlagDial(DialActionSet possible, MSGBITS *setBits, MSGBITS *clearBits, DialAction *whatAction);
/* Fuer die Flagaktionen. Gibt zurueck, ob der User ok angewaehlt hat und den Status   */
/* der Bits sowie die ueber die Radiobuttons gewaehlte Aktion                         */


#endif /* __CAT_ZSEARCHDIAL_H__ */
