/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 21.3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34o'
 *	Eine bersehene deutsche Fehlermeldung internationalisiert.
 */


#include <mte.h>
#include <mtalerts.h>
#include <routinec.h>
#include <routines.h>
#include <strconv.h>

/*DYJ 5.34o Start*/
#include <mtrsc.h>
#include <catlib.h>
/*DYJ  Ende; alt:	
#define AL_NO_MEM           "[3][%P:|F\201r die gew\201nschte|Operation steht|zuwenig Speicher|zur Verf\201gung.][[Abbruch]"
*/

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MTE_InfoAlert(CONST _UBYTE *s1, CONST _UBYTE *s2, CONST _UBYTE *s3)
{
	_UBYTE scrap[512];

	*scrap = '\0';
	if (s1 != NULL)
		strBcat(scrap, s1);
	if (s2 != NULL)
		strBcat(scrap, s2);
	if (s3 != NULL)
		strBcat(scrap, s3);
	mtAlerts_Alert(1, scrap);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD MTE_info(CONST _UBYTE *s)
{
	return mtAlerts_Alert(1, s);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MTE_warnAlert(_BOOL cond, CONST _UBYTE *s1, CONST _UBYTE *s2, CONST _UBYTE *s3)
{
	if (cond)
		MTE_InfoAlert(s1, s2, s3);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MTE_numAlert(_WORD num, CONST _UBYTE *s)
{
	_UBYTE alt[512];
	_UBYTE *p;
	_UBYTE numstr[10];

	strBcpy(alt, s);
	p = strChr(alt, '&');
	if (p != NULL)
	{
		*p = '\0';
		IntToStr(num, 0, numstr, sizeof(numstr));
		strBcat(alt, numstr);
		strBcat(alt, s + (p + 1 - alt));
	}
	MTE_info(alt);
}

/*** ---------------------------------------------------------------------- ***/

 /* Damit nich dauernd die Strings ueberall eingesetzt werden, hier ein zentraler Aufruf */
GLOBAL _VOID MTE_noMemAlert(_VOID)
{
/*DYJ 5.34o Start*/
	MTE_info(Rsc_WrkString(AL_NO_MEM));
/*DYJ  Ende; alt:	
	MTE_info(AL_NO_MEM);
*/
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.34o Start*/
/*DYJ  Ende; alt:	

/* dito */
GLOBAL _VOID MTE_noMemWarn(_BOOL cond)
{
	if (cond)
		MTE_noMemAlert();
}
*/
