/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 15.12.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32i'
 *	Bei Mails ohne Empfnger wird fals vorhanden die Delivered-To
 *	Zeile ausgewertet.
 */


/* 
 * 10.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16m'
 *	Internetmails ohne Datum bekommen jetzt das Einfgedatum verpat.
 *
 * 20.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17f'
 *	An einigen Stellen noch Mime_CntAtt eingebaut.
 *
 * 28.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19b'
 *	Cat wertet jetzt die S- und Z- Zeilen aus dem #HEAD des Outfiles aus.
 *	Beim Erzeugen eines Outfiles werden sie entspr. ausgegeben.
 *
 * 27.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20e'
 *	Wurde ein outf_hdr.txt eingefgt, wurde dabei das log.txt des outfile.txt
 *	berschrieben
 *
 * 28.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20g'
 *	Bei InternetOutfiles werden Punkte am Zeilenanfang verdoppelt, dies
 *	mu beim Einfgen wieder rckgngig gemacht werden.
 *
 * 29.1.03 Martin Elssser  (ME) gekennzeichnet mit 'ME 5.20h'
 *	ich habe in der Internet-Version festgestellt, da die Variable ImpOutfHdr
 *	mit Wert 1 nicht korrekt beachtet wird.
 *
 * 5.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20t'
 *	Files mit der Endung *.822 knnen als Mail angezeigt werden, mssen dafr 
 *	allerdings in die Datenbank eingefgt werden.
 *
 * 4.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20v'
 *	Das Setzen der Flags durch PM-Filter funktionierte nicht mehr.
 *
 * 12.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20zd'
 *	Man kann jetzt ein Backupverzeichnis angeben, in das alle einzufgenden
 *	Outfiles vorher gesichert werden. Damit sollte es nie mehr
 *	Datenverlust geben.
 *
 * 16.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23a' 
 *	iCatPMGroup wurde als unbekannt markiert
 *
 * 7.8.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29e'
 *	Beim Einfgen eigener Mails aus dem Messageordner passierte ein Fehler.
 *	Dadurch konnte man sich die Anhnge nicht ansehen, verschickt wurde es richtig.
 *	Ich habe den Fehler einerseits korrigiert, auerdem werden die falsch 
 *	geschriebenen Anhangstrings beim Einlesen der Mail korrigiert. 
 *
 * 1.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30d'
 *	Bei einer From Zeile wie dieser:
 *	From: <Dimitri.Junker@Onlinehome.de>
 *	kam Cat durcheinander.
 *
 * 25.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30m'
 *	Beim Beseitigen des Foldings konnte es vorkommen, da Cat die
 *	Leerzeile am Ende des Mime-Headers mit der folgenden Zeile
 *	zusammenfgte
 *
 *	12.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32b'
 *	PM-Filter fr Mausdatenbanken freigegeben. Auerdem werden beim
 *	Filtern nach Absender auch Sender bercksichtigt und beim Filtern
 *	nach Empfnger auch CC
 *
 * 2.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34c'
 *	Outfileheader: + und - Zeilen waren Cat angeblich unbekannt
 *
 * 3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34e'
 *	Kamen nach der Mime-Zeile im Header noch andere Headerzeilen 
 *	wurden diese ggf. zerstckelt
 *
 * 3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34f'
 *	ein Leerzeichen zu viel
 *
 * 3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34g'
 *	nur eine kleine Umbenennung um leichter Suchen zu knnen.
 *
 * 3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34k'
 *	Fehlt die REFERENCES-Zeile, versucht Cat die ntige Info
 *	aus der IN-REPLY-TO-Zeile zu extrahieren. War aber eine
 *	syntaktisch falsche REFERENCES-Zeile vorhanden 
 *	funktionierte dies nicht.
 *
 * 7.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35g'
 *	PM-Filter die Nachrichten lschen sollen funktionierten nicht bei
 *	Maus-Outfiles
 *
 * 8.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35h'
 *	Die Maus-Header-Zeile C eingebaut
 *
 * 8.5.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36i'
 *	Bis auf eine Warnung das vorige wieder entfernt.
 *
 * 27.11.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.39d'
 *	In2Cat ab 2.07 fgt im #Log ggf. Fehlermeldungen zu empfangenen
 *  Nachrichten an, die zeigt Cat jetzt an.
 */

#include <parser.h>
#include <userinfo.h>
#include <mtpaths.h>
#include <infofile.h>
#include <arcstart.h>
#include <showimpo.h>
#include <cattypes.h>
#include <catfiles.h>
#include <catlog.h>
#include <catgloba.h>
#include <data.h>
#include <mte.h>
#include <mtedit2.h>		/* (MH) */
#include <protokol.h>
#include <watchdog.h>
#include <messages.h>
#include <confvars.h>
#include <mime.h>
#include <varname4.h>
#include <varname5.h>
#include <varnamel.h>
#include <vdistand.h>
#include <wdwmanag.h>
#include <groupsel.h>
#include <iofilter.h>
#include <handlepo.h>
#include <cathelp.h>
#include <wiedervo.h>		/* (MH) */

#include <mtdir.h>
#include <mtappl.h>
#include <mttextfi.h>
#include <mtutils.h>

#include <magiccoo.h>
#include <magicstr.h>
#include <tos.h>

#include <set.h>
#include <routinec.h>
#include <routines.h>
#include <dir_io.h>
#include <debug.h>
#include <adr.h>
#include <convertd.h>
#include <catmain.h>
#include <vaproto.h>
#include <time.h>
#include <catutil.h>
#include <maustaus.h>
#include <mtrsc.h>
#include <shellcal.h>
#include <pmfilter.h>


#define TRACE_PARSE 1

#if TRACE_PARSE
#  define TRACE(x) SPEC_DEBUG_OUT(x)
#else
#  define TRACE(x) 
#endif

/* Konstanten fuer LOGFILE-Ausgabe */	/* :language: */

#define cSpace9Str   "         "
#define cMessStr     " Nachricht"
#define cExtStr      "en"
#define cWarStr      " war"
#define cDbStr       " vom Datenbankmodul und "
#define cWdogStr     " vom WatchDog abgelehnt. "
#define cImpStr      " importiert."
#define cGroupChange "Gruppenwechsel zu "
#define cPrivate     "Private Messages"
#define cSysop       "SYSOP "

#define cOfNdel      "Outfile-Text konnte nicht gel\224scht werden"
#define cOfDel1      "Outfile-Text gel\224scht"
#define cOfDel2      "Outfile-Text nach Einf\201gen gel\224scht"

#define cUnknown     "Unbekannter Eintrag: "

#define notDeleted   " nicht gel\224scht"
#define Deleted      " gel\224scht"
#define isDupe       "Dupe zu"
#define isErr     	  "Err in #"	/*DYJ 5.39d */
#define refNotFound  "Mitteilung * nicht gefunden"
#define notMausNr	 "ist keine legale MAUS-interne Nummer"
#define notForYou    "Diese Mitteilung ist nicht an Sie"


#define minSpace     32768L     /* Mindestgroesse Outfile-Puffers    */
#define secureBytes  32768L     /* Platz, der auf Einfuegelaufwerk  */
                                /* zusaetzlich zur Laenge des      */
                                /* Outfiles noch vorhanden sein    */
                                /* muss                             */
#define infoFileBuffer 32768L         /* Puffergroesse fuer Textfiles       */
#define logFileBuffer  16384L
#define errFileBuffer  4096L
#define datFileBuffer  4096L


#define spaceForOwnMess 99   /* Platz der bei der Behandlung des Logfiles   */
                             /* fuer eigene Messages zu reservieren versucht */
                             /* wird.                                       */

#define additional 1000		/* Platz fuer soviele neue Msgs erstmal vorsehen */

typedef enum {
	LOG, REN, CMD, HEAD, OUT, mKOM, mNEW, mPER, mANS, normal, nottich
} NrTypes;


/* Beim Einlagern wird jetzt schon versucht, die Gruppenliste in data zu   */
/* erweitern. Klappt dies nicht, dann wird das Einfuegen abgebrochen!       */

/*
Idee:
Es wird ein kleines Array fuer die Verkettungsinformation auf dem Stack
angelegt, dann werden cardinals fuer die Verkettung benutzt, denn das
verbraucht weniger Platz und ist evtl. schneller. Das Array fasst demnaechst
vielleicht so etwa 1000 Msgs, fuer die Testphase erheblich weniger, d.h. so
50 bis 100. Das Outfile wird in zwei Schleifen bearbeitet. In der aeusseren
wird es haeppchenweise in den Speicher geladen und in der inneren
durchgesehen, bis das Verkettungsarray voll ist. d.h. Die innere Schleife
arbeitet den Block im Speicher ab.
*/

#define EndOfList 0xFFFF
#define MAX_ARRAY  1001		/* Maximale Anzahl an Positionen pro Array */
#define MAX_GROUP  1024

typedef struct {
	_UWORD next;
	_ULONG offset;
	VERK_BLK *xLines;
} onePosItem;

typedef onePosItem onePosArray[MAX_ARRAY];
typedef onePosItem *onePosArrayPtr;
typedef _UWORD oneMaxArray[MAX_GROUP];
typedef _UWORD *oneMaxArrayPtr;

#if SETMAX < MAX_GROUP
  you loose
#endif
typedef SET oneGroupSet;


/*
 * es wird ein Array der Startpositionen und eins mit den aktuellen
 * Endwerten der einzelnen Gruppenlisten und ein Array mit der Verwaltungs-
 * information verwaltet. Wenn eine neue Nachricht an eine Gruppenliste
 * angehaengt werden soll, so muss zunaechst in dem Array mit den Start-
 * positionen nachgesehen werden, ob noch kein Eintrag erfolgte. Anschliessend
 * wird im letzten Element dieser Gruppe, das an der Position gMax[gruppe]
 * steht, der neue Eintrag verkettet
 */


typedef struct stO2M{
	CAT_GROUP_NUMBER	gruppe;
	MSGNR				msgNr;
	_WORD				outfNr;
	struct stO2M		*next;
}of2msg;
typedef struct {
	MSGNR not, watch, anz, garbage, status, dupeCount;
/*DYJ 5.39d Start*/
	MSGNR text, unknown, pmNot, cmtsToOwn, outBlocks,pmErr;
/*DYJ  Ende; alt:	
	MSGNR text, unknown, pmNot, cmtsToOwn, outBlocks;
*/
} msgStat;
typedef struct {
	onePosArrayPtr gPos;
	oneMaxArrayPtr gMax;
	oneMaxArrayPtr gStart;
	_UWORD maxPos;			/* Naechste zu belegende Stelle im PointerArray  */

	_BOOL outfType;			/* Normales Outfile Header oder .822-File*/
	TEXTFILENO TxtOut;
	_BOOL TxtOutOpen;		/* Ist noch eine Datei offen? */
	_UBYTE TxtName[PATH_MAX];

	_UBYTE _HUGE *oPtr;		/* der Outfile-Buffer */
	_ULONG oAnz;			/* Laenge des Buffers */
	_ULONG count;			/* Zaehlvariable fuer die Behandlungsprozeduren */

	MSGNR NEUEWAISEN;		/* Anzahl der neuen Waisen */
	MSGNR WAISEN_H;			/* Anzahl der untereinander verknpften Waisen */
	MSGNR WAISEN_V;			/* Anzahl der Waisen zu denen der Kommentar gefunden wurde*/

    /* Fuer die Statistik */
    msgStat statGroup;
    msgStat statPart;
    msgStat statTotal;

	_BOOL firstLog;			/* Erstes Logfile schon erstellt? */

	_BOOL abort;			/* Abbruch wegen Dateifehlers beim Schreiben auf */
							/* die Datenbank */
	_BOOL isWatch;
	_BOOL WatchActive;		/* WatchDog installiert und aktiv, nur fuer Protokoll */
	_BOOL filteredAreRead;  /* Gefilterte auf Gelesen setzen? */

	_BOOL maxOver;			/* Maximalgroesse ueberschritten? */
	_BOOL headThere;		/* #HEAD ist gekommen */
	
	_UBYTE ownName[128];

	oneGroupSet groupsUsed;
	_WORD redrawCheck;

	/* Arrays mit der Verkettungsinformation, demnaechst dynamisch, s.o. */
	onePosArray g;
	oneMaxArray s;
	oneMaxArray m;
	
	/* Fuer Kommentare auf eigene Nachrichten */
	_BOOL writeCmtsFail;	/* Schreiben der comments.dat erfolgreich? (MH) */
	_BOOL writeCmts;		/* Soll die Kommentarliste aktualisiert werden? */
	_ULONG delCmts;			/* Anzahl der geloeschten Eintraege */
	
	_BOOL writeInf;			/* INFO.INF schon geoeffnet? (MH) */
	
	/* Fuer's Aufraeumen */
	_BOOL inMctrl;
	_BOOL infoWdwOpen;
	_BOOL sortReverse;		/* Sortierung des Outfiles*/
	_WORD charset;			/* Default charset*/
	of2msg *o2m;			/*DYJ 5.39d */
} outfileInfo;


#define CR 0x0d
#define LF 0x0a



/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL NrTypes typeOf(CONST _UBYTE *str)
{
	if (str[0] == '\0')
		return nottich;
#define check_type(c1, c2, c3, type) \
	if (str[0] == c1 && str[1] == c2 && str[2] == c3) return type
#define check_type4(c1, c2, c3, c4, type) \
	if (str[0] == c1 && str[1] == c2 && str[2] == c3 && str[3] == c4) return type
	
	check_type('L','O','G', LOG);
	check_type('R','E','N', REN);
	check_type('O','U','T', OUT);
	check_type4('H','E','A','D', HEAD);
	
	return normal;
#undef check_type
#undef check_type4
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isOneInf(CONST _UBYTE *str, _WORD *infLen)
{
	_UBYTE infName[9];
	_UWORD p;

	/* if (str[0] == 'I' || str[0] == 'J') */
	{
		p = 0;
		while (str[p] > ' ' && str[p] != '@' && p <= 8)
		{
			infName[p] = str[p];
			++p;
		}
		*infLen = p;
		if (str[p] != '@' && p <= 8)
		{
			infName[p] = '\0';
			return Infofiles_IsInfoFile(infName, TRUE);
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isUnknownInf(CONST _UBYTE *str, _WORD *infLen)
{
	_UWORD p;

	p = 0;
	while (str[p] > ' ' && str[p] != '@' && p <= 8)
		++p;
	*infLen = p;
	if (str[p] != '@' && p <= 8)
		return TRUE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL OpenTextFile(CONST _UBYTE *path, CONST _UBYTE *name, Textmode mode, _ULONG buff, TEXTFILENO *file)
{
	_UBYTE fname[PATH_MAX];
	
	strBcpy(fname, path);
	F_Path_Append(fname, name);
	return mtTextfiles_OpenTextfile(fname, mode, buff, file) == GERR_OK ||
		mtTextfiles_OpenTextfile(fname, mode, 1, file) == GERR_OK;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*- Logfile behandeln -----------------------------------------------------*/

typedef struct {
	CAT_GROUP_NUMBER openGr;
	OneGroupHandle dat;
	MSGNR anz;
	MSGNR anz2;
	MSGNR not2;
	MSGNR not; /* WatchDog und defekte gibt's hier nicht. */
	_BOOL errOpen;
	TEXTFILENO err; /* Fehlermeldungen u.ae. */
	_UBYTE mscrap[256];
	_BOOL abort;
	
	/* von InsertPersonal: */
	TEXTFILENO theFile;
} logInfo;
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CloseDat(logInfo *info, _BOOL *abort, MSGNR newMsgs)
{
	if (info->openGr!=(CAT_GROUP_NUMBER)dataSys_empty)
	{
		data_CloseOneWriteGroup(&info->dat, newMsgs, !*abort, abort);
		info->openGr = (CAT_GROUP_NUMBER)dataSys_empty;
	}
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL OpenPers(logInfo *info,CAT_GROUP_NUMBER gruppe)
{
	_UBYTE groupScrap[1024];
	if (info->openGr!=gruppe && info->openGr!=(CAT_GROUP_NUMBER)dataSys_empty)
	{
		CloseDat(info, &info->abort, info->anz2 - info->not2);
		info->anz2=0;
		info->not2=0;
	}
	if (info->openGr==(CAT_GROUP_NUMBER)dataSys_empty)
	{
		CatLog_WriteLn();
		CatLog_WriteStringNTime(cGroupChange);
		if (gruppe == dataSys_private)
		{
			CatLog_WriteLine(cPrivate);
			TRACE((EO_TRACE, cGroupChange cPrivate));
		} else if (gruppe < MAX_GROUP)
		{
			GroupSelect_GroupDisplayName(gruppe, groupScrap, sizeof(groupScrap));
			CatLog_WriteLine(groupScrap);
			TRACE((EO_TRACE, "Gruppenwechsel zu %s", groupScrap));
		} else
		{
			CatLog_WriteLine("unknown");
			TRACE((EO_TRACE, cGroupChange "unknown"));
		}
		info->openGr = data_OpenOneGroup(gruppe, spaceForOwnMess, TRUE, &info->dat)?gruppe:(CAT_GROUP_NUMBER)dataSys_empty;
	if (info->openGr==(CAT_GROUP_NUMBER)dataSys_empty)
			return FALSE;
	}
	return TRUE;
}


/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ErrorWrite(logInfo *info, CONST _UBYTE *str)	/* :language: */
{
	if (!info->errOpen)
		info->errOpen = OpenTextFile(DataPath, CATERR_FILENAME, WRITE, errFileBuffer, &info->err);
	if (info->errOpen)
		mtTextfiles_WriteLine(info->err, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ErrorLn(logInfo *info)
{
	if (info->errOpen)
		mtTextfiles_WriteLn(info->err);
}
/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.19b */ /*DYJ 5.20t */
LOCAL _BOOL WriteDat(logInfo *info, PtrRecord *mess, _BOOL *abort)
{
	_BOOL isaDupe;
	_BOOL succ;
	_BOOL dummy;
	_WORD dummyW;
	
	if (info->openGr!=(CAT_GROUP_NUMBER)dataSys_empty)
	{
		mess->msgType=msg_own;
/*DYJ 5.39d Start*/
		succ = data_AppendMessage(info->dat, bOwnMessage, mess, &dummyW, &isaDupe, &dummy, abort,ZS_ATARI,FALSE)!=dataSys_empty;
/*DYJ  Ende; alt:	
		succ = data_AppendMessage(info->dat, bOwnMessage, mess, &dummyW, &isaDupe, &dummy, abort,ZS_ATARI,FALSE);
*/
		if (!succ)
		{
			/* Eigener Dupe, kommt durch :PE */
			if (isaDupe)
				return TRUE;
		}
		return succ;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ErrorClose(logInfo *info)
{
	if (info->errOpen)
	{
		mtTextfiles_CloseTextfile(&info->err);
		info->errOpen = FALSE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL OpenFile(logInfo *info, CONST _UBYTE *name, CONST _UBYTE *ext)
{
	_UBYTE nameScrap[PATH_MAX];

	strBcpy(nameScrap, name);
	strBcat(nameScrap, ext);
	if (!OpenTextFile(MessagePath,
		nameScrap,
		READ,
		datFileBuffer,
		&info->theFile))
	{
		ErrorWrite(info, "Folgende Datei konnte nicht ge\224ffnet werden:");
		ErrorLn(info);
		ErrorWrite(info, nameScrap);
		ErrorLn(info);
		return FALSE;
	}
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	stringSet cpyMsgVar(_UBYTE **ziel,_UBYTE *quell,stringSet bit)				*/
/*	kopiert einen String wenn er nicht leer ist. 								*/
/*	Auerdem wird nach ISO-8859-1 gewandelt Achtung: da nur Pointer kopiert		*/
/*	werden ndert sich so auch die Quelle										*/
/*	Parameter:	ziel,quell: klar oder?											*/
/*				bit:	s. Ergebnis												*/
/*	Ergebnis:	wenn leer 0 sonst bit (f.	mess.whatsThere)					*/		
/*	20.12.01 von Dimitri Junker	DYJ 4.31h										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.17f */
LOCAL stringSet cpyMsgVar(_UBYTE **ziel,_UBYTE *quell,stringSet bit)
{
	if (quell == NULL || quell[0] == '\0')
		bit=0;
	else
	{
		if(UserBLK.isInternet)
		{
			_LONG filter;
			filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],FALSE);
			Mime_WandleIso(quell,quell, strLen(quell),filter,QUOTE_PR_NONE);
		}
		*ziel = quell;
	}
	return bit;
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.17f */	/*DYJ 5.29e */	/*DYJ 5.23i */
LOCAL _VOID InsertPersonal(logInfo *info, /* CONST */ _UBYTE *id, /* CONST */ _UBYTE *longId, CONST _UBYTE *name)
{
	PtrRecord mess;
	msgInfo	msg;
	_UBYTE str[1024],mime[]="V1.1;Content-Type: text/plain; charset=ATARI";
	CAT_GROUP_NUMBER cGNr;
	_BOOL isGroup;
	/* Jetzt normal bearbeiten */
	++info->anz; /* Wieder ein Schreibversuch.. */
	++info->anz2; /* Wieder ein Schreibversuch.. */
	if (strLen(name) > 10)
	{
		++info->not; /* Diese Msg wurde nicht angenommen */
		++info->not2; /* Diese Msg wurde nicht angenommen */
		ErrorWrite(info, "Name zu lang: ");
		ErrorWrite(info, name);
		ErrorLn(info);
	} else
	{
		MemSetZeroStruct(mess);
		mess.relatedFN=-1;
		mess.whatsThere = bId;
		mess.prFlags = fTextDatei;	/*DYJ 5.34g */
		mess.pId = id;

		Messages_GetHdrInfos(info->mscrap,&msg);
		mess.whatsThere |=cpyMsgVar(&mess.pRefNr,msg.refId,bRefNr);
		mess.whatsThere |=cpyMsgVar(&mess.pRId,msg.rId,bRId);
		mess.whatsThere |=cpyMsgVar(&mess.pAn,msg.receiver,bAn);
		mess.whatsThere |=cpyMsgVar(&mess.pWegen,msg.topic,bWegen);
		mess.whatsThere |=cpyMsgVar(&mess.pEZeit,msg.date,bEZeit);
		mess.whatsThere |=cpyMsgVar(&mess.pReplyTo,msg.replyTo,bReplyTo);
		mess.whatsThere |=cpyMsgVar(&mess.pSender,msg.sender,bSender);
		mess.whatsThere |=cpyMsgVar(&mess.pFollowupTo,msg.followupTo,bFollowupTo);
		mess.whatsThere |=cpyMsgVar(&mess.pRef,msg.ref,bRef);
		mess.whatsThere |=cpyMsgVar(&mess.pEZeitX,msg.eZeitX,bEZeitX);
		mess.whatsThere |=cpyMsgVar(&mess.pMId,longId,bMId);
		mess.whatsThere |=cpyMsgVar(&mess.pCc,msg.cc,bCc);
		mess.whatsThere |=cpyMsgVar(&mess.pBcc,msg.bcc,bBcc);
		if(UserBLK.isInternet)
		{
			mess.whatsThere |=cpyMsgVar(&mess.pVon,msg.Absender,bVon);
			if((mess.whatsThere&bVon)==0)
				mess.whatsThere |=cpyMsgVar(&mess.pVon,userAddr,bVon);

			mess.whatsThere |=cpyMsgVar(&mess.pMime,mime,bMime);
		}
		if(Mime_CntAtt(msg.attachment,TRUE))
		{
			_UBYTE ziel[PATH_MAX],oName[PATH_MAX],nummer[PATH_MAX],*anhTs,string[PATH_MAX];
			_WORD i;
			_LONG dummy;
			
			_BOOL first=TRUE;
			anhTs=msg.attachment+4;
			for(i=0;i<Mime_CntAtt(msg.attachment,TRUE);i++)
			{
				anhTs=Mime_ParseAnhStr(anhTs,nummer,oName,&dummy);
				if(Mime_AnhangPfad(ziel,string,&mess,oName,fMultipartM))
				{
					_UBYTE *ptr;
					ptr=Mime_GetMem4Record(&mess,strLen(string)+1);
					strCpy(ptr,string);
					if(first)
					{
						Mime_AddToMultLines(&mess.mAttachment,ptr,0);
						first=FALSE;
					}
					else
						Mime_AddToMultLines(&mess.mAttachment,ptr+4,1);
				}
			}
			mess.whatsThere |=bAttachment;
		}
		if(PmFilter_DoFilter(str,0,PMAB_INIT))
		{
			PmFilter_DoFilter(mess.pVon,0,PMAZ_SEND);
			PmFilter_DoFilter(mess.pAn,0,PMAZ_REC);
			PmFilter_DoFilter(mess.pWegen,0,PMAZ_SUB);
			PmFilter_DoFilter(mess.pReplyTo,0,PMAZ_RTO);	/*DYJ 5.35e */
			PmFilter_DoFilter(id,0,PMAZ_ID);

			isGroup=PmFilter_DoFilter(str,(_WORD)sizeof(str),PMA_GROUP);
/*DYJ 5.35g Start*/
			if(isGroup && !str[0])	/* Msg lschen*/
				cGNr=(CAT_GROUP_NUMBER)dataSys_empty;
			else
			{ 
				if(!isGroup || !GroupSelect_GroupNumber(str, &cGNr))
					cGNr=dataSys_private;
				if(PmFilter_DoFilter(str,(_WORD)sizeof(str),PMA_FLAGS))
					mess.prFlags |=(RECFLAGS)cpyMsgVar(&mess.pFlags,str,fFlags);	/*DYJ 5.34g */
			}
/*DYJ  Ende; alt:	
			if(!isGroup || !GroupSelect_GroupNumber(str, &cGNr))
				cGNr=dataSys_private;
			if(PmFilter_DoFilter(str,(_WORD)sizeof(str),PMA_FLAGS))
				mess.prFlags |=(RECFLAGS)cpyMsgVar(&mess.pFlags,str,fFlags);	/*DYJ 5.34g */
*/
			PmFilter_DoFilter(NULL,0,PMAB_FREE);
		}
		else
			cGNr=dataSys_private;
		if(cGNr!=(CAT_GROUP_NUMBER)dataSys_empty)		/*DYJ 5.35g */
		{							/*DYJ 5.35g */
			OpenPers(info,cGNr);
			if (OpenFile(info, name, textExt))		/* sonst wurde gemeckert */
			{
				mess.txt = info->theFile;
				if (info->abort || !WriteDat(info, &mess, &info->abort))	/* Nur einmal versuchen! */
				{
					ErrorWrite(info, "Die Datenbank hat die Nachricht ");
					ErrorWrite(info, id);
					ErrorWrite(info, " nicht angenommen");
					ErrorLn(info);
					++info->not;
					++info->not2;
				}
				else if((mess.whatsThere&bAttachment)!=0)
				{
					_UBYTE ziel[PATH_MAX],quell[PATH_MAX],oName[PATH_MAX],dummyStr[PATH_MAX],*anhTs,*quellEnd;
					_WORD i;
					_LONG dummy;
					anhTs=msg.attachment+4;
					/* Quell-Filenamen basteln */
					strBcpy(quell, MessagePath);
					Messages_Number2Name(msg.info.number, oName, sizeof(oName));
					F_Path_Append(quell, oName);
					quellEnd=strChr(quell,'\0');
					
					for(i=0;i<Mime_CntAtt(msg.attachment,TRUE);i++)
					{
						sprintf(quellEnd,"_A.%03d",i);
						anhTs=Mime_ParseAnhStr(anhTs,dummyStr,oName,&dummy);
						if(Mime_AnhangPfad(ziel,dummyStr,&mess,oName,fMultipartM))
							CatFiles_copyFile(ziel,quell);
					}
				}
				mtTextfiles_CloseTextfile(&info->theFile);
				if (info->anz2 - info->not2 >= spaceForOwnMess)
				{
					/* Platz fuer neue Nachrichten voll, DB schliessen und dann wieder oeffnen
					 */
					CloseDat(info, &info->abort, info->anz2 - info->not2);
					info->anz2 = 0;
					info->not2 = 0;
				}
			}
		}	/*DYJ 5.35g */
	}
	Mime_FreeMultilines(&mess);
}



/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID checkHeadLine(logInfo *info, CONST _UBYTE *line)
{
	switch (line[0])
	{
	case 'T':
		ErrorWrite(info, "MausTausch-Version vom ");
		ErrorWrite(info, line + 1);
		break;
	case 'V':
		ErrorWrite(info, "Boxversion: ");
		ErrorWrite(info, line + 1);
		break;
	case 'B':
		ErrorWrite(info, "Boxtyp: ");
		ErrorWrite(info, line + 1);
		break;
	case 'I':
		ErrorWrite(info, "Boxname: ");
		ErrorWrite(info, line + 1);
		break;
	case 'D':
		ErrorWrite(info, "Tauschdatum: ");
		ErrorWrite(info, line + 1);
		break;
	case 'U':
		ErrorWrite(info, "User: ");
		ErrorWrite(info, line + 1);
		break;
	case 'W':
		ErrorWrite(info, "eingestellte Zeilenl\204nge: ");	/* :language: */
		ErrorWrite(info, line + 1);
		break;
	case 'L':
		ErrorWrite(info, "eingestellte Seitenl\204nge: ");
		ErrorWrite(info, line + 1);
		break;
	case 'C':
		if (strCmp(line + 1, "\204\224\201\216\231\232\236") != 0)
		{
			ErrorWrite(info, "Die in der Box eingestellten Umlaute entsprechen nicht den ST-Umlauten.");
			ErrorLn(info);
			ErrorWrite(info, "ST-Umlaute: \204\224\201\216\231\232\236");
			ErrorLn(info);
			ErrorWrite(info, "eingestellte Umlaute: ");
		} else
		{
			ErrorWrite(info, "Umlaute: ");
		}
		ErrorWrite(info, line + 1);
		break;
	case 'S': /* Sortierung, interessiert uns nicht */
		ErrorWrite(info, "Sortierung: ");
		ErrorWrite(info, line + 1);
		break;
	case 'Z': /* Zeichensatz, interessiert uns momentan auch nicht */
		ErrorWrite(info, "Zeichensatz: ");
		ErrorWrite(info, line + 1);
		break;
/*DYJ 5.34c Start*/
	case '+': /* Gruppen bestellen */
	case '-': /* Gruppen abbestellen */
		ErrorWrite(info, "Gruppen (ab)bestellen: ");
		ErrorWrite(info, line + 1);
		break;
/*DYJ  Ende; */
	default:
		ErrorWrite(info, cUnknown);
		ErrorWrite(info, line);
	case '.': /* Ende */
		break;
	}
	ErrorLn(info);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21i */
LOCAL _VOID processHead(logInfo *info)
{
	TEXTFILENO head;
	_UBYTE idScrap[1024];
	
	if (!OpenTextFile(DataPath, HEAD_FILENAME, READ, logFileBuffer, &head))
	{
		if (!batchProcess)
		{
			sprintf(idScrap, Rsc_WrkString(MTE_noFileOpen), HEAD_FILENAME);
			MTE_info(idScrap);
		}
	} else
	{
		do
		{
			mtTextfiles_ReadLine(head, idScrap, sizeof(idScrap));
			mtTextfiles_ReadLn(head);
			checkHeadLine(info, idScrap);
		} while (!mtTextfiles_EndofText(head));
		mtTextfiles_CloseTextfile(&head);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DeleteFile(logInfo *info, CONST _UBYTE *name)
{
	_UBYTE fname[PATH_MAX];
	F_ERROR err;
	
	strBcpy(fname, MessagePath);
	F_Path_Append(fname, name);
	if ((err = F_File_Delete(fname)) != GERR_OK)
	{
		if (err != GERR_NOENT)
		{
			ErrorWrite(info, name);
			ErrorWrite(info, notDeleted);
			ErrorLn(info);
		}
	} else
	{
		ErrorWrite(info, name);
		ErrorWrite(info, Deleted);
		ErrorLn(info);
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21i */
LOCAL _VOID processLog(outfileInfo *outfile)
{
	_UBYTE idScrap[256];
	group_line shortId;
	_UBYTE scrap[256]; /* Fuer die Modi nach '#' und '"' */
	_UBYTE type;
	TEXTFILENO log;
	_BOOL refAssigned;
	_BOOL refMess;
	_UBYTE *find;
	_UBYTE *find2;
	_BOOL readNew;
	logInfo info;
	_BOOL fst=TRUE;	/*DYJ 5.39d */
	
	info.anz = 0;
	info.not = 0;
	info.anz2 = 0;
	info.not2 = 0;
	refMess = FALSE; /* == Das bezieht sich noch auf die in scrap gespeicherte ID */
	info.errOpen = FALSE;
	info.openGr=(CAT_GROUP_NUMBER)dataSys_empty;
	info.abort   = FALSE;
	refAssigned = FALSE;
	CatFiles_DeleteFile(DataPath, CATERR_FILENAME);
	/* #HEAD parsen, falls angekommen */
	if (outfile->headThere)
		processHead(&info);
	if (!OpenTextFile(DataPath, LASTLOG_FILENAME, READ, logFileBuffer, &log))
	{
		CatLog_WriteLine(LASTLOG_FILENAME " nicht vorhanden.");
		TRACE((EO_TRACE, LASTLOG_FILENAME " nicht vorhanden."));
		if (!batchProcess)
		{
			sprintf(scrap, Rsc_WrkString(MTE_noFileOpen), LASTLOG_FILENAME);
			MTE_info(scrap);
		}
		return;
	}

	readNew = TRUE;
	type = '\0';
	scrap[0] = '\0';
	do
	{
		if (readNew)
		{
			type = mtTextfiles_ReadChar(log);
			mtTextfiles_ReadLine(log, idScrap, sizeof(idScrap));
			mtTextfiles_ReadLn(log);
		}
		readNew = TRUE;
		switch (type)
		{
		case '!':
			if (strStr(idScrap, "Maximalgr") != NULL &&
				strStr(idScrap, "berschritten") != NULL)
			{
				/* Fehlermeldung rausbringen */
				outfile->maxOver = TRUE;
				ErrorWrite(&info, "Die MAUS meldet: ");
				ErrorWrite(&info, idScrap);
				ErrorLn(&info);
				refMess = FALSE;
				refAssigned = FALSE;
			}
			if (refMess && !refAssigned)
			{
				if (scrap[0] == 'G' && (scrap[1] == '-' || scrap[1] == '+'))
				{
					/* Gruppenbestellung akzeptiert von der Maus */
					strBcpy(info.mscrap, scrap + 2);
					GroupSelect_ClearGroupChange(info.mscrap);
				}
				ErrorWrite(&info, "Info zu Mitteilung ");
				ErrorWrite(&info, scrap);
				ErrorLn(&info);
				ErrorWrite(&info, idScrap);
				ErrorLn(&info);
				/* !!! eigentlich wohl ueberfluessig? */
				if (refAssigned)
					refMess = FALSE;
			} else
			{
				if (refAssigned)
					refMess = FALSE;
			}
			break;
		
		case '#' : /* Modusende bzw. auch Modusanfang */
			refMess = FALSE;
			if (idScrap[0] != '\0')
			{
				refMess = TRUE;
				refAssigned = FALSE;
				strBcpy(scrap, idScrap);
			}
			break;
			
		case '%':
			if (!outfile->headThere)
				checkHeadLine(&info, idScrap);
			break;
			
		case '=':
			if (refMess)		/* Nur dann sinnvoll */
			{
				strBcpy(info.mscrap, scrap);
				if (Messages_IsPrivateMessage(info.mscrap, sizeof(info.mscrap)))
				{
					strBcpy(shortId, idScrap);
					/* Naechste Zeile lesen */
					type = mtTextfiles_ReadChar(log);
					mtTextfiles_ReadLine(log, idScrap, sizeof(idScrap));
					mtTextfiles_ReadLn(log);
					if (type == '!' && idScrap[0] == '=')
					{
						/* wird wohl lange Id sein */
						/* Gleichheitszeichen loeschen */
						strCpy(idScrap, idScrap + 1);
					} else
					{
						readNew = FALSE;
					}
					Messages_GetMsgFileName(scrap, sizeof(scrap));
					InsertPersonal(&info, shortId, idScrap, scrap);
				}
				refAssigned = !Messages_MsgHasCopys(scrap);
				Messages_DeleteMessage(info.mscrap);
				/* refAssigned = TRUE; */
			} else
			{
				ErrorWrite(&info, "Hier steht ein \"=\" in der Landschaft,");	/* :language: */
				ErrorLn(&info);
				ErrorWrite(&info, "das ich mir nicht erkl\204ren kann : =");
				ErrorWrite(&info, idScrap);
				ErrorLn(&info);
			}
			break;
			
		case '?':
/*DYJ 5.39d Start*/
		if (strStr(idScrap, isErr) != NULL)
		{	/*	:? Err in #4 Nachricht unvollstndig wegen Timeout*/
			_WORD outfNr;
			of2msg *o2m=outfile->o2m;
			find=strChr(idScrap,'#')+1;
			outfNr=atoi(find);
			while(o2m)
			{
				if(o2m->outfNr==outfNr)
				{
					_UBYTE gName[40],err[256];
					GroupSelect_GroupDisplayName(o2m->gruppe, gName, sizeof( gName));
					sprintf(err," *Fehler in Nachricht %ld aus Gruppe %s: %s*",o2m->msgNr,gName,strChr(find,' '));		/* :language: */
					if(fst)
					{
						CatLog_WriteStringNTime("bertragungsfehler (in2cat o..)");		/* :language: */
						outfile->statTotal.pmErr++;		
						fst=FALSE;
					}
					CatLog_WriteLine(err);

					break;
				}
				o2m=o2m->next;
			}
		}
		else if (refMess)
/*DYJ  Ende; alt:	
		if (refMess)
*/
			{
				/* :?Dupe zu #A1234@XY vom ... */
				if (strStr(idScrap, isDupe) != NULL)
				{
					ErrorWrite(&info, "Maus meldet Dupe bei Mitteilung: ");
					ErrorWrite(&info, scrap);
					ErrorLn(&info);
					strBcpy(info.mscrap, scrap);
					if (Messages_IsPrivateMessage(info.mscrap, sizeof(info.mscrap)))
					{
						/* Pruefen, ob schon in Datenbank eingefuegt */
						find = strChr(idScrap, '#');
						if (find != NULL)
							strCpy(idScrap, find + 1);
						else
							*idScrap = '\0';
						find = strChr(idScrap, ' ');
						if (find != NULL)
							*find = '\0';
						else
							*idScrap = '\0';
						/* Jetzt steht in idScrap die ID von der Maus */
						if (data_NumberOfID(info.dat, idScrap) == dataSys_empty)
						{
							ErrorWrite(&info, "Nachricht wird eingef\201gt");
							ErrorLn(&info);
							Messages_GetMsgFileName(scrap, sizeof(scrap));
							*shortId = '\0';
							InsertPersonal(&info, idScrap, shortId, scrap);
						} else
						{
							ErrorWrite(&info, "Nachricht wird nicht eingefgt, da sie schon in der Datenbank ist");
							ErrorLn(&info);
						}
					} else
					{
						ErrorWrite(&info, "Nachricht ist \224ffentliche Nachricht, wird nicht eingef\201gt");
						ErrorLn(&info);
					}
					Messages_DeleteMessage(info.mscrap);
				} else if ( Pos(refNotFound, idScrap, 0, TRUE) != POS_NOT_FOUND ||
							Pos(notMausNr,   idScrap, 0, TRUE) != POS_NOT_FOUND)
				{
					/* ?Mitteilung "P17165@LU" nicht gefunden */
					ErrorWrite(&info, "Maus kennt Referenznachricht nicht bei Mitteilung: ");
					ErrorWrite(&info, scrap);
					ErrorLn(&info);
					/* Jetzt einfach dem Messagemanager sagen, er soll aus der
					 * Nachricht eine neue machen ohne Verkettung
					 */
					if (Messages_ChangeMessage(scrap))
					{
						ErrorWrite(&info, "Die Nachricht wird \"Wildwest\"-verkettet");
						ErrorLn(&info);
					} else
					{
						ErrorWrite(&info, "Die Nachricht wird gel\224scht");
						ErrorLn(&info);
						Messages_DeleteMessage(scrap);
					}
				} else if (strStr(idScrap, notForYou) != NULL)
				{
					/* ?Diese Mitteilung ist nicht an Sie */
					ErrorWrite(&info, "Maus kann keine Kommentare auf eigene Nachrichten bei: ");
					ErrorWrite(&info, scrap);
					ErrorLn(&info);
					/* Jetzt einfach dem Messagemanager sagen, er soll aus der
					 * Nachricht eine neue machen als GK
					 */
					if (Messages_MakeGroupcom(scrap))
					{
						ErrorWrite(&info, "Die Nachricht wird als gruppen\201bergreifender Kommentar verschickt");
						ErrorLn(&info);
					} else
					{
						ErrorWrite(&info, "Die Nachricht wird gel\224scht");
						ErrorLn(&info);
						Messages_DeleteMessage(scrap);
					}
				} else
				{
					ErrorWrite(&info, "Maus meldet Fehler bei Mitteilung: ");
					ErrorWrite(&info, scrap);
					ErrorLn(&info);
					ErrorWrite(&info, idScrap);
					ErrorLn(&info);
				}
				refAssigned = TRUE;
			} else
			{
				ErrorWrite(&info, "Fehlermeldung der Maus: ");
				ErrorWrite(&info, idScrap);
				ErrorLn(&info);
			}
			break;
			
		case '"':
			refMess = TRUE;
			strBcpy(scrap, idScrap);
			refAssigned = FALSE;
			find = strChr(scrap, '"');
			if (find != NULL)
			{
				/* zweites Anfuehrungszeichen entfernen */
				strCpy(find, find + 1);
			}
			break;
			
		case '$':		/* $ITG=54907 (CRC geaendert) */
			find = strChr(idScrap, '=');
			refMess = FALSE;
			/* Kennung rauskopieren */
			if (find != NULL)
			{
				/* Gleichheitszeichen gefunden, Infofilenamen nach mscrap kopieren */
				*find++ = '\0';
				strBcpy(info.mscrap, idScrap);
				find2 = strChr(find, ' ');
				if (find2 != NULL)
				{
					*find2 = '\0';
					strCpy(idScrap, find);
					if (!outfile->writeInf)
					{
						Infofiles_LoadInfoInf(FALSE, TRUE);
						outfile->writeInf = TRUE;
					}
					Infofiles_SetInfoCrc(info.mscrap, idScrap);
				}
			} else
			{
				/* Moeglicherweise Jedesmal-Infofile */
				find = strChr(idScrap, ' ');
				if (find != NULL)
				{
					*find = '\0';
					strBcpy(info.mscrap, idScrap);
					if (!outfile->writeInf)
					{
						Infofiles_LoadInfoInf(FALSE, TRUE);
						outfile->writeInf = TRUE;
					}
					strCpy(idScrap, "0");
					Infofiles_SetInfoCrc(info.mscrap, idScrap);
				}
			}
			break;
			
		default:
			ErrorWrite(&info, cUnknown);
			ErrorWrite(&info, idScrap);
			ErrorLn(&info);
			break;
		}
		/* gotId = type == '=' && refMess; */
	} while (!mtTextfiles_EndofText(log));
	
	if (UserBLK.StatusMessagesInInfile)
		DeleteFile(&info, statusInf);
	if (UserBLK.GroupChangesInInfile)
		DeleteFile(&info, grSelect);
	DeleteFile(&info, userCmdFile);

	CloseDat(&info, &info.abort, info.anz - info.not);
	ErrorClose(&info);
	mtTextfiles_CloseTextfile(&log);
	if (outfile->writeInf)
	{
		Infofiles_CleanUpOutBlocks();
		Infofiles_ResetOrderedNowFlag();
		Infofiles_SaveInfoInf();
	}
	
	if (info.anz > 0)	/* Nur falls mind. eine versucht wurde zu schreiben */
	{
		CatLog_putTime();
		CatLog_WriteCard(info.anz - info.not);
		CatLog_WriteString(" von ");
		CatLog_WriteCard(info.anz);
		CatLog_WriteKonjString(cMessStr, "", cExtStr, info.anz);
		CatLog_WriteLine(cImpStr);
		if(info.not)
		{
			CatLog_WriteString(cSpace9Str);
			CatLog_WriteString("*");
			CatLog_WriteCard(info.not);
			CatLog_WriteKonjString(cMessStr, "", cExtStr, info.not);
			CatLog_WriteLine(" wegen eines Fehlers oder vom Datenbankmodul abgelehnt*");
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Parst die Datei REN.TXT, die Gruppenumbenennungsinformationen von
 * der MAUS enthaelt. Wird aufgerufen, wenn der Block #REN im Outfile kommt.
 */
LOCAL _VOID Parser_ParseRenamefile(_VOID)
{
	_UBYTE fname[PATH_MAX];
	TEXTFILENO file;
	_BOOL first, success, newSet, oldSet;
	group_line scrap;
	group_line newName;
	group_line oldName;

	first  = TRUE;
	newSet = FALSE;
	oldSet = FALSE;
	strCpy(fname, DataPath);
	F_Path_Append(fname, renameFileName);
	if (mtTextfiles_OpenTextfile(fname, READ, 512, &file) == GERR_OK)
	{
		while (!mtTextfiles_EndofText(file))
		{
			mtTextfiles_ReadLine(file, scrap, sizeof(scrap));
			mtTextfiles_ReadLn(file);
			switch (scrap[0])
			{
			case 'O':
				strCpy(oldName, scrap + 1);
				oldSet = TRUE;
				break;
			case 'N':
				strCpy(newName, scrap + 1);
				newSet = TRUE;
				break;
			case 'D':
				/* Datum der Umbenennung, interessiert uns erstmal nicht */
				break;
			}
			if (newSet && oldSet)
			{
				success = GroupSelect_ChgGroup(oldName, newName,'\0',"", FALSE);
				if (first)
				{
					CatLog_WriteLn();
					CatLog_WriteLn();
					first = FALSE;
				}
				if (success)
				{
					CatLog_putTime();
					CatLog_WriteString("Gruppe ");
					CatLog_WriteLine(oldName);
					CatLog_WriteString("         umbenannt nach ");
					CatLog_WriteLine(newName);
					TRACE((EO_DEBUG, "Gruppe %s umbenannt nach %s", oldName, newName));
				} else
				{
					CatLog_putTime();
					CatLog_WriteString("*FEHLER! Gruppe ");
					CatLog_WriteLine(oldName);
					CatLog_WriteString("         konnte nicht umbenannt werden nach ");
					CatLog_WriteString(newName);
					CatLog_WriteLine("*");
					TRACE((EO_DEBUG, "Gruppe %s konnte nicht umbenannt werden nach %s", oldName, newName));
				}
				oldSet = FALSE;
				newSet = FALSE;
			}
		}
		mtTextfiles_CloseTextfile(&file);
		/* Jetzt die geaenderte GRUPPEN.INF speichern */
		GroupSelect_SaveGruppenInf();
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Wird vom Parser aufgerufen, wenn ein Infofile geschlossen wurde. Falls es
 * wichtige Informationen enthaelt (ITG), wird es dann direkt geparst
 */

LOCAL _VOID TestDirectParse(CONST _UBYTE *shortname)
{
	if (maus_short_name_equal(shortname, ITG_SHORT_NAME) ||
	 	maus_short_name_equal(shortname, YGA_SHORT_NAME))
	{
		/* Maschinenlesbare Gruppenliste abgleichen mit
		 * interner Gruppenliste
		 */
		GroupSelect_ParseInfofile(FALSE);
	} else if (maus_short_name_equal(shortname, YGN_SHORT_NAME))
	{
		/* Maschinenlesbare Gruppenliste abgleichen mit
		 * interner Gruppenliste
		 */
		GroupSelect_ParseInfofile(TRUE);
	} else if (maus_short_name_equal(shortname, REN_SHORT_NAME))
	{
		/* Gruppenaenderungen parsen */
		Parser_ParseRenamefile();
	} else if (maus_short_name_equal(shortname, YGB_SHORT_NAME))
	{
		/* Bestellte Gruppen */
		GroupSelect_ParseYGB();
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
 * Testet anhand einiger Kleinigkeiten, ob dies ein Outfile ist, nicht
 * 100% sicher, aber immerhin werden die ganz schlimmen Faelle damit
 * erkannt; Attention: may be critical if MAUS changes textfile-format!
 */
LOCAL _BOOL OutfileOk(FILENO handle, _ULONG *len)
{
	_UBYTE c;
	F_ERROR error;
	
	CatFiles_Seek(0L, handle, CatFiles_end);
	error = CatFiles_FilePos(handle, len);
	CatFiles_Seek(0L, handle, CatFiles_start);
	if (error != NoError || *len < 6)
		return FALSE;
	error = CatFiles_ReadFile(&c, handle);
	if (error != NoError || c != '#')
		return FALSE;
	CatFiles_Seek(*len - 5L, handle, CatFiles_start);
	error = CatFiles_ReadFile(&c, handle);
	if (error != NoError || c != CR)
		return FALSE;
	error = CatFiles_ReadFile(&c, handle);
	if (error != NoError || c != LF)
		return FALSE;
	error = CatFiles_ReadFile(&c, handle);
	if (error != NoError || c != '#')
		return FALSE;
	error = CatFiles_ReadFile(&c, handle);
	if (error != NoError || c != CR)
		return FALSE;
	error = CatFiles_ReadFile(&c, handle);
	if (error != NoError || c != LF)
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ImportError(CONST _UBYTE *str, F_ERROR error)
{
	_UBYTE msg[256];
	
	if (batchProcess)
	{
		CatLog_WriteLineNTime(str);
		CatLog_WriteString(": *");
		F_GetErrorMsg(error, PtrSize(msg));
		CatLog_WriteString(msg);
		CatLog_WriteLine("*");
	} else
	{
		F_ErrorAlert(error);
	}
	TRACE((EO_DEBUG, "%s: %d", str, error));
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
 * Outfile fuer das Einfuegen vorbereiten, d.h. noetigenfalls auspacken,
 * weiterhin oeffnen und testen, ob es ok ist; Liefert direkt den Zugriffs-
 * handle und Laenge, falls alles geklappt hat.
 * Diese Prozedur wird immer mit gesetztem WindUpdate aufgerufen, fuer
 * laengere Aktionen sollte daher der Bildschirm freigegeben werden
 */
/*DYJ 5.21b */	/*DYJ 5.20t */	/*DYJ 5.20zd */
LOCAL _BOOL OutfileVorbereiten(CONST _UBYTE *importPath, CONST _UBYTE *outfileName, CONST _UBYTE *archiveName, _BOOL doDeArc, _BOOL txtIsThere, FILENO *handle, _ULONG *length, OUTF_MODE mode)
{
	_DOUBLE space;
	DiskINFO disk;
	_WORD packret;
	_BOOL bool;
	_UBYTE fname[PATH_MAX];
	F_ERROR error;
	
	strBcpy(fname, importPath);
	if (doDeArc)
	{
		F_Path_Append(fname, OUTFILE_NAME);
		if (txtIsThere)
		{
			if (batchProcess || mtAlerts_AlertRSC(1, AL_OUT_OVERWRITE) == 1)
			{
				if ((error = F_File_Delete(fname)) != GERR_OK)
				{
					ImportError(cOfNdel, error);
					CatLog_CloseLog();
					TRACE((EO_DEBUG, cOfNdel));
					return FALSE;
				} else
				{
					CatLog_WriteLineNTime(cOfDel1);
					TRACE((EO_DEBUG, cOfDel1));
				}
			} else
			{
				CatLog_WriteLineNTime("Einf\201gen abgebrochen durch User");
				TRACE((EO_DEBUG, "Einf\201gen abgebrochen durch User"));
				CatLog_CloseLog();
				return FALSE;
			}
		}
	
		if (multiTask)
			Wind_Update(END_UPDATE);
		CatLog_WriteLineNTime("Outfile auspacken");
		ConfVars_GetConfDefBool(cRedirectPackerToLog, &bool, FALSE);
		packret = ARCStarter_DeArc(bool);
		if (multiTask)
			Wind_Update(BEG_UPDATE);
		if (packret != 0)
		{
			/* Outfile auspacken, DeArc muss die Fehlermeldungen bringen!               */
			CatLog_putTime();
			CatLog_WriteString("*Fehler beim Auspacken, GEMDOS-Fehler Nr. ");		
			CatLog_WriteInt(packret);
			CatLog_WriteLine("*");
			TRACE((EO_DEBUG, "Fehler beim Auspacken, GEMDOS-Fehler Nr. %d", packret));
			if (!batchProcess)
				MTE_infoRSC(AL_NO_DEARC);
			return FALSE;
		} else
		{
			CatLog_WriteLineNTime("Outfile ausgepackt");
			CatLog_WriteLn();
			TRACE((EO_TRACE, "Outfile ausgepackt"));
		}
		/*
		Wind_Update(END_UPDATE);
		EventTimer(200);
		Wind_Update(BEG_UPDATE);
		*/
	} else
	{
		_UBYTE scrap[PATH_MAX];
		if (mode==OM_OUTFILE && ConfVars_GetConfigString(cOutfBckPath, scrap, sizeof(scrap)))
			CatFiles_BackupFile(scrap,fname,outfileName);
		F_Path_Append(fname, outfileName);
		*handle = CatFiles_OpenFile(fname, CatFiles_readFile);
		if (!FILENO_OK(*handle))			/* File nicht gefunden?     */
		{
			if (batchProcess)
				ImportError("Outfile-Text nicht gefunden", TO_HANDLE(*handle));
			else if(mode==OM_OUTFILE)
				MTE_infoRSC(AL_OUT_NOT_FOUND);
			return FALSE;
		}
		CatFiles_CloseFile(*handle);
	}
	
	if (multiTask)
		Wind_Update(END_UPDATE);
	/* Hier werden jetzt die IO-Filter aufgerufen */
	if (mode==OM_OUTFILE)
	{
		if (!IoFilter_IoFilterOutfile())
		{
			if (multiTask)
				Wind_Update(BEG_UPDATE);
			return FALSE;
		}
	}
	Messages_ReReadMessageInfo();
	if (multiTask)
		Wind_Update(BEG_UPDATE);
	
	*handle = CatFiles_OpenFile(fname, CatFiles_readFile);
	/* CloseFile durch OutfileOk!                                              */
	
	if (TO_HANDLE(*handle) == -33)	/* File nicht gefunden?     */	/*!ERROR*/
	{
		if (batchProcess)
			ImportError("Outfile-Text nicht gefunden", TO_HANDLE(*handle));
		else if(mode==OM_OUTFILE)
			MTE_infoRSC(AL_OUT_NOT_FOUND);
		return FALSE;
	} else if (!FILENO_OK(*handle))		/* allgemeiner Fehler */
	{
		ImportError("Dateifehler beim \231ffnen von Outfile-Text", TO_HANDLE(*handle));
		return FALSE;
	} else if (!OutfileOk(*handle, length) && mode!=OM_822)
	{
		/* length enthaelt Laenge des Outfiles                                       */
		CatLog_WriteLineNTime("*Defektes Outfile festgestellt*");
		TRACE((EO_DEBUG, "Defektes Outfile festgestellt"));
		if (batchProcess)
		{
			CatFiles_CloseFile(*handle);
			return FALSE;
		}
		if(MTE_infoRSC(AL_WRONG_OUT)==1)
		{
			CatFiles_CloseFile(*handle);
			return FALSE;
		}
		else
		{
			CatLog_WriteLineNTime("*Defektes Outfile auf Userwunsch ignoriert!*");
			TRACE((EO_DEBUG, "Defektes Outfile auf Userwunsch ignoriert!"));
		}
			
	} else
	{
		/*
		 * erst hier ist sicher, dass OUTFILE.TXT 'ok' ist, also OutfileOk passiert
		 * hat
		 */
		if(mode==OM_822)
		{
			(*length)+=51;
			CatLog_WriteLineNTime("822-File ge\224ffnet");
			TRACE((EO_TRACE, "822-File ge\224ffnet"));
		}
		else
		{
			CatLog_WriteLineNTime("Outfile ge\224ffnet und getestet");
			TRACE((EO_TRACE, "Outfile ge\224ffnet und getestet"));
		}
		if (doDeArc && UserBLK.DeleteAfterImport)
		{
			error = CatFiles_DeleteFile(importPath, archiveName);
			if (error != NoError)
			{
				ImportError("Fehler beim L\224schen des Outfile-Archivs", error);
			} else
			{
				CatLog_WriteLineNTime("Outfile-Archiv gel\224scht nach auspacken");
				TRACE((EO_TRACE, "Outfile-Archiv gel\224scht nach auspacken"));
			}
		}
		
		/* MagicDOS.Dfree(disk, ORD(ucase(DataPath[0])) - ORD('A') + 1); */
		D_Info(DataPath, &disk);
		space = disk.free_size;
		if (space < (_DOUBLE)(*length + secureBytes))
		{
			CatFiles_CloseFile(*handle);
			CatLog_WriteLineNTime("*Zuwenig Diskplatz festgestellt*");
			TRACE((EO_DEBUG, "Zuwenig Diskplatz festgestellt"));
			if (!batchProcess)
				MTE_infoRSC(AL_DISKSPACE);
			return FALSE;
		}
	}
	return TRUE;
}
 
/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*------ Einlagern --------------------------------------------------------*/

/* initialisiert die Gruppenliste */
LOCAL _VOID InitList(outfileInfo *outfile)
{
	_UWORD z;

	outfile->maxPos = 0; /* naechste zu belegende Position */
	for (z = 0; z < MAX_GROUP; z++)
	{
		outfile->gMax[z]   = EndOfList; /* Listenschwaenze */
		outfile->gStart[z] = EndOfList; /* Listenkoepfe */
	}
	for (z = 0; z < MAX_ARRAY; z++)
		outfile->gPos[z].next = EndOfList;
	setclr(outfile->groupsUsed);
}

/*** ---------------------------------------------------------------------- ***/
/*
 * haengt die Msg, die bei <count> beginnt, an die Gruppenliste <nr> an
 */
/*DYJ 5.19b */
LOCAL _VOID AppendToListNr(outfileInfo *outfile, _ULONG count, CAT_GROUP_NUMBER nr,VERK_BLK *xLines)
{
	setincl(outfile->groupsUsed, nr);
	if (outfile->gStart[nr] == EndOfList)			/* Noch keine Msg dieser Gruppe gefunden  */
	{
		outfile->gStart[nr] = outfile->maxPos;		/* Dort kommt der erste Eintrag hin       */
		outfile->gMax[nr] = outfile->maxPos;         				/* naechstes zu belegendes Arrayelement    */
	}
	else
	{
		if(outfile->sortReverse)		/*Dann umgekehrt einfgen*/
		{
			outfile->gPos[outfile->maxPos].next=outfile->gStart[nr];
			outfile->gStart[nr] = outfile->maxPos;
		}
		else
		{
			outfile->gPos[outfile->gMax[nr]].next = outfile->maxPos;	/* letztes belegtes Element dieser Gruppe */
			outfile->gMax[nr] = outfile->maxPos;         				/* naechstes zu belegendes Arrayelement    */
		}
	}
	outfile->gPos[outfile->gMax[nr]].next   = EndOfList;
	outfile->gPos[outfile->maxPos].offset = count;
	outfile->gPos[outfile->maxPos].xLines = xLines;
	++outfile->maxPos;								/* wieder naechstes zu belegende Element   */
	/* Ende erreicht, wenn maxPos > maxArray, muss unten in der Schleife        */
	/* festgestellt werden                                                     */
}

/*** ---------------------------------------------------------------------- ***/

/*
 * haengt die Msg, die bei <count> beginnt, an die entsprechende
 * Gruppenliste an. Sucht in der Namensliste der Gruppen nach dem String
 * <gruppe> <sonstige> werden auch sortiert, dazu wird die Liste erweitert
 */
LOCAL _BOOL AppendToList(outfileInfo *outfile, _ULONG count, CONST _UBYTE *gruppe,VERK_BLK *xLines)
{
	CAT_GROUP_NUMBER z;
	
	if (!GroupSelect_GroupNumber(gruppe, &z))
	{
		if (!GroupSelect_AppendGroup(gruppe))
			return FALSE;
		CatLog_WriteStringNTime("Neue Gruppe ");
		CatLog_WriteString(gruppe);
		CatLog_WriteString(" angelegt");
		CatLog_WriteLn();
		TRACE((EO_DEBUG, "Neue Gruppe %s angelegt", gruppe));
	}
	AppendToListNr(outfile, count, z,xLines);
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*------ Auslesen ---------------------------------------------------------*/

/*
 * Wegen next nicht verwirren lassen, erst steht dort der Arrayindes
 * ("Pointer") der aktuellen Msg, anschliessend kommt der naechste dort
 * hinein
 */

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*--------- Sortierung ----------------------------------------------------*/

/*
 * liest eine Zeile aus dem Speicher bis zum CR/LF in <str> ein. CR wird
 * durch ein 0C ersetzt und LF wird uebersprungen
 *
 * vor dem Aufruf muss mittels CheckMemLine und anschliessendem Test
 * festgestellt worden sein, dass die Zeile auch komplett im Puffer ist
 */

LOCAL _VOID ReadMemLine(_ULONG *pCount, _UBYTE *str, size_t strsize, _UBYTE _HUGE *oPtr, _ULONG oAnz)
{
	_UBYTE _HUGE *p;
	_ULONG count;
	
	count = *pCount;
	p = oPtr + count;
	while (count < oAnz && --strsize && *p != CR)
	{
		*str++ = *p++;
		count++;
	}
	*str = '\0';
	/* Die folgende Schleife erledigt auch das Problem, wenn die letzte
	 * Schleife durch String-Ueberlauf abgebrochen wurde
	 */
	while (count < oAnz && *p != LF)
	{
		++count;
		p++;
	}
	if (count < oAnz && *p == LF)
		++count;	/* LF noch mitzaehlen */
	*pCount = count;
}

/*** ---------------------------------------------------------------------- ***/

/*
 * durchsucht den Speicher bis zum CR/LF
 */

LOCAL _VOID CheckMemLine(_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)
{
	_UBYTE _HUGE *p;
	_ULONG count;
	
	count = *pCount;
	p = oPtr + count;
	while (count < oAnz && *p != LF)
	{
		count++;
		p++;
	}
	if (count < oAnz && *p == LF)
		count++;
	*pCount = count;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID CheckMemLineUnfSpl(_ULONG *pCount,_ULONG *pBody, _UBYTE _HUGE *oPtr, _ULONG oAnz)	*/
/*	Liest eine Internet-Infile Zeile und beseitigt das Folding, auerdem wird	*/
/*	das nameFeld in Grobuchstaben gewandelt und durch ein '\0' vomBody getrennt*/
/*  Diese Trennung solle nach der Analyse wieder rckgngig gemacht werden!		*/
/*	Parameter:	pCount:	Position												*/
/*				pBody:	Rckgabe wo der Body der Zeile beginnt					*/
/*				oPtr:	der ganze Block											*/
/*				oAnz:	und seine Lnge											*/
/*	Ergebnis:	keines															*/		
/*	29.8.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID CheckMemLineUnfSpl(_ULONG *pCount,_ULONG *pBody, _UBYTE _HUGE *oPtr, _ULONG oAnz)
{
/*DYJ 5.30m Start*/
	_UBYTE _HUGE *p,*z,*ziel;
/*DYJ  Ende; alt:	
	_UBYTE _HUGE *p,*z;
*/
	_ULONG count;
	
	count = *pCount;
/*DYJ 5.30m Start*/
	ziel=z=p = oPtr + count;
/*DYJ  Ende; alt:	
	z=p = oPtr + count;
*/
	while (count < oAnz && *p != LF && *p!=':')
	{
		count++;
		*(z++)=ucase(*(p++));
	}
	if(*p==':')
	{
		*p='\0';
		*pBody=count+1;
		do
		{
			if(*p==LF)
			{
/*DYJ 5.30m Start*/
				if((p[1]!=' '&&p[1]!='\t')|| z==ziel)
/*DYJ  Ende; alt:	
				if(p[1]!=' '&&p[1]!='\t')
*/
					break;
			}
			else if(*p!=CR)
				*(z++)=*p;
			count++;
			p++;
		}
		while (count < oAnz );
	}
	else
	{
		if(z[-1]=='\r')
			z--;
		*pBody=0;
	}
		
	*z='\0';
	if (count < oAnz && *p == LF)
		count++;
	while(z<p)
		*(z++)='\0';
	*pCount = count;
	while(oPtr[*pBody]==' ' || oPtr[*pBody]=='\t')
		(*pBody)++;
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL HandleMausMessage(outfileInfo *outfile)							*/
/*	War ursprngl. ein Teil von HandleMessage. Da es Maus-Outfile speziefisch	*/
/*	ist habe ich diesen Teil abgesondert.										*/
/*	Parameter:	outfile:	Alles was wir ber das Outfile wissen				*/
/*	Ergebnis:	alles OK?														*/		
/*	27.8.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL HandleMausMessage(outfileInfo *outfile)
{
	_BOOL isGroup = FALSE; 			/* kein 'G' gefunden                                 */
	_BOOL doDelete=FALSE;
	_ULONG old     = outfile->count;	/* jetzige Pos merken                                */
/*DYJ 5.32b Start*/
	VERK_BLK *xLine=NULL;
	_UBYTE str[1024],flagline[100]="";
	_BOOL chkPmf=PmFilter_DoFilter(str,0,PMAB_INIT);
	do
	{
		do		/* Mal alle Zeilen durchrappeln.. */
		{
			CheckMemLine(&outfile->count, outfile->oPtr, outfile->oAnz);
			if(chkPmf)
				PmFilter_DoFilter(outfile->oPtr+outfile->count,0,PMAB_LINE_MAUS);
		}
		while (outfile->count < outfile->oAnz &&
			   outfile->oPtr[outfile->count] != 'G' &&
			   outfile->oPtr[outfile->count] != '#');
		
		/* ..bis zum Ende oder zur Gruppenangabe */
		if (outfile->count < outfile->oAnz &&
			outfile->oPtr[outfile->count] == 'G')		/* Gruppe gefunden? */
		{
			++outfile->count; /* 'G' ueberspringen */
			ReadMemLine(&outfile->count, str, sizeof(str), outfile->oPtr, outfile->oAnz); /* dann mal lesen..           */
			isGroup = TRUE;
			chkPmf=FALSE;
		}
	} while (outfile->count < outfile->oAnz && outfile->oPtr[outfile->count] != '#');
	/* Erstmal weitermachen bis zum Mitteilungsende */
	if(chkPmf)
	{
		_WORD len;
		isGroup=PmFilter_DoFilter(str,(_WORD)sizeof(str),PMA_GROUP);
/*DYJ 5.35g Start*/
		doDelete=isGroup&& !str[0];
		if(!doDelete && PmFilter_DoFilter(flagline+1,(_WORD)(sizeof(flagline)-1),PMA_FLAGS))
/*DYJ  Ende; alt:	
		if(PmFilter_DoFilter(flagline+1,(_WORD)(sizeof(flagline)-1),PMA_FLAGS))
*/
		{
			len=(_WORD)strLen(flagline);
			xLine = SYSMALLOC(sizeof(VERK_BLK)+len, MEM_SHARABLE|MEM_NOERR, "HandleINMessage:Flagzeile");
			if(xLine)
			{
				strCpy(&xLine->data,flagline);
				xLine->nxt=NULL;
			}
			else
				return FALSE;
		}
		PmFilter_DoFilter(NULL,0,PMAB_FREE);
/*DYJ 5.35g Start*/
		if(isGroup && !doDelete)
/*DYJ  Ende; alt:	
		if(isGroup)
*/
		{
			VERK_BLK *xLine1=xLine;
			len=(_WORD)strLen(str)+1;
			xLine = SYSMALLOC(sizeof(VERK_BLK)+len, MEM_SHARABLE|MEM_NOERR, "HandleINMessage:iCatPMGroup");
			if(xLine)
			{
				xLine->data='G';
				strCpy(&xLine->data+1,str);
				xLine->nxt=xLine1;
			}
			else
				return FALSE;
		}
	}
/*DYJ  Ende; alt:	
	_UBYTE str[1024];
	do
	{
		do		/* Mal alle Zeilen durchrappeln.. */
			CheckMemLine(&outfile->count, outfile->oPtr, outfile->oAnz);
		while (outfile->count < outfile->oAnz &&
			   outfile->oPtr[outfile->count] != 'G' &&
			   outfile->oPtr[outfile->count] != '#');
		
		/* ..bis zum Ende oder zur Gruppenangabe */
		if (outfile->count < outfile->oAnz &&
			outfile->oPtr[outfile->count] == 'G')		/* Gruppe gefunden? */
		{
			++outfile->count; /* 'G' ueberspringen */
			ReadMemLine(&outfile->count, str, sizeof(str), outfile->oPtr, outfile->oAnz); /* dann mal lesen..           */
			isGroup = TRUE;
		}
	} while (outfile->count < outfile->oAnz && outfile->oPtr[outfile->count] != '#');
	/* Erstmal weitermachen bis zum Mitteilungsende */
*/
	
	if (outfile->count < outfile->oAnz)
	{
		++outfile->count; /* '#' ueberspringen */
/*DYJ 5.35g Start*/
		if (doDelete)
			TRACE((EO_TRACE, "pos: %lu delete", outfile->count));
		else if (isGroup)
/*DYJ  Ende; alt:	
		if (isGroup)
*/
		{
			TRACE((EO_TRACE, "pos: %lu", outfile->count));
/*DYJ 5.32b Start*/
			return AppendToList(outfile, old, str,xLine);
/*DYJ  Ende; alt:	
			return AppendToList(outfile, old, str,NULL);
*/
			/* mal gucken, wo's hingehoert                                      */
		} else		/* Ist persoenlich!                                              */
		{
			AppendToListNr(outfile, old, dataSys_private,NULL);
		}
	} else
	{
		/* Mitteilung bricht ab, Berechnung des zu verschiebenden Speichers        */
		outfile->count = old - 1; /* Sollte in jedem Fall auf den Anfang der ID zeigen */
		TRACE((EO_TRACE, "pos: %lu", outfile->count));
		return FALSE;
	}
	return TRUE;
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID CpyMemLineUnfold(String1023 ziel,_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)	*/
/*	Kopiert eine Internet-Infile Zeile und beseitigt das Folding				*/
/*	Parameter:	ziel:	na was wohl												*/
/*				pCount:	Position												*/
/*				oPtr:	der ganze Block											*/
/*				oAnz:	und seine Lnge											*/
/*	Ergebnis:	keines															*/
/*	die gleiche Routine wie in mime.c											*/
/*  27.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID CpyMemLineUnfold(String1023 ziel,_ULONG *pCount, _UBYTE _HUGE *oPtr, _ULONG oAnz)
{
	_UBYTE _HUGE *p,*z;
	_ULONG count;
	
	count = *pCount;
	p = oPtr + count;
	z=ziel;
	oAnz=LMin(oAnz,count+sizeof(String1023));	/*Stimmt nicht ganz, aber schneller und sicherer*/
	do
	{
		if(*p==LF)
		{
/*DYJ 5.30m Start*/
			if((p[1]!=' '&&p[1]!='\t')|| z==ziel)
/*DYJ  Ende; alt:	
			if(p[1]!=' '&&p[1]!='\t')
*/
				break;
		}
		else if(*p!=CR)
			*(z++)=*p;
		count++;
		p++;
	}
	while (count < oAnz );
		
	*z='\0';
	if (count < oAnz && *p == LF)
		count++;
	*pCount = count;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL HandleINMessage(outfileInfo *outfile_BOOL isGroup)				*/
/*	Wie HandleMausMessage aber fr Internet-Outfiles							*/
/*	Parameter:	outfile:	Alles was wir ber das Outfile wissen				*/
/*				isGroup:	TRUE wenn es eine M ist							*/
/*	Ergebnis:	alles OK?														*/		
/*	27.8.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20v */	/*DYJ 5.20w */	/*DYJ 5.23a */
LOCAL _BOOL HandleINMessage(outfileInfo *outfile,_BOOL isGroup)
{
	_ULONG old     = outfile->count;	/* jetzige Pos merken                                */
	_UBYTE str[1024],*group=NULL;
	_UBYTE flagline[100]="FLAGZEILEPMF: ";
	VERK_BLK *xLine=NULL;
	_BOOL doDelete=FALSE;
	CheckMemLine(&outfile->count, outfile->oPtr, outfile->oAnz);

	if(isGroup)
	{
		ReadMemLine(&outfile->count, str, sizeof(str), outfile->oPtr, outfile->oAnz); /* dann mal lesen..           */
		group=str+11;
	}
	else if(PmFilter_DoFilter(str,0,PMAB_INIT) )
	{
		_WORD len;
		do		/* Zuerst die Headerzeilen zum Filtern... */
		{
			CpyMemLineUnfold(str,&outfile->count, outfile->oPtr, outfile->oAnz);
			PmFilter_DoFilter(str,0,PMAB_LINE);
		}
		while (outfile->count < outfile->oAnz &&
			   strnCmp(&outfile->oPtr[outfile->count],"\r\n",2 ));
/*DYJ 5.34f Start*/
		strCpy(str,"ICATPMGROUP:");
/*DYJ  Ende; alt:	
		strCpy(str,"ICATPMGROUP: ");
*/
		group=strChr(str,'\0');
/*DYJ 5.35g Start*/
		isGroup=PmFilter_DoFilter(group,(_WORD)sizeof(group)-20,PMA_GROUP);
		doDelete=isGroup && !str[0];
		if(!doDelete && PmFilter_DoFilter(strChr(flagline,'\0'),(_WORD)(sizeof(flagline)-strLen(flagline)-1),PMA_FLAGS))
/*DYJ  Ende; alt:	
		isGroup=PmFilter_DoFilter(group,(_WORD)sizeof(str)-20,PMA_GROUP);
/*DYJ 5.32b Start*/
		if(PmFilter_DoFilter(strChr(flagline,'\0'),(_WORD)(sizeof(flagline)-strLen(flagline)-1),PMA_FLAGS))
/*DYJ  Ende; alt:	
		if(PmFilter_DoFilter(strChr(flagline,'\0'),(_WORD)(sizeof(str)-strLen(flagline-1)),PMA_FLAGS))
*/
*/
		{
			len=(_WORD)strLen(flagline);
			xLine = SYSMALLOC(sizeof(VERK_BLK)+len, MEM_SHARABLE|MEM_NOERR, "HandleINMessage:Flagzeile");
			if(xLine)
			{
				strCpy(&xLine->data,flagline);
				xLine->nxt=NULL;
			}
			else
				return FALSE;
		}
		PmFilter_DoFilter(NULL,0,PMAB_FREE);
/*DYJ 5.35g Start*/
		if(isGroup && !doDelete)
/*DYJ  Ende; alt:	
		if(isGroup)
*/
		{
			VERK_BLK *xLine1=xLine;
			len=(_WORD)strLen(str);
			xLine = SYSMALLOC(sizeof(VERK_BLK)+len, MEM_SHARABLE|MEM_NOERR, "HandleINMessage:iCatPMGroup");
			if(xLine)
			{
				strCpy(&xLine->data,str);
				xLine->nxt=xLine1;
			}
			else
				return FALSE;
		}
	}
	do		/* Mal alle Zeilen durchrappeln.. */
		CheckMemLine(&outfile->count, outfile->oPtr, outfile->oAnz);
	while (outfile->count < outfile->oAnz &&
		   strnCmp(&outfile->oPtr[outfile->count],".\r\n",3 ));
	
	/* ..bis zum Ende */
	CheckMemLine(&outfile->count, outfile->oPtr, outfile->oAnz);
	/* ..bis zum Anfang der nchsten */
	if (outfile->count < outfile->oAnz)
	{
		if(outfile->oPtr[outfile->count]!='#')
		{
			/* Nach dem Msg-Ende mte was neues anfangen        */
			/* oder Mit der Lngenangabe stimmt was nicht       */
			outfile->count = old - 1; /* Sollte in jedem Fall auf den Anfang der Msg zeigen */
			TRACE((EO_TRACE, "pos: %lu", outfile->count));
			return FALSE;
		}
		++outfile->count; /* '#' ueberspringen */
/*DYJ 5.35g Start*/
		if (doDelete)
			TRACE((EO_TRACE, "pos: %lu delete", outfile->count));
		else if (isGroup)
/*DYJ  Ende; alt:	
		if (isGroup)
*/
		{
			TRACE((EO_TRACE, "pos: %lu", outfile->count));
			if(group&& *group)
				return AppendToList(outfile, old, group,xLine);
			else
				return TRUE;			/*Message nicht laden*/
			/* mal gucken, wo's hingehoert                                      */
		} else		/* Ist persoenlich!                                              */
		{
			AppendToListNr(outfile, old, dataSys_private,NULL);
		}
	} else
	{
		/* Mitteilung bricht ab, Berechnung des zu verschiebenden Speichers        */
		outfile->count = old - 1; /* Sollte in jedem Fall auf den Anfang der ID zeigen */
		TRACE((EO_TRACE, "pos: %lu", outfile->count));
		return FALSE;
	}
	return TRUE;
}

/*
 * Geht zunaechst von <count> an aufwaerts durch, bis ein CR/LF/'G' oder
 * ':','>','#' gefunden wird. Wenn ein 'G' gefunden wird, dann wird die
 * Msg an die Liste fuer die entsprechende Gruppe angehaengt. Falls die
 * letzte Zeichenfolge nicht CR/LF/'#' war, dann wird bis zum Erreichen
 * dieser Folge weitergesucht.
 * <count> zeigt immer auf den naechsten zu bearbeitenden Buchstaben
 *
 * Returniert FALSE, wenn eine Mitteilung abbricht und eine Speicher-
 * verschiebung noetig wird
 *
 * Wenn TxtOutOpen TRUE ist dann muss noch eine Infodatei geschrieben
 * werden; bis zu ihrem Ende
 */
/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.19b */	/*DYJ 5.21i */
LOCAL _BOOL HandleMessage(outfileInfo *outfile)
{
	_UBYTE str[1024];
	_UBYTE fname[PATH_MAX];
	_UBYTE OutBlock[16];	/* (MH) */
	_ULONG tmp, tmp2;
	_ULONG old;
	_UBYTE _HUGE *ptr;
	_BOOL isInfo;
	_WORD infLen;
	NrTypes strType;
	_BOOL bool;
	_BOOL weiterBeiKardinal;
	/* Textfiles, d.h. Maus-Infofiles und das Logfile werden separat behandelt */
	
	/* Ende der Zeile suchen, Index steht danach in tmp */
	tmp = outfile->count;
	CheckMemLine(&tmp, outfile->oPtr, outfile->oAnz);
	if (tmp >= outfile->oAnz)
	{
#if TRACE_PARSE && 0
		/* Zeile nicht mehr im Buffer, direkt wieder raus */
		CatLog_WriteString("*Broken Id at beginning of block*");
		CatLog_WriteLn();
#endif
		--outfile->count;	/* ??? */
		return FALSE;
	}
	
	ptr = outfile->oPtr + outfile->count; /* Fuer den Zugriff gleich */
	isInfo = FALSE;
	strType = nottich;
	if (!outfile->TxtOutOpen)
	{
		strType = typeOf(ptr);
		isInfo = isOneInf(ptr, &infLen);
		
#if TRACE_PARSE
		{
			_WORD i;
			
			i = 0;
			while (i < 255 && ptr[i] != CR)
			{
				str[i] = ptr[i];
				++i;
			}
			str[i] = '\0';
		}
		TRACE((EO_TRACE, "Handling Id: %s", str));
#endif
	}
	
	if (isUnknownInf(ptr, &infLen) ||
		outfile->TxtOutOpen ||
		isInfo)
		/*
		strType == REN ||
		strType == HEAD ||
		strType == LOG 
		*/
	{
		/* Hier wird sich auf die Reihenfolge der Abarbeitung verlassen        */
		/* Wenn TxtOut != NULL, dann ist schon eine Textdatei offen und sie muss  */
		/* noch auf die Platte geschrieben werden, da sie beim letzten Mal     */
		/* nicht komplett im Puffer war.                                       */
		/* !! Wenn ein Infotext abbricht, dann kann es nur am Ende sein        */
		_BOOL isOld=FALSE,isIn2Cat=FALSE;
		
		if (!outfile->TxtOutOpen)		/* Noch keine Datei offen, jetzt Namen erstellen   */
		{
			if (strType == HEAD)
				outfile->headThere = TRUE;
			strMcpy(str, infLen + 1, ptr);
			if (!isInfo && isUnknownInf(ptr, &infLen) && (strType == nottich || strType == normal))
			{
				if (strType != OUT)	/* OUT ist bekannt (MH) */
				{
					strMcpy(str, infLen + 1, ptr);
					++outfile->statGroup.unknown;
					CatLog_WriteLn();
					CatLog_WriteStringNTime("*Unbekannter Infotext im Outfile: ");
					CatLog_WriteString(str);
					CatLog_WriteString("*");
					TRACE((EO_DEBUG, "Unbekannter Infotext im Outfile: %s", str));
				}
			}
			strBcpy(outfile->TxtName, str);
			strLwr(str);
			strBcat(str, textExt);
			strBcpy(fname, DataPath);
			F_Path_Append(fname, str);
			ConfVars_GetConfDefBool(cNoInfofileBackups, &bool, FALSE);
			if (!bool)
			{
				/* Nur beim ersten Mal ein Backup von #LOG anlegen! */
				if ((strType == LOG && !outfile->firstLog) || strType != LOG)
				{
					CatGlobal_CreateBackup(fname);
				}
			}
			if (strType == LOG)
			{
				outfile->TxtOutOpen = OpenTextFile(DataPath, str, APPEND, infoFileBuffer, &outfile->TxtOut);
				if (!outfile->TxtOutOpen)
				{
					outfile->TxtOutOpen = OpenTextFile(DataPath, str, WRITE, infoFileBuffer, &outfile->TxtOut);
				}
				outfile->firstLog = TRUE;
			} else
			{
				/* Wenn ein OUT-Block gekommen ist, dann in INFO.INF eintragen, 
				   Beschreibung kommt spaeter dazu (MH) */
				if (strType == OUT)
				{
					if (!outfile->writeInf)
					{
						Infofiles_LoadInfoInf(FALSE, TRUE);
						outfile->writeInf = TRUE;
					}
					strMcpy(OutBlock, infLen + 1, ptr);
					strUpr(OutBlock);
					
					/* Liste aktualisieren -> alte entfernen, neue eintragen */
					if (Infofiles_IsInfoFile(OutBlock, TRUE))
						Infofiles_DeleteEntry(OutBlock);

					Infofiles_AddEntry(TRUE, FALSE, TRUE, TRUE, 0, -1, 0, OutBlock, DEFAULT_OUTBLOCK, NULL, FALSE, FALSE);
					Infofiles_SetInfoCrc(OutBlock, "-1");	
					outfile->statGroup.outBlocks++;
				}
				outfile->TxtOutOpen = OpenTextFile(DataPath, str, WRITE, infoFileBuffer, &outfile->TxtOut);
			}
			if (!outfile->TxtOutOpen)
			{
				if (batchProcess)
				{
					CatLog_WriteStringNTime(str);
					CatLog_WriteLine("*konnte nicht geschrieben werden*");
				} else
				{
					sprintf(fname, Rsc_WrkString(MTE_noFileWrite), str);
					MTE_info(fname);
				}
			}
			CheckMemLine(&outfile->count, outfile->oPtr, outfile->oAnz); /* #LOG u.ae. ueberspringen           */
			++outfile->statGroup.text; /* ein weiterer Text ist gekommen */
		} else
		{
			/* d.h. das Textfile ist schon offen, es liegt ein Wechsel des       */
			/* Puffers vor, da beim alten das Ende ueberschritten wurde.          */
		}
		
		old = outfile->count; /* Mitzaehlen, fuer die Anzeige unten */
		
		/* Hier gilt folgendes: Wir sind entweder am Anfang des Infofiles
		 * oder mittendrin. oPtr^[count] zeigt auf das erste Zeichen einer
		 * Zeile, d.h. auf einen ':' oder ein '#' (z.b. bei leeren Infofiles)
		 * Wir kopieren nun zeilenweise alles in die Textdatei, count zeigt
		 * dabei *immer* auf den Anfang der Zeile!
		 */
		tmp = outfile->count;   /* tmp ist der temporaere Zaehler. */
		weiterBeiKardinal=(*outfile->TxtName=='Y');	/* Bei Y-Infofiles kann theoretisch ein # enthalten sein, erst nach der "."-Zeile kommt das Ende*/
		while (tmp < outfile->oAnz && (outfile->oPtr[tmp] != '#' || weiterBeiKardinal))
		{
			if (outfile->oPtr[tmp] == ':' && !weiterBeiKardinal)
				++tmp;    /* ':' ueberspringen */
			tmp2 = tmp;
			/* Ende der Zeile suchen, Index steht danach in tmp */
			CheckMemLine(&tmp, outfile->oPtr, outfile->oAnz);
			if (tmp < outfile->oAnz)
			{
				/* Zeile ist noch im aktuellen Buffer, tmp zeigt aufs Ende,
				 * tmp2 auf Anfang!
				 */
				ReadMemLine(&tmp2, str, sizeof(str), outfile->oPtr, outfile->oAnz);
				if (strType == HEAD)
				{
					if(!strnCaseCmp(str,"SIN2CAT",7))	/* Sort In2Cat*/
						outfile->sortReverse=TRUE;
					else if (*str=='s' || *str=='S')	/* Sort irgendwie sonst */
						outfile->sortReverse=FALSE;
					else if(!strnCaseCmp(str,"ZATARI",6))	/* Atarizeichensatz	*/
						outfile->charset=ZS_ATARI;
					else if(!strnCaseCmp(str,"ZISO-8859-1",8))	/* Windowszeichensatz	*/
						outfile->charset=ISO8859_1;
					else if(!strnCaseCmp(str,"BIN2CAT",7))	/* In2Cat	*/
						isIn2Cat=TRUE;
					else if(!strnCaseCmp(str,"V1.",3))		/* Versioansnummer*/
					{
						if(atoi(str+3)<46)
							isOld=TRUE;	
					}
				}
				if(weiterBeiKardinal && !strCmp(str,"."))
					weiterBeiKardinal=FALSE;
				else
				{
					if (outfile->TxtOutOpen)		/* Nur schreiben, wenn das oeffnen geklappt hat    */
					{
						mtTextfiles_WriteLine(outfile->TxtOut, str);
						mtTextfiles_WriteLn(outfile->TxtOut);
					}
				}
				/*
				 * count auf Anfang der naechsten Zeile zeigen lassen
				 */
				outfile->count = tmp2;
			}
		}
		if((strType == HEAD) && isOld && isIn2Cat)
		{
			outfile->sortReverse=TRUE;
			outfile->charset=ISO8859_1;
		}
		
		/*
		 * Entweder sind wir am Ende des Infofiles oder der Buffer ist am Ende
		 */
		showImport_SetNew(outfile->count - old);
		CatGlobal_busyMouse();
		if (tmp >= outfile->oAnz)		/* alle Zeichen im Puffer behandelt; kein Ende    */
		{
			/* Was muss man hier machen? Erstmal jedenfalls nichts  */
			return FALSE; /* !!! Hier broken zurueckgeben! */
		} else
		{
			++outfile->count;			/* '#' ueberspringen                                      */
			if (outfile->TxtOutOpen)
			{
				mtTextfiles_CloseTextfile(&outfile->TxtOut); /* Alles drin                   */
				outfile->TxtOutOpen = FALSE; /* entwerten..                                */
				/* Jetzt eventuell direkt parsen, falls noetig */
				TestDirectParse(outfile->TxtName);
				outfile->TxtName[0] = '\0';
			}
		}
		bool=TRUE;
	} else		 /* es ist eine Msg oder Statusmeldung                               */
	{
		if(!strnCmp(&outfile->oPtr[outfile->count],"PM@IN",5))
			bool=HandleINMessage(outfile,FALSE);
		else if(!strnCmp(&outfile->oPtr[outfile->count],"OM@IN",5))
			bool=HandleINMessage(outfile,TRUE);
		else	
			bool=HandleMausMessage(outfile);
	}
	TRACE((EO_TRACE, "pos: %lu", outfile->count));
	return bool;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
Die Definition der Zeile im Outfile ist:

Kuerzel: s (Achtung, klein)

G   Gelesen (Nicht gelesen entspricht G-)
X   Totalloeschung
F   Interessant (entspricht wohl fixieren bei anderen)
L   Gefiltert
V   Vererben
D   Teilloeschung
K   Kommentieren
B   Beantworten
C   Echt gut (genauer: Userflag 1, Name frei konfigurierbar)
M   Echt Mist (genauer: Userflag 2, Name frei konfigurierbar)

G, X und F muessen, sofern vorhanden, am Anfang stehen.

*/

LOCAL _VOID CheckFlag(_UBYTE ch, MSGBITS bit, MSGBITS *bits)
{
	if (ch == ucase(ch))
		*bits |= bit;
	else
		*bits &= ~bit;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CheckFlagLine(CONST _UBYTE *str, MSGBITS *bitWhishes, _BOOL filteredAreRead)
{
	while (*str >= ' ') /* ??? */
	{
		switch (ucase(*str))
		{
			case 'B': CheckFlag(*str, bAntworten, bitWhishes); break;
			case 'C': CheckFlag(*str, bUser1, bitWhishes); break;
			case 'D': CheckFlag(*str, bTeilloeschung, bitWhishes); break;
			case 'F': CheckFlag(*str, bInteressant, bitWhishes); break;
			case 'G': CheckFlag(*str, bGelesen, bitWhishes); break;
			case 'K': CheckFlag(*str, bKommentieren, bitWhishes); break;
			case 'L': CheckFlag(*str, bFiltered, bitWhishes); break;
			case 'M': CheckFlag(*str, bUser2, bitWhishes); break;
			case 'V': CheckFlag(*str, bVererben, bitWhishes); break;
			case 'X': CheckFlag(*str, bTotalloeschung, bitWhishes); break;
			case 'O': CheckFlag(*str, bOwnMessage, bitWhishes); break;
			case 'T': CheckFlag(*str, bComToOwnMessage, bitWhishes); break;
		}
		str++;
	}
	if ((*bitWhishes & bFiltered) && filteredAreRead)
		*bitWhishes |= bGelesen;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID AddFlagLine(_UBYTE *ziel,CONST _UBYTE *quell)							*/
/*	2 Flaglines kombinieren, wobei die 1. vorrang hat.							*/
/*	Parameter:	ziel,quell: die beiden											*/
/*	Ergebnis:	keines															*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID AddFlagLine(_UBYTE *ziel,CONST _UBYTE *quell)
{
	_UBYTE *ptr;
	while (*quell >= ' ') /* ??? */
	{
		if(!strCaseChr(ziel,*quell))
		{
			ptr=strChr(ziel,' ');
			if(ptr)
				*ptr=*quell;
		}
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID TranslateFlagline(_UBYTE *str)										*/
/*	Keine Ahnung wer die idiotische Idee hatte 2 verschiedene Bezeichnungen fr	*/
/*	die Flags einzufhren. Hier wird notfalls gewandelt							*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	4.2.03 von Dimitri Junker	DYJ 5.20v										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID TranslateFlagline(_UBYTE *str)
{
	while (*str >= ' ') /* ??? */
	{
		switch (*str)
		{
			case 'T':*str='D' ; break;
			case 't':*str='d' ; break;
			case 'I':*str='F' ; break;
			case 'i':*str='f' ; break;
			case 'L':*str='G' ; break;
			case 'l':*str='g' ; break;
			case 'F':*str='L' ; break;
			case 'f':*str='l' ; break;
			case 'X':*str='M' ; break;
			case 'x':*str='m' ; break;
			case 'D':*str='X' ; break;
			case 'd':*str='x' ; break;
		}
		str++;
	}
}
/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*--- Ausgabe ---------------------------------------------------------------*/

LOCAL _VOID HandleEvents(_VOID)
{
	_UWORD evnt, event;
	_WORD message[8];
	_UBYTE key, scan;
	_UWORD buts, kstate;
	_WORD taste, mx, my, clicks;
	_BOOL doExit;
	
	if (multiTask)
	{
		/* Hier bei MultiTasking noch eine kleiner EventMulti und ein paar
		 * Events verarbeiten
		 */
		do
		{
			evnt = evnt_multi(MU_MESAG | MU_TIMER,
				0, 0, 0,
				0, 0, 0, 0, 0,
				0, 0, 0, 0, 0,
				message,
				0, 0,
				&mx, &my, &buts, &kstate, &taste, &clicks);
			/* Den Timerevent brauchen wir nicht */
			event = evnt;
			event &= ~MU_TIMER;
			doExit = event == 0;
			scan = (taste >> 8) & 0xff;
			key = taste & 0xff;
			WdwManager_HandleEvent(&evnt, message, buts, kstate, key, scan, taste, mx, my, clicks);
		} while (!doExit);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Look, if the deflector-shields of CAT are hard enough to deflect incoming
 * enemy message
 */
LOCAL _BOOL DeflectorShieldsStrongEnough(PtrRecord *mess, MSGBITS *bitWhishes, _BOOL filteredAreRead)
{
	watchType DogsOpinion;
	
	if (mess->msgType != msg_normal)
		return FALSE;
	/* user-aided external deflector-shield */
	/* phasers locked on target */
	if (mess->pGruppe != NULL)
		--mess->pGruppe;		/* Freundlichkeit fuer WatchDog */
	if (mess->pWegen != NULL)
		--mess->pWegen;			/* Freundlichkeit fuer WatchDog */
	if (mess->pVon != NULL)
		--mess->pVon;			/* Freundlichkeit fuer WatchDog */
	if (multiTask)
		Wind_Update(BEG_UPDATE);
	DogsOpinion = WatchDog_AcceptThis(mess);
	if (multiTask)
		Wind_Update(END_UPDATE);
	if (DogsOpinion == pCatForget || DogsOpinion == pCatFiltered)
	{
		CatLog_WriteStringNTime("Nachricht ");
		CatLog_WriteString(mess->pId);
		if (DogsOpinion == pCatForget)
		{
			CatLog_WriteLine(" von WatchDog abgelehnt.");
			TRACE((EO_TRACE, "Nachricht %s von WatchDog abgelehnt.", mess->pId));
			/* Scotty, energy */
			return TRUE; /* user-aided deflection succeded */
		} else /* if (DogsOpinion == Protokoll.pCatFiltered) */
		{
			CatLog_WriteLine(" vom WatchDog als gefiltert markiert");
			TRACE((EO_TRACE, "Nachricht %s von WatchDog als gefiltert markiert.", mess->pId));
			*bitWhishes |= bFiltered;
			if (filteredAreRead)
				*bitWhishes |= bGelesen;
		}
	}
	if (mess->pGruppe != NULL)
		++mess->pGruppe;		/* Freundlichkeit fuer CAT */
	if (mess->pWegen  != NULL)
		++mess->pWegen;			/* Freundlichkeit fuer CAT */
	if (mess->pVon    != NULL)
		++mess->pVon;			/* Freundlichkeit fuer CAT */
	return FALSE;
	/* enemy Message entering .. */
}

/*** ---------------------------------------------------------------------- ***/

/*
 * start : Startbyte der Zeile, next : Startbyte der naechsten Zeile
 * In den gepufferten Text an passender Stelle ein Nullbyte schreiben
 */
LOCAL _VOID AppendZero(_UBYTE _HUGE *oPtr, _ULONG start, _ULONG next)
{
	if (next >= start + 2)
	{
		oPtr[next - 2] = '\0';
		/* Dort sollte das CR stehen, wenn nicht ist etwas schiefgelaufen  */
	} else
	{
		oPtr[start] = '\0';
		/* Dann muss man wohl von einer leeren Zeile ausgehen               */
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Stellt fest, ob es sich bei der uebergebenen Msg um eine
 * kopierte oder weitergegebene Msg handelt.
 */
LOCAL _BOOL checkCopy(CONST _UBYTE *ptr)
{
	if (strnCmp(ptr, "Kopiert von", 11) == 0)
		return TRUE;
	if (strnCmp(ptr, "Weitergegeben von", 17) == 0)
		return TRUE;
	return FALSE;
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID FWS_2_1SP(_UBYTE *str)												*/
/*	Ersetzt 'folding white spaces' durch ein Leerzeichen						*/
/*	Parameter:	str:	der anzupassende String									*/
/*	Ergebnis:	keines															*/		
/*	31.8.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
_VOID FWS_2_1SP(_UBYTE *str)
{
	_UBYTE *q,*z;
	
	for(z=q=str;*q;q++)
	{
		if(*q==' ' || *q=='\t')
		{
			if(q[1]!=' '&&q[1]!='\t')
				*(z++)=' ';
		}
		else
			*(z++)=*q;
	}
	*z='\0';
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD	parse_Zeitzone(_UBYTE *zeitzone)									*/
/*	Versucht die Zeitzone zu erkennen, entweder an ihrem Namen (UTC,MEZ,EST,...)*/
/*	oder an der Form +0100 u..													*/
/*	Parameter:	zeitzone:	die Zeitzone als Text								*/
/*	Ergebnis:	die Zeitzone als Differenz zu UTC in Minuten					*/		
/*	25.11.01 von Dimitri Junker	DYJ 5.00a										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
LOCAL _WORD	parse_Zeitzone(_UBYTE *zeitzone)
{
	_WORD	stunden=0,minuten=TZ_LOCALTIME;
	strUpr(zeitzone);
	if(*zeitzone && strCmp(zeitzone,"-0000"))
	{
		switch(zeitzone[2])
		{
			case 'T':
				switch(zeitzone[1])
				{
					case 'D':
						stunden=1;
					case 'S':
						switch(zeitzone[0])
						{
							case 'E':	/*EDT und EST*/
								minuten=-300+60*stunden;
								break;
							case 'C':	/*CDT und CST*/
								minuten=-360+60*stunden;
								break;
							case 'M':	/*MDT und MST*/
								minuten=-420+60*stunden;
								break;
							case 'P':	/*PDT und PST*/
								minuten=-300+60*stunden;
								break;
						}
						break;
					case 'E':	/* CET*/
						if(zeitzone[0]=='C')
							minuten=60;
						break;
					case 'M':	/*GMT*/
						if(zeitzone[0]=='G')
							minuten=0;
						break;
				}
				break;
			case 'S':	/*MESZ*/
				if(zeitzone[3]!='Z')
					break;
				stunden=1;
			case 'Z':	/*MEZ*/
				if( zeitzone[0]=='M' && zeitzone[1]=='E')
					minuten=60+60*stunden;
				break;
			case 'C':	/*UTC*/
				if( zeitzone[0]=='U' && zeitzone[1]=='T')
					minuten=0;
		}
		if(minuten!=TZ_LOCALTIME)
		{
			if(sscanf(zeitzone,"%3d%2d",&stunden,&minuten)==2)
			{
				if(stunden<0)
					minuten*=-1;
				minuten+=stunden*60;
			}
			else
				minuten=TZ_LOCALTIME;
		}
	}
	return minuten;
}

/*** ------------------------------------------------------------------------ ***/
/*	_BOOL parseNewElem(_UBYTE *nameAdr,_UBYTE *bodyAdr,PtrRecord *toData)		*/
/*	Analysiert Headerzeilen die nicht zum eigentl. Maus-Outfile Header gehren.	*/
/*	Sie kommen also in IN-Headern vor, knnen aber auch in Maus-Headern in den	*/
/*	'>'-Zeilen stehen.															*/
/*	Parameter:	nameAdr:	Feldname											*/
/*				bodyAdr:	Wert												*/
/*				toData:		Zieldatenstruktur									*/
/*	Ergebnis:	ausgewertet?													*/		
/*	14.12.01 von Dimitri Junker	DYJ 4.30zr										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.00a */	/*DYJ 5.20w */
LOCAL _BOOL parseNewElem(_UBYTE *nameAdr,_UBYTE *bodyAdr,PtrRecord *toData)
{
	_BOOL done=FALSE;
	_UBYTE _HUGE *tmpAdr;
	struct tm zeit;
	_UBYTE monat[4]="   ",month_names[]      =       "JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC";

	switch (*nameAdr)
	{
	case 'C':
		if(!strCmp(nameAdr,"CC"))
		{
			toData->pCc = bodyAdr;
			toData->whatsThere |= bCc;
			done=TRUE;
		}
		break;
	case 'R':
		if(!strCmp(nameAdr,"REFERENCES"))
		{
			toData->pRef = bodyAdr;
			toData->whatsThere |= bRef;
			done=TRUE;
			if((toData->whatsThere&bRefNr) ==0)
			{
				tmpAdr=strrChr(bodyAdr,'<');
				if(tmpAdr)
				{
					toData->pRefNr=tmpAdr+1;
					toData->whatsThere |= bRefNr;
				}
			}
		}
		else if(!strnCmp(nameAdr,"RESENT-",7))
		{
			bodyAdr=nameAdr+7;
			tmpAdr=strChr(bodyAdr,'\0');
			*tmpAdr=':';
			nameAdr[6]='\0';
			Mime_AddToMultLines(&toData->mResent,bodyAdr,toData->whatsThereM&bmResent);
			toData->whatsThereM |= bmResent;
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"RETURN-PATH"))
		{
			toData->pRetPath = bodyAdr;
			toData->whatsThere |= bRetPath;
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"RECEIVED"))
		{
			Mime_AddToMultLines(&toData->mReceived,bodyAdr,toData->whatsThereM&bmReceived);
			toData->whatsThereM |= bmReceived;
			done=TRUE;
		}
		break;
	case 'B':
		if(!strCmp(nameAdr,"BCC"))
		{
			toData->pBcc = bodyAdr;
			toData->whatsThere |= bBcc;
			done=TRUE;
		}
		break;
	case 'K':
		if(!strCmp(nameAdr,"KEYWORDS"))
		{
			Mime_AddToMultLines(&toData->mKeyW,bodyAdr,toData->whatsThereM&bmKeyW);
			toData->whatsThereM |= bmKeyW;
			done=TRUE;
		}
		break;
	case 'P':
		if(!strCmp(nameAdr,"PATH"))
		{
			toData->pPath = bodyAdr;
			toData->whatsThere |= bPath;
			done=TRUE;
		}
		break;
	case 'X':
		if(!strCmp(nameAdr,"X-MAILER") || !strCmp(nameAdr,"X-NEWSREADER"))
		{
			toData->pMailer = bodyAdr;
			toData->whatsThere |= bMailer;
			done=TRUE;
		}
		break;
	case 'T':
		if(!strCmp(nameAdr,"TRACE"))
		{
			Mime_AddToMultLines(&toData->mTrace,bodyAdr,toData->whatsThereM&bmTrace);
			toData->whatsThereM |= bmTrace;
			done=TRUE;
		}
		break;
	case 'D':
		if(!strCmp(nameAdr,"DATE"))		/*Date: Tue, 21 Aug 2001 01:11:50 GMT*/
		{
			_UBYTE zeitzone[10];
			tmpAdr=strChr(bodyAdr,',');		/* Evtl. Wochentag vor Komma berspringen*/
			if(tmpAdr)
				tmpAdr++;
			else
				tmpAdr=bodyAdr;
			FWS_2_1SP(tmpAdr);
			sscanf(tmpAdr,"%d %3c %d %d:%d:%d %6s",&zeit.tm_mday,monat,&zeit.tm_year,&zeit.tm_hour,&zeit.tm_min,&zeit.tm_sec,zeitzone);
			strUpr(monat);
			tmpAdr=strStr(month_names,monat);
			if(tmpAdr)
				zeit.tm_mon=(_WORD)((_LONG)tmpAdr-(_LONG)month_names)/4;
			else
			{
				CatLog_WriteStringNTime("*Unbekannter Monat:* ");
				CatLog_WriteLine(monat);
				TRACE((EO_DEBUG, "Unbekannter Monat: %s", monat));
			}
			if(zeit.tm_year<50)			/* 20xx	*/
				zeit.tm_year+=100;
			else if(zeit.tm_year>999)	/* xxxx	*/	/* laut RFC2822 obs-year: y=50-999 ->y+=1900*/
				zeit.tm_year-=1900;
			strftime(nameAdr,15,"%Y%m%d%H%M",&zeit);
			toData->pEZeit = nameAdr;
			toData->whatsThere |= bEZeit;
			{
				_WORD	minuten;
				_UBYTE *ezeitX,*ptr;
				ezeitX=strChr(nameAdr,'\0')+1;
				strftime(ezeitX,10,"%Y %S",&zeit);
				minuten=parse_Zeitzone(zeitzone);
				if(minuten!=TZ_LOCALTIME)
				{
					ptr=strChr(nameAdr,'\0');
					sprintf(ptr," %d",minuten);
				}
				toData->pEZeitX = ezeitX;
				toData->whatsThere |= bEZeitX;
			}
			done=TRUE;
		}
		break;
	}
	return done;
}
/*** ------------------------------------------------------------------------ ***/
/*	VOID chkMlServer(_UBYTE *gruppe,_UBYTE *mailingList)					*/
/*	Prft ob die Gruppe eine Pseudo-OM Gruppe ist und bereits ein F'up hat		*/
/*	ggf wird es zu dem in der Mailing-List-Zeile des Header bergbene Adresse	*/
/*	gesetzt.																	*/
/*	Parameter:	gruppe:	Gruppenname												*/
/*				mailingList: Headerzeile, sieht z.B. so aus:					*/
/*	Mailing-List: list news_hapla@yahoogroups.de; contact news_hapla-owner@yahoogroups.de*/
/*	Ergebnis:	keines															*/		
/*	1.3.04 von Dimitri Junker	DYJ 5.34d										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID chkMlServer(_UBYTE *gruppe,_UBYTE *mailingList)
{
	CAT_GROUP_NUMBER z;
	if (GroupSelect_GroupNumber(gruppe, &z))
	{
		group_line line;
		if(!GroupSelect_isPseudoOM(z))
			GroupSelect_setPseudo(z,FALSE);
		if(!GroupSelect_GetFollowUp(gruppe,line))
		{
			CONST _UBYTE *cPtr;
			cPtr=strCaseStr(mailingList,"list ");
			if(cPtr && cPtr[-1]<=' ')
			{
				_UBYTE *ptr;
				cPtr=strChr(cPtr+1,' ');
				cPtr+=strSpn(cPtr," ");
				strCpy(line,cPtr);
				ptr=strChr(line,';');
				if(ptr)
					*ptr='\0';
/*DYJ 5.35c Start*/
				GroupSelect_SetGrpParN(gruppe,line,LS_FOLLOWUP_LINE);
/*DYJ  Ende; alt:	
				GroupSelect_SetFollowUpN(gruppe,line);
*/
			}
			cPtr=strCaseStr(mailingList,"contact ");
			if(cPtr && cPtr[-1]<=' ')
			{
				_UBYTE *ptr;
				cPtr=strChr(cPtr+1,' ');
				cPtr+=strSpn(cPtr," ");
				strCpy(line,cPtr);
				ptr=strChr(line,';');
				if(ptr)
					*ptr='\0';
/*DYJ 5.35c Start*/
				GroupSelect_SetGrpParN(gruppe,line,LS_CHEF_LINE);
/*DYJ  Ende; alt:	
				GroupSelect_SetChefN(gruppe,line);
*/
			}
		}
	}
	
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL analHeaderZeileMaus(PtrRecord *toData,_UBYTE *bodyAdr)				*/
/*	Analysiert eine Header-Zeile aus der Maus, war frher Teil von 				*/
/*	readHeaderMaus, mute aber zur analyse der xLines raus.						*/
/*	Parameter:	toData:	Ziel der Daten											*/
/*				bodyAdr: 2.Zeichen der Zeile									*/
/*	Ergebnis:	isCopy															*/		
/*	25.7.02 von Dimitri Junker	DYJ 4.41f										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19b */	/*DYJ 5.20w */
LOCAL _BOOL analHeaderZeileMaus(PtrRecord *toData,_UBYTE  *bodyAdr,_LONG filter)
{
	_WORD multiType;
	_BOOL isCopy=FALSE;			/* Gibt an, ob es sich bei der bearbeiteten Msg */
							/* um eine Kopie handelt. Dann wird der Header  */
							/* naemlich doch mit in die Message gepackt     */
	if(filter!=FILTER_NONE &&(strStr(bodyAdr,"=?")==NULL || strStr(bodyAdr,"?=")==NULL))
		Mime_WandleIso(bodyAdr,bodyAdr, strLen(bodyAdr),filter,QUOTE_PR_NONE);
	switch (bodyAdr[-1])
	{
	case '-':
		if(strCmp(bodyAdr,toData->pId))
		{
			toData->pRefNr = bodyAdr;
			toData->whatsThere |= bRefNr;
		}
		break;
		
	case 'A':
		toData->pAn = bodyAdr;
		toData->whatsThere |= bAn;
		break;

	case 'B':
		toData->pBSZeit = bodyAdr;
		toData->whatsThere |= bBSZeit;
		break;
	
/*DYJ 5.35h Start auerdem die restlichen case alphabetisch geordnet*/
	case 'C':
/*DYJ 5.36i Start*/
		CatLog_WriteLineNTime("*Zeichensatzwandlung abgestellt:* ");
		CatLog_WriteLineNTime("*Bitte in Tausch/(Maus)Tauschkommandos reaktivieren* ");
		TRACE((EO_DEBUG, "Zeichensatzwandlung abgestellt"));
 /*DYJ  Ende; alt:
	{
		_UBYTE ctyp[200]="Content-Type: charset=\"";
		strCat(ctyp,bodyAdr);
		strCat(ctyp,"\"");
		Mime_AddToMultLines(&toData->mMime,ctyp,toData->prFlags&fmMime);	
		toData->prFlags |= fmMime;
		break;
	}
*/
/*DYJ  Ende; */
	case 'D':
		toData->pDistribution = bodyAdr;
		toData->whatsThere |= bDistribution;
		break;
	case 'E':
		toData->pEZeit = bodyAdr;
		toData->whatsThere |= bEZeit;
		break;
	case 'F':
		toData->pFollowupTo = bodyAdr;
		toData->whatsThere |= bFollowupTo;
		break;
	case 'G':
	{
/*DYJ 5.34d Start*/
		if((toData->prFlags&fMailingList) !=0)
		{
			chkMlServer(bodyAdr,toData->pGruppe);
			toData->prFlags^=fMailingList;
		}
/*DYJ  Ende; */
		toData->pGruppe = bodyAdr;
		toData->whatsThere |= bGruppe;
		break;
	}		
	case 'I':
		toData->pMId = bodyAdr;
		toData->whatsThere |= bMId;
		break;
	
	case 'M':
/*DYJ 5.35h Start*/
		Mime_AddToMultLines(&toData->mMime,bodyAdr,toData->prFlags&fmMime);
		toData->prFlags |= fmMime;
		multiType=Mime_multiType(toData->pMime);
		if(multiType>-1)
			toData->prFlags |= multiType;
/*DYJ  Ende; alt:	
		toData->pMime = bodyAdr;
		multiType=Mime_multiType(toData->pMime);
		if(multiType>-1)
			toData->prFlags |= multiType;	/*DYJ 5.34g */
		else
			toData->whatsThere |= bMime;
*/
		
		break;
	case 'N':
		toData->pName = bodyAdr;
		toData->whatsThere |= bName;
		break;
	
	case 'O':
		toData->pBox = bodyAdr;
		toData->whatsThere |= bBox;
		break;
		
	case 'R':
		toData->pRId = bodyAdr;
		toData->whatsThere |= bRId;
		break;
	case 'S':
		toData->pSender = bodyAdr;
		toData->whatsThere |= bSender;
		break;
	case 'T':
		toData->pReplyTo = bodyAdr;
		toData->whatsThere |= bReplyTo;
		break;
	case 'V':
		toData->pVon = bodyAdr;
		toData->whatsThere |= bVon;
		break;
		
	case 'W':
		toData->pWegen = bodyAdr;
		toData->whatsThere |= bWegen;
		break;
	case 'Y':
		toData->pGate = bodyAdr;
		toData->whatsThere |= bGate;
		break;

	case '>':
		isCopy = checkCopy(bodyAdr);
		if (!isCopy)
		{
			_UBYTE _HUGE *p;
			p = bodyAdr;
			while (*p && *p != LF && *p!=':')
			{
				*p=ucase(*p);
				p++;
			}
			bodyAdr[strcSpn(bodyAdr," \t")]='\0';
			if(*p==':')
			{
				*p='\0';
				p++;
				p+=strSpn(p," \t");
				parseNewElem(bodyAdr,p,toData);
			}
		}
		break;
		
/*DYJ 5.32b Start*/
	case 's':
		if(toData->prFlags&fFlags)	/* Das alte von PM-Filter*/	/*DYJ 5.34g */
			AddFlagLine(toData->pFlags,bodyAdr);
		else
		{
			toData->pFlags=bodyAdr;
			toData->prFlags|=fFlags;	/*DYJ 5.34g */
		}
		break;
	case '':
		TranslateFlagline(bodyAdr);
		toData->pFlags=bodyAdr;
		toData->prFlags|=fFlags;	/*DYJ 5.34g */
		break;
/*DYJ  Ende; alt:	
	case 's':
		toData->pFlags=bodyAdr;
		toData->prFlags |=fFlags;	/*DYJ 5.34g */
		break;
*/
	case '*':
		/* Nachrichtentyp */
			toData->prFlags|= fType;	/*DYJ 5.34g */
			switch (bodyAdr[0])
			{
				case 'A': toData->msgType = msg_normal; break;
				case 'P': toData->msgType = msg_personal; break;
				case 'S': toData->msgType = msg_status; break;
				default: toData->prFlags &=~ fType; break;	/*DYJ 5.34g */
			}
		break;
	
	default:		/* Sonst nichts machen */
		CatLog_WriteStringNTime("*Unbekannte Zeilen-ID:* ");
		CatLog_WriteLine(bodyAdr - 1);
		TRACE((EO_DEBUG, "Unbekannte Zeilen-ID: %s", bodyAdr - 1));
		break;
	}
	return isCopy;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID readHeaderMaus(outfileInfo *outfile,PtrRecord *toData,_ULONG *count,MSGBITS *bitWhishes)	*/
/* 	Header abarbeiten, war ursprnglich Teil von:WriteOneMsg					*/
/*	Parameter:	outfile:	hier lesen											*/
/*				toData:		und hier das gelesene eintragen						*/
/*				count:		Leseposition										*/
/*				bitWhishes:	Bits die gesetzt werden sollen						*/
/*	Ergebnis:	keines															*/		
/*	27.8.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19b */
LOCAL _VOID readHeaderMaus(outfileInfo *outfile,PtrRecord *toData,_ULONG *count,MSGBITS *bitWhishes)
{	
	_ULONG old;
	_UBYTE _HUGE *tmpAdr;
	VERK_BLK *xLines;
	_LONG filter=FILTER_NONE;
	if(UserBLK.isInternet && outfile->charset==ZS_ATARI)
		filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],FALSE);
	else if (!UserBLK.isInternet && outfile->charset==ISO8859_1)
		filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],TRUE);
	toData->msgType=msg_normal;
	xLines=toData->tmpMem;
	while(xLines)
	{
		if(analHeaderZeileMaus(toData,&(xLines->data)+1,filter))
			TRACE((EO_DEBUG, ">-Zeile in xLines"));
		xLines=xLines->nxt;
	}
	do
	{
		old = *count;
		CheckMemLine(count, outfile->oPtr, outfile->oAnz);
		AppendZero(outfile->oPtr, old, *count);
		/* die folgende Adresse nur einmal berechnen, spart Code */
		tmpAdr = &outfile->oPtr[old+1];
		if(analHeaderZeileMaus(toData,tmpAdr,filter))
		{
			*count = old;
			break;
		}
	}while (outfile->oPtr[*count] != ':' && outfile->oPtr[*count] != '#');
	if(toData->prFlags&fFlags)	/*DYJ 5.34g */
		CheckFlagLine(toData->pFlags, bitWhishes, outfile->filteredAreRead);
	/* Beginn des Headers, der Message oder Ende */

	if(UserBLK.isInternet && (toData->whatsThere&bWegen)==0)
	{
		toData->pWegen = outfile->oPtr+(*count);	/*wird ja wohl irgendwo eine 0 kommen*/
		while(toData->pWegen[0])
			toData->pWegen--;
		toData->whatsThere |= bWegen;
	}
	if((toData->whatsThere&bVon)!=0)
	{
		if (strCmp(toData->pVon, outfile->ownName) == 0)
		{
			*bitWhishes |= bOwnMessage;
		} else
		{
			if (strnCaseCmp(toData->pVon, cSysop, sizeof(cSysop)-1) == 0)
			{
				/* Test auf eigene Nachricht als Sysop */
				if (strCmp(toData->pVon + sizeof(cSysop) - 1, outfile->ownName) == 0)
				{
					*bitWhishes |= bOwnMessage;
				}
			}
			else if((toData->whatsThere&(bGruppe|bAn|bVon))==(bGruppe|bVon))	/* Bei PMs gibts bessere Methoden*/
			{
				if (adr_exist(ADR_ALIAS,toData->pVon))
					*bitWhishes |= bOwnMessage;
			}
		}
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *klammerInhalt(_UBYTE *str,_UBYTE klammern[2])						*/
/*	Gibt den Inhalt eines Klammerpaares zurck, dabei wird der bergebene String*/
/*	verndert, nmlich die schlieende Klammer durch \0 ersetzt					*/
/*	Parameter:	str:	Der String in dem die Klammern sein sollen				*/
/*				klammern:ffnende und schlieende Klammer also z.B. "()"		*/
/*	Ergebnis:	Pointer auf das Zeichen hinter der ffnenden Klammer oder NULL	*/		
/*	1.9.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
_UBYTE *klammerInhalt(_UBYTE *str,_UBYTE klammern[2])
{
	_UBYTE *ret,*ende;
	ret=strChr(str,klammern[0]);
	if(ret)
	{
		ret++;
		ende=strChr(ret,klammern[1]);
		if(ende)
			*ende='\0';
		else
			ret=NULL;
	}
	return ret;
}

/*** ------------------------------------------------------------------------ ***/
/*	_BOOL analHeaderZeileIN(PtrRecord *toData,_UBYTE _HUGE *nameAdr,_UBYTE _HUGE *bodyAdr,_LONG filter,_BOOL isPM)	*/
/*	Analysiert eine NNTP/POP3 Header-Zeile, war frher Teil von 				*/
/*	readHeaderIN, mute aber zur Analyse der xLines raus.						*/
/*	Parameter:	toData:	Ziel der Daten											*/
/*				nameAdr: Hier steht das Schlsselwort							*/
/*				bodyAdr: und hier der zugehrige Wert							*/
/*				filter:	 Zeichensatzfilter falls nicht MimeEncodedWord			*/
/*				isPM:	was wohl?												*/
/*	Ergebnis:	Ende des Headers?												*/		
/*	25.7.02 von Dimitri Junker	DYJ 4.41f										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19b */	/*DYJ 5.20w */	/*DYJ 5.32i */	/*DYJ 5.20v */
LOCAL _BOOL analHeaderZeileIN(PtrRecord *toData,_UBYTE _HUGE *nameAdr,_UBYTE _HUGE *bodyAdr,_LONG filter,_BOOL isPM)
/*DYJ  Ende; alt:	
LOCAL _BOOL analHeaderZeileIN(PtrRecord *toData,_UBYTE _HUGE *nameAdr,_UBYTE _HUGE *bodyAdr,_LONG filter)
*/
{
	_BOOL done=FALSE,headEnd=FALSE;
	if(filter!=FILTER_NONE &&(strStr(bodyAdr,"=?")==NULL || strStr(bodyAdr,"?=")==NULL))
		Mime_WandleIso(bodyAdr,bodyAdr, strLen(bodyAdr),filter,QUOTE_PR_NONE);

	switch (*nameAdr)
	{
	case 'C':
		if(!strCmp(nameAdr,"CONTENT-TYPE"))
		{
			_WORD multiType;
			multiType=Mime_multiType(bodyAdr);
/*DYJ 5.33b Start*/
			if(multiType==-2 &&UserBLK.MimeTextMode )
			{
				if((UserBLK.MimeTextMode==1 && strCaseStr(bodyAdr,"text/")==NULL)||
				   (UserBLK.MimeTextMode==2 && strCaseStr(bodyAdr,"text/plain")==NULL))
					multiType=fMultipart1;
			}
/*DYJ  Ende; */
			if(multiType>-1)
			{
				toData->prFlags |= multiType;	/*DYJ 5.34g */
				toData->pMime =nameAdr;
			}
			else
			{
				Mime_AddToMultLines(&toData->mMime,nameAdr,toData->prFlags&fmMime);	/*DYJ 5.34g */
				toData->prFlags |= fmMime;	/*DYJ 5.34g */
			}
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"CONTENT-TRANSFER-ENCODING"))
		{
			Mime_AddToMultLines(&toData->mMime,nameAdr,toData->prFlags&fmMime);	/*DYJ 5.34g */
			toData->prFlags |= fmMime;	/*DYJ 5.34g */
			done=TRUE;
		}
		break;
	case 'D':
		if(!strCmp(nameAdr,"DISTRIBUTION"))
		{
			if(strLen(bodyAdr)<8)
			{
				_UBYTE _HUGE distr[10];
				strCpy(distr,bodyAdr);
				strUpr(distr);
				if(strStr("GLOBAL WORLD INET",distr))
				{
					strCpy(bodyAdr,"N");
					toData->pDistribution = bodyAdr;
					toData->whatsThere |= bDistribution;
					done=TRUE;
				}
			}
		}
/*DYJ 5.32i Start*/
		else if(isPM && !strCmp(nameAdr,"DELIVERED-TO") && (toData->whatsThere&bAn)==0)
		{
			toData->pAn = bodyAdr;
			toData->whatsThere |= bAn;
		}
/*DYJ  Ende; */
		break;
	case 'E':
		if(!strCmp(nameAdr,"ENVELOPE-TO") && (toData->whatsThere&bAn)==0)
		{
			toData->pAn = bodyAdr;
			toData->whatsThere |= bAn;
		}
		break;
	case 'F':
		if(!strCmp(nameAdr,"FROM"))
		{
			_UBYTE _HUGE *tmpAdr;
			if(*bodyAdr=='\"')												/* "Name" <Emailadresse>	*/
			{
				toData->pVon = klammerInhalt(bodyAdr,"<>");
				toData->pName = klammerInhalt(bodyAdr,"\"\"");
				toData->whatsThere |= bVon|bName;
			}else if((toData->pName = klammerInhalt(bodyAdr,"()"))!=NULL)	/* Emailadresse (Name)	*/
			{
				tmpAdr=toData->pName-2;
				while(*tmpAdr==' ')
					tmpAdr--;
				tmpAdr[1]='\0';
				toData->pVon =bodyAdr;
				toData->whatsThere |= bVon|bName;
			}else if((toData->pVon = klammerInhalt(bodyAdr,"<>"))!=NULL)	/* Name <Emailadresse>	*/
			{
/*DYJ 5.30d Start*/
				if(((_LONG)(toData->pVon) -(_LONG)bodyAdr)>1)
				{
					tmpAdr=toData->pVon-2;
					while(*tmpAdr==' ')
						tmpAdr--;
					tmpAdr[1]='\0';
					toData->pName =bodyAdr;
					toData->whatsThere |= bVon|bName;
				}
				else
					toData->whatsThere |= bVon;
/*DYJ  Ende; alt:	
				tmpAdr=toData->pVon-2;
				while(*tmpAdr==' ')
					tmpAdr--;
				tmpAdr[1]='\0';
				toData->pName =bodyAdr;
				toData->whatsThere |= bVon|bName;
*/
			}else															/* Nur Emailadresse	*/
			{
				toData->pVon =bodyAdr;
				toData->whatsThere |= bVon;
			}				
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"FOLLOWUP-TO"))
		{
			toData->pFollowupTo = bodyAdr;
			toData->whatsThere |= bFollowupTo;
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"FLAGZEILE"))	/*CAT-Spez*/
		{
			if(toData->prFlags&fFlags)	/* Das alte von PM-Filter*/	/*DYJ 5.34g */
				AddFlagLine(toData->pFlags,bodyAdr);
			else
			{
				toData->pFlags=bodyAdr;
				toData->prFlags|=fFlags;	/*DYJ 5.34g */
			}
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"FLAGZEILEPMF"))	/*CAT-Spez*/
		{
			TranslateFlagline(bodyAdr);
			toData->pFlags=bodyAdr;
			toData->prFlags|=fFlags;	/*DYJ 5.34g */
			done=TRUE;
		}
		break;
	case 'I':
		if(!strCmp(nameAdr,"IN-REPLY-TO"))
		{
			_UBYTE *tmp=toData->pRefNr;	/*DYJ 5.34k */
			toData->pRefNr = klammerInhalt(bodyAdr,"<>");
			if(toData->pRefNr)
			{
				toData->whatsThere |= bRefNr;
				done=TRUE;
			}
			else
				toData->pRefNr=tmp;	/*DYJ 5.34k */
		}
		else if(!strCmp(nameAdr,"ICATGROUP") || !strCmp(nameAdr,"ICATPM"))	/*CAT-Spez*/
			done=TRUE;							/*Ist schon in HandleINMessage ausgewertet worden*/
		else if(!strCmp(nameAdr,"ICATPMGROUP"))		/*CAT-Spez*/
		{
			strdelRightSpace(bodyAdr);
/*DYJ 5.34d Start*/
			if((toData->prFlags&fMailingList) !=0)
			{
				chkMlServer(bodyAdr,toData->pGruppe);
				toData->prFlags^=fMailingList;
			}
/*DYJ  Ende; */
			toData->pGruppe = bodyAdr;
			toData->whatsThere |= bGruppe;
			done=TRUE;
		}
		break;
	case 'M':
		if(!strCmp(nameAdr,"MESSAGE-ID"))
		{
			toData->pId = klammerInhalt(bodyAdr,"<>");
			if(toData->pId)
			{
				toData->whatsThere |= bId;
				done=TRUE;
			}
		}
		else if(!strCmp(nameAdr,"MIME-VERSION"))
		{
			Mime_AddToMultLines(&toData->mMime,nameAdr+5,toData->prFlags&fmMime);	/*DYJ 5.34g */
			toData->prFlags |= fmMime;	/*DYJ 5.34g */
			done=TRUE;
		}
/*DYJ 5.34d Start*/
		else if(!strCmp(nameAdr,"MAILING-LIST"))
		{
			if((toData->whatsThere &bGruppe) ==0)
			{
				toData->pGruppe = bodyAdr;		/*Nur zum Zwischenspeichern*/
				toData->prFlags|=fMailingList;
			}
			else
				chkMlServer(toData->pGruppe,bodyAdr);
		}
/*DYJ  Ende; */
		break;
	case 'N':
		if(!strCmp(nameAdr,"NEWSGROUPS"))
		{
/*DYJ 5.34d Start*/
			if((toData->prFlags&fMailingList) !=0)
			{
				chkMlServer(bodyAdr,toData->pGruppe);
				toData->prFlags^=fMailingList;
			}
/*DYJ  Ende; */
			toData->pGruppe = bodyAdr;
			toData->whatsThere |= bGruppe;
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"NNTP-POSTING-HOST"))
		{
			toData->pGate = bodyAdr;
			toData->whatsThere |= bGate;
			done=TRUE;
		}
		break;
	case 'O':
		if(!strCmp(nameAdr,"ORGANIZATION"))
		{
			toData->pBox = bodyAdr;
			toData->whatsThere |= bBox;
			done=TRUE;
		}
		break;
	case 'R':
		if(!strCmp(nameAdr,"REPLY-TO"))
		{
			toData->pReplyTo = bodyAdr;
			toData->whatsThere |= bReplyTo;
			done=TRUE;
		}
		break;
	case 'S':
		if(!strCmp(nameAdr,"SUBJECT"))
		{
			toData->pWegen = bodyAdr;
			toData->whatsThere |= bWegen;
			done=TRUE;
		}
		else if(!strCmp(nameAdr,"SENDER"))
		{
			toData->pSender = bodyAdr;
			toData->whatsThere |= bSender;
			done=TRUE;
		}
		break;
	case 'T':
		if(!strCmp(nameAdr,"TO"))
		{
			toData->pAn = bodyAdr;
			toData->whatsThere |= bAn;
			done=TRUE;
		}
		break;
	case '\n':
	case '\r':
	case '\0':
		headEnd=TRUE;
		done=TRUE;
	}

	if(!done)
		done=parseNewElem(nameAdr,bodyAdr,toData);
	if(!bodyAdr[-2])
		bodyAdr[-2]=':';
	if(!done)
	{
		Mime_AddToMultLines(&toData->mUnknown,nameAdr,toData->whatsThereM&bmUnknown);
		toData->whatsThereM |= bmUnknown;
	}
	return headEnd;
}
/*** ------------------------------------------------------------------------ ***/
/*	MSGBITS readHeaderIN(outfileInfo *outfile,PtrRecord *toData,_ULONG *count,_BOOL isPM)	*/
/*  Internet Header abarbeiten 													*/
/*	Parameter:	outfile:	hier lesen											*/
/*				toData:		und hier das gelesene eintragen						*/
/*				count:		Leseposition										*/
/*				isPM:		na was wohl											*/
/*	Ergebnis:	die MSGBITS														*/		
/*	27.8.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.16m */	/*DYJ 5.19b */
/*DYJ 5.32i Start*/
LOCAL MSGBITS readHeaderIN(outfileInfo *outfile,PtrRecord *toData,_ULONG *count,_BOOL isPM)
/*DYJ  Ende; alt:	
LOCAL MSGBITS readHeaderIN(outfileInfo *outfile,PtrRecord *toData,_ULONG *count)
*/
{	
	_ULONG old,body;
	MSGBITS bitWhishes=0;
	_UBYTE _HUGE *nameAdr,*bodyAdr;
	_BOOL isCopy=FALSE;			/* Gibt an, ob es sich bei der bearbeiteten Msg */
							/* um eine Kopie handelt. Dann wird der Header  */
							/* naemlich doch mit in die Message gepackt     */
	
	_ULONG multipartStart=0l;
	VERK_BLK *xLines;
	_LONG filter=FILTER_NONE;
	if(UserBLK.isInternet && outfile->charset==ZS_ATARI)
		filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],FALSE);
	else if (!UserBLK.isInternet && outfile->charset==ISO8859_1)
		filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],TRUE);

	xLines=toData->tmpMem;
	while(xLines)
	{
		nameAdr = &(xLines->data);
		bodyAdr = strChr(nameAdr,':');
		if(bodyAdr)
		{
			*bodyAdr='\0';
			bodyAdr++;
		}
/*DYJ 5.32i Start*/
		analHeaderZeileIN(toData,nameAdr,bodyAdr,filter,isPM);
/*DYJ  Ende; alt:	
		analHeaderZeileIN(toData,nameAdr,bodyAdr,filter);
*/
		xLines=xLines->nxt;
	}
	do
	{
		old = *count;
		CheckMemLineUnfSpl(count,&body, outfile->oPtr, outfile->oAnz);
		/* die folgende Adresse nur einmal berechnen, spart Code */
		nameAdr = &outfile->oPtr[old];
		bodyAdr = &outfile->oPtr[body];
/*DYJ 5.32i Start*/
		if(analHeaderZeileIN(toData,nameAdr,bodyAdr,filter,isPM))
/*DYJ  Ende; alt:	
		if(analHeaderZeileIN(toData,nameAdr,bodyAdr,filter))
*/
			break;
	}while (!isCopy );

	if((toData->whatsThere&bEZeit)==0)
	{
		struct tm *zeit;
		time_t clock;
		char *ptr;
		ptr=Mime_GetMem4Record(toData,30);
		if(ptr)
		{
			CatLog_WriteLineNTime("Mail ohne Datum, fge Einfgedatum ein");
			TRACE((EO_TRACE, "Mail ohne Datum, fge Einfgedatum ein"));
			clock=time(NULL);
			zeit=localtime(&clock);
			strftime(ptr,15,"%Y%m%d%H%M",zeit);
			toData->pEZeit = ptr;
			toData->whatsThere |= bEZeit;
			{
				_UBYTE *ezeitX;
				ezeitX=strChr(nameAdr,'\0')+1;
				strftime(ezeitX,10,"%Y %S",zeit);
				toData->pEZeitX = ezeitX;
				toData->whatsThere |= bEZeitX;
			}
		}
	}

	if(toData->prFlags & fMultipartMask)	/*DYJ 5.34g */
		multipartStart=toData->pMime-outfile->oPtr;
	if(toData->prFlags&fFlags)	/*DYJ 5.34g */
		CheckFlagLine(toData->pFlags, &bitWhishes, outfile->filteredAreRead);
	if(multipartStart)
		*count=multipartStart;
	if((toData->whatsThere&bWegen)==0)
	{
		toData->pWegen = outfile->oPtr+(*count);	/*wird ja wohl irgendwo eine 0 kommen*/
		while(toData->pWegen[0])
			toData->pWegen--;
		toData->whatsThere |= bWegen;
	}
	if ((toData->whatsThere&(bGruppe|bAn|bVon))==(bGruppe|bVon))	/* Bei PMs gibts bessere Methoden*/
	{
		if (adr_exist(ADR_EIGENE,toData->pVon))
			bitWhishes |= bOwnMessage;
	}
	/* Beginn des Headers, der Message oder Ende */
	if(!outfile->oPtr[*count] || outfile->oPtr[*count]=='\n')
	(*count)++;
	return bitWhishes;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.19b */	/*DYJ 5.20g */	/*DYJ 5.20t */
LOCAL _BOOL WriteOneMsg(outfileInfo *outfile, OneGroupHandle handle, _ULONG MessStart, _BOOL *isaDupe,VERK_BLK *xLines)
{
	/* Gibt eine Gruppe aus; Rueckgabewert ist, der Wert von MTDataBase     */
	_UWORD	aktMsgNr=0;	/*DYJ 5.39d */
	_ULONG count;
	_ULONG old;
	_ULONG start;
	PtrRecord toData;
	MSGBITS bitWhishes;		/* Hier werden die Flags uebergeben, die direkt */
							/* beim Einfuegen gesetzt werden sollen.        */
	
	_WORD waisenStatus;
	_BOOL comToOwn;	/* (MH) */
	_BOOL isInMsg=FALSE;
	_UBYTE _HUGE *tmpAdr;
	_UBYTE id4Hdr[256],dat4Hdr[16],Betreff[256];
	static _UBYTE lfdZ='A';
	
	bitWhishes = 0;			/* Normalerweise haetten wir gerne leere Bits */
	count = MessStart;		/* MessStart zeigt auf den ersten char nach '#'  */
	old   = count;
	start = old;			/* Fuer die Fuellstandsanzeige                   */
	
	CheckMemLine(&count, outfile->oPtr, outfile->oAnz); /* Zeile auslesen, MausNr           */
	AppendZero(outfile->oPtr, old, count);
	
	/* Alles andere muss nicht kommen und wird erstmal auf null gesetzt */
	MemSetZeroStruct(toData);
	toData.relatedFN=-1;
	
	
	toData.msgType=msg_normal;
	toData.tmpMem=xLines;
/*DYJ 5.32i Start*/
	if((!strnCmp(&outfile->oPtr[old],"PM@IN",5)))
	{
		isInMsg=TRUE;
		aktMsgNr=atoi(&outfile->oPtr[old+5]);	/*DYJ 5.39d */
		bitWhishes=readHeaderIN(outfile,&toData,&count,TRUE);
	}
	else if((!strnCmp(&outfile->oPtr[old],"OM@IN",5)))
	{
		isInMsg=TRUE;
		aktMsgNr=atoi(&outfile->oPtr[old+5]);	/*DYJ 5.39d */
		bitWhishes=readHeaderIN(outfile,&toData,&count,FALSE);
	}
/*DYJ  Ende; alt:	
	if((!strnCmp(&outfile->oPtr[old],"PM@IN",5)) ||
	   (!strnCmp(&outfile->oPtr[old],"OM@IN",5)))
	{
		isInMsg=TRUE;
		bitWhishes=readHeaderIN(outfile,&toData,&count);
	}
*/
	else
	{
		if(outfile->outfType==OM_OUTFHDR)
		{
			_UBYTE *at;
			at=strChr(&outfile->oPtr[old],'@');
			ConvertDate_MakeDate(id4Hdr,sizeof(id4Hdr)-2);
			id4Hdr[0]='C';
			id4Hdr[1]='L';
			id4Hdr[12]=lfdZ;
			id4Hdr[13]='\0';
			if(lfdZ>='Z')
				lfdZ='A';
			else
				lfdZ++;
			if(at)
				strMcat(id4Hdr,sizeof(id4Hdr),at);
			else
				strMcat(id4Hdr,sizeof(id4Hdr),"@Local");
			toData.pId =id4Hdr;
		}
		else
			toData.pId = &outfile->oPtr[old];
		toData.whatsThere = bId;
		readHeaderMaus(outfile,&toData,&count,&bitWhishes);
	}
	if (outfile->oPtr[count] != '#' ||isInMsg )		/* Dann kommt noch eine Nachricht */
	{
		
		if(outfile->outfType==OM_OUTFHDR)
		{
			_UBYTE *cmd,*akt,cmdLine[256],tmp[12];
#if SPEC_DEBUG
			_WORD res;
#endif
			_UWORD cDt, cTi;
			F_TIME t;
			toData.prFlags |=fIsHeader;	/*DYJ 5.34g */
			do
			{
				++count; /* Anfangsbuchstaben ueberspringen */
				old = count;
				CheckMemLine(&count, outfile->oPtr, outfile->oAnz);
				AppendZero(outfile->oPtr, old, count);
				/* die folgende Adresse nur einmal berechnen, spart Code */
				tmpAdr = &outfile->oPtr[old+1];
				switch (tmpAdr[-1])
				{
					case 'F':
						if(OpenTextFile(tmpAdr,NULL,READ,datFileBuffer,&toData.txt))
							toData.prFlags |= fTextDatei;	/*DYJ 5.34g */
						toData.pDelDatei = tmpAdr;
						Messages_FileSize(tmpAdr, NULL, &cDt, &cTi);
						if((toData.whatsThere & bEZeit)==0)
						{
							toData.pEZeit = dat4Hdr;
							toData.whatsThere |= bEZeit;
							ConvertDate_MakeFreeDate(cDt, cTi, toData.pEZeit, sizeof(dat4Hdr));
						}
						if(toData.whatsThere & bWegen && strChr(toData.pWegen,'%'))
						{
							strMcpy(Betreff,sizeof(Betreff),toData.pWegen);
							toData.pWegen=Betreff;
							T_Localtime(T_DosToSystime(cDt, cTi), &t);
							ConvertDate_DateToText(&t, "DD.MM.YYYY", tmp, sizeof(tmp));
							CatGlobal_ReplaceStr(Betreff, sizeof(Betreff), "%D",tmp);
							ConvertDate_TimeToText(&t, "HH:MM", tmp, sizeof(tmp));
							CatGlobal_ReplaceStr(Betreff, sizeof(Betreff), "%T",tmp);
							CatGlobal_ReplaceStr(Betreff, sizeof(Betreff), "%%","%");
						}
	
						break;
					case 'D':
						toData.prFlags |=fDelDatei;	/*DYJ 5.34g */
						break;
					case 'R':
						cmd=tmpAdr;
						if(*cmd=='\'')	/* Falls gequotet entquoten */
						{
							akt=cmd++;
							while(*cmd &&(cmd[0]!='\'' || cmd[1]=='\''))
							{
								if(cmd[0]=='\'')
									cmd++;
								*(akt++)=*(cmd++);
							}
							*akt='\0';
							cmd++;
						}
						else
						{
							cmd=strChr(tmpAdr,' ');
							*cmd='\0';
							cmd++;
						}
						while(cmd && *cmd==' ')
							cmd++;
						buildCmdLine(cmd,cmdLine,sizeof(cmdLine),DO_QUOTE);
						SPEC_DEBUG_OUT((EO_DEBUG, "Programmstart aus outf_hdr.txt: %s %s", tmpAdr, cmdLine + 1));
#if SPEC_DEBUG
						res = ARCStarter_ExecProgram(tmpAdr, cmdLine, ARCSTART_REDRAW);
						SPEC_DEBUG_OUT((EO_DEBUG, "Returncode: %d", res));
#else
						ARCStarter_ExecProgram(tmpAdr, cmdLine, ARCSTART_REDRAW);
#endif
				}
			} while (count < outfile->oAnz &&
					outfile->oPtr[count] != '#' );
			/* bis zum Ende dieser Msg oder 16k                              */
			
		}
		else if((toData.prFlags&fMultipartMask)!=0)			/*Text wird erst beim Splitten von MultipartMime extrahiert*/	/*DYJ 5.34g */
		{
			old=count=(_ULONG)toData.pMime-(_ULONG)outfile->oPtr;
			if(isInMsg)
			{
				do
				{
					do		/* eine Zeile lesen.. */
					{
						++count;
					} while (count < outfile->oAnz &&
							outfile->oPtr[count-1] != LF &&
							outfile->oPtr[count-1] != '\0');
				} while (count < outfile->oAnz &&
						(outfile->oPtr[count-3] != '.' || outfile->oPtr[count-4] != LF));
				/* bis zum Ende dieser Msg                              */
				toData.TextMax=(mess_len)(count-old-3);
				old=count;
			}
			else
			{
				do
				{
/*DYJ 5.34e Start*/
					if(outfile->oPtr[count]==':')
						++count; /* Anfangsbuchstaben ueberspringen */
/*DYJ  Ende; alt:	
					++count; /* Anfangsbuchstaben ueberspringen */
*/
					do		/* eine Zeile lesen.. */
					{
						outfile->oPtr[old] = outfile->oPtr[count];
						++toData.TextMax;
						++count;
						++old;
					} while (count < outfile->oAnz &&
							outfile->oPtr[old-1] != LF &&
							outfile->oPtr[old-1] != '\0');
				} while (count < outfile->oAnz && (outfile->oPtr[count] != '#'));
				/* bis zum Ende dieser Msg                              */
			}
		}
		else
		{
			_BOOL zweiPkt;
			toData.pText = &outfile->oPtr[count];
			toData.prFlags |=fText;	/*DYJ 5.34g */
			old = count;
			do
			{
				zweiPkt=FALSE;
				if((!isInMsg) || ((outfile->oPtr[count]=='.')&&(outfile->oPtr[count+1]=='.')))	/* Doppelpkt bei mausmail oder verdoppelter Pkt bei Internetmail*/
				{
					zweiPkt=isInMsg;
					++count; /* Anfangsbuchstaben ueberspringen */
				}
				do		/* eine Zeile lesen.. */
				{
					outfile->oPtr[old] = outfile->oPtr[count];
					++toData.TextMax;
					++count;
					++old;
				} while (count < outfile->oAnz &&
						outfile->oPtr[old-1] != CR &&
						outfile->oPtr[old-1] != '\0');
				if (count < outfile->oAnz)
				{
					/* ..bis zum CR                                                */
					outfile->oPtr[old - 1] = LF; /* CR durch LF ersetzen                    */
					++count;         /* LF ueberspringen                         */
				}
			} while (count < outfile->oAnz &&
					((!isInMsg && outfile->oPtr[count] != '#')||
					 ( isInMsg &&(outfile->oPtr[old-2] != '.' || strChr("\n\r",outfile->oPtr[old-3])==NULL) || zweiPkt)));
			if(isInMsg)
				toData.TextMax-=2;
			/* bis zum Ende dieser Msg                              */
		}
	}
	if (count < outfile->oAnz)
	{
		showImport_SetNew(count - start);
		CatGlobal_busyMouse();
		if((toData.prFlags&fType)==0)	/*DYJ 5.34g */
/*DYJ 5.39c Start*/
			toData.msgType = data_PreCheck(&toData,handle);
/*DYJ  Ende; alt:	
			toData.msgType = data_PreCheck(&toData);
*/
		toData.prFlags|=fType;	/*DYJ 5.34g */
		if (toData.msgType == msg_status)
			++outfile->statGroup.status;
		if (toData.msgType == msg_garbage)
		{
			++outfile->statGroup.garbage;
			if(outfile->outfType==OM_OUTFHDR)
			{
				toData.prFlags^=fTextDatei;		/*Lag es 'nur' am fehlenden Textfile? */	/*DYJ 5.34g */
/*DYJ 5.39c Start*/
				if(data_PreCheck(&toData,handle)==msg_garbage)
/*DYJ  Ende; alt:	
				if(data_PreCheck(&toData)==msg_garbage)
*/
					data_dumpMess(&toData);
				else
				{
					CatLog_WriteLineNTime("Warnung im Outfile:");
					CatLog_WriteString(cSpace9Str);
					CatLog_WriteString("Einzufgendes Textfile nicht vorhanden   : ");
					CatLog_WriteLine(toData.pDelDatei);
				}
				toData.prFlags^=fTextDatei;	/*DYJ 5.34g */
				
			}
			else
				data_dumpMess(&toData);
		} else if (DeflectorShieldsStrongEnough(&toData, &bitWhishes, outfile->filteredAreRead))
		{
			++outfile->statGroup.watch;
		} else
		{
/*DYJ 5.39d Start*/
			MSGNR msgNr=data_AppendMessage(handle, bitWhishes, &toData, &waisenStatus, isaDupe, &comToOwn, &outfile->abort,outfile->charset,outfile->outfType==OM_822);
			if(msgNr!=dataSys_empty)
			{
				of2msg *o2m=SYSMALLOC(sizeof(of2msg), MEM_SHARABLE|MEM_NOERR, "WriteOneMsg: o2m");
				if(o2m)
				{
					o2m->next=outfile->o2m;
					outfile->o2m=o2m;
					o2m->msgNr=msgNr;
					o2m->gruppe=data_GetGroupNr(handle);
					o2m->outfNr=aktMsgNr;
				}
/*DYJ  Ende; alt:	
			if (data_AppendMessage(handle, bitWhishes, &toData, &waisenStatus, isaDupe, &comToOwn, &outfile->abort,outfile->charset,outfile->outfType==OM_822))
			{
*/
				switch(	waisenStatus&3)
				{
					case 1:	
						CatLog_WriteStringNTime("Neuer Waise ID: ");
						CatLog_WriteString(toData.pId);
						CatLog_WriteLine(" eingetragen");
						++outfile->NEUEWAISEN;
						break;
					case 2:	
						CatLog_WriteStringNTime("Neuer Waise ID: ");
						CatLog_WriteString(toData.pId);
						CatLog_WriteLine(" mit altem Waisen verknpft");
						++outfile->WAISEN_H;
						break;
				}
				if((waisenStatus&4)==4)
				{
					CatLog_WriteStringNTime("Alte Waisengruppe mit neuer Message ID: ");
					CatLog_WriteString(toData.pId);
					CatLog_WriteLine(" verknpft.");
					++outfile->WAISEN_V;
				}
				
				/* Eintrag in COMMENTS.DAT schreiben (MH) */
				if (comToOwn)
				{
					SPEC_DEBUG_OUT((EO_DEBUG, "Parser: comToOwn == TRUE"));
					if (outfile->writeCmts && !WiederVorlage_WriteCmts(&toData))
					{
						SPEC_DEBUG_OUT((EO_DEBUG, "Parser: !WiederVorlage_WriteCmts()"));
						outfile->writeCmtsFail = TRUE;
					}
					outfile->statTotal.cmtsToOwn++;	/* immer zaehlen */
				}
				Mime_FreeMultilines(&toData);
				return TRUE;
			} else
			{
				Mime_FreeMultilines(&toData);
				return FALSE;
			}
		}
	} else
	{
		CatLog_WriteStringNTime("*Internal error in parser, crash avoided, message possibly lost*");
		TRACE((EO_ERROR, "Internal error in parser, crash avoided, message possibly lost"));
	}
	/* Message -> data */
	Mime_FreeMultilines(&toData);
	return TRUE; /* Nicht von der Datenbank abgelehnt */
	}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID clearStats(msgStat *stat)
{
	stat->anz = 0;
	stat->not = 0;
	stat->watch = 0;
	stat->garbage = 0;
	stat->status = 0;
	stat->dupeCount = 0;
	stat->text = 0;
	stat->unknown = 0;
	stat->pmNot = 0;
	stat->pmErr = 0;		/*DYJ 5.39d */
	stat->cmtsToOwn = 0;	/* (MH) */
	stat->outBlocks = 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID addStats(msgStat *sums, msgStat *stat)
{
	sums->anz += stat->anz;
	sums->not += stat->not;
	sums->watch += stat->watch;
	sums->garbage += stat->garbage;
	sums->status += stat->status;
	sums->dupeCount += stat->dupeCount;
	sums->text += stat->text;
	sums->unknown += stat->unknown;
	sums->cmtsToOwn += stat->cmtsToOwn;	/* (MH) */
	sums->outBlocks += stat->outBlocks;
}

/*** ---------------------------------------------------------------------- ***/

/* gibt den Inhalt einer Gruppe aus */
LOCAL _BOOL WriteOneGroup(outfileInfo *outfile, CAT_GROUP_NUMBER gruppe)
{
	OneGroupHandle handle; /* Zugriffshandle fuer die Datenbank   */
	_UWORD actualElem; /* Aktueller MsgPointer im Array              */
	_UBYTE groupScrap[1024];
	_BOOL isaDupe;
	MSGNR num_mess;
	
	clearStats(&outfile->statGroup);
	actualElem = outfile->gStart[gruppe];
	if (actualElem != EndOfList)
	{
		CatLog_WriteLn();
		CatLog_WriteStringNTime(cGroupChange);
		if (gruppe == dataSys_private)
		{
			CatLog_WriteLine(cPrivate);
			TRACE((EO_DEBUG, cGroupChange cPrivate));
		} else if (gruppe < MAX_GROUP)
		{
			GroupSelect_GroupDisplayName(gruppe, groupScrap, sizeof(groupScrap));
			CatLog_WriteLine(groupScrap);
			TRACE((EO_DEBUG, "Gruppenwechsel zu %s", groupScrap));
		} else
		{
			CatLog_WriteLine("unknown");
			TRACE((EO_DEBUG, cGroupChange "unknown"));
		}
		
		if (!data_OpenOneGroup(gruppe, additional, TRUE, &handle))
		{
			CatLog_WriteLineNTime("*\231ffnen der Datenbank nicht m\224glich*");
			TRACE((EO_DEBUG, "\231ffnen der Datenbank nicht m\224glich"));
			outfile->abort = TRUE;
			return FALSE;
		}
		do
		{
			if (!WriteOneMsg(outfile, handle, outfile->gPos[actualElem].offset, &isaDupe,outfile->gPos[actualElem].xLines))
			{
				if (isaDupe)
					++outfile->statGroup.dupeCount;
				++outfile->statGroup.not;
			}
			++outfile->statGroup.anz;
			if ((outfile->statGroup.anz % (MSGNR)outfile->redrawCheck) == 0)
				HandleEvents();
			actualElem = outfile->gPos[actualElem].next;
		} while (actualElem != EndOfList && !outfile->abort);
		
		num_mess = outfile->statGroup.anz - outfile->statGroup.not - outfile->statGroup.watch - outfile->statGroup.garbage - outfile->statGroup.status;
		if (!outfile->abort)
		{
			data_CloseOneWriteGroup(&handle, num_mess, TRUE, &outfile->abort);
		} else
		{
			data_CloseOneWriteGroup(&handle, num_mess, FALSE, &outfile->abort);
			outfile->abort = TRUE;
		}
		
		CatLog_putTime();
		CatLog_WriteCard(num_mess);
		CatLog_WriteString(" von ");
		CatLog_WriteCard(outfile->statGroup.anz - outfile->statGroup.status);
		CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statGroup.anz - outfile->statGroup.status);
		CatLog_WriteLine(cImpStr);
		CatLog_WriteString(cSpace9Str);
		CatLog_WriteCard(outfile->statGroup.not);
		CatLog_WriteString(cDbStr);
		CatLog_WriteCard(outfile->statGroup.watch);
		CatLog_WriteLine(cWdogStr);
		CatLog_WriteString(cSpace9Str);
		CatLog_WriteCard(outfile->statGroup.garbage);
		CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statGroup.garbage);
		CatLog_WriteKonjString(cWarStr, "", cExtStr, outfile->statGroup.garbage);
		CatLog_WriteLine(" fehlerhaft.");
		TRACE((EO_TRACE, "%lu von %lu Nachrichten importiert.\n%u vom Datenbankmodul und %lu vom Watchdog abgelehnt.\n%lu Nachrichten waren fehlerhaft",
			num_mess, outfile->statGroup.anz - outfile->statGroup.status,
			outfile->statGroup.not, outfile->statGroup.watch,
			outfile->statGroup.garbage));
		if (gruppe == dataSys_private)
		{
			CatLog_WriteString(cSpace9Str);
			CatLog_WriteCard(outfile->statGroup.status);
			CatLog_WriteKonjString(" Statusmeldung", "", "en", outfile->statGroup.status);
			CatLog_WriteLine(cImpStr);
			TRACE((EO_TRACE, "%lu Statusmeldungen importiert.", outfile->statGroup.status));
		}
	}
	return !outfile->abort;
}
/*** ---------------------------------------------------------------------- ***/

/*
* gibt nacheinander alle in der Gruppenliste gespeicherten Msg an data
* weiter (ueber WriteMessage)
* Bricht bei Fehlermeldung von data ab
* Geht davon aus, dass die behandelte Msg komplett im Speicher steht,
* wovon man nach Kai's Doku bei der jetzigen Puffergroesse ausgehen darf
*/

LOCAL _VOID WriteBufferedOutfile(outfileInfo *outfile)
{
	_UWORD z;
	
	for (z = 0; z < MAX_GROUP; z++)
	{
		if (setin(outfile->groupsUsed, z))
		{
			if (!WriteOneGroup(outfile, z))
				return;
			addStats(&outfile->statPart, &outfile->statGroup);
			if (GroupSelect_isPrivate(z))
			{
				outfile->statPart.pmNot += outfile->statGroup.not + outfile->statGroup.garbage; /* Anzahl der Fehler in PMs */
			}
			HandleEvents();
		}
	}
}

/*-------------------------------------------------------------------------*/

/*
* Durchsucht den angelegten Puffer, schreibt auftretende Textfiles
* in die entsprechenden Dateien und legt Listen mit den Anfaengen der
* einzelnen Mitteilungen an
* Der Puffer wird bis oAnz durchsucht
* count gibt an, wo die Suche anfangen soll
* normalerweise 1, damit das erste '#' uebersprungen wird
*/

LOCAL _BOOL HandleOutfileBuffer(outfileInfo *outfile, _ULONG *count)
{
	_BOOL messageOk;
	
	outfile->count = *count;
	do
	{
		InitList(outfile);
		clearStats(&outfile->statGroup);
		do
		{
			messageOk = HandleMessage(outfile);
			/* Dann wurde am Ende eine Msg durch die Puffergrenze getrennt -> kopieren */
			/* old enthaelt die Startposition der letzten Message                       */
		} while (messageOk &&
			(outfile->maxPos < (MAX_ARRAY-1)) &&
			outfile->count < outfile->oAnz &&
			(outfile->oPtr[outfile->count] != CR || outfile->oPtr[outfile->count+1] != LF));
		addStats(&outfile->statPart, &outfile->statGroup); /* fuer text und unknown */
		WriteBufferedOutfile(outfile);
	} while (messageOk &&
		outfile->count < outfile->oAnz &&
		(outfile->oPtr[outfile->count] != CR || outfile->oPtr[outfile->count+1] != LF) &&
		!outfile->abort);
	*count = outfile->count;
	return messageOk;
}

/*-------------------------------------------------------------------------*/

LOCAL _VOID cleanUp(outfileInfo *outfile)
{
	CatLog_CloseLog();
	if (outfile->inMctrl)
	{
		Wind_Update(END_MCTRL);
		outfile->inMctrl = FALSE;
	}
	if (multiTask)
	{
		/* Wind_Update wieder setzen und Menu wieder anschalten */
		VDIStandards_enableOrDisableMenu(FALSE);
		Wind_Update(BEG_UPDATE);
	}
	if (outfile->infoWdwOpen)
	{
		showImport_Close();
		outfile->infoWdwOpen = FALSE;
	}
	if (outfile->oPtr != NULL)
		SFREE(outfile->oPtr);
	OFREE(outfile);
	MouseArrow();
}

/*-------------------------------------------------------------------------*/
/*DYJ 5.19b */	/*DYJ 5.20w */
/*ME 5.20h */	/*DYJ 5.20e */	/*DYJ 5.21b */	/*DYJ 5.20t */
GLOBAL _WORD Parser_OutfileEinsortieren(
CONST _UBYTE *importPath,
CONST _UBYTE *outfileName,
CONST _UBYTE *archiveName,
CONST _UBYTE *arcName,
	OUTF_MODE mode)
{
	_ULONG estMem;			/* Vermutete noetige Groesse fuer die Pufferung     */
	_ULONG isAvail;			/* Vorhandener Speicher                         */
	
	_UBYTE scrap[PATH_MAX];	/* Zugriffspfade erstellen         */
	
	_BOOL doDeArc;			/* Auspacken noetig?                              */
	_BOOL txtIsThere;		/* Ist ein Outfile-Text schon vorhanden?         */
	
	FILENO outHandle;		/* Handle des Outfiles                           */
	_ULONG outLength;		/* Laenge des Outfiles                           */
	_ULONG processed;		/* Wieviele Bytes wurden schon behandelt?        */
	
	_ULONG toRead;			/* Berechnung der Anzahl zu lesender Bytes      */
	_ULONG count;
	_UBYTE *bing;
	CAT_GROUP_NUMBER pGroup;
	outfileInfo *outfile;
	F_ERROR error;

	if(mode!=OM_822)
	{
		WiederVorlage_InitCmts();	/* (MH) */

		if (!CatLog_OpenLog(mode==OM_OUTFHDR))
	
		{
			if (!batchProcess)
				MTE_infoRSC(AL_NO_CATLOG);
			return 0;
		}
	}
	TRACE((EO_DEBUG, "Outfile einf\201gen gestartet"));
	
	if (handlePool_isOneGroupOpen())
	{
		CatLog_WriteLineNTime("*Interner Fehler in der Lesehandleliste. Einf\201gen abgebrochen.*");
		TRACE((EO_ERROR, "Interner Fehler in der Lesehandleliste. Einf\201gen abgebrochen."));
		if (!batchProcess)
			MTE_infoRSC(AL_GROUPS_OPEN);
		CatLog_CloseLog();
		return 0;
	}
	
	if ((outfile = NEW(outfileInfo, "OutfileEinsortieren")) == NULL)
	{
		CatLog_CloseLog();
		return 0;
	}
	MemSetZeroStruct(*outfile);
	outfile->outfType=mode;
	/* vorlaeufig */
	outfile->gPos = outfile->g;
	outfile->gMax = outfile->m;
	outfile->gStart = outfile->s;
	if(UserBLK.isInternet ||mode==OM_822)
		outfile->charset=ISO8859_1;
	else
		outfile->charset=ZS_ATARI;
	
	clearStats(&outfile->statTotal);
	
	ConfVars_GetConfDefInt(cCheckRedrawMsgCount, &outfile->redrawCheck, 40);
	strBcpy(outfile->ownName, userAddr);	/* !!! */
	
	ConfVars_GetConfDefBool(cFilteredAreRead, &outfile->filteredAreRead, FALSE);
	
	outfile->delCmts = 0;
	outfile->writeCmtsFail = FALSE;
	ConfVars_GetConfDefBool(cWriteCommentsEntries, &outfile->writeCmts, TRUE);
	
	CatGlobal_busyMouse();
	if (multiTask)
	{
		/* Bildschirm freigeben und alle Menus sperren
		 */
		VDIStandards_enableOrDisableMenu(TRUE);
		Wind_Update(END_UPDATE);
	}
	doDeArc   = arcName[0] != '\0';			/* auspacken, wenn Packer angemeldet      */
	
	strBcpy(scrap, importPath);
	if (doDeArc)
		F_Path_Append(scrap, OUTFILE_NAME);
	else
		F_Path_Append(scrap, outfileName);
	txtIsThere = CatFiles_Exists(scrap);	/* Outfile.txt da?                    */
	
	strBcpy(scrap, importPath);
	F_Path_Append(scrap, archiveName);
	if (!CatFiles_Exists(scrap))		/* Ist das Outfile ueberhaupt da?   */
	{
		if( doDeArc )
		{
			CatLog_WriteLineNTime("Outfile-Archiv nicht gefunden");
			TRACE((EO_DEBUG, "Outfile-Archiv nicht gefunden"));
		}
		else
		{
			CatLog_WriteLineNTime("Outfile nicht gefunden");
			TRACE((EO_DEBUG, "Outfile nicht gefunden"));
		}
		if (!batchProcess)
		{
			if (multiTask)
				Wind_Update(BEG_UPDATE);
			if( doDeArc )
				MTE_infoRSC(AL_NO_OUT_ARC); /* Outfile nicht vorhanden !    */
			else
				MTE_infoRSC(AL_NO_OUT_TXT); /* Outfile nicht vorhanden !    */
			if (txtIsThere)
			{
				CatLog_WriteLineNTime("Outfile-Text ist vorhanden");
				TRACE((EO_TRACE, "Outfile-Text ist vorhanden"));
			}
			if (doDeArc && txtIsThere && mtAlerts_AlertRSC(1, AL_DO_INSERT) == 1)
			{
				doDeArc = FALSE; /* trotzdem einfuegen! */
				CatLog_WriteLineNTime("User best\204tigt: Outfile-Text trotzdemeinf\201gen.");	/* :language: */
				TRACE((EO_DEBUG, "User best\204tigt: Outfile-Text trotzdem einf\201gen."));
			}
			else
			{
				if (doDeArc && txtIsThere)
				{
					CatLog_WriteLineNTime("User lehnt einf\201gen vom Outfile-Text ab");
					TRACE((EO_DEBUG, "User lehnt einf\201gen vom Outfile-Text ab"));
				}
				/* Aufraeumen */
				if (multiTask)
					Wind_Update(END_UPDATE);
				cleanUp(outfile);
				return 0;
			}
			if (multiTask)
				Wind_Update(END_UPDATE);
		} else
		{
			CatLog_WriteLineNTime("Einf\201gen abgebrochen, da Batchbetrieb");
			TRACE((EO_DEBUG, "Einf\201gen abgebrochen, da Batchbetrieb"));
			cleanUp(outfile);
			return 0;
		}
	}
	if (multiTask)
		Wind_Update(BEG_UPDATE);
	if (!OutfileVorbereiten(importPath, outfileName, archiveName, doDeArc, txtIsThere, &outHandle, &outLength, outfile->outfType))
	{
		if (multiTask)
			Wind_Update(END_UPDATE);
		cleanUp(outfile);
		return 1;
	}
	if (multiTask)
		Wind_Update(END_UPDATE);
	
	/* Altes Logfile loeschen */
	if(mode==OM_OUTFILE)
		CatFiles_DeleteFile(DataPath, LASTLOG_FILENAME);
	
	Wind_Update(BEG_MCTRL); /* Prozesswechsel sperren */
	outfile->inMctrl = TRUE;
	
	estMem = data_EstimateNecessaryMemory(additional);
	
	CatLog_putTime();
	CatLog_WriteCard(outLength);
	CatLog_WriteLine(" Bytes Outfile L\204nge. ");
	CatLog_putTime();
	CatLog_WriteCard(estMem);
	CatLog_WriteLine(" Bytes sch\204tzt das Datenbankmodul als Speicherbedarf");
	TRACE((EO_TRACE, "%lu Bytes Outfile L\204nge.\n%lu Bytes sch\204tzt das Datenbankmodul als Speicherbedarf", outLength, estMem));
	
	/* Schleife, da sich z.B. bei MiNT der freie Speicher zwischen fragen und  */
	/* Anforderung aendern kann. Aus demselben Grund kann die Pufferung der     */
	/* Parameterdateien auch jetzt noch schiefgehen, aber ich weiss nicht, wie  */
	/* man das umgehen kann.                                                   */
	
	do
	{
		CatLog_WriteLineNTime("Beginne Allozierungsschleife");
		TRACE((EO_TRACE, "Beginne Allozierungsschleife"));
		isAvail = (_ULONG)Malloc(-1L);			/* Wieviel ist da?              */
		CatLog_putTime();
		CatLog_WriteCard(isAvail);
		CatLog_WriteLine(" Bytes gr\224\236ter Speicherblock");
		TRACE((EO_TRACE, "%lu Bytes gr\224\236ter Speicherblock", isAvail));
		if (isAvail < minSpace)
		{
			CatFiles_CloseFile(outHandle);
			CatLog_WriteLineNTime("*Nicht genug Speicher frei f\201r das Einf\201gen*");
			TRACE((EO_DEBUG, "Nicht genug Speicher frei f\201r das Einf\201gen"));
			MouseArrow();
			if (!batchProcess)
				MTE_noMemAlert();
			cleanUp(outfile);
			return 1;
		}
		if (isAvail < estMem + minSpace)
		{
			_BOOL bufferAlert;
			
			/* Parameterdatei passt vermutlich nicht rein, oder kein Platz mehr fuer das */
			/* Outfile                                                                 */
			/* Alert kommt nur, wenn nicht abgeschaltet */
			ConfVars_GetConfDefBool(cEnableLowMemWarning, &bufferAlert, TRUE);
			if (!batchProcess && bufferAlert && mtAlerts_AlertRSC(2, AL_NO_MEM_FOR_BUFFER) != 1)
			{
				CatFiles_CloseFile(outHandle);
				CatLog_WriteLineNTime("User lehnt Einf\201gen ab; Pufferspeicher zu klein");
				TRACE((EO_DEBUG, "User lehnt Einf\201gen ab; Pufferspeicher zu klein"));
				cleanUp(outfile);
				return 1;
			}
			outfile->oAnz = LMin(minSpace, outLength);
			/* Nur das anfordern, was noetig ist, aber hoechstens minSpace       */
			CatLog_WriteStringNTime("Minimumspeicher: ");
			TRACE((EO_DEBUG, "Minimumspeicher"));
		} else if (isAvail < estMem + outLength)
		{
			outfile->oAnz = isAvail - estMem; /* Anfordern, was moeglich ist                */
			CatLog_WriteStringNTime("Teilpufferung: ");
			TRACE((EO_DEBUG, "Teilpufferung"));
		} else
		{
			outfile->oAnz = outLength; /* Alles anfordern, Outfile passt komplett         */
			CatLog_WriteStringNTime("Vollpufferung: ");
			TRACE((EO_DEBUG, "Vollpufferung"));
		}
		/* Alloziere Speicher readable und TT-RAM preferred */
		outfile->oPtr = SYSMALLOC(outfile->oAnz, MEM_SHARABLE|MEM_NOERR, "OutfileEnsortieren: outfile buffer");
		CatLog_WriteCard(outfile->oAnz);
		CatLog_WriteLine(" Bytes angefordert");
		TRACE((EO_TRACE, "%lu Bytes angefordert", outfile->oAnz));
		
	} while (outfile->oPtr == NULL); /* Wir machen den Spass solange, bis es geklappt hat..  */
	outfile->inMctrl = FALSE;
	Wind_Update(END_MCTRL);/* Prozesswechsel wieder freigeben */
	
	CatLog_WriteLineNTime("Ende der Allozierungsschleife, Speicher angefordert");
	TRACE((EO_TRACE, "Ende der Allozierungsschleife, Speicher angefordert"));
	
	CatLog_WriteLn();
	CatLog_WriteLineNTime("Beginn des Einf\201gens");
	TRACE((EO_TRACE, "Beginn des Einf\201gens"));
	WatchDog_isWatchDog(&outfile->isWatch, &outfile->WatchActive);
	CatLog_WriteLn();
	CatLog_WriteString(cSpace9Str);
	if (outfile->isWatch)
	{
		CatLog_WriteString("WatchDog installiert und ");
		if (!outfile->WatchActive)
			CatLog_WriteString("nicht ");
		CatLog_WriteString("aktiv.");
		TRACE((EO_TRACE, "Watchdog installiert und %saktiv.", outfile->WatchActive ? "" : "nicht "));
	} else
	{
		CatLog_WriteString("Kein WatchDog installiert.");
		TRACE((EO_TRACE, "Kein WatchDog installiert."));
	}
	CatLog_WriteLn();
	
	showImport_Open(outLength,Rsc_WrkString(SIO_IMPORT));
	outfile->infoWdwOpen = TRUE;
	
	HandleEvents();
	
	if(mode==OM_OUTFILE)
		data_PrepareToWrite();
	CatFiles_Seek(0L, outHandle, CatFiles_start);
	processed = 0;     /* Bisher wurde nichts behandelt                     */
	count     = 0;     /* Anzahl der Restbytes von der letzten Runde        */
	outfile->TxtOutOpen = FALSE; /* und auch keine Textdatei offen                    */
	/* Achtung, hier wird count fuer zwei verschiedene Funktionen gebraucht!  */
	do
	{
		clearStats(&outfile->statPart);
		
		TRACE((EO_TRACE, "--- Repeat-Schleife in Outfile-Einsortieren ---\nprocessed: %lu\ncount: %lu", processed, count));
	
		toRead = LMin(outfile->oAnz - count, outLength - processed - count); /* -count neu! */
		outfile->oAnz = LMin(outfile->oAnz, outLength - processed); /* + count weg! */
		/* Am Ende brauchen wir nicht mehr soviel und die Prozeduren oben */
		/* muessen das auch erfahren */
		if(mode==OM_822)
		{
			strCpy(&outfile->oPtr[count],"#OM@IN\r\niCatGroup: tmp.822\r\nFLAGZEILEPMF: D\r\n");
			error = CatFiles_ReadMuch(toRead-51, outHandle, &outfile->oPtr[count+45]);
			strCpy(&outfile->oPtr[count+toRead-6],"\r\n.\r\n#");
		}
		else
			error = CatFiles_ReadMuch(toRead, outHandle, &outfile->oPtr[count]);
		if (error != NoError)
		{
			ImportError("Dateifehler beim Lesen des Outfiles", error);
			cleanUp(outfile);
			return 1;
		}
		count = 1; /* Warum steht hier eine 1????? YYYY jetzt funktioniert's! */
		TRACE((EO_TRACE, "oAnz: %lu", outfile->oAnz));
		if (!HandleOutfileBuffer(outfile, &count))
		{
			processed += count;
			/* Hier muss kopiert werden, da eine Msg auf der Puffergrenze steht */
			/* count steht auf der Startposition der getrennten Message */
			/* Den Block nach vorne schieben */
			MemCpy(outfile->oPtr, &outfile->oPtr[count], outfile->oAnz - count);
			count = outfile->oAnz - count; /* Anzahl der Restbytes */
		} else
		{
			count = 0; /* keine Restbytes */
			processed += outfile->oAnz;
		}
		TRACE((EO_TRACE, "count: %lu", count));
		
		addStats(&outfile->statTotal, &outfile->statPart);
		outfile->statTotal.pmNot += outfile->statPart.pmNot;
	} while (processed < outLength && !outfile->abort); /* BIS ALLES DURCHGENUDELT IST */
	
	error = CatFiles_CloseFile(outHandle); /* Hier ist ein Fehler tolerierbar */
	if (error != NoError)
		ImportError("Dateifehler beim Schliessen des Outfiles", error);
	SFREE(outfile->oPtr);
	outfile->oPtr = NULL;
	
	/* Soll geloescht werden ?  */
	CatLog_WriteLn();
	if (!outfile->abort &&
		outfile->statTotal.garbage == 0 &&
		outfile->statTotal.not - outfile->statTotal.dupeCount == 0 &&
		UserBLK.DeleteAfterImport && outfile->outfType==OM_OUTFILE)
	{
		error = CatFiles_DeleteFile(importPath, outfileName);
		if (error != NoError)
		{
			/* OUTFILE.TXT loeschen.. */
			ImportError("Fehler beim L\224schen des Outfiles", error);
			CatLog_WriteLineNTime(cOfNdel);
			TRACE((EO_DEBUG, cOfNdel));
		} else
		{
			CatLog_WriteLineNTime(cOfDel2);
			TRACE((EO_DEBUG, cOfDel2));
		}
	} else if(!outfile->abort && UserBLK.DeleteAfterImport && outfile->outfType==OM_OUTFILE)
	{
		CatLog_WriteStringNTime("*Outfile-Text nach Einf\201gen nicht gel\224scht*, da ");
		if (outfile->statTotal.garbage != 0)
		{
			CatLog_WriteCard(outfile->statTotal.garbage);
			CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statTotal.garbage);
			CatLog_WriteString(" kaputt ");
			if (outfile->statTotal.not - outfile->statTotal.dupeCount == 0)
			{
				CatLog_WriteKonjString(cWarStr, ".", "en.", outfile->statTotal.garbage);
				CatLog_WriteLn();
			} else
			{
				CatLog_WriteString("und ");
			}
		}
		if (outfile->statTotal.not - outfile->statTotal.dupeCount != 0)
		{
			CatLog_WriteCard(outfile->statTotal.not - outfile->statTotal.dupeCount);
			CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statTotal.not - outfile->statTotal.dupeCount);
			CatLog_WriteString(" abgelehnt ");
			CatLog_WriteKonjString("wurde", ".", "n.", outfile->statTotal.not - outfile->statTotal.dupeCount);
			CatLog_WriteLn();
		}
		TRACE((EO_DEBUG, "Outfile-Text nicht gel\224scht, da %lu Nachrichten kaputt waren und %lu abgelehnt wurden",
			outfile->statTotal.garbage, outfile->statTotal.not - outfile->statTotal.dupeCount));
	}

	WiederVorlage_CloseCmts();	/* (MH) */

	if(!outfile->abort && outfile->outfType==OM_OUTFILE)
	{
		CatLog_WriteLn();
		if(mode==OM_OUTFILE)
		{
			processLog(outfile);
			/* Hier werden jetzt die Filter nach dem Einfuegen aufgerufen */
			data_WritePos();
			IoFilter_IoFilterPastOutfile();
			data_ReadPos();
			Messages_ReReadMessageInfo();
		}
		
		/* Kommentarliste aufraeumen (MH) */
		if (outfile->writeCmts && WiederVorlage_CleanUpCmts(&outfile->delCmts))
		{
			CatLog_WriteLineNTime("Die " cmtsDataName "-Datei wurde aufger\204umt.");/* :language: */
			CatLog_WriteString(cSpace9Str);
			CatLog_WriteCard(outfile->delCmts);
			CatLog_WriteKonjString(" Eintr", "ag", "\204ge", outfile->delCmts);
			CatLog_WriteKonjString(" wurde", "", "n", outfile->delCmts);
			CatLog_WriteLine(" gel\224scht.");
			CatLog_WriteLn();
		}
	}
	
	CatLog_WriteLn();
	CatLog_putTime();
	CatLog_WriteLine("--- Gesamtstatistik ---");
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->statTotal.anz - outfile->statTotal.not - outfile->statTotal.watch - outfile->statTotal.garbage - outfile->statTotal.status);
	CatLog_WriteString(" von ");
	CatLog_WriteCard(outfile->statTotal.anz - outfile->statTotal.status);
	CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statTotal.anz - outfile->statTotal.status);
	CatLog_WriteLine(cImpStr);
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->statTotal.not);
	CatLog_WriteString(cDbStr);
	CatLog_WriteCard(outfile->statTotal.watch);
	CatLog_WriteLine(cWdogStr);
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->statTotal.garbage);
	CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statTotal.garbage);
	CatLog_WriteKonjString(cWarStr, "", cExtStr, outfile->statTotal.garbage);
	CatLog_WriteLine(" fehlerhaft.");
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->statTotal.dupeCount);
	CatLog_WriteKonjString(cMessStr, "", cExtStr, outfile->statTotal.dupeCount);
	CatLog_WriteKonjString(cWarStr, " ein", cExtStr, outfile->statTotal.dupeCount);
	CatLog_WriteKonjString(" Dupe", "", "s", outfile->statTotal.dupeCount);
	CatLog_WriteLine(".");
	CatLog_WriteKonjString(cSpace9Str "Es kam", " ", "en ", outfile->statTotal.text);
	CatLog_WriteCard(outfile->statTotal.text);
	CatLog_WriteKonjString(" Maus-Infotext", "", "e", outfile->statTotal.text);
	CatLog_WriteLine(".");
	CatLog_WriteKonjString(cSpace9Str "Es kam", " ", "en ", outfile->statTotal.outBlocks);
	CatLog_WriteCard(outfile->statTotal.outBlocks);
	CatLog_WriteKonjString(" OUT-Bl", "ock", "\224cke", outfile->statTotal.outBlocks);
	CatLog_WriteLine(".");
	CatLog_WriteKonjString(cSpace9Str "Es kam", " ", "en ", outfile->statTotal.unknown);
	CatLog_WriteCard(outfile->statTotal.unknown);
	CatLog_WriteKonjString(" unbekannte", "r", "", outfile->statTotal.unknown);
	CatLog_WriteKonjString(" Infotext", "", "e", outfile->statTotal.unknown);
	CatLog_WriteLine(".");
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->statTotal.status);
	CatLog_WriteKonjString(" Statusmeldung", "", "en", outfile->statTotal.status);
	CatLog_WriteLine(cImpStr);
	
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->NEUEWAISEN);
	CatLog_WriteKonjString(" neue", "r", "", outfile->NEUEWAISEN);
	CatLog_WriteKonjString(" Waise", "", "n", outfile->NEUEWAISEN);
	CatLog_WriteKonjString(" wurde", "", "n", outfile->NEUEWAISEN);
	CatLog_WriteLine(" gefunden.");
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->WAISEN_H);
	CatLog_WriteKonjString(" neue", "r", "", outfile->WAISEN_H);
	CatLog_WriteKonjString(" Waise", "", "n", outfile->WAISEN_H);
	CatLog_WriteKonjString(" wurde", "", "n", outfile->WAISEN_H);
	CatLog_WriteLine(" mit anderen verknpft.");
	CatLog_WriteString(cSpace9Str);
	CatLog_WriteCard(outfile->WAISEN_V);
	CatLog_WriteKonjString(" alte", "r", "", outfile->WAISEN_V);
	CatLog_WriteKonjString(" Waise", "", "n", outfile->WAISEN_V);
	CatLog_WriteKonjString(" wurde", "", "n", outfile->WAISEN_V);
	CatLog_WriteLine(" adoptiert.");
	
	/* Resultat der Kommentarliste in Catlog schreiben (MH) */
	if (outfile->writeCmts)
	{
		CatLog_WriteString(cSpace9Str);
		CatLog_WriteCard(outfile->statTotal.cmtsToOwn);
		CatLog_WriteKonjString(" Kommentar", "", "e", outfile->statTotal.cmtsToOwn);
		CatLog_WriteString(" auf eigene Mitteilungen gefunden, ");
		if (outfile->statTotal.cmtsToOwn > 0)
		{
			if (!outfile->writeCmtsFail)
			{
				CatLog_WriteLine("in Liste geschrieben.");
			} else
			{
				CatLog_WriteLine("es ist jedoch ein Fehler");
				CatLog_WriteString(cSpace9Str);
				CatLog_WriteLine("beim Schreiben der " cmtsDataName " aufgetreten.");
			}
		} else
		{
			CatLog_WriteLine("nichts zu tun gewesen.");
		}
	}	
	
	TRACE((EO_TRACE, "\
	%lu von %lu Nachrichten importiert.\n\
	%lu vom Datenbankmodul und %lu vom Watchdog abgelehnt.\n\
	%lu Nachrichten waren fehlerhaft.\n\
	%lu Nachrichten waren Dupes.\n\
	Es kamen %lu Maus-Infotexte.\n\
	Es kamen %lu OUT-Bl\224cke.\n\
	Es kamen %lu unbekannte Infotexte.\n\
	%lu Statusmeldungen wurden importiert.\n\
	%lu Usenet-Verkettungen wurden gefunden, %lu konnten hergestellt werden.\n\
	%lu Kommentare auf eigene Mitteilungen gefunden.",
	
		outfile->statTotal.anz - outfile->statTotal.not - outfile->statTotal.watch - outfile->statTotal.garbage - outfile->statTotal.status,
		outfile->statTotal.anz - outfile->statTotal.status,
		outfile->statTotal.not,
		outfile->statTotal.watch,
		outfile->statTotal.garbage,
		outfile->statTotal.dupeCount,
		outfile->statTotal.text,
		outfile->statTotal.outBlocks,
		outfile->statTotal.unknown,
		outfile->statTotal.status,
		outfile->statTotal.cmtsToOwn));
	CatLog_CloseLog();
	TRACE((EO_DEBUG, "Einf\201gen beendet"));
	
	if (multiTask)
	{
		/* Wind_Update wieder setzen und Menu wieder anschalten */
		VDIStandards_enableOrDisableMenu (FALSE);
		Wind_Update(BEG_UPDATE);
	}
	showImport_Close();
	MouseArrow();
	data_WritePos();
	
	bing=cBingNoMails;
	pGroup=dataSys_private;
	do
	{
		if (data_unreadMsgCount(pGroup) != 0)
		{
			bing=cBingNewMails;
			break;
		}
		pGroup=GroupSelect_NextPrivGroupNumber(pGroup);
	}while(pGroup!=NO_GROUP);
	CatGlobal_Bing(bing);
	
	if (!batchProcess)
	{
/*DYJ 5.39d Start*/
		if (outfile->statTotal.pmNot != 0 || outfile->statTotal.pmErr)
/*DYJ  Ende; alt:	
		if (outfile->statTotal.pmNot != 0)
*/
		{
			/* Wenn Fehler bei den PMs aufgetreten sind, dann wahlweise CATLOG.TXT oeffnen (MH) */
			if (mtAlerts_AlertRSC(1, AL_PM_DEFECT) == 1)
				MTEdit2_OpenEditWindow(DataPath, CATLOG_FILENAME, FALSE, UserBLK.InfofilesReadOnly);
		}
		if (outfile->maxOver)
		{
			if (mtAlerts_AlertRSC(2, AL_OVERSIZE) == 1)
				CatHelp_DoHelp(CatHelp_oversize);
		}
	}
/*DYJ 5.39d Start*/
	while(outfile->o2m)
	{
		of2msg *nxt=outfile->o2m->next;
		SFREE(outfile->o2m);
		outfile->o2m=nxt;
	}
/*DYJ  Ende; */
	OFREE(outfile);
	
	Protokoll_SendPathUpdate(MessagePath);
	Protokoll_SendPathUpdate(DataPath);
	
	return 2;
}

/*-------------------------------------------------------------------------*/

/*
 * Schliesst die noch offene Protokolldatei im Falle eines Absturzes
 * Wird direkt in cat.c in den ExeptionHandler gehaengt.
 */
GLOBAL _VOID Parser_EmergencyClose(_VOID)
{
	CatLog_WriteLn();
	CatLog_WriteLine("### " CATLOG_FILENAME " durch Traphandler geschlossen ###");
	CatLog_CloseLog();
	WiederVorlage_CloseCmts();	/* comments.dat wird auch geschlossen (MH) */
	TRACE((EO_FATAL, "### " CATLOG_FILENAME " durch Traphandler geschlossen ###"));
}
