/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 */


#include <showimpo.h>
#include <wdwmanag.h>
#include <maustaus.h>

#include <mtutils.h>
#include <mtappl.h>
#include <mtdials.h>

LOCAL OBJECT *box;
LOCAL GRECT rect;
LOCAL _ULONG maxval, pos;
LOCAL _BOOL inWindow;
LOCAL HWND wdwHandle = -1;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL bProc(HWND wdw, _VOID *special, _WORD mx, _WORD my, _UWORD kstate, _UWORD buttons, _WORD clicks)	
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(buttons);
	UNUSED(clicks);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL kProc(HWND wdw, _VOID *special, _WORD taste, _UBYTE key, _UBYTE scan, _UWORD kstate)	
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(taste);
	UNUSED(key);
	UNUSED(scan);
	UNUSED(kstate);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeP(HWND wdw,HVDI vdiH, _VOID *special, _BOOL force)
{
	UNUSED(wdw);
	UNUSED(vdiH);
	UNUSED(special);
	return force;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL topP(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID untopP(HWND wdw, _VOID *special)	
{
	UNUSED(wdw);
	UNUSED(special);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)	
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(doc);
	UNUSED(slided);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getRect(HWND wdw,HVDI vdiH, _VOID *special, GRECT *work)
{
	UNUSED(wdw);
	UNUSED(vdiH);
	UNUSED(special);
	rect = *work;
	box[ROOT].ob_x = work->g_x;
	box[ROOT].ob_y = work->g_y;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawInfo(HWND wdw, HVDI vdi, _VOID *env, CONST GRECT *clip)
{
	UNUSED(wdw);
	UNUSED(vdi);
	Objc_draw(env, ROOT, MAX_DEPTH, clip);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateP(HWND wdw, _VOID *special, _BOOL begin)	
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
		Wind_Update(BEG_UPDATE);
	else
		Wind_Update(END_UPDATE);
}
/*** ------------------------------------------------------------------------ ***/
/*	_ULONG showImport_Inq(_ULONG *absolute,_UBYTE *txt,size_t sizeTxt)			*/
/*	gibt die aktuellen Werte zurck, um so die Box vorbergehend schlieen zu	*/
/*	knnen und spter zu restaurieren											*/
/*	Parameter:	absolute,txt:	die bei open bergebenen Werte					*/
/*				sizeTxt:		Gre von txt									*/
/*	Ergebnis:	aktuelle Position												*/
/*	4.11.01 von Dimitri Junker	DYJ 4.30u										*/
/*** ------------------------------------------------------------------------ ***/
_ULONG showImport_Inq(_ULONG *absolute,_UBYTE *txt,size_t sizeTxt)
{
	if(wdwHandle<0)
		return 0xffffffffl;
	else
	{
		box = TreeAddr[IMPORT];
		*absolute=maxval;
		ObjcString(box, IM_STR, txt,sizeTxt);
		return pos;
	}
}
/*** ---------------------------------------------------------------------- ***/

/* Oeffnet die Box */

GLOBAL _VOID showImport_Open(_ULONG absolute,char *txt)
{
	GRECT full;
	_UWORD comps;
	_BYTE oldFrame;
	HVDI vdi;

	box = TreeAddr[IMPORT];
	box[FILL].ob_width = 1;
	maxval = absolute;
	pos = 0;
	/* Jetzt Fuellstil auf Solid und Farbe setzen, falls Farbe */
	if (Bitplanes > 1)
	{
		OBSPEC_SET_INTERIORCOL(box[FILL].ob_spec, RED);
		OBSPEC_SET_FILLPATTERN(box[FILL].ob_spec, 7 /* IP_SOLID */);
	}
	SetObjcString(box, IM_STR, txt);
	/* Outlined abschalten und Rand auf 1 Pixel setzen */
	DelObjFlags(box, ROOT, OUTLINED);
	oldFrame = OBSPEC_GET_FRAMESIZE(box[ROOT].ob_spec);
	OBSPEC_SET_FRAMESIZE(box[ROOT].ob_spec, -1);
	mtDials_DialCenter(box, CSCREEN, 0, 0, &rect);
	ObjcArea(box, ROOT, &rect);
	/* Jetzt Fenster fuer Box oeffnen */
	comps = NAME | MOVER;
	Wind_calc(WC_BORDER, comps, &rect, &full);
	if (full.g_y < deskSize.g_y)
		full.g_y = deskSize.g_y;
	if (full.g_x < deskSize.g_x)
		full.g_x = deskSize.g_x;
	if (WdwManager_OpenWindow(bProc,
		kProc,
		FUNK_NULL,		/* timerProc */
		&full, &full, comps,
		FALSE, 			/* snap */
		"",
		ProgramName,
		FUNK_NULL,		/* snapProc */
		closeP,
		redrawInfo,
		topP,
		untopP,
		updateP,
		setWork,
		getRect,
		FUNK_NULL,		/* hideProc */
		0,				/* pixelOffset */
		box,			/* env */
		TRUE,			/* onlyThisTop */
		TRUE,			/* showIt */
		FALSE,			/* supportIconify */
		FALSE,			/* openWorkstation */
		FALSE,		/* hasIdem  */
		&wdwHandle, &vdi))
	{
		inWindow = TRUE;
		WdwManager_FullRedrawWdw(wdwHandle);
	} else
	{
		inWindow = FALSE;
		DelObjFlags(box, ROOT, OUTLINED);
		OBSPEC_SET_FRAMESIZE(box[ROOT].ob_spec, oldFrame);
		Wind_Update(BEG_UPDATE);
		mtDials_DialCenter(box, CSCREEN, 0, 0, &rect);
		Form_dial(FMD_START, &rect, &rect);
		Objc_draw(box, ROOT, MAX_DEPTH, &rect);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt neue Fuellstandsanzeige */
GLOBAL _VOID showImport_SetNew(_ULONG newValue)
{
	GRECT rect;
	_WORD oldW, newW;

	pos += newValue;
	oldW = box[FILL].ob_width;
	if (pos > maxval)
	{
		pos = maxval;
		newW = box[AFILL].ob_width;
	} else
	{
		newW = (_WORD)((((double)box[AFILL].ob_width) * pos) / maxval);	
	}
	if (oldW != newW && newW > 0)
	{
		box[FILL].ob_width = newW;
		rect.g_x = box[ROOT].ob_x + box[AFILL].ob_x + oldW;
		rect.g_y = box[ROOT].ob_y + box[AFILL].ob_y;
		rect.g_w = newW - oldW + 1;
		rect.g_h = box[AFILL].ob_height;
		if (inWindow)
			WdwManager_RedrawWdw(wdwHandle, &rect);
		else
			Objc_draw(box, AFILL, 2, &rect);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst die Box wieder */
GLOBAL _VOID showImport_Close(_VOID)
{
	if (inWindow)
	{
		inWindow = FALSE;
		WdwManager_CloseWindow(wdwHandle, TRUE);
		wdwHandle = -1;
	} else
	{
		Form_dial(FMD_FINISH, &rect, &rect);
		Wind_Update(END_UPDATE);
	}
}
