#ifndef __CAT_UUDECODE_H__
#define __CAT_UUDECODE_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __FILE_IO_H__
#include <file_io.h>
#endif


_VOID UUDecode_BeginDecode(_VOID);
/* Initialisiert die Dekodierung
 */

F_ERROR UUDecode_DecodeLine(_UBYTE *line);
/* Dekodiert eine Zeile
 */

_VOID UUDecode_EndDecode(_VOID);
/* Beendet die Dekodierung, schliesst ggf. offene Dateien
 */


#endif /* __CAT_UUDECODE_H__ */
