#ifndef __CAT_ARCASS_H__
#define __CAT_ARCASS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif


typedef _VOID (*outProcType)(_UBYTE ch);


_BOOL ARCAss_SetTrap(_VOID);

_VOID ARCAss_RestoreTrap(_VOID);

_VOID ARCAss_SetOutputProc(outProcType p);
/* Setzt die Ausgabeprozedur fuer die Ausgabeumlenkung
 */

_VOID ARCAss_ClearOutputProc(_VOID);
/* Loescht eine ggf. gesetzte Ausgabeprozedur
 */


#endif /* __CAT_ARCASS_H__ */
