#ifndef __CAT_ARCSTARTER_H__
#define __CAT_ARCSTARTER_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif


#define ARCSTART_TOLOG      0x0001
#define ARCSTART_NOREDIRECT 0x0002
#define ARCSTART_REDRAW     0x0004

_WORD ARCStarter_ExecProgram(CONST _UBYTE *name, CONST _UBYTE *cmd, _UWORD flags);
/* Ruft ein Programm mit IO-Umlenkung auf
 * Wenn toLog TRUE ist, dann werden die Ausgaben auch in der Datei
 * CATLOG.TXT protokolliert (sofern diese offen ist)
 * Wenn noRedirect angegeben ist, dann wird die Ausgabe des Programmes
 * nie umgelenkt.
 */

_WORD ARCStarter_DeArc(_BOOL toLog);
/* Packt das Outfile aus
 */

_WORD ARCStarter_Archive(_VOID);
/* Packt das Infile ein
 */


#endif /* __CAT_ARCSTARTER_H__ */
