#ifndef __CAT_CATLOG_H__
#define __CAT_CATLOG_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

/*
 * Cat-Logfile des MausTausch-Importes
 *
 * Am besten komplett importieren, deswegen auch keine speziellen Namen
 *
 *
 */

_BOOL CatLog_OpenLog(_BOOL isHdr);

_VOID CatLog_CloseLog(_VOID);

_VOID CatLog_Write(_UBYTE c);
_VOID CatLog_WriteCard(_ULONG c);
_VOID CatLog_WriteInt(_LONG i);

_VOID CatLog_WriteString(CONST _UBYTE *str);
_VOID CatLog_WriteKonjString(CONST _UBYTE *str, CONST _UBYTE *single, CONST _UBYTE *plural, _ULONG count);
_VOID CatLog_WriteLine(CONST _UBYTE *str);
_VOID CatLog_WriteTearLine(_VOID);
_VOID CatLog_WriteLn(_VOID);

_VOID CatLog_WriteStringNTime(CONST _UBYTE *str);
_VOID CatLog_WriteLineNTime(CONST _UBYTE *str);

_VOID CatLog_putDate(_VOID);
_VOID CatLog_putTime(_VOID);


#endif /* __CAT_CATLOG_H__ */
