#ifndef __DRAGDROP_H__
#define __DRAGDROP_H__

#ifndef __PORTAB_H__
#  include <portab.h>
#endif

#define DD_OK          0
#define DD_NAK         1
#define DD_EXT         2
#define DD_LEN         3
#define DD_TRASH       4
#define DD_PRINTER     5
#define DD_CLIPBOARD   6

/* timeout in milliseconds */
#define DD_TIMEOUT     4000

/* number of bytes of "preferred
 * extensions" sent by receipient during
 * open
 */
#define DD_NUMEXTS     8
#define DD_EXTLEN      4
#define DD_EXTSIZE     (DD_NUMEXTS * DD_EXTLEN)

/* max size of a drag&drop item name */
#define DD_NAMEMAX     128

#define DD_HDRMIN      9  /* type (DD_EXTLEN) + size (LONG) + terminator */
/* max length of a drag&drop header */
#define DD_HDRMAX      (8+DD_NAMEMAX)

_WORD dd_parse_args(_UBYTE *str);

#endif /* __DRAGDROP_H__ */
