#ifndef __CAT_GROUPCOMMENT_H__
#define __CAT_GROUPCOMMENT_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */




#ifndef __PORTAB_H__
#include <portab.h>
#endif



_BOOL GroupComment_PrepareID(_UBYTE *pText, _UBYTE **id, _UBYTE *saveChar, _UBYTE **savePos);
/* Aus dem in <pText> stehenden String eine oder 2 IDs herausholen oder auch nicht.. :-)  */
/* In <saveChar> steht anschliessend ein Buchstabe, der bei <savePos> im          */
/* entnommen im erfolgreichen Fall wurde.                                         */
/* <id> zeigt anschliessend auf die nullterminierte ID                            */

_BOOL GroupComment_PrepareIDnGroup(_UBYTE *str, _UBYTE **id, _UBYTE **gr);
/* Aus dem in <str> stehenden String die IDs und Gruppe herausholen oder nicht.    */
/* <id> zeigt anschliessend auf die nullterminierte ID                            */
/* und <gr> auf die nullterminiert Gruppe innerhalb von <str>                     */


#endif /* __CAT_GROUPCOMMENT_H__ */
