#ifndef __CAT_HASHING2_H__
#define __CAT_HASHING2_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#include <cat_vb.h>
#include <cattypes.h>
#include <data.h>

typedef struct _hInfo hInfo, *hashHandle;
#ifndef __HASHING2_IMPLEMENTATION__
struct _hInfo { int dummy; };
#endif


#ifndef _CRC16
#define _CRC16
typedef _UWORD CRC16;
#endif
GLOBAL hashHandle Hashing2_ToHash(CRC16 crc[2], MSGNR anz, MSGNR add,_UWORD anzCrc);

/* gibt hashHandle zurueck, die hashcrcs werden in einem Array[0..xx] */
/* uebergeben, dessen Anzahl <anz> ist. <add> gibt die Anzahl der     */
/* noch zu erwartenden Nachrichten an                                 */

_VOID Hashing2_ReleaseHash(hashHandle h);

_VOID Hashing2_AddCrc(hashHandle h, CRC16 *crc);
_VOID Hashing2_AddCrcNr(hashHandle ptr, CRC16 crc[2],MSGNR nr);
_VOID Hashing2_SubCrcNr(hashHandle ptr, CRC16 crc[2],MSGNR eintrNr);
/* Achtung, Reihenfolge wird beachtet! */

MSGNR Hashing2_GetFirst(hashHandle h, CRC16 crc);
/* 0FFFFFFFFH nichts gefunden */

MSGNR Hashing2_GetNext(hashHandle h);
/* 0FFFFFFFFH nicht gefunden */

hashHandle Hashing2_getEmptyHash(_VOID);

_BOOL Hashing2_emptyHash(hashHandle h);


#endif /* __CAT_HASHING2_H__ */
