#ifndef __MENU_KEY_H__
#define __MENU_KEY_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif

typedef _VOID (*menuProc)(_WORD item, _WORD title, _UWORD kbshift);

_WORD MenuKey_FindTitle(OBJECT *menu, _WORD search_idx);
_BOOL MenuKey_FindKeycode(CONST _UBYTE *str, _WORD *keycode, _WORD *offset);
_BOOL MenuKey_KeyToStr(_WORD key, _UBYTE *str, size_t strsize);
_UWORD MenuKey_TranslateKey(_WORD keycode, _UWORD kbshift);
_VOID MenuKey_Init(OBJECT *tree);
_BOOL MenuKey_Test(OBJECT *tree, _WORD keycode, _UWORD kbshift, menuProc hdlMenu, _BOOL showMouse);

#endif /* __MENU_KEY_H__ */
