#ifndef __CAT_MTE_H__
#define __CAT_MTE_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#include <catlib.h>

_VOID MTE_InfoAlert(CONST _UBYTE *s1, CONST _UBYTE *s2, CONST _UBYTE *s3);

_WORD MTE_info(CONST _UBYTE *s);

_VOID MTE_warnAlert(_BOOL cond, CONST _UBYTE *s1, CONST _UBYTE *s2, CONST _UBYTE *s3);

_VOID MTE_numAlert(_WORD num, CONST _UBYTE *s);
/* Ersetzt in s das Zeichen & durch die Zahl num und ruft dann
 * MTE.info auf.
 */

_VOID MTE_noMemAlert(_VOID);
/* Damit nicht dauernd die Strings ueberall eingesetzt werden, hier ein zentraler Aufruf */

/*DYJ 5.34o Start*/
/*DYJ  Ende; alt:	
_VOID MTE_noMemWarn(_BOOL cond);
/* dito */
*/

#endif /* __CAT_MTE_H__ */
