/*****************************************************************************
 *		ROUTINE.C
 *****************************************************************************/
/*
	strCpy u.. Befehle
 */
#include <portab.h>
#include <string.h>


/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *strCat( _UBYTE *dest, CONST _UBYTE *src )									*/
/*	wie strcat allerdings ohne den Absturz bei bergabe von NULL. 				*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	18.5.02 von Dimitri Junker	DYJ 4.38b										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
char    *strcat( char *s1, const char *s2 );
GLOBAL _UBYTE *strCat( _UBYTE *dest, CONST _UBYTE *src )
{
	if(dest && src)
		return strcat(dest,src);
	 else
	 	return dest;
}

/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE  *strCpy( _UBYTE *dest, CONST _UBYTE *src )							*/
/*	wie strcpy allerdings ohne den Absturz bei bergabe von NULL. 				*/
/*	3.8.02 von Dimitri Junker	DYJ 4.41n										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE  *strCpy( _UBYTE *dest, CONST _UBYTE *src )
{
	_UBYTE *d;
	CONST _UBYTE *s;
	if(!dest)
		return NULL;
	if(!src)
		*dest='\0';
	else
	{
		for(d=dest,s=src;*s;s++,d++)
			*d=*s;
		*d=*s;
	}
	return dest;
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE  *strnCpy( _UBYTE *dest, CONST _UBYTE *src,size_t maxlen )			*/
/*	wie strncpy allerdings ohne den Absturz bei bergabe von NULL. 				*/
/*	3.8.02 von Dimitri Junker	DYJ 4.41n										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE  *strnCpy( _UBYTE *dest, CONST _UBYTE *src,size_t maxlen )
{
	_UBYTE *d,leer[]="";
	CONST _UBYTE *s;
	
	if(!dest)
		return NULL;
	if(!src)
		dest=leer;
	for(d=dest,s=src;maxlen;d++,maxlen--)
	{
		*d=*s;
		if(*s)
			s++;
	}
	return dest;
	
}