/*****************************************************************************
 *		ROUTINE.C
 *****************************************************************************/

#include <portab.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.24d */
GLOBAL _WORD strnCaseCmp(CONST _UBYTE *str1, CONST _UBYTE *str2, size_t leng)
{
	_UBYTE c1, c2;
	_LONG count;

	if (str1 == NULL)
		str1 = "";
	if (str2 == NULL)
		str2 = "";
	count = leng;
	do
	{
		c1 = ucase(*str1++);
		c2 = ucase(*str2++);
	} while (--count >= 0 && c1 != '\0' && c1 == c2);
	if (count < 0)
		return 0;
	if (c1 == c2)
		return 0;
	if (c1 == '\0')
		return -1;
	if (c2 == '\0')
		return 1;
	return c1 - c2;
}

