/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>

/*** ---------------------------------------------------------------------- ***/

LOCAL F_TIME static_t;

/*
 * T_Localtime converts the unified time in seconds to a local time structure
 */
GLOBAL F_TIME *T_Localtime(SYSTIME ltime, F_TIME *t)
{
	if (ltime == 0)
	{
		if (t == NULL)
			t = &static_t;
		T_SetZero(t);
		return t;
	}
	ltime = T_Tzadjust(ltime, TRUE);
	return T_Converttime(ltime, t);
}


