/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>
#include <ro_mem.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID T_SetZero(F_TIME *t)
{
	MemSetZeroStruct(*t);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL T_IsZero(CONST F_TIME *t)
{
	return t->tm_year == 0 &&
		t->tm_mon == 0 &&
		t->tm_mday == 0 &&
		t->tm_hour == 0 &&
		t->tm_min == 0 &&
		t->tm_sec == 0;
}
