#ifndef __CAT_SHELLCALL_H__
#define __CAT_SHELLCALL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

typedef enum {
	noShell,
	shellP,
	shellProg
} shellType;


_VOID ShellCall_CallShell(CONST _UBYTE *str, _BOOL withRedirection);

shellType ShellCall_IsShell(_VOID);

#endif /* __CAT_SHELLCALL_H__ */
