#include <atari.h>
#include <tos.h>

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _UBYTE *GetEnvironment(_VOID)
{
#ifdef __GNUC__
	return _base->p_env;
#endif
#ifdef __PUREC__
	return _BasPag->p_env;
#endif
#ifdef __BORLANDC__
	return _BasPag->p_env;
#endif
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FreeEnvironment(CONST _UBYTE *env)
{
	UNUSED(env);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL rsrc_flip(_VOID *hdr, _LONG size)
{
	UNUSED(hdr);
	UNUSED(size);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CanDoSuper(_VOID)
{
	return Ssystem(-1, 0, 0) == -32 ||
		Ssystem(S_SECLEVEL, -1, 0) == 0 ||
		Pgeteuid() == 0;
}
