#include "_file_io.h"
#include <routinec.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL FILENO F_PathFile_Create(CONST _UBYTE *pfad)
{
	FILENO   handle = F_File_Create (pfad);

	if (!FILENO_OK(handle))			/* evtl. Pfad nicht vorhanden */
	{
		_UBYTE  str[PATH_MAX], *test;

		strBcpy(str, pfad);
		test = strrChr (str, '\\');
		if (test == NULL)
			test = strrChr(str, '/');
		if (test != NULL)
		{
			*test = '\0';
			if (F_Path_Create(str) != GERR_OK)
				return handle;
			return F_File_Create(pfad);
		}
	}
	return handle;
}


