#include "_file_io.h"
#include <portaes.h>
#include <routinec.h>
#include <routines.h>

LOCAL _UBYTE program_path[PATH_MAX];

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID F_Path_Get_Program(_UBYTE *path, CONST _UBYTE *name)
{
	if (name != NULL)
	{
#if GUI_VERSION
		LOCAL _BOOL been_here;
		if (!been_here)
		{
			shel_read(path, path);
			been_here = TRUE;
		}
		strCpy(path, name);
		if (shel_find(path) == 0)
			strCpy(path, name);
#else
		strCpy(path, program_path);
		F_Path_Append(path, name);
#endif
	} else
	{
		strCpy(path, "");
	}
	F_Path_Fullname(path);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID F_Path_Set_Program(CONST _UBYTE *path)
{
	if (path != NULL)
	{
		strBcpy(program_path, path);
		F_Path_Dirname(program_path);
	}
}
