#include "_file_io.h"

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR F_File_Read(FILENO fd, _VOID *buf, _LONG wtSize, _LONG *readSize)
{
	_LONG   size, wsize;
	_WORD   ii = 0;
	F_ERROR err;
	DOSFNO handle;
	
	SavePD();
	wsize = 0;
	if ((err = FiBufHandle(fd, &handle)) == GERR_OK)
	{
		while ((size = Fread((_WORD)handle, wtSize, buf)) == NETERR)
		{
			if (!NetzwerkDa)
				break;
			ii++;
			if (ii > 5)
				break;
			NETWAIT();
		}
		if (size > 0)
			wsize += size;
	}
	RestorePD();

	if (wsize > 0)
		FiBuf[TO_HANDLE(fd)].seekPos += wsize;
	if (readSize != NULL)
		*readSize = wsize;
	return err;
}
