PROJECT_ROOT=	/src/cat

INCLUDES=	-I$(PROJECT_ROOT)/mos/include \
		-I$(PROJECT_ROOT)/lib \
		-I$(PROJECT_ROOT)/magic/include \
		-I$(PROJECT_ROOT)/lib/tos
DEFINES=	

#
# Fuer Pure-C, mit Compiler-Driver cc
#
#CC=		cc
#CFLAGS=		-O -W2 -g
#LDFLAGS=	-g
#AR=		plink
#ARFLAGS=	-Y -G -J -O=
#A=		.lib
#LIB=
#SYSLIBS=	-lpcgem
#PCINCLUDE=	$(PROJECT_ROOT)/pc/include
#PCLIB=		$(PROJECT_ROOT)/pc
#PCCFLAGS=	-A- -P -K -M- -G -D__STDC__=1 -L64
#export PCINCLUDE PCLIB PCCFLAGS

#
# fuer GNU-C:
#
CC=		gcc
CFLAGS=		-O2 -g -Wall -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings -Werror
LDFLAGS=	-g
ARFLAGS=	rcs 
SYSLIBS=	-lgem
#A=.olb
#LIB=
A=.a
LIB=lib

#
# fuer Sozobon (ungetestet):
#
#CC=		cc
#CFLAGS=		-O -g
#LDFLAGS=	-g
#ARFLAGS=	rc 
#SYSLIBS=	-lgem
#A=.a
#LIB=lib

OBJ_DIR=	$(PROJECT_ROOT)/obj
BIN_DIR=	$(PROJECT_ROOT)/bin

COMPILE=	@echo compiling $?; $(CC) $(EXTRA_DEFINES) $(DEFINES) $(EXTRA_INCLUDES) $(INCLUDES) $(CFLAGS) $(XCFLAGS) -c -o $@

CATLIB=		$(OBJ_DIR)/$(LIB)cat$(A)
EDITLIB=	$(OBJ_DIR)/$(LIB)edit$(A)
MAGICLIB=	$(OBJ_DIR)/$(LIB)magic$(A)
EMULIB=		$(OBJ_DIR)/$(LIB)atari$(A)
