#include <portaes.h>

LOCAL _WORD update_count = 0;
LOCAL _WORD mctrl_count = 0;

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL Wind_Update(_WORD begend)
{
	_BOOL result = FALSE;
	
	switch (begend)
	{
	case BEG_UPDATE:
		if (update_count == 0)
			wind_update(BEG_UPDATE);
		update_count++;
		result = TRUE;
		break;
	case BEG_UPDATE|BEG_CHECK:
		if (update_count == 0)
		{
			_WORD out1, out2, out3, out4;
			
			if (appl_xgetinfo(APG_WINDOWS, &out1, &out2, &out3, &out4) && out4 == 1)
			{
				if (wind_update(begend) != 0)
					result = TRUE;
			} else
			{
				wind_update(BEG_UPDATE);
				result = TRUE;
			}
		} else
		{
			result = TRUE;
		}
		if (result)
			update_count++;
		break;
	case END_UPDATE:
		update_count--;
		if (update_count == 0)
			wind_update(END_UPDATE);
		if (update_count <= 0)
			result = TRUE;
		break;
	case BEG_MCTRL:
		if (mctrl_count == 0)
			wind_update(BEG_MCTRL);
		mctrl_count++;
		result = TRUE;
		break;
	case BEG_MCTRL|BEG_CHECK:
		if (mctrl_count == 0)
		{
			_WORD out1, out2, out3, out4;
			
			if (appl_xgetinfo(APG_WINDOWS, &out1, &out2, &out3, &out4) && out4 == 1)
			{
				if (wind_update(begend) != 0)
					result = TRUE;
			} else
			{
				wind_update(BEG_MCTRL);
				result = TRUE;
			}
		} else
		{
			result = TRUE;
		}
		if (result)
			mctrl_count++;
		break;
	case END_MCTRL:
		mctrl_count--;
		if (mctrl_count == 0)
			wind_update(END_MCTRL);
		if (mctrl_count <= 0)
			result = TRUE;
		break;
	}
	return result;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Wind_New(_VOID)
{
	wind_new();
	update_count = 0;
	mctrl_count = 0;
}
