/*****************************************************************************
 *	TOS/_FILE_IO.H
 *****************************************************************************/

#ifndef ___FILEIO_H__
#define ___FILEIO_H__

#include <stdio.h>
/*#include <string.h>*/
#include <stdlib.h>
#include <time.h>
#include <portab.h>
#include <dir_io.h>
#include <mintbind.h>
#include <file_io.h>

#ifndef GUI_VERSION
#  define GUI_VERSION 1
#endif

/* #define DEBUG */

#define NETERR -36
#define NETWAIT()  EventTimer(200)

#define ATR_FILE 0
#define ATR_SUBDIR FA_DIREC

#define MIN_DOS_HANDLE (-6)

typedef _LONG DOSFNO;
#define LEGAL_DOSFNO(handle) ((handle) >= MIN_DOS_HANDLE)

typedef struct
{
	_BOOL   open;
	_BOOL   used;
	DOSFNO  handle;
	_WORD   mode;
	_LONG   seekPos;
	_UBYTE  path[PATH_MAX];
} FILE_BUF;

#define VALID_FILENO(fno) (TO_HANDLE(fno) >= 0 && TO_HANDLE(fno) < fi_buf_size)

#ifdef DEBUG
EXTERN _WORD   OpenFiles;
#endif
EXTERN FILE_BUF *FiBuf;
EXTERN _WORD fi_buf_size;

EXTERN _BOOL   NetzwerkDa;

#if !GUI_VERSION
#undef SavePD
#undef RestorePD
#endif
#ifndef SavePD
#define SavePD()
#define RestorePD()
#endif

EXTERN _UBYTE sys_workpath[PATH_MAX];


EXTERN F_ERROR FiBufClose(FILENO fd);
EXTERN F_ERROR FiBufHandle(FILENO fd, DOSFNO *handle);
EXTERN FILENO FiBufSave(DOSFNO handle, CONST _UBYTE *path, _WORD mode);
EXTERN F_ERROR FiBufOpen(CONST _UBYTE *datei, _WORD mode, _LONG offset, DOSFNO *handle);
EXTERN F_ERROR sysFclose(FILE_BUF *ff);

#endif /* ___FILEIO_H__ */
