#ifndef __CAT_MSGVARNL_H__
#define __CAT_MSGVARNL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



/* alias.c */
#define cShowAliasName                  "ShowAliasName"
#define cShowAliasNames                 "ShowAliasNames"


/* data.c */
#define cDangerousDupeMode              "DangerousDupeMode"
#define cIgnOrphAft						"IgnOrphAft"
#define cTabSize                        "TabSize"
#define cIgnoreCrcError               	"IgnoreCrcError"
#define cFilteredAreRead                "FilteredAreRead"
#define cDontShowRe                		"DontShowRe"
#define cLongIdWins						"LongIdWins"		/*DYJ 5.32j */
/*catgloba.c*/
#define cMausId                         "MausId"
#define cUserName                       "UserName"
#define cAvModus						"AvMode"

/* catmain */
#define cPrintCFGFile                   "PrintCFGFile"
#define cAlertsInWindow                 "AlertsInWindow"
#define cMiNTDomain                     "MiNTDomain"
#define cAllowEmptyCmd                  "AllowEmptyCmd"		/*DYJ 5.30*/

/* cathelp.c */
#define cExternHelp                     "ST-GuideHelp"

/* infofile.c */
#define cInfoGroupVisible               "InfoGroupVisible"

/* mime.c*/
#define cAttachTMode                  	"AttachTMode"
#define cAttachOName                  	"AttachOName"
#define cUseTosNames                  	"UseTosNames"
#define cMimeTyp                  		"MimeTyp."
#define cMimeExt                  		"MimeExt"
#define cUseTabsInMail					"UseTabsInMail"
#define cUseKeytab						"UseKeytab"
#define cCP1252Mode						"CP1252Mode"		/*DYJ 5.37b */

/* arcstart.c */
#define cNoCLS                          "NoCLS"
#define cOutfBckPath                    "OutfBckPath"

/* groupsel.c */
#define cGroupNum						"GroupNum"

#define cImportAtStart                  "ImportAtStart"
#define cMakeInfileAfterImport          "MakeInfileAfterImport"
#define cMakeInfileAtEnd                "MakeInfileAtEnd"
#define cWordWrap                       "WordWrap"
#define cDeleteAfterImport              "DeleteAfterImport"
#define cDeleteBeforeTerm               "DeleteBeforeTerm"
#define cAutoSaveOptions                "AutoSaveOptions"   /* !! Info-Text anders */
#define cStartTermAtStart               "StartTermAtStart"
#define cImportAfterTermPrg             "ImportAfterTermPrg"
#define cMakeInfileBeforeTerminal       "MakeInfileBeforeTerminal"
#define cTerminalAsOverlay              "TerminalAsOverlay"
#define cConvertDiaresis                "ConvertDiaresis"
#define cAutoUndo                       "AutoUndo"
#define cInfofilesReadOnly              "InfofilesReadOnly"
#define cIgnoreRead                     "IgnoreRead"
#define cButtonWindowPos                "ButtonWindowPos"
#define cRightMargin                    "RightMargin"
#define cWaitingTime                    "WaitingTime"
#define cUserString1                    "UserString1"
#define cUserString2                    "UserString2"
#define cRequestInfofiles               "RequestInfofiles"
#define cMessagesInInfile               "MessagesInInfile"
#define cGroupChangesInInfile           "GroupChangesInInfile"
#define cStatusMessagesInInfile         "StatusMessagesInInfile"
#define cInitialQuote                   "InitialQuote"
#define cBlkAftQuote                    "BlkAftQuote"
#define cSillyChecks                    "SillyChecks"   /* :-) */
#define cReferenceLine1                 "ReferenceLine1"
#define cReferenceLine1M                "ReferenceLine1M"	/*DYJ 5.30l */
#define cReferenceLine2                 "ReferenceLine2"
#define cWWVerkettung                 	"WWVerkettung"
#define cSortGroups                     "SortGroups"
#define cWatchBox                       "WatchBox"
#define cRedirectPacker                 "RedirectPacker"   /* wer benutzt schon ARC */
#define cAutomaticSplit                 "AutomaticSplit"
#define cSendParagraphs                 "SendParagraphs"
#define cIgnoreFiltered                 "IgnoreFiltered"
#define cMimeTextMode                 	"MimeTextMode"	/*DYJ 5.33b */
#define cSplitSize                      "SplitSize"
#define cMessageDateInInfile            "MessageDateInInfile"
#define cIsInternet                     "IsInternet"
#define cCatUserHome                    "CatUserHome"

/* fio_pcas.c */
#define cTruncExt						"TruncExt"
#endif /* __CAT_MSGVARNL_H__ */
