#ifndef __CAT_VDIUTIL_H__
#define __CAT_VDIUTIL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif


_VOID VDIUtil_SetObjColor(OBJECT *tr, _WORD ob, _WORD foreground, _WORD background);
/* Setzt die Farbe fuer ein Objekt */

_VOID VDIUtil_SetTreeColor(OBJECT *tr, _WORD foreground, _WORD background);
/* Farben fuer einen Objektbaum setzen */

_VOID VDIUtil_SetLongIntStr(OBJECT *tree, _WORD obj, _LONG val);
_BOOL VDIUtil_GetLongIntStr(OBJECT *tree, _WORD obj, _LONG *val);

_VOID VDIUtil_SetIntStr(OBJECT *tree, _WORD obj, _WORD val);
_BOOL VDIUtil_GetIntStr(OBJECT *tree, _WORD obj, _WORD *val);

_VOID VDIUtil_SetXString(OBJECT *tree, _WORD obj, OBJECT *sTree, _WORD idx);
_VOID VDIUtil_SetXStringAdr(OBJECT *tree, _WORD obj, OBJECT *sTree, _WORD idx);
_VOID VDIUtil_SetXState(OBJECT *tree, _WORD obj, _WORD xState);
_WORD VDIUtil_GetXState(OBJECT *tree, _WORD obj);

_WORD VDIUtil_FormHandle(OBJECT *form);

_BOOL VDIUtil_isKey(_UWORD *kstate, _UBYTE *scan, _UBYTE *ch);
/* sieht per event_multi nach, ob ein Buchstabe vorliegt */

/* Ein bisschen VDI-Erweiterung */
_VOID VDIUtil_Text(_BOOL isFSM, HVDI hdl, _WORD x, _WORD y, CONST _UBYTE *string);
_VOID VDIUtil_NText(_BOOL isFSM, HVDI hdl, _WORD x, _WORD y, CONST _UBYTE *string, _WORD len);
/* v_gtext */

_WORD VDIUtil_InqTextextend(_BOOL isFSM, HVDI hdl, CONST _UBYTE *string);
_WORD VDIUtil_InqNTextextend(_BOOL isFSM, HVDI hdl, CONST _UBYTE *string, _WORD len);
/* vqt_extent */

_VOID VDIUtil_SelectFont(HVDI handle, HWND wdw, _BOOL onlyMono, _WORD font, _WORD size);

#endif /* __CAT_VDIUTIL_H__ */
