#ifndef __CAT_WILDCARDS_H__
#define __CAT_WILDCARDS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

_BOOL WildCards_NameMatching(CONST _UBYTE *source, CONST _UBYTE *pattern);

_BOOL WildCards_MatchName(CONST _UBYTE *source, CONST _UBYTE *pattern, _BOOL ignoreCase);

#endif /* __CAT_WILDCARDS_H__ */
