/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __CAT_LISTUTILS_H__
#define __CAT_LISTUTILS_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#ifndef __CAT_MTUTILS_H__
#include <mtutils.h>
#endif

typedef struct _tPoint {
	_WORD x;
	_WORD y;
} tPoint;



_VOID ListUtils_WordArray(CONST GRECT *r1, CONST GRECT *r2, _WORD *arr);

GRECT ListUtils_FrameRects(CONST GRECT *r1, CONST GRECT *r2);

GRECT ListUtils_DiffVertRect(CONST GRECT *r1, CONST GRECT *r2);
/* liefert das Rechteck aus r1, das nicht von r2 ueberdeckt wird
 */

_VOID ListUtils_CalcAbsArea(OBJECT *tree, _WORD obj, GRECT *r);

/* slider Routinen */

_VOID ListUtils_formSetSlider(OBJECT *dial, _WORD parent, _WORD slider, _BOOL vertical, _LONG maxVal, _LONG currentVal, _BOOL draw);


#endif /* __CAT_LISTUTILS_H__ */
