/*
 * Diese Datei ist Teil des Megamax Modula-2 Entwicklungssytems,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Megamax Modula-2 ist Copyright (c) by Thomas Tempelmann.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <filename.h>
#include <file_io.h>
#include <routinec.h>


_VOID SplitPath(CONST _UBYTE *source, _UBYTE *path, _UBYTE *name)
{
	_UBYTE buf[PATH_MAX];
	
	if (path == NULL)
		path = buf;
	if (name == NULL)
		name = buf;
	strMcpy(name, PATH_MAX, F_Path_Basename(source));
	strMcpy(path, PATH_MAX, source);
	F_Path_Dirname(path);
	F_Path_Append(path, "");
}
