#ifndef __DIRENT_H__
#define __DIRENT_H__

#include <mintbind.h>

struct dirent {
	ino_t d_ino;
	char d_name[1];
};

typedef struct _dir {
	_DTA d_dta;
	long d_handle;
	struct dirent *d_dirent;
	int d_first;
} DIR;

DIR *opendir(const char *path);
struct dirent *readdir(DIR *dir);
int closedir(DIR *dir);
void rewinddir(DIR *dir);

#endif /* __DIRENT_H__ */
