/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZDO_H__
#define __PUTZ_PUTZDO_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __MOS_LISTS_H__
#include <lists.h>
#endif

/* CAT und CatPutz */

#ifndef __PUTZ_PUTZTYPES_H__
#include <putztype.h>
#endif


_WORD PutzDo_CountSelectedEntries(List *gr);

grListEntry *PutzDo_FirstSelectedGroup(List *gr);

grListEntry *PutzDo_NextSelectedGroup(List *gr, CAT_GROUP_NUMBER currentGroup);

grListEntry *PutzDo_GetGroupEntry(CAT_GROUP_NUMBER index);

_VOID PutzDo_SelectAll(_BOOL select);

_VOID PutzDo_CalcTotals(_VOID);

_VOID PutzDo_PerformDelete(HWND wdwHandle);

_VOID PutzDo_InitDelete(HWND wdwHandle);

_BOOL PutzDo_InitGroupFlags(CAT_GROUP_NUMBER groupIndex, _BOOL doAlts, putzOptsRec *options);

/*DYJ 5.36g Start*/
_BOOL PutzDo_GetGroupFlags(CONST _UBYTE *name, _BOOL doAlts, putzOptsRec *putzOpts,delState defNoAnsFlg);
/*DYJ  Ende; alt:	
_BOOL PutzDo_GetGroupFlags(CONST _UBYTE *name, _BOOL doAlts, putzOptsRec *putzOpts);
*/

_VOID PutzDo_SetGroupFlags(CONST _UBYTE *name, CONST putzOptsRec *putzOpts);

_VOID PutzDo_SetGroupNrFlags(CAT_GROUP_NUMBER groupIndex, CONST putzOptsRec *putzOpts);

_VOID PutzDo_DeleteGroupFlags(CAT_GROUP_NUMBER groupIndex);


#endif /* __PUTZ_PUTZDO_H__ */
