/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZLIST_H__
#define __PUTZ_PUTZLIST_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __PUTZ_PUTZTYPES_H__
#include <putztype.h>
#endif


_WORD PutzList_GetPartCount(_VOID);

_WORD PutzList_GetMaxLineWidth(_VOID);

_WORD PutzList_GetPartWidth(_WORD part);

TextJustification PutzList_GetPartJustification(displayListEntry *ptr, _WORD part);

_VOID PutzList_GetPart(displayListEntry *ptr, _WORD part, _UBYTE *str, size_t strsize, _BOOL fillUp);

_VOID PutzList_SetMaxNameLength(_WORD maxLen);

_BOOL PutzList_ParseFormat(CONST _UBYTE *format);

_VOID PutzList_InitFormat(_VOID);


#endif /* __PUTZ_PUTZLIST_H__ */
