/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZRSC_H__
#define __PUTZ_PUTZRSC_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __PORTAES_H__
#include <portaes.h>
#endif

#ifndef __MOS_LISTS_H__
#include <lists.h>
#endif

#ifndef __PUTZ_PUTZTYPES_H__
#include <putztype.h>
#endif


typedef GRECT TwoRects[2];


extern OBJECT *selectBox;
extern OBJECT *infoBox;
extern OBJECT *info2Box;
extern OBJECT *helpBox;
extern OBJECT *pathBox;
extern OBJECT *optBox;
extern OBJECT *actBox;
extern OBJECT *imBox;
extern OBJECT *menu;
extern _BOOL AutoSaveOptions;


/*DYJ 5.22a Start*/
_BOOL PutzRsc_InitResource(_VOID);
/*DYJ  Ende; alt:	
_BOOL PutzRsc_InitResource(CONST _UBYTE *resourceName);
*/

_VOID PutzRsc_LoadParameter(CONST _UBYTE *dataPath);

_VOID PutzRsc_SaveParameter(CONST _UBYTE *dataPath);

_VOID PutzRsc_doInfo(_VOID);

_BOOL PutzRsc_doOptBox(_BOOL oneGroup, putzOptsRec *putzOpts);

_VOID PutzRsc_doPathBox(_VOID);

_VOID PutzRsc_ClrRsrc(_VOID);

OBJECT *PutzRsc_GetTreeAddr(_WORD tree);

_UBYTE *PutzRsc_WrkString(_WORD nr);		/*DYJ 5.22a */

#endif /* __PUTZ_PUTZRSC_H__ */
