/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 23.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17h'
 *	Falls beim Lschen einer Gruppe Fehler beim Lschen oder umbenennen der Files
 *	auftreten mach CatPutz erstmal weiter und sagt dem user was er tuen soll.
 *
 * 6.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20u'
 *	Durch eine nicht initialisierte Variable schien ein Fehler in Catputz
 *	aufzutreten der aber gar nicht da war.
 *
 * 11.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20y'
 *	LOGFILE Ausgabe beim Lschen von Gruppen aktiviert.
 *
 * 16.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20zh'
 *	Bei falschen Verweisen kann es zu Abstrzen kommen, deshalb werden jetzt erst
 *	alle Verweise getestet und ggf. gelscht.
 *
 * 18.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21e'
 *	Falsche Fehlerausgabe
 *
 * 1.5.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36e'
 *	Eigentlich sollen beim Putzen von Nachrichten auch deren Anhnge
 *	gelscht werden, dies klappt aber naturgem ggf nicht bei
 *	defekten Nachrichten, also wird dies sicherheitshalber 
 *	erst garnicht mehr probiert
 */


#include <putzgrou.h>
#include <putzvers.h>
#include <putztype.h>
#include <putzlog.h>
#include <putzinit.h>
#include <putzacti.h>
#include <groupsel.h>
#include <catfiles.h>
#include <mtpaths.h>
#include <zcalccrc.h>
#include <data.h>

#include <mtappl.h>
#include <mtalerts.h>
#include <filename.h>
#include <magicsys.h>
#include <magicstr.h>
#include <magiccoo.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif
#include <routines.h>

#include <ro_mem.h>
#include <file_io.h>
#include <stddef.h>
#include <s_endian.h>
#include <strconv.h>
#include <wiederv2.h>
#include <PUTZRSC.H>	/*DYJ 5.36f */
#include <catputz.H>	/*DYJ 5.36f */

LOCAL _VOID chkWiederv(pBlock *param, delState *pdState);
LOCAL _UBYTE **wvor_IDs=NULL;
LOCAL _LONG wvor_anz=-1l;

/*DYJ 5.36f Start*/
/*DYJ  Ende; alt:	
#define AL_OPEN_GROUP         "[3][%P:|Die Gruppe kann|nicht ge\224ffnet werden!][[Abbruch]"
#define AL_CORRUPT_HEADER     "[3][%P:|Keine oder kaputte |CAT-Datenbank! |Header nicht in Ordnung!][[Abbruch]"
#define AL_TEMP_FILES         "[3][%P:|Kann tempor\204re Dateien|nicht anlegen!][[Abbruch]"
#define AL_MEM_MESSAGE_BUF    "[3][%P:|Kein Speicher f\201r|Messagebuffer frei!][[Abbruch]"
#define AL_CONFIRM_DELETE     "[2][%%P:|Soll die Gruppe|%s wirklich|gel\224scht werden?][[Ja|[Nein]"
#define AL_DELETE_GROUP       "[3][%P:|Konnte nicht alle Dateien l\224schen!|M\224glicherweise ist die Gruppe jetzt|besch\204digt. S.Logfile fr Rettung.][[Weiter]"
#define AL_RENAME_GROUP_FILES "[3][%P:|Konnte Gruppendateien nicht umbenennen!|M\224glicherweise ist die Datenbank jetzt|besch\204digt!S.Logfile fr Rettung.][[Weiter]"
#define AL_WRONG_BUF		  "[3][%P:|WriteBufer f\201r falsches File benutzt][[Abbruch]"

#define deletedText "<gel\224scht von CatPutz " CATPUTZ_XVERSION ">\012"
*/

#define getNewNums(a) a<
LOCAL putzOptsRec putzOpts;
  
LOCAL FILENO parFile = -1;
LOCAL FILENO datFile = -1;
LOCAL FILENO tabFile = -1;
LOCAL FILENO WaiFile = -1;
LOCAL FILENO NewWai = -1;
LOCAL FILENO newDat = -1;
LOCAL FILENO newPar = -1;
LOCAL FILENO newTab = -1;
      
LOCAL _WORD parVers;
LOCAL _ULONG datSize;
      

LOCAL CRC16 *tabArray=NULL,*newTabArray=NULL;
LOCAL MSGNR *newNums=NULL;
LOCAL MSGNR newNumsSize=0l;
LOCAL parFileType *parArray;
LOCAL parFileType *newParArray;

WAISEN *WaiArray;
MSGNR AnzWaisen,AnzDummyWai;
_BOOL DelWai;
LOCAL MSGNR *WaiNr;		/* Die Nummer des Waisen, bzw DummyWaisen*/
LOCAL _BOOL WaiBuffered;

     
      
      
LOCAL _UBYTE *datBuffer;

LOCAL _UBYTE *GlBuf; /* globaler Buffer */
LOCAL mess_len GlBufLen=0l; /* Lnge des globalen Buffers */
      
LOCAL _BOOL datBuffered;
LOCAL _BOOL tabBuffered;
LOCAL _BOOL parBuffered;
      
LOCAL MSGNR msgCounter;    /* Counter fuer neue Messagefiles */
      
LOCAL _ULONG bRead;

LOCAL MSGNR badMsg;
LOCAL MSGNR partDeleted;
LOCAL MSGNR deleted;
LOCAL MSGNR firstUnread;
LOCAL MSGNR unreadCounter;
      
LOCAL CAT_GROUP_NUMBER currentGroup;
LOCAL MSGNR AnzMessages;
      
LOCAL _BOOL hasFileLocking;
LOCAL _BOOL stopDelete;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

#if 0
LOCAL _ULONG MemAvail(_VOID)
{
	return (_ULONG)Malloc(-1L);
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID WriteBytes(FILENO f, CONST _VOID *addr, _ULONG bytes)
{
	_ULONG count;
	_WORD state;
	
	count = Fwrite(f, bytes, addr);
	if (count != bytes)
	{
		if ((_LONG)count < 0)
		{
			/* GEMDOS-Fehler */
			state = (_WORD)count;
		} else
		{
			state = notAllWritten;
		}
		F_ErrorAlert(state);
		stopDelete = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ReadBytes(FILENO f, _VOID *addr, _ULONG bytes, _ULONG *bytesRead)
{
	_WORD state;
	
	*bytesRead = Fread(f, bytes, addr);
	if ((*bytesRead) != bytes)
	{
		if ((_LONG)(*bytesRead) < 0)
		{
			/* GEMDOS-Fehler */
			state = (_WORD)(*bytesRead);
		} else
		{
			state = notAllRead;
		}
		F_ErrorAlert(state);
		stopDelete = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _UBYTE *Wbuffer;
LOCAL _ULONG WbufPos, WbufSize;
LOCAL FILENO WbufHdl;
LOCAL _ULONG BytesWritten;

/*
 * Liefert aktuelle Byteposition des Dateizeigers.
 */
LOCAL _ULONG FilePos(FILENO f)
{
	_ULONG fp;
	
	if (f == WbufHdl)
		fp = BytesWritten;
	else
		fp = Fseek(0L, f, 1);
	return fp;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _ULONG FileSize(FILENO f)
{
	_ULONG fp, size;
	XATTR xattr;
	
	/* MultiTOS (bzw. MiNT) scheint bei FSTAT noch einen Bug zu haben */
	if (!multiTOS && Fcntl(f, (_VOID *)&xattr, 0x4600 /* FSTAT */) == 0)
		return xattr.size;
	fp = Fseek(0L, f, 1);
	size = Fseek(0L, f, 2);
	/* Position wieder restaurieren */
	Fseek(fp, f, 0);
	return size;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL FILENO OpenFile(CONST _UBYTE *name)
{
	_UWORD mode;
	
	mode = FO_RW;
	if (hasFileLocking)
	{
		/* Jeglichen anderen Zugriff verbieten */
		mode |= 0x0010;
	}
	return (FILENO)Fopen(name, mode);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL FILENO CreateFile(CONST _UBYTE *name)
{
	return (FILENO)Fcreate(name, 0);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID WriteBuffered(FILENO fHdl, CONST _VOID *pbuf, _ULONG l)
{
	_ULONG remain;
	_ULONG wrBytes;
	CONST _UBYTE *buf;

	if(WbufHdl!=fHdl)
	{
/*DYJ 5.36f Start*/
		mtAlerts_Alert(1, PutzRsc_WrkString(AL_WRONG_BUF));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, AL_WRONG_BUF);
*/
		return;
	}
	
	buf = pbuf;
	if (WbufSize == 0)
	{
		WriteBytes(fHdl, buf, l);
	} else if (l + WbufPos > WbufSize)
	{
		remain = l;
		do
		{
			wrBytes = WbufSize - WbufPos;
			MemCpy(&Wbuffer[WbufPos], buf, wrBytes);
			buf += wrBytes;
			remain -= wrBytes;
			WbufPos += wrBytes;
			WriteBytes(fHdl, Wbuffer, WbufPos);
			if (stopDelete)
			{
				BytesWritten += l - remain;
				return;
			}
			WbufPos = 0;
		} while (remain >= WbufSize);
		MemCpy(&Wbuffer[WbufPos], buf, remain);
		WbufPos = remain;
	} else
	{
		MemCpy(&Wbuffer[WbufPos], buf, l);
		WbufPos += l;
	}
	BytesWritten += l;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MakeWriteBuffer(FILENO fHdl)
{
	Wbuffer = NULL;
	WbufSize = 0x80000L;
	while (Wbuffer == NULL && WbufSize > 0)
	{
		Wbuffer = SYSMALLOC(WbufSize, MEM_NOERR, "MakeWriteBuffer");
		if (Wbuffer == NULL)
			WbufSize -= 0x1000;
	}
	PutzLog_putTime();
	if (WbufSize == 0)
	{
		Wbuffer = NULL;
		PutzLog_WriteLine("Zuwenig Speicher f\201r Writebuffer");
	} else
	{
		WbufHdl = fHdl;
		PutzLog_WriteCard(WbufSize);
		PutzLog_WriteLine(" Bytes Writebuffer angelegt");
	}
	WbufPos = 0;
	BytesWritten = 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CloseWriteBuffer(FILENO fHdl)
{
	if (WbufSize > 0 && Wbuffer != NULL && fHdl == WbufHdl)
	{
		/* Buffer noch flushen */
		if (!stopDelete && WbufPos > 0)
			WriteBytes(fHdl, Wbuffer, WbufPos);
		FREE(Wbuffer, WbufSize);
		Wbuffer = NULL;
		WbufPos = 0;
		WbufSize = 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR getGroupMsgs(_VOID)
{
	MSGNR anz;
	if(FileSize(parFile)>dbHeaderLength)
	{
		if(parVers==dbVersion)
			anz=(MSGNR)( (FileSize(parFile) - dbHeaderLength) / sizeof(pBlock));
		else
			anz=(MSGNR)( (FileSize(parFile) - dbHeaderLength) / sizeof(pBlock_X));
	}
	else
		anz=0;
	return anz;
}

/*** ---------------------------------------------------------------------- ***/

#if 0
LOCAL _ULONG getGroupBytes(_VOID)
{
	return FileSize(datFile);
}
#endif

/*** ---------------------------------------------------------------------- ***/

/* Loesch-Funktionen  */
/* nicht auf dupeinfo anwenden wenn nicht gewrleistet ist, da es die richtige Verionsnummer hat*/
LOCAL _VOID GetDat(FILENO f, _ULONG start, _VOID *buf, _ULONG length, _ULONG *bytesRead)
{
	_VOID *sAddr;
	
	if (start < datSize && start + length <= datSize)
	{
		if (datBuffered)
		{
			sAddr = datBuffer + start;
			MemCpy(buf, sAddr, length);
			*bytesRead = length;
		} else
		{
			Fseek(start, f, 0);
			ReadBytes(f, buf, length, bytesRead);
		}
	} else
	{
		*bytesRead = 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CopyTab(MSGNR index)
{
	CRC16 theCrc[2];
	_ULONG bytesRead;
	if (tabBuffered)
	{
		newTabArray[msgCounter*2] 	= tabArray[index*2];
		newTabArray[msgCounter*2+1]	= tabArray[index*2+1];
	} else if(tabFile>-1)
	{
		Fseek((_LONG)index * sizeof(CRC16)*2l, tabFile, 0);
		ReadBytes(tabFile, theCrc, 2*sizeof(CRC16), &bytesRead);
		WriteBytes(newTab, theCrc, 2*sizeof(CRC16));
	}


}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CopyParam(pBlock *param)
{
	param->crc = ZCalcCrc_CalcCrcArray(&param->crc + 1, (_UWORD)(sizeof(*param) - offsetof(pBlock, crc) - sizeof(param->crc)));
	if (parBuffered)
		(newParArray->params)[msgCounter] = *param;
	else
		WriteBytes(newPar, param, sizeof(*param));
}


/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID partDelete(MSGNR idx, pBlock *param)
{
	MSGNR oldNum;
	_ULONG newStart;
	dupeInfoType dupeInfo;

	/* Erst mal auf gueltige Werte pruefen */
	if (param->Start < datSize &&
		param->hLength < 4096 &&
		param->idLength < 1024 &&
		param->Start + param->hLength + param->Length <= datSize)
	{
		_UBYTE dTxt[100];
		oldNum = idx;
		newNums[idx] = msgCounter;
		if (!(param->bits & bGelesen))
		{
			if (firstUnread == dataSys_empty)
				firstUnread = msgCounter;
			++unreadCounter;
		}
		
		/* Kopieren der einzelnen Datei-Teile */
		/* zuerst TAB-Datei */
		CopyTab(oldNum);
		if (stopDelete)
			return;
		/* Jetzt WaiNr verschieben */
		if(WaiNr)
			WaiNr[msgCounter]=WaiNr[oldNum];
		
		/* Jetzt DAT-Datei kopieren */
/*DYJ 5.36f Start*/
		sprintf(dTxt,"<%s CatPutz %s >\n",PutzRsc_WrkString(deletedText), CATPUTZ_XVERSION);
		GetDat(datFile, param->Start, GlBuf, param->hLength + strLen(dTxt)+1, &bRead);
		if (bRead != param->hLength + strLen(dTxt)+1)
			stopDelete = TRUE;
/*DYJ  Ende; alt:	
		GetDat(datFile, param->Start, GlBuf, param->hLength + sizeof(deletedText), &bRead);
		if (bRead != param->hLength + sizeof(deletedText))
			stopDelete = TRUE;
*/
		dupeInfo = *(dupeInfoType *)(&param->Datum);
		dupeInfo.setTerminator = Terminator;
		data_delAttach(param,GlBuf);
		newStart = FilePos(newDat);
		/* Redundaten Infos anpassen */
		dupeInfo.Datum = param->Datum;
		dupeInfo.items = param->items;
		dupeInfo.bits  = param->bits;
		dupeInfo.hLength  = param->hLength;
		dupeInfo.idLength = param->idLength;
		dupeInfo.Start  = newStart;
		dupeInfo.setTerminator = Terminator;
/*DYJ 5.36f Start*/
		if (param->Length >= strLen(dTxt))
		{
			param->Length = (data_offset)(strLen(dTxt));
/*DYJ  Ende; alt:	
		if (param->Length >= (sizeof(deletedText) - 1))
		{
			param->Length = (data_offset)(sizeof(deletedText) - 1);
*/
			dupeInfo.Length = param->Length;
			WriteBuffered(newDat, GlBuf, param->hLength);
			if (stopDelete)
				return;
/*DYJ 5.36f Start*/
			WriteBuffered(newDat, dTxt, param->Length);
/*DYJ  Ende; alt:	
			WriteBuffered(newDat, deletedText, param->Length);
*/
			if (stopDelete)
				return;
			WriteBuffered(newDat, &dupeInfo, sizeof(dupeInfo));
			if (stopDelete)
				return;
		} else
		{
			dupeInfo.Length = param->Length;
			WriteBuffered(newDat, GlBuf, param->hLength + param->Length);
			if (stopDelete)
				return;
			WriteBuffered(newDat, &dupeInfo, sizeof(dupeInfo));
			if (stopDelete)
				return;
		}
		
		/* Und jetzt noch PAR-Datei */
		param->Start = newStart;
		param->KomCount = 0;
		
		CopyParam(param);
		++msgCounter;
		++partDeleted;
	} else
	{
		newNums[idx] = dataSys_notSaved;
		++badMsg;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID noDelete(MSGNR idx, pBlock *param)
{
	MSGNR oldNum;
	_ULONG newStart;
	dupeInfoType dupeInfo;

	/* Erst mal auf gueltige Werte pruefen */
	if (param->Start < datSize &&
		param->hLength < 4096 &&
		param->idLength < 1024 &&
		param->Start + param->hLength + param->Length <= datSize)
	{
		oldNum = idx;
		newNums[idx] = msgCounter;
		if (!(param->bits & bGelesen))
		{
			if (firstUnread == dataSys_empty)
				firstUnread = msgCounter;
			++unreadCounter;
		}
		
		/* Kopieren der einzelnen Datei-Teile */
		/* zuerst TAB-Datei */
		CopyTab(oldNum);
		if (stopDelete)
			return;
		/* Jetzt WaiNr verschieben */
		if(WaiNr)
			WaiNr[msgCounter]=WaiNr[oldNum];
		
		/* Jetzt DAT-Datei kopieren */
		if((param->hLength + param->Length)>GlBufLen)
		{
			SFREE(GlBuf);
			GlBuf = MALLOC((GlBufLen=param->hLength + param->Length), "noDelete: message buffer");
			if (GlBuf == NULL)
			{
/*DYJ 5.36f Start*/
				mtAlerts_Alert(1,PutzRsc_WrkString(AL_MEM_MESSAGE_BUF));
/*DYJ  Ende; alt:	
				mtAlerts_Alert(1, AL_MEM_MESSAGE_BUF);
*/
				GlBufLen=0L;
				stopDelete = TRUE;
				return;
			}
		}
		GetDat(datFile, param->Start, GlBuf, param->hLength + param->Length, &bRead);
		if (bRead != param->hLength + param->Length)
			stopDelete = TRUE;
		dupeInfo = *(dupeInfoType *)(&param->Datum);
		dupeInfo.setTerminator = Terminator;
		newStart = FilePos(newDat);
		/*
		 * Fehler aus aelteren CatPutz-Versionen korrigieren, die bei
		 * teilgeloeschten Nachrichten ein '\0'-Byte zu viel geschrieben haben
		 */
		if (param->Length > 25 &&			/* muesste laenger als deletedText sein */
			GlBuf[param->hLength] == '<' &&	/* erstes Zeichn von deletedText */
			GlBuf[param->hLength + param->Length - 1] == '\0' &&
			GlBuf[param->hLength + param->Length - 2] == '\012')
			--param->Length;
		
		/* redundante Infos anpassen */
		dupeInfo.Datum = param->Datum;
		dupeInfo.items = param->items;
		dupeInfo.bits  = param->bits;
		dupeInfo.hLength  = param->hLength;
		dupeInfo.idLength = param->idLength;
		dupeInfo.Length = param->Length;
		dupeInfo.Start  = newStart;
		dupeInfo.setTerminator = Terminator;
		WriteBuffered(newDat, GlBuf, param->hLength + param->Length);
		if (stopDelete)
			return;
		WriteBuffered(newDat, &dupeInfo, sizeof(dupeInfo));
		if (stopDelete)
			return;
		
		/* Und jetzt noch PAR-Datei */
		param->Start = newStart;
		param->KomCount = 0;
		CopyParam(param);
		++msgCounter;
	} else
	{
		newNums[idx] = dataSys_notSaved;
		++badMsg;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID totalDelete(MSGNR idx, pBlock *param)
{
	if(param->items&itemAttachment)
	{
		/* Erst mal auf gueltige Werte pruefen */
		if (param->Start < datSize &&
			param->hLength < 4096 &&
			param->idLength < 1024 &&
			param->Start + param->hLength + param->Length <= datSize)
		{
			GetDat(datFile, param->Start, GlBuf, param->hLength, &bRead);
			if (bRead == param->hLength)
				data_delAttach(param,GlBuf);
		}
	}
	newNums[idx] = dataSys_notSaved;
	++deleted;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID badDelete(MSGNR idx, pBlock *param)
{
	if(param->items&itemAttachment)
	{
		/* Erst mal auf gueltige Werte pruefen */
		if (param->Start < datSize &&
			param->hLength < 4096 &&
			param->idLength < 1024 &&
			param->Start + param->hLength + param->Length <= datSize)
		{
			GetDat(datFile, param->Start, GlBuf, param->hLength, &bRead);
/*DYJ 5.36e Start*/
/*DYJ  Ende; alt:	
			if (bRead == param->hLength)
				data_delAttach(param,GlBuf);
*/
		}
	}
	newNums[idx] = dataSys_notSaved;
	++badMsg;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID closeGroup(_VOID)
{
	if (parFile >= 0)
	{
		Fclose(parFile);
		parFile = -1;
	}
	if (datFile >= 0)
	{
		Fclose(datFile);
		datFile = -1;
	}
	if (tabFile >= 0)
	{
		Fclose(tabFile);
		tabFile = -1;
	}
	if (WaiFile >= 0)
	{
		Fclose(WaiFile);
		WaiFile = -1;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID openGroup(_VOID)
{
	DB_NAMES dbf;
	_ULONG bRead;
	FileHeaderType fHeader;

	GroupSelect_makeFilenames(currentGroup, FALSE, &dbf,tmpPath);
	WaiFile = OpenFile(dbf.waiName);


	parFile = OpenFile(dbf.parName);
	tabFile = OpenFile(dbf.tabName);
	datFile = OpenFile(dbf.datName);
	if (!FILENO_OK(parFile) ||
		!FILENO_OK(datFile))
	{
		closeGroup();
/*DYJ 5.36f Start*/
		mtAlerts_Alert(1,PutzRsc_WrkString(AL_OPEN_GROUP) );
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, AL_OPEN_GROUP);
*/
		stopDelete = TRUE;
		return;
	}
	ReadBytes(parFile, &fHeader, sizeof(fHeader), &bRead);
	parVers=fHeader.Version;
	if(parVers!=dbVersion)		/* Statt TAB zwischen Version 1<->2 zu wandeln lsche ich sie, CAT kann sie dann neu erzeugen*/
	{
		if(FILENO_OK(tabFile))
			Fclose(tabFile);
		tabFile=-1;
		F_File_Delete(dbf.tabName);
	}
		
	if (bRead != sizeof(fHeader) ||
		fHeader.CatMagic != dbCatMagic ||
		fHeader.Version < dbVersMin ||
		fHeader.Version > dbVersMax ||
		fHeader.VersionMagic != dbVersionMagic)
	{
		closeGroup();
/*DYJ 5.36f Start*/
		mtAlerts_Alert(1,PutzRsc_WrkString(AL_CORRUPT_HEADER));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, AL_CORRUPT_HEADER);
*/
		stopDelete = TRUE;
		return;
	}
	Fseek(0L, parFile, 0);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID closeNewFiles(_VOID)
{
	if (newPar >= 0)
	{
		Fclose(newPar);
		newPar = -1;
	}
	if (newTab >= 0)
	{
		Fclose(newTab);
		newTab = -1;
	}
	if (newDat >= 0)
	{
		Fclose(newDat);
		newDat = -1;
	}
	if (NewWai >= 0)
	{
		Fclose(NewWai);
		NewWai = -1;
	}

}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID createNewFiles(_VOID)
{
	DB_NAMES dbf;

	GroupSelect_makeFilenames(currentGroup, TRUE, &dbf,tmpPath);

	if(FILENO_OK(WaiFile))
		NewWai = CreateFile(dbf.waiName);
	newPar = CreateFile(dbf.parName);

	if(FILENO_OK(tabFile))
		newTab = CreateFile(dbf.tabName);
	newDat = CreateFile(dbf.datName);
	if (!FILENO_OK(newPar) ||
	   (!FILENO_OK(newTab) && FILENO_OK(tabFile))  ||
	   (!FILENO_OK(NewWai) && FILENO_OK(WaiFile))  ||
		!FILENO_OK(newDat))
	{
		closeNewFiles();
/*DYJ 5.36f Start*/
		mtAlerts_Alert(1,PutzRsc_WrkString(AL_TEMP_FILES));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, AL_TEMP_FILES);
*/
		stopDelete = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID deleteNewFiles(_VOID)
{
	DB_NAMES dbf;

	GroupSelect_makeFilenames(currentGroup, TRUE, &dbf,tmpPath);

	F_File_Delete(dbf.waiName);
	F_File_Delete(dbf.parName);
	F_File_Delete(dbf.tabName);
	F_File_Delete(dbf.datName);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL moveFile(CONST _UBYTE *from, CONST _UBYTE *to)
{
	FILENO s, d;
	_UBYTE *mbuf;
	_ULONG slen, blen, pos, readB;
	
	if (F_Path_Rename(from, to) == GERR_OK)
		return TRUE;
	s = OpenFile(from);
	if (!FILENO_OK(s))
		return FALSE;
	slen = FileSize(s);
	blen = slen;
	mbuf = NULL;
	while (mbuf == NULL && blen)
	{
		mbuf = SYSMALLOC(blen, MEM_NOERR, "moveFile");
		if (mbuf == 0)
			blen >>= 1;
	}
	if (mbuf == NULL)
	{
		Fclose(s);
		return FALSE;
	}
	d = CreateFile(to);
	if (!FILENO_OK(d))
	{
		FREE(mbuf, blen);
		Fclose(s);
		return FALSE;
	}
	pos = 0L;
	while (pos + blen <= slen)
	{
		ReadBytes(s, mbuf, blen, &readB);
		if (stopDelete)
			break;
		WriteBytes(d, mbuf, blen);
		if (stopDelete)
			break;
		pos += blen;
	}
	if (pos < slen)
	{
		ReadBytes(s, mbuf, slen - pos, &readB);
		if (!stopDelete)
			WriteBytes(d, mbuf, slen - pos);
	}
	Fclose(s);
	Fclose(d);
	FREE(mbuf, blen);
	if (stopDelete)
		return FALSE;
	if (F_File_Delete(from) != GERR_OK)
	{
		stopDelete = TRUE;
		return FALSE;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID makeNewNames(_VOID)
{
	DB_NAMES dbf;
	DB_NAMES ndbf;
	
	GroupSelect_makeFilenames(currentGroup, TRUE, &ndbf,tmpPath);
	GroupSelect_makeFilenames(currentGroup, FALSE,&dbf,tmpPath);
	F_File_Delete(dbf.waiName);
	if(DelWai)
		F_File_Delete(ndbf.waiName);
	else
		moveFile(ndbf.waiName, dbf.waiName);

	F_File_Delete(dbf.parName);
	F_File_Delete(dbf.datName);
	F_File_Delete(dbf.tabName);
	moveFile(ndbf.parName, dbf.parName);
	moveFile(ndbf.datName, dbf.datName);
	moveFile(ndbf.tabName, dbf.tabName);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID openNewPar(_VOID)
{
	_UBYTE parName[PATH_MAX];
	_UBYTE gName[PATH_MAX];
	
	data_Number2Name(currentGroup, gName);
	strCat(gName, ".pa");	/*DYJ 5.20w */
	strCpy(parName, tmpPath);	/*DYJ 5.20w */
	F_Path_Append(parName, gName);
	newPar = OpenFile(parName);
}

/*** ------------------------------------------------------------------------ ***/
/*						*/
/*								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	10.12.00 von Dimitri Junker	DYJ 4.52b										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID openNewWai(_VOID)
{
	_UBYTE waiName[PATH_MAX];
	_UBYTE gName[PATH_MAX];
	_UWORD mode=FO_WRITE;
	
	data_Number2Name(currentGroup, gName);
	strCat(gName, ".wa");	/*DYJ 5.20w */
	strCpy(waiName, tmpPath);	/*DYJ 5.20w */
	F_Path_Append(waiName, gName);
	NewWai = OpenFile(waiName);
	if(NewWai<0 && !DelWai)
	{
		if (hasFileLocking)
		{
			/* Jeglichen anderen Zugriff verbieten */
			mode |= 0x0010;
		}
		NewWai=(FILENO)Fopen(waiName, mode);
		if(FILENO_OK(NewWai))
		{
			AnzWaisen=0;
			WriteBytes(NewWai,&AnzWaisen,sizeof(AnzWaisen));
			Fclose(NewWai);
		}
		NewWai = OpenFile(waiName);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID bufferNewWai(_VOID)												*/
/*	Im Gegensatz zum parArray/newParArray gibt es nur ein waiArray				*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	10.12.00 von Dimitri Junker	DYJ 4.52b										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID bufferNewWai(_VOID)
{
	_ULONG waiSize;
	
	if (!WaiBuffered &&AnzWaisen)
	{
		waiSize=AnzWaisen*sizeof(WAISEN);
	 	WaiArray = SYSMALLOC(waiSize, MEM_NOERR, "bufferNewWai");
		if (WaiArray != NULL)
		{
			Fseek(sizeof(AnzWaisen), NewWai, 0);
			ReadBytes(NewWai, WaiArray, waiSize, &bRead);
			if (bRead == waiSize)
				WaiBuffered = TRUE;
			else
			{
				SFREE(WaiArray);
				WaiArray = NULL;
			}
		}
	}
}


/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID BufferTabAndPar(_VOID)
{
	_ULONG tabSize, parSize;

	/* zuerst PAR buffern */
	parArray = NULL;
	newParArray = NULL;
	tabArray = NULL;
	newTabArray = NULL;
	AnzMessages=getGroupMsgs();
	parSize=dbHeaderLength+AnzMessages*sizeof(pBlock);

	if(newNumsSize<AnzMessages)
	{
		if(newNums)
			FREE(newNums,sizeof(MSGNR)*newNumsSize);
		newNums = NULL;
		if(WaiNr)
			FREE(WaiNr,sizeof(MSGNR)*newNumsSize);
		WaiNr = NULL;
		newNums = SYSMALLOC(sizeof(MSGNR)*AnzMessages, MEM_NOERR, "BufferTabAndPar: newNums");
		if (newNums == NULL)
			return;
		WaiNr = SYSMALLOC(sizeof(MSGNR)*AnzMessages, MEM_NOERR, "BufferTabAndPar: WaiNr");
		if (WaiNr == NULL)
		{
			FREE(newNums,sizeof(MSGNR)*AnzMessages);
			newNums = NULL;
			return;
		}
		newNumsSize=AnzMessages;
	}
	MemSet(newNums, 0xff, AnzMessages * sizeof(*newNums));

	parBuffered = FALSE;
	tabBuffered = FALSE;
	parArray = SYSMALLOC(parSize, MEM_NOERR, "BufferTabAndPar: par");
	if (parArray == NULL)
		return;
	newParArray = SYSMALLOC(parSize, MEM_NOERR, "BufferTabAndPar: newpar");
	if (newParArray == NULL)
	{
		FREE(parArray, parSize);
		parArray = NULL;
		return;
	}
	ReadBytes(parFile, &parArray->dbHeader, dbHeaderLength, &bRead);
	if(bRead==dbHeaderLength && !data_ReadFromPar(parFile,parVers,0,AnzMessages, parArray->params))
	{
		parBuffered = TRUE;
		newParArray->dbHeader = parArray->dbHeader;
		newParArray->dbHeader.Version = dbVersion;
	} else
	{
		FREE(newParArray, parSize);
		newParArray = NULL;
		FREE(parArray, parSize);
		parArray = NULL;
	}
	/* jetzt TAB puffern */
	if(!FILENO_OK(tabFile))
		return; 
	tabSize = FileSize(tabFile);
	tabArray = SYSMALLOC(tabSize, MEM_NOERR, "BufferTabAndPar: tab");
	if (tabArray == NULL)
		return;
	newTabArray = SYSMALLOC(tabSize, MEM_NOERR, "BufferTabAndPar: newtab");
	if (newTabArray == NULL)
	{
		FREE(tabArray, tabSize);
		tabArray = NULL;
		return;
	}
	ReadBytes(tabFile, tabArray, tabSize, &bRead);
	if (bRead == tabSize)
	{
		tabBuffered = TRUE;
	} else
	{
		FREE(newTabArray, tabSize);
		newTabArray = NULL;
		FREE(tabArray, tabSize);
		tabArray = NULL;
	}
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetParam(FILENO pFile, MSGNR index, pBlock *param)
{
	_WORD pVers;
	
	if (parBuffered)
	{
		*param = (parArray->params)[index];
	} else
	{
		if(pFile==parFile)
			pVers=parVers;
		else
			pVers=dbVersion;
		data_ReadFromPar(pFile,pVers,index,1, param);
	}
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID PutParam(FILENO pFile, MSGNR index, pBlock *param)
{
	param->crc = ZCalcCrc_CalcCrcArray(&param->crc + 1, (_UWORD)(sizeof(*param) - offsetof(pBlock, crc) - sizeof(param->crc)));
	if (parBuffered)
	{
		(parArray->params)[index] = *param;
	} else
	{
		Fseek(dbHeaderLength + index * sizeof(pBlock), pFile, 0);
		WriteBytes(pFile, param, sizeof(*param));
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID GetWaise(FILENO wFile, MSGNR index, WAISEN *waise)				*/
/*	Liest einen Waisen entweder aus dem buffer oder aus dem File				*/
/*	Parameter:	wFile:	Das File												*/
/*				index:	Nr des Waisen											*/
/*				waise:	Da soll es hinkopiert werden								*/
/*	Ergebnis:	keines															*/		
/*	24.11.00 von Dimitri Junker	DYJ 4.51a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID GetWaise(FILENO wFile, MSGNR index, WAISEN *waise)
{
	_ULONG bread;
	if (WaiBuffered)
		*waise = WaiArray[index];
	else
	{
		Fseek(sizeof(MSGNR) + index * sizeof(WAISEN), wFile, 0);
		ReadBytes(wFile, waise, sizeof(*waise), &bread);
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID PutWaise(FILENO wFile, MSGNR index, WAISEN *waise)				*/
/*	Schreibt einen Waiseneintrag ins File bzw in den Buffer						*/
/*	Parameter:	wFile:	Das File												*/
/*				index:	Nr des Waisen											*/
/*				waise:	Da steht es												*/
/*	Ergebnis:	keines															*/		
/*	24.11.00 von Dimitri Junker	DYJ 4.51a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID PutWaise(FILENO wFile, MSGNR index, WAISEN *waise)
{
	if (WaiBuffered)
	{
		WaiArray[index] = *waise;
	} else
	{
		Fseek(sizeof(MSGNR) + index * sizeof(WAISEN), wFile, 0);
		WriteBytes(wFile, waise, sizeof(*waise));
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID BufferWai(_VOID)												*/
/*	Puffert	das Waifile falls mglich											*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	24.11.00 von Dimitri Junker	DYJ 4.51a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID BufferWai(_VOID)
{
	_ULONG waiSize;
	MSGNR aktWai,aktMsg,geschMsg;
	pBlock param;
	WAISEN waise;
	/* WAI buffern */
	WaiArray = NULL;
	
	for(aktMsg=0;aktMsg<AnzMessages;aktMsg++)
/*DYJ 5.20zh Start*/
	{
		_BOOL err=FALSE;
		GetParam(parFile,aktMsg,&param);
		if(param.upMess>=AnzMessages && param.upMess<dataSys_notSaved)
		{
			PutzLog_putTime();
			PutzLog_WriteString("Fehler in der Messageverkettung von Nachricht ");
/*DYJ 5.21e Start*/
			PutzLog_WriteCard(aktMsg+1);
			PutzLog_WriteString(" gefunden. Diese zeigte nach oben auf: ");
			PutzLog_WriteCard(param.upMess+1);
/*DYJ  Ende; alt:	
			PutzLog_WriteCard(aktMsg);
			PutzLog_WriteString(" gefunden. Diese zeigte nach oben auf: ");
			PutzLog_WriteCard(param.upMess);
*/
			PutzLog_WriteLine(".");
			param.upMess=dataSys_empty;
			err=TRUE;
		}
		if(param.downMess>=AnzMessages && param.downMess<dataSys_notSaved)
		{
			PutzLog_putTime();
			PutzLog_WriteString("Fehler in der Messageverkettung von Nachricht ");
/*DYJ 5.21e Start*/
			PutzLog_WriteCard(aktMsg+1);
			PutzLog_WriteString(" gefunden. Diese zeigte nach unten auf: ");
			PutzLog_WriteCard(param.downMess+1);
/*DYJ  Ende; alt:	
			PutzLog_WriteCard(aktMsg);
			PutzLog_WriteString(" gefunden. Diese zeigte nach oben auf: ");
			PutzLog_WriteCard(param.upMess);
*/
			PutzLog_WriteLine(".");
			param.downMess=dataSys_empty;
			err=TRUE;
		}
		if(param.rightMess>=AnzMessages && param.rightMess<dataSys_notSaved)
		{
			PutzLog_putTime();
			PutzLog_WriteString("Fehler in der Messageverkettung von Nachricht ");
/*DYJ 5.21e Start*/
			PutzLog_WriteCard(aktMsg+1);
			PutzLog_WriteString(" gefunden. Diese zeigte nach rechts auf: ");
			PutzLog_WriteCard(param.rightMess+1);
/*DYJ  Ende; alt:	
			PutzLog_WriteCard(aktMsg);
			PutzLog_WriteString(" gefunden. Diese zeigte nach oben auf: ");
			PutzLog_WriteCard(param.upMess);
*/
			PutzLog_WriteLine(".");
			param.rightMess=dataSys_empty;
			err=TRUE;
		}
		if(param.leftMess>=AnzMessages && param.leftMess<dataSys_notSaved)
		{
			PutzLog_putTime();
			PutzLog_WriteString("Fehler in der Messageverkettung von Nachricht ");
/*DYJ 5.21e Start*/
			PutzLog_WriteCard(aktMsg+1);
			PutzLog_WriteString(" gefunden. Diese zeigte nach links auf: ");
			PutzLog_WriteCard(param.leftMess+1);
/*DYJ  Ende; alt:	
			PutzLog_WriteCard(aktMsg);
			PutzLog_WriteString(" gefunden. Diese zeigte nach oben auf: ");
			PutzLog_WriteCard(param.upMess);
*/
			PutzLog_WriteLine(".");
			param.leftMess=dataSys_empty;
			err=TRUE;
		}
		if(err)
			PutParam(parFile,aktMsg,&param);

/*DYJ  Ende; */
		WaiNr[aktMsg]=dataSys_empty;
	}		/*DYJ 5.20zh */
	WaiBuffered = FALSE;
	if(WaiFile<0)
	{
		AnzWaisen=0;
		DelWai= TRUE;
	}
	else
	{
		waiSize=FileSize(WaiFile);
		if(waiSize<sizeof(AnzWaisen))
		{
			AnzWaisen=0;
			waiSize=0;
		}
		else
		{
			ReadBytes(WaiFile, &AnzWaisen, sizeof(AnzWaisen), &bRead);
			waiSize-=sizeof(AnzWaisen);
			if((waiSize/sizeof(WAISEN))<AnzWaisen)
				AnzWaisen=waiSize/sizeof(WAISEN);
		}
		DelWai=FALSE;
	}
	waiSize=AnzWaisen*sizeof(WAISEN);
	if(AnzWaisen)
		WaiArray = SYSMALLOC(waiSize, MEM_NOERR, "BufferWai");
	else
		WaiArray = NULL;
	if(WaiArray)
	{
		ReadBytes(WaiFile, WaiArray, waiSize, &bRead);
		if (bRead == waiSize)
			WaiBuffered = TRUE;
		else
		{
			FREE(WaiArray, waiSize);
			WaiArray = NULL;
		}
		for(aktWai=0;aktWai<AnzWaisen;aktWai++)
		{
			GetWaise(WaiFile,aktWai,&waise);
			aktMsg=waise.msgNr;
			if(waise.crc[0]==(CRC16)dataSys_empty && waise.crc[1]==(CRC16)dataSys_empty)
			{
				while(aktMsg<AnzMessages)
				{
					GetParam(parFile,aktMsg,&param);
					param.upMess=dataSys_empty;
					PutParam(parFile,aktMsg,&param);
					aktMsg=param.rightMess;
				}
				waise.msgNr=dataSys_empty;
				PutWaise(WaiFile,aktWai,&waise);
			}
			else
			{
				while(aktMsg<AnzMessages)
				{
					WaiNr[aktMsg]=aktWai;
					GetParam(parFile,aktMsg,&param);
					aktMsg=param.rightMess;
				}
			}
		}
	}
/* Jede horizontale Reihe bekommt eine Nummer, falls es einen dazugehrigen Eintrag 
	in der Waisenliste gibt ist es oben bereits geschehen, sonst wird hier einfach
	eine laufende Nummer vergeben.*/
	aktWai=AnzWaisen;
	for(aktMsg=0;aktMsg<AnzMessages;aktMsg++)
	{
		if(WaiNr[aktMsg]==dataSys_empty)
		{
			GetParam(parFile,aktMsg,&param);
			if(param.rightMess!=dataSys_empty && param.leftMess==dataSys_empty)
			{
				geschMsg=aktMsg;
				do
				{
					WaiNr[geschMsg]=aktWai;
					if((geschMsg=param.rightMess)==dataSys_empty)
						break;
					GetParam(parFile,geschMsg,&param);
				}while(1);
				aktWai++;
			}
		}
	}		
	AnzDummyWai=aktWai-AnzWaisen;
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID BufferDatFile(_VOID)
{
	datSize = FileSize(datFile);
	datBuffered = FALSE;
	if(parVers!=dbVersion)
		return;
	
	datBuffer = SYSMALLOC(datSize, MEM_NOERR, "BufferDatFile");
	if (datBuffer == NULL)
		return;
	ReadBytes(datFile, datBuffer, datSize, &bRead);
	if (bRead == datSize)
	{
		datBuffered = TRUE;
	} else
	{
		FREE(datBuffer, datSize);
		datBuffer = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID killBuffer(_VOID)
{
	if (datBuffer != NULL)
	{
		SFREE(datBuffer);
		datBuffer = NULL;
	}
	if (newTabArray != NULL)
	{
		SFREE(newTabArray);
		newTabArray = NULL;
	}
	if (tabArray != NULL)
	{
		SFREE(tabArray);
		tabArray = NULL;
	}
	if (newParArray != NULL)
	{
		SFREE(newParArray);
		newParArray = NULL;
	}
	if (parArray != NULL)
	{
		SFREE(parArray);
		parArray = NULL;
	}
	if (WaiArray != NULL)
	{
		SFREE(WaiArray);
		WaiArray = NULL;
	}
	
}



/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL CheckLongDate(MAUSDATE date)
{
	_UWORD c1, year, m, d;
	
	/* Jahr */
	year = (_WORD)(date / 100000000UL);
	date %= 100000000UL;
	year += 1990;
	/* Jetzt ist das Jahr bestimmt. */ 
	if (year < 1980) 
		return FALSE;
	/* Monat */
	c1  = (_WORD)(date / 10000000UL);
	m = c1 * 10;
	date %= 10000000UL;
	c1 = (_WORD)(date / 1000000UL);
	m = m + c1;
	if (m < 1 || m > 12)
		return FALSE;
	date %= 1000000UL;
	/* Tag */
	c1 = (_WORD)(date / 100000UL);
	d  = c1 * 10;
	date %= 100000UL;
	c1 = (_WORD)(date / 10000UL);
	d  = d + c1;
	if (d < 1 || d > 31)
		return FALSE;
	date %= 10000UL;
	/* Stunde */
	c1  = (_WORD)(date / 1000UL);
	date %= 1000UL;
	m = c1; 
	c1 = (_WORD)(date / 100UL);
	m = m * 10 + c1;               /* Stunde */
	if (m > 23)
		return FALSE;
	date %= 100UL;
	/* Minute */
	c1 = (_WORD)(date / 10);
	date %= 10UL;
	m = c1 * 10 + (_WORD)(date);
	if (m > 59)
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL IsMessOk(pBlock *param)
{
	return (param->Start < datSize) &&
		(param->hLength < 4096) &&
		(param->idLength < 1024) &&
		(param->Start + param->hLength + param->Length <= datSize) &&
		CheckLongDate(param->Datum);
}

/*** ------------------------------------------------------------------------ ***/
/*	_BOOL tstDat(pBlock *param)													*/
/*	Macht 2 Tests zur Prfung der DAT											*/
/*	Parameter:	param:	PAR-Info zur msg															*/
/*	Ergebnis:	OK?															*/		
/*	4.3.03 von Dimitri Junker	DYJ 5.21l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL tstDat(pBlock *param)
{
	struct{
		_UBYTE	endId[2];
		_WORD	anz;
		_WORD offs0;
	}datTst;
	_ULONG br;
	GetDat(datFile, param->Start + ((param->idLength-1)&0xfffe), &datTst, sizeof(datTst), &br);
	if(datTst.endId[(param->idLength-1)&1] || ((datTst.anz+1)*sizeof(data_offset)+param->idLength+(param->idLength&1))!=datTst.offs0)
		return FALSE;
	else
		return TRUE;
}
/*** ---------------------------------------------------------------------- ***/
LOCAL delState deleteByFlags(pBlock *param, MSGNR idx, _WORD pass)
{
	pInfoType pInfo;
	_ULONG br;
	UNUSED(idx);
	UNUSED(pass);
	/* Erst mal auf gueltige Werte pruefen */
	if (!IsMessOk(param))
		return badMess;
	/* Hier muss jetzt nur bei der privaten Gruppe auch noch das 
	 * Statusdatum geprueft werden
	 */
/*DYJ 5.36g Start*/
	if (putzOpts.noAnsFlg == noDel)
/*DYJ  Ende; alt:	
	if (currentGroup == dataSys_private)
*/
	{
		GetDat(datFile, param->Start + param->hLength - sizeof(pInfoType), &pInfo, sizeof(pInfo), &br);
		if (!CheckLongDate(pInfo.LeseDatum))
		{
			return badMess;
		}
		if (pInfo.Status == 'Z' || pInfo.Status == 'N')
		{
			if (param->bits & bTotalloeschung)
			{
				return totalDel;
			} else if (param->bits & bTeilloeschung)
			{
				if (param->KomCount == 0 && putzOpts.delWithoutComm)
					return totalDel;
				else
					return partDel;
			}
			return noDel;
		}
	}
/*DYJ 5.21l Start*/
	if(!tstDat(param))
		return badMess;
/*DYJ  Ende; */
	if ((putzOpts.intFlag == noDel && (param->bits & bInteressant)) ||
		(putzOpts.usrFlg1 == noDel && (param->bits & bUser1)) ||
		(putzOpts.usrFlg2 == noDel && (param->bits & bUser2)) ||
		(putzOpts.filtFlg == noDel && (param->bits & bFiltered)) ||
		(putzOpts.readFlg == noDel && (param->bits & bGelesen)))
	{
		return noDel;
	}
	if (param->bits & bTotalloeschung)
	{
		return totalDel;
	} else if (param->bits & bTeilloeschung)
	{
		if (param->KomCount == 0 && putzOpts.delWithoutComm)
			return totalDel;
		else
			return partDel;
	}
	if (putzOpts.deleteByDate && (param->Datum > putzOpts.delDate))
	{
		return noDel;
	}
	if ((putzOpts.intFlag == totalDel && (param->bits & bInteressant)) ||
		(putzOpts.usrFlg1 == totalDel && (param->bits & bUser1)) ||
		(putzOpts.usrFlg2 == totalDel && (param->bits & bUser2)) ||
		(putzOpts.filtFlg == totalDel && (param->bits & bFiltered)) ||
		(putzOpts.readFlg == totalDel && (param->bits & bGelesen)))
	{
		return totalDel;
	}
	if ((putzOpts.intFlag == partDel && (param->bits & bInteressant)) ||
		(putzOpts.usrFlg1 == partDel && (param->bits & bUser1)) ||
		(putzOpts.usrFlg2 == partDel && (param->bits & bUser2)) ||
		(putzOpts.filtFlg == partDel && (param->bits & bFiltered)) ||
		(putzOpts.readFlg == partDel && (param->bits & bGelesen)))
	{
		if (param->KomCount == 0)
			return totalDel;
		else
			return partDel;
	}
	if (putzOpts.noRdFlg != ignoreFlag && !(param->bits & bGelesen))
		return putzOpts.noRdFlg;
	return noDel;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL delState deleteDate(pBlock *param, MSGNR idx, _WORD pass)
{
	pInfoType pInfo;
	_ULONG br;
	
	UNUSED(idx);
	UNUSED(pass);
	/* Erst mal auf gueltige Werte pruefen */
	if (!IsMessOk(param))
		return badMess;
	/* Hier muss jetzt nur bei der privaten Gruppe auch noch das 
	 * Statusdatum geprueft werden
	 */
	if (currentGroup == dataSys_private)
	{
		GetDat(datFile, param->Start + param->hLength - sizeof(pInfoType), &pInfo, sizeof(pInfo), &br);
		if (!CheckLongDate(pInfo.LeseDatum))
			return badMess;
		if (pInfo.Status == 'Z' || pInfo.Status == 'N')
		{
			if (param->bits & bTotalloeschung)
			{
				return totalDel;
			} else if (param->bits & bTeilloeschung)
			{
				if (param->KomCount == 0 && putzOpts.delWithoutComm)
					return totalDel;
				else
					return partDel;
			}
			return noDel;
		}
	}
/*DYJ 5.21l Start*/
	if(!tstDat(param))
		return badMess;
/*DYJ  Ende; */
	if (putzOpts.deleteByDate && param->Datum > putzOpts.delDate)
		return noDel;
	if (param->bits & bInteressant)
		return noDel;
	return totalDel;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR newAnz, minIdx;

LOCAL delState deleteDateAndNum(pBlock *param, MSGNR idx, _WORD pass)
{
	pInfoType pInfo;
	_ULONG br;
	delState res;

	/* Erst mal auf gueltige Werte pruefen */
	if (!IsMessOk(param))
		return badMess;
		
	/* Hier muss jetzt nur bei der privaten Gruppe auch noch das 
	 * Statusdatum geprueft werden
	 */
	if (currentGroup == dataSys_private)
	{
		GetDat(datFile, param->Start + param->hLength - sizeof(pInfoType), &pInfo, sizeof(pInfo), &br);
		if (!CheckLongDate(pInfo.LeseDatum))
			return badMess;
		if (pInfo.Status == 'Z' || pInfo.Status == 'N')
		{
			if (param->bits & bTotalloeschung)
			{
				return totalDel;
			} else if (param->bits & bTeilloeschung)
			{
				if (param->KomCount == 0 && putzOpts.delWithoutComm)
					return totalDel;
				else
					return partDel;
			}
			return noDel;
		}
	}
	if (pass == 1)
	{
/*DYJ 5.21l Start*/
		if(!tstDat(param))
			return badMess;
/*DYJ  Ende; */
		if (param->Datum > putzOpts.delDate)
		{
			if (newAnz >= putzOpts.number)
			{
				res = totalDel;
			} else
			{
				++newAnz;
				res = noDel;
			}
		} else
		{
			res = totalDel;
		}
		if (res == noDel)
			minIdx = idx;
		return res;
	} else
	{
		/* pass > 1 */
		if (idx >= minIdx)
		{
			if (param->Datum > putzOpts.delDate)
			{
				return noDel;
			} else
			{
				if (param->bits & bInteressant)
					return noDel;
				return totalDel;
			}
		} else
		{
			if (param->bits & bInteressant)
				return noDel;
			return totalDel;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL delState deleteNum(pBlock *param, MSGNR idx, _WORD pass)
{
	pInfoType pInfo;
	_ULONG br;
	delState res;

	/* Erst mal auf gueltige Werte pruefen */
	if (!IsMessOk(param))
		return badMess;
	
	/* Hier muss jetzt nur bei der privaten Gruppe auch noch das 
	 * Statusdatum geprueft werden
	 */
	if (currentGroup == dataSys_private)
	{
		GetDat(datFile, param->Start + param->hLength - sizeof(pInfoType), &pInfo, sizeof(pInfo), &br);
		if (!CheckLongDate(pInfo.LeseDatum))
			return badMess;
		if (pInfo.Status == 'Z' || pInfo.Status == 'N')
		{
			if (param->bits & bTotalloeschung)
			{
				return totalDel;
			} else if (param->bits & bTeilloeschung)
			{
				if (param->KomCount == 0 && putzOpts.delWithoutComm)
					return totalDel;
				else
					return partDel;
			}
			return noDel;
		}
	}
	if (pass == 1)
	{
/*DYJ 5.21l Start*/
		if(!tstDat(param))
			return badMess;
/*DYJ  Ende; */
		if (newAnz >= putzOpts.number)
		{
			res = totalDel;
		} else
		{
			++newAnz;
			res = noDel;
		}
		if (res == noDel)
			minIdx = idx;
		return res;
	} else
	{
		/* pass > 1 */
		if (idx >= minIdx)
		{
			return noDel;
		} else
		{
			if (param->bits & bInteressant)
				return noDel;
			return totalDel;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL deleteProc shouldBeDeleted;

LOCAL _WORD doDelete(_VOID)
{
	MSGNR i;
	delState dState;
	pBlock param;
	_WORD pass;
	_BOOL doPass2;
	doPass2 = FALSE;
	pass = 0;
	if (putzOpts.dMode == PutzTypes_dNum || putzOpts.dMode == PutzTypes_dDateAndNum)
	{
		/* First pass! */
		pass = 1;
		newAnz = 0;
		minIdx = AnzMessages;
		for (i = AnzMessages; i != 0; )
		{
			--i;
			GetParam(parFile, i, &param);
			if (!PutzAction_TellAction(4, AnzMessages - i))
			{
				stopDelete = TRUE;
				return 0;
			}
			dState = shouldBeDeleted(&param, i, pass);
			if (dState == badMess)
				doPass2 = TRUE;
		}
		PutzLog_putTime();
		PutzLog_WriteString("Pass 1 beendet");
		PutzLog_WriteLn();
		if (putzOpts.dMode == PutzTypes_dNum && !doPass2)
		{
			if (putzOpts.number >= AnzMessages - 1)
			{
				PutzLog_putTime();
				PutzLog_WriteString("Pass 2 wird nicht ben\224tigt, nichts zu l\224schen");
				PutzLog_WriteLn();
				return 1;
			}
		}
	} else
	{
		PutzLog_putTime();
		PutzLog_WriteString("Pass 1 wird nicht ben\224tigt, \201bersprungen");
		PutzLog_WriteLn();
	}
	++pass;
	PutzAction_BeginNextPass(1);
	for (i = 0; i < AnzMessages; i++)
	{
		GetParam(parFile, i, &param);
		if (!PutzAction_TellAction(1, i + 1))
		{
			stopDelete = TRUE;
			return 0;
		}
		if ((i == AnzMessages-1) && (msgCounter == 0))
			dState = noDel;
		else
			dState = shouldBeDeleted(&param, i, pass);
		chkWiederv(&param, &dState);
		switch (dState)
		{
			case -1:
				PutzLog_putTime();
				PutzLog_WriteString("Pass 2 wg.Speichermangel abgebrochen");
				return 2;
			case partDel : partDelete(i, &param); break;
			case noDel   : noDelete(i, &param); break;
			case totalDel: totalDelete(i, &param); break;
			case badMess : badDelete(i, &param); break;
			default: break;
		}
		if (stopDelete)
			return 0;
		/*
		PutParam (parFile, i, parArray, param);
		*/
	}
	PutzLog_putTime();
	PutzLog_WriteString("Pass 2 beendet");
	PutzLog_WriteLn();
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FlushParam(FILENO pFile, _VOID *addr)
{
	if (parBuffered)
	{
		Fseek(0L, pFile, 0);
		WriteBytes(pFile, addr, dbHeaderLength + msgCounter * sizeof(pBlock));
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID FlushWaisen(FILENO wFile, _VOID *addr)							*/
/*	Schreibt gepufferte Waisen ins File											*/
/*	Parameter:	wFile:	Das Ziel												*/
/*				addr:	Die Quelle												*/
/*	Ergebnis:	keines															*/		
/*	8.11.00 von Dimitri Junker	DYJ 4.51a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID FlushWaisen(FILENO wFile, _VOID *addr)
{
	if (WaiBuffered)
	{
		Fseek(0L, wFile, 0);
		WriteBytes(wFile,&AnzWaisen,sizeof(AnzWaisen));
		WriteBytes(wFile, addr, AnzWaisen * sizeof(WAISEN));
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FlushTab(FILENO pFile, _VOID *addr)
{
	if (tabBuffered)
	{
		Fseek(0L, pFile, 0);
		WriteBytes(pFile, addr, msgCounter * sizeof(CRC16)*2);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID bufferNewPar(_VOID)
{
	_ULONG parSize;
	
	AnzMessages = msgCounter;
	parSize = AnzMessages * sizeof(pBlock) + dbHeaderLength;
	if (parBuffered)
	{
		MemCpy(parArray, newParArray, parSize);
		SFREE(newParArray);
		newParArray = NULL;
	} else
	{
		parArray = SYSMALLOC(parSize, MEM_NOERR, "bufferNewPar");
		if (parArray != NULL)
		{
			Fseek(0L, newPar, 0);
			ReadBytes(newPar, parArray, parSize, &bRead);
			if (bRead == parSize)
			{
				parBuffered = TRUE;
			} else
			{
				SFREE(parArray);
				parArray = NULL;
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR IncCommCount(FILENO pFile, MSGNR index, MSGNR comment)
{
	MSGNR child;
	pBlock param;

	GetParam(pFile, index, &param);
	++param.KomCount;
	if (param.KomCount == 1)
	{
		param.downMess = comment;
		if (param.downMess == dataSys_notSaved)
		{
			param.downMess = dataSys_empty;
			param.KomCount = 0;
		}
		PutParam(pFile, index, &param);
		index=dataSys_empty;
	}
	else
	{
		PutParam(pFile, index, &param);
		index=dataSys_empty;
		child=param.downMess;
		while(child<AnzMessages)
		{
			GetParam(pFile, child, &param);
			index=child;
			child=param.rightMess;
		}
		if(index<AnzMessages)
		{
			param.rightMess=comment;
			PutParam(pFile, index, &param);
		}
		else
			index=dataSys_empty;
	}
	return index;
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL MSGNR IncWaiCount(FILENO pFile,FILENO wFile, MSGNR comment)			*/
/*	Fgt eine Msg zum zugehrigen Waisen hinzu									*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	24.11.00 von Dimitri Junker	DYJ 4.51a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL MSGNR IncWaiCount(FILENO pFile,FILENO wFile, MSGNR comment)
{
	pBlock param;
	WAISEN waise;
	MSGNR index,child;
	if((index=WaiNr[comment])>=AnzWaisen)	/* Entweder kein Waise oder DummyWaise*/
		return dataSys_empty;
	GetWaise(wFile,index , &waise);
	++waise.kommentarAnzahl;
	if (waise.kommentarAnzahl == 1)
	{
		waise.msgNr = comment;
		if (waise.msgNr == dataSys_notSaved)
		{
			waise.msgNr = dataSys_empty;
			waise.kommentarAnzahl = 0;
		}
		PutWaise(wFile, index, &waise);
		index=dataSys_empty;
	}
	else
	{
		PutWaise(wFile, index, &waise);
		index=dataSys_empty;
		child=waise.msgNr;
		while(child<AnzMessages)
		{
			GetParam(pFile, child, &param);
			index=child;
			child=param.rightMess;
		}
		if(index<AnzMessages)
		{
			param.rightMess=comment;
			PutParam(pFile, index, &param);
		}
		else
			index=dataSys_empty;
	}
	WaiNr[comment]=dataSys_empty;	/*Ist abgearbeitet*/
	return index;
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID makeNewLinks(_VOID)
{
	MSGNR i;
	pBlock param;
	WAISEN waise;
	MSGNR *dummyWai=NULL,dWai;
	pBlock paramL;
	
	if(AnzDummyWai)
	{
		dummyWai = SYSMALLOC(sizeof(MSGNR)*AnzDummyWai, MEM_NOERR, "makeNewLinks: dummyWai");
		if(dummyWai)
		{
			for (i = 0; i < AnzDummyWai; i++)
				dummyWai[i] = dataSys_empty;
		}
	}
/* Alle wichtige Info steht in upMess und WaiNr	-> den Rest erstmal lschen*/
	for (i = 0; i < AnzWaisen; i++)
	{
		GetWaise(NewWai, i, &waise);
		waise.kommentarAnzahl = 0;
		waise.msgNr = dataSys_empty;
		PutWaise(NewWai, i, &waise);
	}
/*DYJ  Ende; 	*/

	for (i = 0; i < AnzMessages; i++)
	{
		GetParam(newPar, i, &param);
		param.KomCount = 0;
		param.downMess = dataSys_empty;
		param.rightMess = dataSys_empty;
		param.leftMess = dataSys_empty;
		PutParam(newPar, i, &param);
	}

/*Jetzt wieder aufbauen*/		
	for (i = 0; i < AnzMessages; i++)
	{
		GetParam(newPar, i, &param);
		/* Kommentare bearbeiten */
	/* 1.Versuch: upMess existiert noch	*/
		if (param.upMess < dataSys_notSaved)
		{
			if(newNums[param.upMess]!=i)
				param.upMess = newNums[param.upMess];
			else
				param.upMess = dataSys_empty;
			if (param.upMess < AnzMessages)
			{
				param.leftMess=IncCommCount(newPar, param.upMess, i);
				WaiNr[i]=dataSys_empty;	/*Ist abgearbeitet*/
			}
		}
	/* 2.Versuch: Es gibt einen Eintrag in der Waisenliste	*/
		if (param.upMess == dataSys_notSaved)
			param.leftMess=IncWaiCount(newPar,NewWai, i);
	/* 3.Versuch: Verkettung ber Dummy-Waisen	*/
		if(dummyWai && WaiNr[i]!=dataSys_empty)
		{
			dWai=WaiNr[i]-AnzWaisen;
			if(dummyWai[dWai]!=dataSys_empty)	/* dann hatten wir schon einen aus der Reihe	*/
			{
				param.leftMess=dummyWai[dWai];
				GetParam(newPar, dummyWai[dWai], &paramL);
				paramL.rightMess=i;
				PutParam(newPar, dummyWai[dWai], &paramL);
			}
			dummyWai[dWai]=i;
		}
		PutParam(newPar, i, &param);
	}
	if(dummyWai)
		FREE(dummyWai,sizeof(MSGNR)*AnzDummyWai);
}
/*DYJ  Ende; alt:	

LOCAL _VOID makeNewLinks(_VOID)
{
	MSGNR i;
	pBlock param;
	
	for (i = 0; i < AnzMessages; i++)
	{
		GetParam(newPar, i, &param);
#if 0
		if (currentGroup == dataSys_private)
		{
			if (Question < dataSys_notSaved)
			{
				Question = newNums[Question];
				if (Question != dataSys_notSaved && Question >= i)
					Question = dataSys_notSaved;
			}
			if (Answer < dataSys_notSaved)
			{
				Answer = newNums[Answer];
				IF (Answer != dataSys_notSaved && Answer <= i)
					Answer = dataSys_notSaved;
			}
			if (Answer == dataSys_notSaved)
				Answer = dataSys_empty;
		} else
#endif
		{
			/* Kommentare bearbeiten */
			if (param.upMess < dataSys_notSaved)
			{
				param.upMess = newNums[param.upMess];
				if (param.upMess != dataSys_notSaved && param.upMess >= i)
					param.upMess = dataSys_notSaved;
				if (param.upMess < dataSys_notSaved && param.upMess < AnzMessages)
					IncCommCount(newPar, param.upMess, i);
			}
			if (param.downMess < dataSys_notSaved)
			{
				param.downMess = newNums[param.downMess];
				if (param.downMess != dataSys_notSaved && (param.downMess <= i || param.downMess >= AnzMessages))
					param.downMess = dataSys_notSaved;
			}
			if (param.downMess == dataSys_notSaved || param.downMess > AnzMessages)
			{
				param.downMess = dataSys_empty;
				param.KomCount = 0;
			}
			if (param.rightMess < dataSys_notSaved)
			{
				param.rightMess = newNums[param.rightMess];
				if (param.rightMess != dataSys_notSaved && (param.rightMess >= i || param.rightMess >= AnzMessages))
					param.rightMess = dataSys_notSaved;
			}
			if (param.rightMess == dataSys_notSaved)
				param.rightMess = dataSys_empty;
			if (param.leftMess < dataSys_notSaved)
			{
				param.leftMess = newNums[param.leftMess];
				if (param.leftMess != dataSys_notSaved && (param.leftMess <= i || param.leftMess >= AnzMessages))
					param.leftMess = dataSys_notSaved;
				if (param.leftMess == dataSys_notSaved && param.upMess < dataSys_notSaved && param.upMess < AnzMessages)
					param.leftMess = buildNewRight(newPar, param.upMess, i);
			}
			if (param.leftMess == dataSys_notSaved || param.leftMess >= AnzMessages)
				param.leftMess = dataSys_empty;
		}
		PutParam(newPar, i, &param);
	}


}
*/



/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID linkNewPar(_VOID)
{
	openNewPar();
	bufferNewPar();
	openNewWai();
	bufferNewWai();
	if (AnzMessages > 0)
	{
		/* Neue Verkettung aufbauen */
		makeNewLinks();
	}
	if (parBuffered)
	{
		FlushParam(newPar, parArray);
		SFREE(parArray);
		parArray = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID updateWai(_VOID)
{
	MSGNR i,anzWaiNeu=0;
	WAISEN waise;
	
	for(i=0;i<AnzWaisen;i++)
	{
		GetWaise(WaiFile,i,&waise);
		if(waise.msgNr<dataSys_notSaved)
			PutWaise(NewWai,anzWaiNeu++,&waise);
	}
	AnzWaisen=anzWaiNeu;
	if (WaiBuffered)
	{
		FlushWaisen(NewWai, WaiArray);
		SFREE(WaiArray);
		WaiArray = NULL;
	}
	else
	{
		if(FILENO_OK(NewWai))
		{
			Fseek(0L, NewWai, 0);
			WriteBytes(NewWai,&AnzWaisen,sizeof(AnzWaisen));
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
typedef enum { aktuellePos, neuePos, letztePos, unreadPos, unreadCount } posType;
typedef enum { actualPos, newPos, lastPos } PositionType;
*/


/*** ---------------------------------------------------------------------- ***/


GLOBAL _BOOL PutzGroup_deleteInGroup(grListEntry *group, CONST putzOptsRec *options, delMode mode)
{
	_ULONG rdB;
	_WORD res;
	FileHeaderType header;
	hasFileLocking = FindCookie(COOKIE_DosFlock, NULL);
	currentGroup = group->info->catNumber;
	stopDelete = FALSE;
	switch (mode)
	{
		case PutzTypes_dFlags     : shouldBeDeleted = deleteByFlags; break;
		case PutzTypes_dDate      : shouldBeDeleted = deleteDate;    break;
		case PutzTypes_dNum       : shouldBeDeleted = deleteNum;     break;
		case PutzTypes_dDateAndNum: shouldBeDeleted = deleteDateAndNum; break;
		default: return FALSE;
	}
	putzOpts = *options;
	GlBuf = MALLOC((GlBufLen=80000L), "PutzGroup_deleteInGroup: message buffer");
	if (GlBuf == NULL)
	{
/*DYJ 5.36f Start*/
		mtAlerts_Alert(1,PutzRsc_WrkString(AL_MEM_MESSAGE_BUF));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, AL_MEM_MESSAGE_BUF);
*/
		return FALSE;
	}
	openGroup();
	if (stopDelete)
	{
		closeGroup();
		SFREE(GlBuf);
		GlBuf = NULL;
		GlBufLen=0L;
		return FALSE;
	}
	PutzAction_ReInitActionBox(group->info->name, getGroupMsgs());
	PutzLog_putTime();
	PutzLog_WriteString("Gruppenwechsel zu ");
	PutzLog_WriteString(group->info->name);
	PutzLog_WriteString(", ");
	PutzLog_WriteCard(getGroupMsgs());
	PutzLog_WriteString(" Messages zu bearbeiten mit ");
	PutzLog_WriteCard(group->preBytes);
	PutzLog_WriteLine(" Bytes.");
	stopDelete = !PutzAction_TellAction(0, 0);
	msgCounter = 0;
	partDeleted = 0;
	badMsg = 0;
	deleted = 0;
	firstUnread = dataSys_empty;
	unreadCounter = 0;
	
	/* Tab und Par-File lesen */
	BufferTabAndPar();
	if (AnzMessages > 0 && !newNums)
	{
		PutzLog_WriteString (", Zu wenig Speicher fr newNums + WaiNr");
		closeGroup();
		closeNewFiles();
		deleteNewFiles();
		killBuffer();
		SFREE(GlBuf);
		GlBuf = NULL;
		GlBufLen=0;
		return FALSE;
	}
	BufferWai();

	/* Datenfile buffern */
	BufferDatFile();
	PutzAction_ShowBuffStatus(tabBuffered, parBuffered, datBuffered,WaiBuffered);
	PutzLog_putTime();
	if (!tabBuffered && !parBuffered && !tabBuffered && !WaiBuffered)
		PutzLog_WriteString("Nichts gebuffert");
	else
	{
		if (tabBuffered)
			PutzLog_WriteString("TAB-File gebuffert");
		if (parBuffered)
			PutzLog_WriteString(", PAR-File gebuffert");
		if (datBuffered)
			PutzLog_WriteString (", DAT-File gebuffert");
		if (WaiBuffered)
			PutzLog_WriteString (", Wai-File gebuffert");
	}
	PutzLog_WriteLn();
	if (AnzMessages > 0)
	{
		/* Neue Files anlegen */
		createNewFiles();
		if (stopDelete)
		{
			closeGroup();
			closeNewFiles();
			deleteNewFiles();
			killBuffer();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		/* dbHeader in par-File schreiben */
		if (!parBuffered)
		{
			ReadBytes(parFile, &header, dbHeaderLength, &rdB);
			header.Version=dbVersion;
			WriteBytes(newPar, &header, dbHeaderLength);
		}
		if (stopDelete)
		{
			closeGroup();
			closeNewFiles();
			deleteNewFiles();
			killBuffer();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		/* Writebuffer anlegen */
		MakeWriteBuffer(newDat);
		/* Loeschen starten */
		res = doDelete();
		if (datBuffered)
		{
			SFREE(datBuffer);
			datBuffer = NULL;
		}
		if (stopDelete || res > 0)
		{
			closeGroup();
			/* Writebuffer schliessen */
			CloseWriteBuffer(newDat);
			closeNewFiles();
			deleteNewFiles();
			killBuffer();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			if (res > 0)
			{
				group->postMsgs = group->preMsgs;
				group->postBytes = group->preBytes;
				group->status=GRP_DONE;
			}
			return !stopDelete;
		}
		/* Alte Files schliessen */
		if (parBuffered)
			FlushParam(newPar, newParArray);
		if (stopDelete)
		{
			closeGroup();
			/* Writebuffer schliessen */
			CloseWriteBuffer (newDat);
			closeNewFiles();
			deleteNewFiles();
			killBuffer();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		if (tabBuffered)
		{
			FlushTab(newTab, newTabArray);
			SFREE(tabArray);
			tabArray = NULL;
			SFREE(newTabArray);
			newTabArray = NULL;
		}
		/* Writebuffer schliessen */
		CloseWriteBuffer(newDat);
		if (stopDelete)
		{
			closeNewFiles();
			deleteNewFiles();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		
		/* Summeneintrag neu setzen */
		group->badDel =  badMsg;
		group->totalDel = deleted;
		group->partDel =  partDeleted;
		group->postMsgs = msgCounter;
		group->postBytes = FileSize(newDat);
		totalEntry.badDel += badMsg;
		totalEntry.totalDel += deleted;
		totalEntry.partDel += partDeleted;
		totalEntry.postMsgs += msgCounter;
		totalEntry.postBytes += group->postBytes;
		closeGroup();
		closeNewFiles();
		if (stopDelete)
		{
			deleteNewFiles();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		stopDelete = !PutzAction_TellAction(2, AnzMessages);
		if (stopDelete)
		{
			deleteNewFiles();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		
		/* Kommentarverkettung neu erstellen */
		PutzLog_putTime();
		PutzLog_WriteLine("Kommentarverkettung neu aufbauen");

		linkNewPar();

		/* *.WAI anpassen */
		PutzLog_putTime();
		PutzLog_WriteLine("Waisenliste aufrumen");
		updateWai();
		closeNewFiles();
		
		/* Gruppen.POS updaten */
		data_updateGrPos(currentGroup,newNums,msgCounter,deleted+badMsg,firstUnread, unreadCounter);
		/* Alte Files loeschen und neue umbenennen */
		PutzLog_putTime();
		PutzLog_WriteLine ("Gruppendateien umkopieren");
		stopDelete = !PutzAction_TellAction(3, AnzMessages);
		if (stopDelete)
		{
			deleteNewFiles();
			SFREE(GlBuf);
			GlBuf = NULL;
			GlBufLen=0L;
			return FALSE;
		}
		makeNewNames();
		PutzLog_putTime();
		PutzLog_WriteString("Gruppe ");
		PutzLog_WriteString(group->info->name);
		PutzLog_WriteString(" geschlossen, Messages nachher: ");
		PutzLog_WriteCard(group->postMsgs);
		PutzLog_WriteString(", Bytes nachher: ");
		PutzLog_WriteCard(group->postBytes);
		PutzLog_WriteLn();
		PutzLog_WriteLn();
	} else
	{
		closeGroup();
	}
	SFREE(GlBuf);
	GlBuf = NULL;
	GlBufLen=0L;
	group->status=GRP_DONE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.17h */	/*DYJ 5.20u */ /*DYJ 5.20y */
GLOBAL _BOOL PutzGroup_deleteGroup(grListEntry *group, _BOOL noConfirm)
{
	CAT_GROUP_NUMBER maxNum;
	GROUPNR anz;
	DB_NAMES dbf;
	DB_NAMES dbf2;
	_WORD errDelRen=0;
	_UBYTE msg[sizeof(groupName) + 80];
	grListEntry *mE;

	if (!noConfirm)
	{
/*DYJ 5.36f Start*/
		sprintf(msg,PutzRsc_WrkString(AL_CONFIRM_DELETE), group->info->name);
/*DYJ  Ende; alt:	
		sprintf(msg, AL_CONFIRM_DELETE, group->info->name);
*/
		if (mtAlerts_Alert(2, msg) != 1)
			return FALSE;
	}

	PutzLog_OpenLog(DataPath);
	PutzLog_putTime();
	PutzLog_WriteString(CATPUTZ_VERSION);
	PutzLog_WriteString(" f\201r CAT ab 3.0 gestartet");
	PutzLog_WriteLn();
	PutzLog_WriteString("L\224sche Gruppe komplett: ");
	PutzLog_WriteString(group->info->name);
	PutzLog_WriteLn();
	PutzLog_WriteLine("L\224sche alle Anhnge ");
	data_delAllAttach(group->info->catNumber);

	/* Gruppe loeschen */
	/* Erstmal Gruppe mit hoechster Nummer herausfinden */
	GroupSelect_CountCatGroupsMax(&maxNum);
	
	/* Dateien loeschen und umbenennen */
	if((anz=GroupSelect_CntCatNum(group->info->catNumber))==1)
	{
		GroupSelect_makeFilenames(group->info->catNumber, FALSE, &dbf,tmpPath);
		/* Dateien loeschen */
		if (F_File_Delete(dbf.datName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht l\224schen: ");
			PutzLog_WriteString(dbf.datName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand lschen");
			PutzLog_WriteLn();
			errDelRen=1;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File gel\224scht: ");
			PutzLog_WriteString(dbf.datName);
			PutzLog_WriteLn();
		}
		if (F_File_Delete(dbf.waiName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht l\224schen: ");
			PutzLog_WriteString(dbf.waiName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand lschen");
			PutzLog_WriteLn();
			errDelRen+=2;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File gel\224scht: ");
			PutzLog_WriteString(dbf.waiName);
			PutzLog_WriteLn();
		}
		if (F_File_Delete(dbf.parName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht l\224schen: ");
			PutzLog_WriteString(dbf.parName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand lschen");
			PutzLog_WriteLn();
			errDelRen+=4;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File gel\224scht: ");
			PutzLog_WriteString(dbf.parName);
			PutzLog_WriteLn();
		}
		if (F_File_Delete(dbf.tabName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht l\224schen: ");
			PutzLog_WriteString(dbf.tabName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand lschen");
			PutzLog_WriteLn();
			errDelRen+=8;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File gel\224scht: ");
			PutzLog_WriteString(dbf.tabName);
			PutzLog_WriteLn();
		}
		if(errDelRen)
/*DYJ 5.36f Start*/
			mtAlerts_Alert(1,PutzRsc_WrkString(AL_DELETE_GROUP));
/*DYJ  Ende; alt:	
			mtAlerts_Alert(1, AL_DELETE_GROUP);
*/
		anz=0;
	}
	GroupSelect_DeleteGroup(group->info->name);
	
	if (!anz && (CAT_GROUP_NUMBER)maxNum > group->info->catNumber)
	{
		/* Von der letzten Gruppe die Nummer noch aendern 
		 * und die Dateien umbenennen 
		 */
		GroupSelect_makeFilenames(maxNum, FALSE, &dbf2,tmpPath);
		/* Jetzt Dateien umbennen */
		if ((errDelRen&1)>0 || F_Path_Rename(dbf2.datName, dbf.datName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht umbenennen: ");
			PutzLog_WriteString(dbf2.datName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.datName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand umbenennen");
			PutzLog_WriteLn();
			errDelRen+=0x10;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File umbenannt: ");
			PutzLog_WriteString(dbf2.datName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.datName);
			PutzLog_WriteLn();
		}
		if ((errDelRen&2)>0 || F_Path_Rename(dbf2.waiName, dbf.waiName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht umbenennen: ");
			PutzLog_WriteString(dbf2.waiName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.waiName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand umbenennen");
			PutzLog_WriteLn();
			errDelRen+=0x20;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File umbenannt: ");
			PutzLog_WriteString(dbf2.waiName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.waiName);
			PutzLog_WriteLn();
		}
		if ((errDelRen&4)>0 || F_Path_Rename(dbf2.parName, dbf.parName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht umbenennen: ");
			PutzLog_WriteString(dbf2.parName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.parName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand umbenennen");
			PutzLog_WriteLn();
			errDelRen+=0x40;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File umbenannt: ");
			PutzLog_WriteString(dbf2.parName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.parName);
			PutzLog_WriteLn();
		}
		if ((errDelRen&8)>0 || F_Path_Rename(dbf2.tabName, dbf.tabName) != GERR_OK)
		{
			PutzLog_WriteString("Konnte folgendes File nicht umbenennen: ");
			PutzLog_WriteString(dbf2.tabName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.tabName);
			PutzLog_WriteLn();
			PutzLog_WriteString("Bitte per Hand umbenennen");
			PutzLog_WriteLn();
			errDelRen+=0x80;
		}
		else
		{
			PutzLog_WriteString("Habe folgendes File umbenannt: ");
			PutzLog_WriteString(dbf2.tabName);
			PutzLog_WriteString(" -> ");
			PutzLog_WriteString(dbf.tabName);
			PutzLog_WriteLn();
		}
		if(errDelRen)
/*DYJ 5.36f Start*/
			mtAlerts_Alert(1,PutzRsc_WrkString(AL_RENAME_GROUP_FILES));
/*DYJ  Ende; alt:	
			mtAlerts_Alert(1, AL_RENAME_GROUP_FILES);
*/

		/* Jetzt die gruppe in der Putzliste suchen */
		Lists_ResetList(&putzList);
		mE = Lists_NextEntry(&putzList);
		while (mE != NULL)
		{
			if (mE->info->catNumber == (CAT_GROUP_NUMBER)maxNum)
			{
				mE->info->catNumber = group->info->catNumber;
				GroupSelect_SetNewCatNumber(mE->info->name, group->info->catNumber);
				mE = NULL;
			} else
			{
				mE = Lists_NextEntry(&putzList);
			}
		}
	} else
	{
		/* Gruppen.INF sichern */
		GroupSelect_SaveGruppenInf();
	}
	
	/* Jetzt gruppen.pos noch aendern */
	if (data_ReadPos())
	{
		/* Jetzt ist das geladen, Aenderungen vornehmen */
		data_CopyPos(group->info->catNumber,maxNum);
		data_WritePos();
		data_CloseBase();
	}
	
	/* Geaenderte Gruppenliste von CAT noch sichern */
	GroupSelect_SaveGroupList();
	/* Ok, die externen Arbeiten sind fertig. Jetzt folgt der interne Kram */
	/* Eintrag noch aus der Putzliste loeschen */
	Lists_ResetList(&putzList);
	mE = Lists_NextEntry(&putzList);
	while (mE != group)
		mE = Lists_NextEntry(&putzList);
	Lists_RemoveEntry(&putzList, mem_free);
	
	PutzLog_CloseLog();	/*DYJ 5.20y */
	return errDelRen==0;
}


LOCAL _VOID chkWiederv(pBlock *param, delState *pdState)
{
	_UBYTE aktid[300];
	_ULONG br;
	_LONG i;
	if((*pdState==partDel || *pdState==totalDel )&& wvor_anz)
	{
		if(!wvor_IDs)
		{
			wvor_IDs=WV_getMsgIDs(&wvor_anz);
			if(wvor_IDs==NULL )
			{
				if(wvor_anz!=0)
					*pdState=-1;		/*Speicherfehler o,.*/
				return;
			}
		}
		
		for(i=0;i<wvor_anz;i++)
		{
			GetDat(datFile, param->Start, aktid, param->idLength, &br);
			if(!strCmp(wvor_IDs[i],aktid))
			{
				*pdState=noDel;
				break;
			}
		}
	}
	
}
GLOBAL _VOID initWiederv(_VOID)
{
	if(wvor_IDs)
		SFREE(wvor_IDs);
	wvor_IDs=NULL;
	wvor_anz=-1;
}

